"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.billingPaymentsAPI = billingPaymentsAPI;
var _routes = require("./routes");
function billingPaymentsAPI(req) {
  return {
    loadPaymentProfilesForCloneApp: function loadPaymentProfilesForCloneApp(appId) {
      return req.billing.get(_routes.routes.paymentProfilesForCloneApp(appId));
    },
    confirmConsolidateApp: function confirmConsolidateApp(appId, _ref) {
      var paymentProfileId = _ref.paymentProfileId,
        newBillingPlan = _ref.newBillingPlan,
        newBillingPeriod = _ref.newBillingPeriod;
      return req.billing.put(_routes.routes.consolidateApp(appId, paymentProfileId)).query({
        newBillingPlan: newBillingPlan,
        newBillingPeriod: newBillingPeriod
      });
    },
    loadPaymentProfiles: function loadPaymentProfiles() {
      return req.billing.get(_routes.routes.devPaymentProfile());
    },
    setAppPaymentProfile: function setAppPaymentProfile(appId, paymentProfileId) {
      return req.billing.put(_routes.routes.appPaymentProfileCard(appId, paymentProfileId));
    },
    setAutomationPaymentProfile: function setAutomationPaymentProfile(appId, paymentProfileId) {
      return req.billing.put(_routes.routes.automationPaymentProfileCard(appId, paymentProfileId));
    },
    addPaymentProfile: function addPaymentProfile(data) {
      return req.billing.post(_routes.routes.devPaymentProfile(), data);
    },
    updatePaymentProfile: function updatePaymentProfile(id, data) {
      return req.billing.put(_routes.routes.devPaymentProfileById(id), data);
    },
    deletePaymentProfile: function deletePaymentProfile(id) {
      return req.billing["delete"](_routes.routes.devPaymentProfileById(id));
    },
    exchangeBBtoUSD: function exchangeBBtoUSD(appId, bbAmount) {
      return req.billing.post(_routes.routes.exchangeBB(appId), bbAmount).set({
        'Content-Type': 'application/json'
      });
    }
  };
}