"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _routes = require("./utils/routes");
var routes = (0, _routes.prepareRoutes)({
  service: '/:appId/console/cachecontrol/:service',
  serviceTarget: '/:appId/console/cachecontrol/:service/:target'
});
var _default = function _default(req) {
  return {
    loadAllServiceItems: function loadAllServiceItems(appId, service) {
      return req.get(routes.service(appId, service));
    },
    loadServiceItem: function loadServiceItem(appId, service, target) {
      return req.get(routes.serviceTarget(appId, service, target));
    },
    createServiceItem: function createServiceItem(appId, service, target, data) {
      return req.post(routes.serviceTarget(appId, service, target), data);
    },
    updateServiceItem: function updateServiceItem(appId, service, target, data) {
      return req.put(routes.serviceTarget(appId, service, target), data);
    },
    deleteServiceItem: function deleteServiceItem(appId, service, target) {
      return req["delete"](routes.serviceTarget(appId, service, target));
    }
  };
};
exports["default"] = _default;