"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _urls = _interopRequireDefault(require("./urls"));
var normalizeValue = function normalizeValue(value) {
  return typeof value === 'string' ? value : JSON.stringify(value);
};
var normalizeResponse = function normalizeResponse(res) {
  return Object.keys(res).map(function (key) {
    var _res$key = res[key],
      expireAt = _res$key.expireAt,
      value = _res$key.value;
    return {
      objectId: key,
      value: normalizeValue(value),
      expireAt: expireAt,
      key: key
    };
  });
};
var _default = function _default(req) {
  return {
    get: function get(appId, _ref) {
      var pageSize = _ref.pageSize,
        offset = _ref.offset;
      return Promise.all([req.get(_urls["default"].cache(appId)).query({
        pagesize: pageSize,
        offset: offset
      }).then(normalizeResponse), this.count(appId)]).then(function (_ref2) {
        var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
          data = _ref3[0],
          totalRows = _ref3[1];
        return {
          data: data,
          totalRows: totalRows
        };
      });
    },
    count: function count(appId) {
      return req.get("".concat(_urls["default"].cache(appId), "/count"));
    },
    update: function update(appId, record) {
      var key = record.key,
        value = record.value,
        expireAt = record.expireAt,
        objectId = record.objectId;
      var id = key || objectId;
      return req.put(_urls["default"].cache(appId, id), JSON.stringify(value)).query({
        expireAt: expireAt
      }).type('application/json');
    },
    remove: function remove(appId, key) {
      return req["delete"](_urls["default"].cache(appId, key));
    }
  };
};
exports["default"] = _default;