"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _urls = _interopRequireDefault(require("./urls"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var DEFAULT_NAME_PATTERN = '*';
var normalizeResponse = function normalizeResponse(item) {
  return _objectSpread(_objectSpread({}, item), {}, {
    objectId: item.name
  });
};
var _default = function _default(req) {
  return {
    get: function get(appId, _ref) {
      var pageSize = _ref.pageSize,
        offset = _ref.offset,
        sortField = _ref.sortField,
        sortDir = _ref.sortDir,
        _ref$pattern = _ref.pattern,
        pattern = _ref$pattern === void 0 ? DEFAULT_NAME_PATTERN : _ref$pattern;
      return req.get(_urls["default"].atomicCounters(appId)).query({
        pageSize: pageSize,
        offset: offset,
        sortField: sortField,
        sortDir: sortDir,
        pattern: pattern
      });
    },
    listNames: function listNames(appId) {
      var pattern = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_NAME_PATTERN;
      return req.get("".concat(_urls["default"].atomicCounters(appId), "/").concat(pattern, "/list-names"));
    },
    listCounters: function listCounters(appId, names) {
      return req.post("".concat(_urls["default"].atomicCounters(appId), "/list-by-names"), names);
    },
    create: function create(appId, name, value) {
      return req.post("".concat(_urls["default"].atomicCounters(appId), "/").concat(encodeURIComponent(name)), {
        value: value
      }).then(normalizeResponse);
    },
    update: function update(appId, name, currentValue, newValue) {
      return req.put("".concat(_urls["default"].atomicCounters(appId), "/").concat(encodeURIComponent(name)), {
        currentValue: currentValue,
        newValue: newValue
      });
    },
    remove: function remove(appId, name) {
      return req["delete"]("".concat(_urls["default"].atomicCounters(appId), "/").concat(encodeURIComponent(name)));
    }
  };
};
exports["default"] = _default;