"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _urls = _interopRequireDefault(require("./urls"));
var _default = function _default(req) {
  return {
    loadPacks: function loadPacks() {
      return req.get("".concat(_urls["default"].gamification(), "/packs"));
    },
    getMapItems: function getMapItems(packId) {
      return req.get("".concat(_urls["default"].gamification(), "/map-items")).query({
        packId: packId
      });
    },
    getProgress: function getProgress() {
      return req.get("".concat(_urls["default"].gamification(), "/progress"));
    },
    loadLevels: function loadLevels() {
      return req.get("".concat(_urls["default"].gamification(), "/levels"));
    },
    loadBadges: function loadBadges() {
      return req.get("".concat(_urls["default"].gamification(), "/badges"));
    },
    loadEarnBBItems: function loadEarnBBItems() {
      return req.get("".concat(_urls["default"].gamification(), "/earn"));
    },
    loadRedeemBBItems: function loadRedeemBBItems() {
      return req.get("".concat(_urls["default"].gamification(), "/redeem"));
    },
    loadActivityHistory: function loadActivityHistory() {
      return req.get("".concat(_urls["default"].gamification(), "/activity-history"));
    },
    loadTrivia: function loadTrivia() {
      return req.get("".concat(_urls["default"].gamification(), "/trivia"));
    },
    checkTriviaAnswer: function checkTriviaAnswer(triviaId, answerId, taskId) {
      return req.post("".concat(_urls["default"].gamification(), "/trivia"), {
        triviaId: triviaId,
        answerId: answerId,
        taskId: taskId
      });
    },
    submitSocialSharing: function submitSocialSharing(data) {
      return req.post("".concat(_urls["default"].gamification(), "/social-share"), data);
    },
    reportSocialActivity: function reportSocialActivity(data) {
      return req.post("".concat(_urls["default"].gamification(), "/social-link"), data);
    },
    getLastUpdates: function getLastUpdates() {
      return req.get("".concat(_urls["default"].gamification(), "/updates"));
    },
    markEventPlayed: function markEventPlayed(taskId) {
      return req.put("".concat(_urls["default"].gamification(), "/mark-event-played"), {
        taskId: taskId
      });
    },
    enableAppAPITracking: function enableAppAPITracking(appId) {
      return req.put("".concat(_urls["default"].gamificationApp(appId), "/enable"));
    },
    disableAppAPITracking: function disableAppAPITracking(appId) {
      return req.put("".concat(_urls["default"].gamificationApp(appId), "/disable"));
    },
    isAppAPITrackingEnabled: function isAppAPITrackingEnabled(appId) {
      return req.get("".concat(_urls["default"].gamificationApp(appId), "/enabled"));
    },
    enableAccountAPITracking: function enableAccountAPITracking() {
      // enable API monitoring for all developer's apps
      return req.put("".concat(_urls["default"].gamification(), "/enable"));
    },
    disableAccountAPITracking: function disableAccountAPITracking() {
      // disable API monitoring for all developer's apps
      return req.put("".concat(_urls["default"].gamification(), "/disable"));
    },
    isAccountAPITrackingEnabled: function isAccountAPITrackingEnabled() {
      return req.get("".concat(_urls["default"].gamification(), "/enabled"));
    },
    unlockSpringboardPlan: function unlockSpringboardPlan(appId) {
      return req.put("".concat(_urls["default"].gamification(), "/unlock-springboard")).query({
        appId: appId
      });
    },
    getFreeMilestoneProgress: function getFreeMilestoneProgress() {
      return req.get("".concat(_urls["default"].gamification(), "/free-plan-milestone-progress"));
    },
    getUnlockedFreePlanAppId: function getUnlockedFreePlanAppId() {
      return req.get("".concat(_urls["default"].gamification(), "/free-plan-status"));
    },
    getSettings: function getSettings() {
      return req.get("".concat(_urls["default"].gamification(), "/settings"));
    },
    saveSettings: function saveSettings(settings) {
      return req.put("".concat(_urls["default"].gamification(), "/settings"), settings);
    },
    getSocialPostsCollection: function getSocialPostsCollection() {
      return req.get("".concat(_urls["default"].gamification(), "/social-posts-templates"));
    }
  };
};
exports["default"] = _default;