"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CacheTags = void 0;
Object.defineProperty(exports, "DevPermissions", {
  enumerable: true,
  get: function get() {
    return _devPermissions.DevPermissions;
  }
});
Object.defineProperty(exports, "Request", {
  enumerable: true,
  get: function get() {
    return _backendlessRequest["default"];
  }
});
exports.createClient = void 0;
Object.defineProperty(exports, "urls", {
  enumerable: true,
  get: function get() {
    return _urls["default"];
  }
});
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _backendlessRequest = _interopRequireDefault(require("backendless-request"));
var CacheTags = _interopRequireWildcard(require("./utils/cache-tags"));
exports.CacheTags = CacheTags;
var _urls = _interopRequireDefault(require("./urls"));
var _activityManager = _interopRequireDefault(require("./activity-manager"));
var _analytics = _interopRequireDefault(require("./analytics"));
var _apiDocs = _interopRequireDefault(require("./api-docs"));
var _apps = _interopRequireDefault(require("./apps"));
var _automation = _interopRequireDefault(require("./automation"));
var _billing = require("./billing");
var _bl = _interopRequireDefault(require("./bl"));
var _cloudCode = _interopRequireDefault(require("./cloud-code"));
var _blueprints = _interopRequireDefault(require("./blueprints"));
var _cache = _interopRequireDefault(require("./cache"));
var _cacheControl = _interopRequireDefault(require("./cache-control"));
var _codegen = _interopRequireDefault(require("./codegen"));
var _codeless = _interopRequireDefault(require("./codeless"));
var _counters = _interopRequireDefault(require("./counters"));
var _dataConnectors = _interopRequireDefault(require("./data-connectors"));
var _dataViews = _interopRequireDefault(require("./data-views"));
var _dataHives = _interopRequireDefault(require("./data-hives"));
var _dataToVisualize = _interopRequireDefault(require("./data-to-visualize"));
var _developerProfile = _interopRequireDefault(require("./developer-profile"));
var _devTeam = _interopRequireDefault(require("./dev-team"));
var _email = _interopRequireDefault(require("./email"));
var _files = _interopRequireDefault(require("./files"));
var _gamification = _interopRequireDefault(require("./gamification"));
var _geo = _interopRequireDefault(require("./geo"));
var _license = _interopRequireDefault(require("./license"));
var _messaging = _interopRequireDefault(require("./messaging"));
var _navigator = _interopRequireDefault(require("./navigator"));
var _projectTemplate = _interopRequireDefault(require("./project-template"));
var _security = _interopRequireDefault(require("./security"));
var _devPermissions = _interopRequireWildcard(require("./dev-permissions"));
var _openAi = _interopRequireDefault(require("./open-ai"));
var _integrations = _interopRequireDefault(require("./integrations"));
var _pdf = _interopRequireDefault(require("./pdf"));
var _settings = _interopRequireDefault(require("./settings"));
var _status = _interopRequireDefault(require("./status"));
var _tables = _interopRequireDefault(require("./tables"));
var _transfer = _interopRequireDefault(require("./transfer"));
var _user = _interopRequireDefault(require("./user"));
var _users = _interopRequireDefault(require("./users"));
var _warning = _interopRequireDefault(require("./warning"));
var _uiBuilder = _interopRequireDefault(require("./ui-builder"));
var _chartBuilder = _interopRequireDefault(require("./chart-builder"));
var _visualizations = _interopRequireDefault(require("./visualizations"));
var _consolePreview = _interopRequireDefault(require("./console-preview"));
var _quickApps = _interopRequireDefault(require("./quick-apps"));
var _frExtensions = _interopRequireDefault(require("./fr-extensions"));
var _community = require("./community");
var _marketplace = require("./marketplace");
var _referrals = require("./referrals");
var _initialQuestionnaire = require("./initial-questionnaire");
var _sqlService = require("./sql-service");
var _system = require("./system");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Context = /*#__PURE__*/function () {
  function Context(authKey, options) {
    (0, _classCallCheck2["default"])(this, Context);
    this.options = options;
    this.authKey = authKey;
    this.middleware = options.middleware;
  }
  (0, _createClass2["default"])(Context, [{
    key: "setAuthKey",
    value: function setAuthKey(authKey) {
      this.authKey = authKey;
    }

    /**
     * @param {Request} req
     * @returns {Request}
     */
  }, {
    key: "apply",
    value: function apply(req, middleware) {
      if (this.authKey) {
        req.set('auth-key', this.authKey);
      }
      if (this.middleware) {
        this.middleware(req);
      }
      if (middleware) {
        middleware(req);
      }
      return req;
    }
  }]);
  return Context;
}();
/**
 * @param {Context} context
 * @param {String} serverUrl
 */
var contextifyRequest = function contextifyRequest(context, serverUrl, middleware) {
  var result = {
    context: context
  };
  var addServerUrl = function addServerUrl(path) {
    return serverUrl && !path.startsWith('http') ? serverUrl + path : path;
  };
  _backendlessRequest["default"].methods.forEach(function (method) {
    result[method] = function (path, body) {
      return context.apply(new _backendlessRequest["default"](addServerUrl(path), method, body), middleware);
    };
  });
  return result;
};
var DEFAULT_OPTIONS = {
  billingURL: null,
  billingAuth: null
};
var createClient = function createClient(serverUrl, authKey, options) {
  options = _objectSpread(_objectSpread({}, DEFAULT_OPTIONS), options);
  var context = new Context(authKey, options);
  var request = contextifyRequest(context, serverUrl);
  if (options.billingURL) {
    request.billing = contextifyRequest(context, options.billingURL, function (req) {
      if (options.billingAuth) {
        req.set({
          'Authorization': "Basic ".concat(options.billingAuth)
        });
      }
    });
  } else {
    request.billing = request;
  }
  if (options.communityURL) {
    request.community = contextifyRequest(context, options.communityURL, function (req) {
      req.path = req.path.replace('/console/community', '');
    });
  } else {
    request.community = request;
  }
  if (options.sqlServiceURL) {
    request.sqlService = contextifyRequest(context, options.sqlServiceURL);
  } else {
    request.sqlService = request;
  }
  if (options.automationURL) {
    request.automation = contextifyRequest(context, options.automationURL, function (req) {
      req.path = req.path.replace('/console/automation', '');
    });
  } else {
    request.automation = request;
  }
  if (options.nodeApiURL) {
    request.nodeAPI = contextifyRequest(context, options.nodeApiURL, function (req) {
      req.path = req.path.replace('/api/node-server', '');
    });
  } else {
    request.nodeAPI = request;
  }
  var destroy = function destroy() {
    context.middleware = function (req) {
      req.send = function () {
        return Promise.reject(new Error('Client has been destroyed'));
      };
      return req;
    };
  };
  return request.api = {
    destroy: destroy,
    request: request,
    system: (0, _system.systemAPI)(request),
    activityManager: (0, _activityManager["default"])(request),
    analytics: (0, _analytics["default"])(request),
    apiDocs: (0, _apiDocs["default"])(request),
    apps: (0, _apps["default"])(request),
    automation: (0, _automation["default"])(request),
    billing: (0, _billing.billingAPI)(request),
    bl: (0, _bl["default"])(request),
    cloudCode: (0, _cloudCode["default"])(request),
    blueprints: (0, _blueprints["default"])(request),
    cache: (0, _cache["default"])(request),
    cacheControl: (0, _cacheControl["default"])(request),
    codegen: (0, _codegen["default"])(request),
    codeless: (0, _codeless["default"])(request),
    counters: (0, _counters["default"])(request),
    dataConnectors: (0, _dataConnectors["default"])(request),
    dataViews: (0, _dataViews["default"])(request),
    dataHives: (0, _dataHives["default"])(request),
    dataToVisualize: (0, _dataToVisualize["default"])(request),
    developerProfile: (0, _developerProfile["default"])(request),
    devTeam: (0, _devTeam["default"])(request),
    email: (0, _email["default"])(request),
    files: (0, _files["default"])(request),
    gamification: (0, _gamification["default"])(request),
    geo: (0, _geo["default"])(request),
    license: (0, _license["default"])(request),
    messaging: (0, _messaging["default"])(request),
    navigator: (0, _navigator["default"])(request),
    projectTemplate: (0, _projectTemplate["default"])(request),
    security: (0, _security["default"])(request),
    devPermissions: (0, _devPermissions["default"])(request),
    openAI: (0, _openAi["default"])(request),
    settings: (0, _settings["default"])(request),
    status: (0, _status["default"])(request),
    tables: (0, _tables["default"])(request),
    transfer: (0, _transfer["default"])(request),
    user: (0, _user["default"])(request, context),
    users: (0, _users["default"])(request),
    warning: (0, _warning["default"])(request),
    uiBuilder: (0, _uiBuilder["default"])(request),
    chartBuilder: (0, _chartBuilder["default"])(request),
    community: (0, _community.community)(request),
    sqlService: (0, _sqlService.sqlService)(request),
    marketplace: (0, _marketplace.marketplace)(request),
    referrals: (0, _referrals.referrals)(request),
    visualizations: (0, _visualizations["default"])(request),
    initialQuestionnaire: (0, _initialQuestionnaire.initialQuestionnaire)(request),
    consolePreview: (0, _consolePreview["default"])(request),
    quickApps: (0, _quickApps["default"])(request),
    integrations: (0, _integrations["default"])(request),
    pdf: (0, _pdf["default"])(request),
    frExtensions: (0, _frExtensions["default"])(request)
  };
};
exports.createClient = createClient;