"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initialQuestionnaire = void 0;
var _routes = require("./utils/routes");
var routes = (0, _routes.prepareRoutes)({
  questions: '/console/community/initial-questionnaire/questions',
  answers: '/console/community/initial-questionnaire/answers',
  status: '/console/community/initial-questionnaire/status'
});
var initialQuestionnaire = function initialQuestionnaire(req) {
  return {
    loadQuestions: function loadQuestions() {
      return req.community.get(routes.questions());
    },
    sendAnswers: function sendAnswers(answers) {
      return req.community.post(routes.answers(), answers);
    },
    loadStatus: function loadStatus() {
      return req.community.get(routes.status());
    }
  };
};
exports.initialQuestionnaire = initialQuestionnaire;