"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _routes = require("./utils/routes");
/* eslint-disable max-len */

var routes = (0, _routes.prepareRoutes)({
  containers: '/api/app/:appId/quick-apps/containers',
  container: '/api/app/:appId/quick-apps/containers/:containerId',
  deploy: '/api/app/:appId/quick-apps/deploy/:containerId'
});
var _default = function _default(req) {
  return {
    loadContainers: function loadContainers(appId) {
      return req.get(routes.containers(appId));
    },
    loadContainer: function loadContainer(appId, containerId) {
      return req.get(routes.container(appId, containerId));
    },
    createContainer: function createContainer(appId, data) {
      return req.post(routes.containers(appId), data);
    },
    deleteContainer: function deleteContainer(appId, containerId) {
      return req["delete"](routes.containers(appId, containerId));
    },
    deployContainer: function deployContainer(appId, containerId, data) {
      return req.post(routes.deploy(appId, containerId), data);
    }
  };
};
exports["default"] = _default;