"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.referrals = void 0;
var _routes = require("./utils/routes");
var routes = (0, _routes.prepareRoutes)({
  inviteCode: '/console/community/referrals/invite-code',
  inviteId: '/console/community/referrals/invite-id',
  invites: '/console/community/referrals/invites',
  confirmUserRegistered: '/console/community/referrals/events/confirm-user-registered',
  confirmFirstAppCreated: '/console/community/referrals/events/confirm-first-app-created'
});
var referrals = function referrals(req) {
  return {
    loadInviteCode: function loadInviteCode() {
      return req.community.get(routes.inviteCode());
    },
    loadInvites: function loadInvites() {
      return req.community.get(routes.invites());
    },
    sendInvite: function sendInvite(inviteData) {
      return req.community.post(routes.invites(), inviteData);
    },
    checkInviteId: function checkInviteId(id) {
      return req.community.post(routes.inviteId(), id);
    },
    confirmUserRegistered: function confirmUserRegistered(inviteData) {
      return req.community.post(routes.confirmUserRegistered(), inviteData);
    },
    confirmFirstAppCreated: function confirmFirstAppCreated() {
      return req.community.post(routes.confirmFirstAppCreated());
    }
  };
};
exports.referrals = referrals;