"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _routes = require("./utils/routes");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; } /* eslint-disable max-len */
var routes = (0, _routes.prepareRoutes)({
  init: '/:appId/console/ui-builder/init',
  sdkStyles: '/:appId/console/ui-builder/library/sdk/styles',
  sdkComponents: '/:appId/console/ui-builder/library/sdk/components',
  layoutTemplates: '/:appId/console/ui-builder/library/layout-templates',
  pageTemplates: '/:appId/console/ui-builder/library/page-templates',
  customComponentTemplates: '/:appId/console/ui-builder/library/custom-component-templates',
  themes: '/:appId/console/ui-builder/library/themes',
  theme: '/:appId/console/ui-builder/library/themes/:themeId',
  themeStyle: '/:appId/console/ui-builder/library/themes/:themeId/style',
  themeAction: '/:appId/console/ui-builder/library/themes/:themeId/:action',
  remoteThemes: '/:appId/console/ui-builder/library/remote/themes',
  remoteTheme: '/:appId/console/ui-builder/library/remote/themes/:themeId',
  containers: '/:appId/console/ui-builder/containers',
  container: '/:appId/console/ui-builder/containers/:containerName',
  containerSettings: '/:appId/console/ui-builder/containers/:containerName/settings',
  containerCustomConfigs: '/:appId/console/ui-builder/containers/:containerName/custom-configs',
  containerFavicon: '/:appId/console/ui-builder/containers/:containerName/favicon',
  containerViewport: '/:appId/console/ui-builder/containers/:containerName/viewport',
  containerMetaTags: '/:appId/console/ui-builder/containers/:containerName/meta-tags',
  containerCustomHeadContent: '/:appId/console/ui-builder/containers/:containerName/custom-head-content',
  containerExternalLibraries: '/:appId/console/ui-builder/containers/:containerName/external-libraries',
  containerDefaultI18n: '/:appId/console/ui-builder/containers/:containerName/i18n',
  containerPWASettings: '/:appId/console/ui-builder/containers/:containerName/pwa/settings',
  containerPWAIcon: '/:appId/console/ui-builder/containers/:containerName/pwa/icon',
  removedContainers: '/:appId/console/ui-builder/removed-containers',
  removedContainer: '/:appId/console/ui-builder/removed-containers/:containerName',
  containerBackups: '/:appId/console/ui-builder/containers/:containerName/backups',
  containerBackupsPolicy: '/:appId/console/ui-builder/containers/:containerName/backups/policy',
  containerBackupUpload: '/:appId/console/ui-builder/containers/:containerName/backups/upload',
  containerBackupDownloadLink: '/:appId/console/ui-builder/containers/:containerName/backups/download/sign/:backupId',
  containerI18ns: '/:appId/console/ui-builder/containers/:containerName/i18n/dictionary',
  containerI18n: '/:appId/console/ui-builder/containers/:containerName/i18n/dictionary/:dictionaryName',
  containerI18nKeys: '/:appId/console/ui-builder/containers/:containerName/i18n/key',
  containerI18nKey: '/:appId/console/ui-builder/containers/:containerName/i18n/key/:key',
  containerI18nKeyRename: '/:appId/console/ui-builder/containers/:containerName/i18n/key/:key/rename',
  containerAutomations: '/:appId/console/ui-builder/containers/:containerName/automations',
  containerAction: '/:appId/console/ui-builder/containers/:containerName/:action',
  containerStyles: '/:appId/console/ui-builder/containers/:containerName/styles',
  containerStyle: '/:appId/console/ui-builder/containers/:containerName/styles/:name',
  containerFunctions: '/:appId/console/ui-builder/containers/:containerName/functions',
  containerFunction: '/:appId/console/ui-builder/containers/:containerName/functions/:functionId',
  containerFunctionLogic: '/:appId/console/ui-builder/containers/:containerName/functions/:functionId/logic',
  installCustomFunctionsFromMarketplace: '/:appId/console/ui-builder/containers/:containerName/functions/install/:productId',
  removeFunctionsPack: '/:appId/console/ui-builder/containers/:containerName/functions/remove-functions-pack/:productId',
  containerPages: '/:appId/console/ui-builder/containers/:containerName/pages',
  containerPage: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName',
  containerPageUI: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName/ui',
  containerPageLogic: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName/logic/:componentUid/:handlerName',
  containerPageUnusedLogic: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName/unused-logic',
  containerComponentAddReference: '/:appId/console/ui-builder/containers/:containerName/components/add-reference',
  containerComponentInstall: '/:appId/console/ui-builder/containers/:containerName/components/install/:productId',
  containerLayouts: '/:appId/console/ui-builder/containers/:containerName/layouts',
  containerLayout: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId',
  containerLayoutUI: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId/ui',
  containerLayoutLogic: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId/logic/:componentUid/:handlerName',
  containerLayoutUnusedLogic: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId/unused-logic',
  containerReusableComponents: '/:appId/console/ui-builder/containers/:containerName/components/reusable',
  containerReusableComponent: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId',
  containerReusableComponentClone: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/clone',
  containerReusableComponentUpgrade: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/upgrade',
  containerReusableComponentUI: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/ui',
  containerReusableComponentLogic: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/logic/:componentUid/:handlerName',
  containerReusableComponentUnusedLogic: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/unused-logic',
  containerCustomComponents: '/:appId/console/ui-builder/containers/:containerName/components/custom',
  containerCustomComponent: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId',
  containerCustomComponentPreview: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/preview',
  containerCustomComponentClone: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/clone',
  containerCustomComponentUpgrade: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/upgrade',
  containerCustomComponentModel: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/model',
  containerCustomComponentFiles: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/files',
  containerCustomComponentFilesDownloadLink: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/files/sign',
  containerCustomComponentFileContent: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/content/:fileId'
});
var _default = function _default(req) {
  return {
    init: function init(appId) {
      return req.post(routes.init(appId));
    },
    //-- SDK -----//
    loadSDKStyles: function loadSDKStyles(appId) {
      return req.get(routes.sdkStyles(appId));
    },
    loadSDKComponents: function loadSDKComponents(appId) {
      return req.get(routes.sdkComponents(appId));
    },
    //-- SDK -----//
    //-- LIBRARY -----//
    loadLayoutTemplates: function loadLayoutTemplates(appId) {
      return req.get(routes.layoutTemplates(appId));
    },
    loadPageTemplates: function loadPageTemplates(appId) {
      return req.get(routes.pageTemplates(appId));
    },
    loadCustomComponentTemplates: function loadCustomComponentTemplates(appId) {
      return req.get(routes.customComponentTemplates(appId));
    },
    //-- LIBRARY -----//
    //-- CONTAINER -----//
    createContainer: function createContainer(appId, container) {
      return req.post(routes.containers(appId), container);
    },
    updateContainer: function updateContainer(appId, containerName, container) {
      return req.put(routes.container(appId, containerName), container);
    },
    deleteContainer: function deleteContainer(appId, containerName) {
      return req["delete"](routes.container(appId, containerName));
    },
    loadContainer: function loadContainer(appId, containerName) {
      return req.get(routes.container(appId, containerName));
    },
    publishContainer: function publishContainer(appId, containerName, options) {
      return req.post(routes.containerAction(appId, containerName, 'publish'), options);
    },
    applyContainerTheme: function applyContainerTheme(appId, containerName, theme) {
      return req.post(routes.containerAction(appId, containerName, 'apply-theme'), theme);
    },
    loadContainerStyles: function loadContainerStyles(appId, containerName) {
      return req.get(routes.containerStyles(appId, containerName));
    },
    loadContainerStyle: function loadContainerStyle(appId, containerName, name) {
      return req.get(routes.containerStyle(appId, containerName, name));
    },
    updateContainerStyle: function updateContainerStyle(appId, containerName, name, style) {
      return req.put(routes.containerStyle(appId, containerName, name), style);
    },
    deleteContainerStyle: function deleteContainerStyle(appId, containerName, name) {
      return req["delete"](routes.containerStyle(appId, containerName, name));
    },
    //-- CONTAINER -----//
    //-- BACKUPS -----//
    loadRemovedContainers: function loadRemovedContainers(appId) {
      return req.get(routes.removedContainers(appId));
    },
    deleteRemovedContainer: function deleteRemovedContainer(appId, containerName) {
      return req["delete"](routes.removedContainer(appId, containerName));
    },
    loadContainerBackups: function loadContainerBackups(appId, containerName) {
      return req.get(routes.containerBackups(appId, containerName));
    },
    updateContainerBackupsPolicy: function updateContainerBackupsPolicy(appId, containerName, backupsPolicy) {
      return req.put(routes.containerBackupsPolicy(appId, containerName), backupsPolicy);
    },
    createContainerBackup: function createContainerBackup(appId, containerName, backup) {
      return req.post(routes.containerBackups(appId, containerName), backup);
    },
    deleteContainerBackups: function deleteContainerBackups(appId, containerName, backupsIds) {
      return req["delete"](routes.containerBackups(appId, containerName), backupsIds);
    },
    getBackupDownloadLink: function getBackupDownloadLink(appId, containerName, backupId) {
      return req.get(routes.containerBackupDownloadLink(appId, containerName, backupId));
    },
    uploadBackup: function uploadBackup(appId, containerName, file, data) {
      return req.post(routes.containerBackupUpload(appId, containerName)).form(_objectSpread(_objectSpread({}, data), {}, {
        file: file
      }));
    },
    //-- BACKUPS -----//
    //-- SETTINGS -----//
    updateContainerSettings: function updateContainerSettings(appId, containerName, settings) {
      return req.put(routes.containerSettings(appId, containerName), settings);
    },
    updateContainerCustomConfigs: function updateContainerCustomConfigs(appId, containerName, customConfigs) {
      return req.put(routes.containerCustomConfigs(appId, containerName), customConfigs);
    },
    updateContainerDefaultI18n: function updateContainerDefaultI18n(appId, containerName, defaultI18n) {
      return req.put(routes.containerDefaultI18n(appId, containerName), {
        defaultI18n: defaultI18n
      });
    },
    saveContainerI18n: function saveContainerI18n(appId, containerName, dictionaryName, dictionaryObject) {
      return req.put(routes.containerI18n(appId, containerName, dictionaryName), dictionaryObject);
    },
    deleteContainerI18n: function deleteContainerI18n(appId, containerName, dictionaryName) {
      return req["delete"](routes.containerI18n(appId, containerName, dictionaryName));
    },
    updateContainerI18nKey: function updateContainerI18nKey(appId, containerName, key, changes) {
      return req.put(routes.containerI18nKey(appId, containerName, key), changes);
    },
    renameContainerI18nKey: function renameContainerI18nKey(appId, containerName, oldKeyName, newKeyName) {
      return req.put(routes.containerI18nKeyRename(appId, containerName, oldKeyName)).query({
        newKeyName: newKeyName
      });
    },
    deleteContainerI18nKeys: function deleteContainerI18nKeys(appId, containerName, keys) {
      return req["delete"](routes.containerI18nKeys(appId, containerName), keys);
    },
    uploadContainerFavicon: function uploadContainerFavicon(appId, containerName, favicon) {
      return req.put(routes.containerFavicon(appId, containerName)).form({
        favicon: favicon
      });
    },
    removeContainerFavicon: function removeContainerFavicon(appId, containerName) {
      return req["delete"](routes.containerFavicon(appId, containerName));
    },
    updateContainerViewport: function updateContainerViewport(appId, containerName, viewport) {
      return req.put(routes.containerViewport(appId, containerName), viewport);
    },
    updateContainerMetaTags: function updateContainerMetaTags(appId, containerName, metaTags) {
      return req.put(routes.containerMetaTags(appId, containerName), metaTags);
    },
    updateContainerCustomHeadContent: function updateContainerCustomHeadContent(appId, containerName, data) {
      return req.put(routes.containerCustomHeadContent(appId, containerName), {
        data: data
      });
    },
    updateContainerExternalLibraries: function updateContainerExternalLibraries(appId, containerName, externalLibraries) {
      return req.put(routes.containerExternalLibraries(appId, containerName), externalLibraries);
    },
    updateContainerPWASettings: function updateContainerPWASettings(appId, containerName, settings) {
      return req.put(routes.containerPWASettings(appId, containerName), settings);
    },
    updateContainerPWAIcon: function updateContainerPWAIcon(appId, containerName, file) {
      return req.put(routes.containerPWAIcon(appId, containerName)).form({
        file: file
      });
    },
    //-- SETTINGS -----//
    //-- THEMES -----//
    searchThemes: function searchThemes(appId) {
      return req.get(routes.remoteThemes(appId));
    },
    loadThemes: function loadThemes(appId) {
      return req.get(routes.themes(appId));
    },
    createTheme: function createTheme(appId, theme) {
      return req.post(routes.themes(appId), theme);
    },
    updateTheme: function updateTheme(appId, themeId, theme) {
      return req.put(routes.theme(appId, themeId), theme);
    },
    deleteTheme: function deleteTheme(appId, themeId) {
      return req["delete"](routes.theme(appId, themeId));
    },
    publishTheme: function publishTheme(appId, themeId, data) {
      return req.post(routes.themeAction(appId, themeId, 'publish'), data);
    },
    loadThemeStyle: function loadThemeStyle(appId, themeId) {
      return req.get(routes.themeStyle(appId, themeId));
    },
    updateThemeStyle: function updateThemeStyle(appId, themeId, content) {
      return req.put(routes.themeStyle(appId, themeId), {
        content: content
      });
    },
    //-- THEMES -----//
    //-- PAGE -----//
    createPage: function createPage(appId, containerName, data) {
      return req.post(routes.containerPages(appId, containerName), data);
    },
    updatePage: function updatePage(appId, containerName, pageName, page) {
      return req.put(routes.containerPage(appId, containerName, pageName), page);
    },
    deletePage: function deletePage(appId, containerName, pageName) {
      return req["delete"](routes.containerPage(appId, containerName, pageName));
    },
    getPageUI: function getPageUI(appId, containerName, pageName) {
      return req.get(routes.containerPageUI(appId, containerName, pageName));
    },
    updatePageUI: function updatePageUI(appId, containerName, pageName, data) {
      return req.put(routes.containerPageUI(appId, containerName, pageName), data);
    },
    getPageLogic: function getPageLogic(appId, containerName, pageName, componentUid, handlerName) {
      return req.get(routes.containerPageLogic(appId, containerName, pageName, componentUid, handlerName));
    },
    createPageLogic: function createPageLogic(appId, containerName, pageName, componentUid, handlerName) {
      return req.post(routes.containerPageLogic(appId, containerName, pageName, componentUid, handlerName));
    },
    updatePageLogic: function updatePageLogic(appId, containerName, pageName, componentUid, data) {
      return req.put(routes.containerPageLogic(appId, containerName, pageName, componentUid), data);
    },
    deletePageLogic: function deletePageLogic(appId, containerName, pageName, componentUid, handlerName) {
      return req["delete"](routes.containerPageLogic(appId, containerName, pageName, componentUid, handlerName));
    },
    deletePageUnusedLogic: function deletePageUnusedLogic(appId, containerName, pageName, componentUids) {
      return req["delete"](routes.containerPageUnusedLogic(appId, containerName, pageName), {
        componentUids: componentUids
      });
    },
    //-- PAGE -----//
    addReferenceToMarketplaceProduct: function addReferenceToMarketplaceProduct(appId, containerName, data) {
      return req.post(routes.containerComponentAddReference(appId, containerName), data);
    },
    installComponentFromMarketplace: function installComponentFromMarketplace(appId, containerName, productId, data) {
      return req.post(routes.containerComponentInstall(appId, containerName, productId), data);
    },
    //-- LAYOUTS -----//
    createLayout: function createLayout(appId, containerName, data) {
      return req.post(routes.containerLayouts(appId, containerName), data);
    },
    updateLayout: function updateLayout(appId, containerName, layoutId, data) {
      return req.put(routes.containerLayout(appId, containerName, layoutId), data);
    },
    deleteLayout: function deleteLayout(appId, containerName, id) {
      return req["delete"](routes.containerLayout(appId, containerName, id));
    },
    getLayoutUI: function getLayoutUI(appId, containerName, id) {
      return req.get(routes.containerLayoutUI(appId, containerName, id));
    },
    updateLayoutUI: function updateLayoutUI(appId, containerName, id, data) {
      return req.put(routes.containerLayoutUI(appId, containerName, id), data);
    },
    getLayoutLogic: function getLayoutLogic(appId, containerName, id, componentUid, handlerName) {
      return req.get(routes.containerLayoutLogic(appId, containerName, id, componentUid, handlerName));
    },
    updateLayoutLogic: function updateLayoutLogic(appId, containerName, id, componentUid, data) {
      return req.put(routes.containerLayoutLogic(appId, containerName, id, componentUid), data);
    },
    createLayoutLogic: function createLayoutLogic(appId, containerName, id, componentUid, handlerName) {
      return req.post(routes.containerLayoutLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteLayoutLogic: function deleteLayoutLogic(appId, containerName, id, componentUid, handlerName) {
      return req["delete"](routes.containerLayoutLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteLayoutUnusedLogic: function deleteLayoutUnusedLogic(appId, containerName, id, componentUids) {
      return req["delete"](routes.containerLayoutUnusedLogic(appId, containerName, id), {
        componentUids: componentUids
      });
    },
    //-- LAYOUTS -----//
    //-- REUSABLE COMPONENTS -----//
    createReusableComponent: function createReusableComponent(appId, containerName, data) {
      return req.post(routes.containerReusableComponents(appId, containerName), data);
    },
    cloneReusableComponent: function cloneReusableComponent(appId, containerName, id, data) {
      return req.post(routes.containerReusableComponentClone(appId, containerName, id), data);
    },
    upgradeReusableComponent: function upgradeReusableComponent(appId, containerName, id, data) {
      return req.post(routes.containerReusableComponentUpgrade(appId, containerName, id), data);
    },
    loadReusableComponent: function loadReusableComponent(appId, containerName, id) {
      return req.get(routes.containerReusableComponent(appId, containerName, id));
    },
    updateReusableComponent: function updateReusableComponent(appId, containerName, data) {
      return req.put(routes.containerReusableComponent(appId, containerName, data.id), data);
    },
    deleteReusableComponent: function deleteReusableComponent(appId, containerName, id) {
      return req["delete"](routes.containerReusableComponent(appId, containerName, id));
    },
    updateReusableComponentUI: function updateReusableComponentUI(appId, containerName, id, data) {
      return req.put(routes.containerReusableComponentUI(appId, containerName, id), data);
    },
    getReusableComponentLogic: function getReusableComponentLogic(appId, containerName, id, componentUid, handlerName) {
      return req.get(routes.containerReusableComponentLogic(appId, containerName, id, componentUid, handlerName));
    },
    updateReusableComponentLogic: function updateReusableComponentLogic(appId, containerName, id, componentUid, data) {
      return req.put(routes.containerReusableComponentLogic(appId, containerName, id, componentUid), data);
    },
    createReusableComponentLogic: function createReusableComponentLogic(appId, containerName, id, componentUid, handlerName) {
      return req.post(routes.containerReusableComponentLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteReusableComponentLogic: function deleteReusableComponentLogic(appId, containerName, id, componentUid, handlerName) {
      return req["delete"](routes.containerReusableComponentLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteReusableComponentUnusedLogic: function deleteReusableComponentUnusedLogic(appId, containerName, id, componentUids) {
      return req["delete"](routes.containerReusableComponentUnusedLogic(appId, containerName, id), {
        componentUids: componentUids
      });
    },
    //-- REUSABLE COMPONENTS -----//
    //-- CUSTOM COMPONENTS -----//
    createCustomComponent: function createCustomComponent(appId, containerName, data) {
      return req.post(routes.containerCustomComponents(appId, containerName), data);
    },
    cloneCustomComponent: function cloneCustomComponent(appId, containerName, id, data) {
      return req.post(routes.containerCustomComponentClone(appId, containerName, id), data);
    },
    upgradeCustomComponent: function upgradeCustomComponent(appId, containerName, id, data) {
      return req.post(routes.containerCustomComponentUpgrade(appId, containerName, id), data);
    },
    loadCustomComponent: function loadCustomComponent(appId, containerName, id) {
      return req.get(routes.containerCustomComponent(appId, containerName, id));
    },
    deleteCustomComponent: function deleteCustomComponent(appId, containerName, id) {
      return req["delete"](routes.containerCustomComponent(appId, containerName, id));
    },
    updateCustomComponent: function updateCustomComponent(appId, containerName, data) {
      return req.put(routes.containerCustomComponent(appId, containerName, data.id), data);
    },
    updateCustomComponentPreview: function updateCustomComponentPreview(appId, containerName, id, data) {
      return req.put(routes.containerCustomComponentPreview(appId, containerName, id), data);
    },
    loadComponentFileContent: function loadComponentFileContent(appId, containerName, id, fileId) {
      return req.get(routes.containerCustomComponentFileContent(appId, containerName, id, fileId));
    },
    updateCustomComponentFiles: function updateCustomComponentFiles(appId, containerName, id, files) {
      return req.put(routes.containerCustomComponentFileContent(appId, containerName, id), {
        files: files
      });
    },
    uploadCustomComponentFiles: function uploadCustomComponentFiles(appId, containerName, id, data) {
      return req.post(routes.containerCustomComponentFiles(appId, containerName, id), data);
    },
    getCustomComponentFileDownloadLink: function getCustomComponentFileDownloadLink(appId, containerName, id, fileId) {
      return req.get(routes.containerCustomComponentFilesDownloadLink(appId, containerName, id)).query({
        fileId: fileId
      });
    },
    //-- CUSTOM COMPONENTS -----//
    //-- FUNCTIONS -----//
    loadContainerFunctions: function loadContainerFunctions(appId, containerName) {
      return req.get(routes.containerFunctions(appId, containerName));
    },
    createContainerFunction: function createContainerFunction(appId, containerName, fn) {
      return req.post(routes.containerFunctions(appId, containerName), fn);
    },
    updateContainerFunction: function updateContainerFunction(appId, containerName, id, definition) {
      return req.put(routes.containerFunction(appId, containerName, id), definition);
    },
    deleteContainerFunction: function deleteContainerFunction(appId, containerName, id) {
      return req["delete"](routes.containerFunction(appId, containerName, id));
    },
    deleteContainerFunctionsPack: function deleteContainerFunctionsPack(appId, containerName, productId) {
      return req["delete"](routes.removeFunctionsPack(appId, containerName, productId));
    },
    loadContainerFunctionLogic: function loadContainerFunctionLogic(appId, containerName, id) {
      return req.get(routes.containerFunctionLogic(appId, containerName, id));
    },
    updateContainerFunctionLogic: function updateContainerFunctionLogic(appId, containerName, id, data) {
      return req.put(routes.containerFunctionLogic(appId, containerName, id), data);
    },
    installCustomFunctionsFromMarketplace: function installCustomFunctionsFromMarketplace(appId, containerName, productId) {
      return req.post(routes.installCustomFunctionsFromMarketplace(appId, containerName, productId));
    },
    //-- FUNCTIONS -----//
    saveAutomationsTriggers: function saveAutomationsTriggers(appId, containerName, triggers) {
      return req.put(routes.containerAutomations(appId, containerName), triggers);
    }
  };
};
exports["default"] = _default;