"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var UNITS_CONVERTERS = {
  miles: 'mi',
  yards: 'yd',
  kilometers: 'km',
  meters: 'km'
};
var RADIUS_CONVERTERS = {
  meters: function meters(value) {
    return value / 1000;
  }
};
var SQL = {
  and: function and() {
    for (var _len = arguments.length, tokens = new Array(_len), _key = 0; _key < _len; _key++) {
      tokens[_key] = arguments[_key];
    }
    var result = tokens.reduce(function (memo, token) {
      if (token) {
        memo = memo ? "".concat(memo, " AND (").concat(token, ")") : token;
      }
      return memo;
    }, '');
    return result ? result : undefined;
  },
  "in": function _in(name, items) {
    var tokens = items.map(function (item) {
      return typeof item === 'string' ? "'".concat(item, "'") : item;
    });
    return items.length ? "(".concat(name, " IN (").concat(tokens.join(', '), "))") : undefined;
  },
  distance: function distance(lat, lng, unit, radius) {
    var u = UNITS_CONVERTERS[unit];
    var r = RADIUS_CONVERTERS[unit] ? RADIUS_CONVERTERS[unit](radius) : radius;
    return "distance(".concat(lat, ", ").concat(lng, ", latitude, longitude) < ").concat(u, "(").concat(r, ")");
  }
};
var _default = SQL;
exports["default"] = _default;