"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.billingAPI = billingAPI;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _routes = require("./routes");
var _payments = require("./payments");
var _limits = require("./limits");
var _plans = require("./plans");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function billingAPI(req) {
  return _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, (0, _payments.billingPaymentsAPI)(req)), (0, _limits.billingLimitsAPI)(req)), (0, _plans.billingPlansAPI)(req)), {}, {
    getAppBillingInfo: function getAppBillingInfo(appId) {
      return req.billing.get(_routes.routes.appBillingInfo(appId));
    },
    getAutomationBillingInfo: function getAutomationBillingInfo(appId) {
      return req.billing.get(_routes.routes.automationBillingInfo(appId));
    },
    getSubscriptionStatus: function getSubscriptionStatus(appId) {
      return req.billing.get(_routes.routes.subscriptionStatus(appId));
    },
    loadSubscriptionsInfo: function loadSubscriptionsInfo() {
      return req.billing.get(_routes.routes.devSubscriptionsInfo());
    },
    getAppBillingPeriodInfo: function getAppBillingPeriodInfo(appId) {
      return req.billing.get(_routes.routes.appBillingPeriodInfo(appId));
    },
    getAutomationBillingPeriodInfo: function getAutomationBillingPeriodInfo(appId) {
      return req.billing.get(_routes.routes.automationBillingPeriodInfo(appId));
    } // TODO: seems like we do not use the function
    // getInviteCode(appId) {
    //   return req.billing.get(routes.inviteCode(appId))
    // },
  });
}