"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.billingPlansAPI = billingPlansAPI;
var _routes = require("./routes");
function billingPlansAPI(req) {
  return {
    getAppPlans: function getAppPlans(appId) {
      return req.billing.get(_routes.routes.appBillingPlans(appId));
    },
    getAutomationPlans: function getAutomationPlans(appId) {
      return req.billing.get(_routes.routes.automationBillingPlans(appId));
    },
    switchToAppPlan: function switchToAppPlan(appId, planId, billingPeriod) {
      return req.billing.put(_routes.routes.switchAppPlan(appId, planId, billingPeriod));
    },
    switchToAutomationPlan: function switchToAutomationPlan(appId, planId, billingPeriod) {
      return req.billing.put(_routes.routes.switchAutomationPlan(appId, planId, billingPeriod));
    },
    unlockPlan: function unlockPlan(appId, planId) {
      return req.billing.put(_routes.routes.unlockPlan(appId, planId));
    }
  };
}