"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _urls = _interopRequireDefault(require("./urls"));
var _default = function _default(req) {
  return {
    getCharts: function getCharts(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/chart-builder"));
    },
    createChart: function createChart(appId, chartSource, chartTarget) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/chart-builder/chart"), {
        chartSource: chartSource,
        chartTarget: chartTarget
      });
    },
    updateChart: function updateChart(appId, chartSource, chartTarget) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/chart-builder/chart/").concat(chartSource.name), {
        chartSource: chartSource,
        chartTarget: chartTarget
      });
    },
    deleteChart: function deleteChart(appId, chartName) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/chart-builder/chart/").concat(chartName));
    },
    renameChart: function renameChart(appId, oldChartName, newChartName) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/chart-builder/rename-chart"), {
        oldChartName: oldChartName,
        newChartName: newChartName
      });
    }
  };
};
exports["default"] = _default;