"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CACHE_PATH = void 0;
var _isObject2 = _interopRequireDefault(require("lodash/isObject"));
var _urls = _interopRequireDefault(require("./urls"));
var GENERATORS_PATH = 'codegen/features/generators';
var JSON_PATTERN = '*.json';
var PAGE_SIZE = 100;
var CACHE_PATH = 'codegen/cache.json';

// TODO: remove this transformation when the format of options will be changed
exports.CACHE_PATH = CACHE_PATH;
var OPTION_NAMES_MAP = {
  'selections': 'options',
  'default': 'defaultValue',
  'tooltip': 'hint'
};
// TODO: remove this transformation when the format of options will be changed
var normalizeOptions = function normalizeOptions(options) {
  return options && options.map(normalizeOption);
};
// TODO: remove this transformation when the format of options will be changed
var normalizeOption = function normalizeOption(option) {
  for (var key in option) {
    var normalizeName = OPTION_NAMES_MAP[key];
    if (normalizeName) {
      option[normalizeName] = option[key];
      delete option[key];
    }
  }
  return option;
};
var _default = function _default(req) {
  return {
    getGeneratedProject: function getGeneratedProject(appId, codegenData) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/codegen"), codegenData);
    },
    getGenerators: function getGenerators(appId) {
      var listGenerators = function listGenerators(appId) {
        return req.api.files.loadDirectory(appId, GENERATORS_PATH, {
          pattern: JSON_PATTERN,
          sub: false,
          pageSize: PAGE_SIZE
        });
      };
      var getFeatureFile = function getFeatureFile(file) {
        return req.get(_urls["default"].fileView(appId, file.url)).then(function (feature) {
          if ((0, _isObject2["default"])(feature) && !Array.isArray(feature)) {
            // TODO: remove this transformation when the format of options will be changes
            feature.options = normalizeOptions(feature.options);
            return feature;
          } else {
            return {
              error: file.name
            };
          }
        })["catch"](function () {
          return undefined;
        });
      };
      return listGenerators(appId).then(function (_ref) {
        var data = _ref.data;
        return Promise.all(data.map(getFeatureFile));
      }).then(function (features) {
        return features.filter(function (feature) {
          return !!feature;
        });
      });
    },
    getCache: function getCache(appId) {
      return req.get(_urls["default"].fileView(appId, CACHE_PATH));
    }
  };
};
exports["default"] = _default;