"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _urls = _interopRequireDefault(require("./urls"));
var _default = function _default(req) {
  return {
    loadApiServices: function loadApiServices(appId) {
      return req.get(_urls["default"].codelessApiServices(appId));
    },
    loadFunctions: function loadFunctions(appId) {
      return req.get(_urls["default"].codelessFunctions(appId));
    },
    createFunction: function createFunction(appId, fn) {
      return req.post(_urls["default"].codelessFunctions(appId), fn);
    },
    loadFunctionSource: function loadFunctionSource(appId, functionId) {
      return req.get(_urls["default"].codelessFunctionSource(appId, functionId));
    },
    updateFunctionSource: function updateFunctionSource(appId, functionId, xml, code, definition) {
      return req.put(_urls["default"].codelessFunctionSource(appId, functionId), {
        xml: xml,
        code: code,
        definition: definition
      });
    },
    removeFunctionSource: function removeFunctionSource(appId, functionId) {
      return req["delete"](_urls["default"].codelessFunctionSource(appId, functionId));
    },
    deployCodelessModel: function deployCodelessModel(appId, model, items) {
      return req.post(_urls["default"].codelessDeployModel(appId, model), items);
    }
  };
};
exports["default"] = _default;