"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _urls = _interopRequireDefault(require("./urls"));
var _totalRows = _interopRequireDefault(require("./utils/total-rows"));
var _table = require("./utils/table");
var recordsReq = function recordsReq(req, appId, connectorId, table, query, resetCache) {
  var url = "".concat(_urls["default"].dataConnectorTableEntries(appId, connectorId, table.name), "/find");
  return (0, _table.tableRecordsReq)(req, url, table, query, resetCache);
};
var recordsCountReq = function recordsCountReq(req, appId, connectorId, table, query, resetCache) {
  var url = _urls["default"].dataConnectorTableEntries(appId, connectorId, table.name);
  return (0, _table.tableRecordsReq)(req, url, table, query, resetCache);
};
var _default = function _default(req) {
  return {
    getTemplates: function getTemplates(appId) {
      return req.get(_urls["default"].dataConnectorTemplates(appId));
    },
    getConnectors: function getConnectors(appId, forceRefresh) {
      return req.get(_urls["default"].dataConnectors(appId)).query({
        forceRefresh: forceRefresh
      });
    },
    activateConnector: function activateConnector(appId, connector) {
      return req.post(_urls["default"].dataConnectors(appId), connector);
    },
    deleteConnector: function deleteConnector(appId, connectorId) {
      return req["delete"](_urls["default"].dataConnector(appId, connectorId));
    },
    updateConnector: function updateConnector(appId, connector) {
      return req.put(_urls["default"].dataConnector(appId, connector.id), connector);
    },
    getConnectorTables: function getConnectorTables(appId, connectorId, query) {
      return req.get(_urls["default"].dataConnectorTables(appId, connectorId)).query(query);
    },
    getConnectorTableEntries: function getConnectorTableEntries(appId, connectorId, table, query) {
      return recordsReq(req, appId, connectorId, table, query);
    },
    getConnectorTableEntriesCount: function getConnectorTableEntriesCount(appId, connectorId, table, query, resetCache) {
      return (0, _totalRows["default"])(req).getFor(recordsCountReq(req, appId, connectorId, table, query, resetCache));
    },
    getConnectorStoredProcedures: function getConnectorStoredProcedures(appId, connectorId) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      return req.get(_urls["default"].dataConnectorStoredProcedures(appId, connectorId)).query({
        forceRefresh: options.forceRefresh
      });
    },
    executeConnectorStoredProcedure: function executeConnectorStoredProcedure(appId, connectorId, procedureId, params) {
      return req.post(_urls["default"].dataConnectorStoredProcedureExecution(appId, connectorId, procedureId), params);
    }
  };
};
exports["default"] = _default;