"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.recordsReq = exports.recordsCountReq = exports.groupRecordsReq = exports.groupRecordsCountReq = exports["default"] = void 0;
var _urls = _interopRequireWildcard(require("./urls"));
var _views = require("./utils/views");
var _totalRows = _interopRequireDefault(require("./utils/total-rows"));
var _table = require("./utils/table");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var dataTableFindUrl = function dataTableFindUrl(appId, tableName) {
  return "".concat((0, _urls.dataTable)(appId, tableName), "/find");
};
var recordsReq = function recordsReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var resetCache = arguments.length > 4 ? arguments[4] : undefined;
  return (0, _views.viewRecordsReq)(req, dataTableFindUrl(appId, view.name), view, query, resetCache);
};
exports.recordsReq = recordsReq;
var recordsCountReq = function recordsCountReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var resetCache = arguments.length > 4 ? arguments[4] : undefined;
  return (0, _views.viewRecordsCountReq)(req, (0, _urls.dataTable)(appId, view.name), view, query, resetCache);
};
exports.recordsCountReq = recordsCountReq;
var groupRecordsReq = function groupRecordsReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  return (0, _views.viewRecordsGroupReq)(req, (0, _urls.dataTableGroup)(appId, view.name), view.viewId, query);
};
exports.groupRecordsReq = groupRecordsReq;
var groupRecordsCountReq = function groupRecordsCountReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  return (0, _views.viewRecordsGroupCountReq)(req, (0, _urls.dataTableGroupCount)(appId, view.name), query);
};
exports.groupRecordsCountReq = groupRecordsCountReq;
var _default = function _default(req) {
  return {
    getViews: function getViews(appId) {
      return req.get((0, _urls.dataViews)(appId));
    },
    getViewRecords: function getViewRecords(appId, viewName) {
      return req.get("".concat((0, _urls.dataViews)(appId), "/").concat(viewName));
    },
    createView: function createView(appId, view) {
      return req.post((0, _urls.dataViews)(appId), view);
    },
    updateView: function updateView(appId, view) {
      return req.put((0, _urls.dataViews)(appId, view.viewId), view);
    },
    renameView: function renameView(appId, viewId, name) {
      return req.put("".concat((0, _urls.dataViews)(appId, viewId), "/name"), {
        name: name
      });
    },
    deleteView: function deleteView(appId, viewId) {
      return req["delete"]((0, _urls.dataViews)(appId, viewId));
    },
    loadRecords: function loadRecords(appId, view, query) {
      return recordsReq(req, appId, view, query);
    },
    getRecordsCount: function getRecordsCount(appId, view, query, resetCache) {
      return (0, _totalRows["default"])(req).getViaPostFor(recordsCountReq(req, appId, view, query, resetCache));
    },
    getRecordsCounts: function getRecordsCounts(appId, views, resetCache) {
      return req.post("".concat(_urls["default"].data(appId), "/tables-counters"), {
        tables: views,
        resetCache: resetCache
      });
    },
    loadGroupRecords: function loadGroupRecords(appId, view, query) {
      return groupRecordsReq(req, appId, view, query);
    },
    getGroupRecordsCount: function getGroupRecordsCount(appId, view, query) {
      return groupRecordsCountReq(req, appId, view, query);
    },
    loadSampleRecords: function loadSampleRecords(appId, table) {
      var query = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var params = (0, _table.composeRequestParams)(table, query);
      return req.post("".concat(_urls["default"].data(appId), "/table-pre-view/").concat(encodeURI(table.name), "/find"), params);
    }
  };
};
exports["default"] = _default;