"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _urls = _interopRequireWildcard(require("./urls"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var _default = function _default(req) {
  return {
    getDevelopers: function getDevelopers(appId) {
      return req.get((0, _urls.devTeam)(appId));
    },
    updateDevPermissions: function updateDevPermissions(appId, devId, permissions) {
      return req.put("".concat((0, _urls.devTeam)(appId, devId), "/permissions"), permissions);
    },
    updateDevPermissionGroups: function updateDevPermissionGroups(appId, devId, groups) {
      return req.put("".concat((0, _urls.devTeam)(appId, devId), "/permission/groups"), groups);
    },
    inviteDeveloper: function inviteDeveloper(appId, email) {
      return req.post((0, _urls.devTeam)(appId), email);
    },
    removeDeveloper: function removeDeveloper(appId, devId) {
      return req["delete"]("".concat((0, _urls.devTeam)(appId, devId)));
    },
    updateNotificationSettings: function updateNotificationSettings(appId, settings) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/notifications/limits"), settings);
    },
    transferOwnership: function transferOwnership(appId, developerId) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/devteam/owner"), {
        developerId: developerId
      });
    },
    loadOwnershipTransferProposals: function loadOwnershipTransferProposals() {
      return req.get('/console/devteam/application-owner-change/pending-received-proposal');
    },
    confirmOwnershipChange: function confirmOwnershipChange(appId, data) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/devteam/owner-confirm"), data);
    },
    loadSentOwnershipTransfer: function loadSentOwnershipTransfer(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/devteam/application-owner-change/pending-sent-proposal"));
    },
    cancelSentOwnershipTransfer: function cancelSentOwnershipTransfer(appId) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/devteam/application-owner-change/pending-sent-proposal"));
    },
    generateDeveloperSignature: function generateDeveloperSignature() {
      return req.get("".concat(_urls["default"].console(), "/developer/signature"));
    }
  };
};
exports["default"] = _default;