"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _routes = require("./utils/routes");
var routes = (0, _routes.prepareRoutes)({
  getProfile: '/console/community/profile/me',
  removeProfile: '/console/community/profile/me',
  removeApp: '/console/community/profile/app',
  setProfile: '/console/community/profile',
  getCountries: '/console/community/countries',
  checkUsername: '/console/community/profile/username/check'
});
var _default = function _default(req) {
  return {
    getMyProfile: function getMyProfile() {
      return req.community.get(routes.getProfile());
    },
    createProfile: function createProfile(profileData) {
      return req.community.post(routes.setProfile(), profileData);
    },
    updateProfile: function updateProfile(profileData) {
      return req.community.put(routes.setProfile(), profileData);
    },
    getCountries: function getCountries() {
      return req.community.get(routes.getCountries());
    },
    updateProfilePhoto: function updateProfilePhoto(profilePhoto) {
      return req.community.post(routes.setProfile(), profilePhoto);
    },
    checkUsernameAvailable: function checkUsernameAvailable(userName) {
      return req.community.get(routes.checkUsername()).query({
        userName: userName
      });
    },
    updateProfileBackground: function updateProfileBackground(background) {
      return req.community.post(routes.setProfile(), background);
    },
    remove: function remove() {
      return req.community["delete"](routes.removeProfile());
    },
    removeApp: function removeApp(appId) {
      return req.community["delete"](routes.removeApp()).query({
        appId: appId
      });
    }
  };
};
exports["default"] = _default;