"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _urls = _interopRequireDefault(require("./urls"));
var _default = function _default(req) {
  return {
    loadEmailTemplates: function loadEmailTemplates(appId) {
      return this.loadTemplates(appId);
    },
    loadTemplates: function loadTemplates(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/email"));
    },
    saveEmailTemplate: function saveEmailTemplate(appId, template) {
      return this.saveTemplate(appId, template);
    },
    saveTemplate: function saveTemplate(appId, template) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/email/events"), template);
    },
    sendTestEmail: function sendTestEmail(appId, emailData) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/email/events/test"), emailData);
    },
    updateEmailParams: function updateEmailParams(appId, emailSettings) {
      return req.put(_urls["default"].mailSettings(appId), emailSettings);
    },
    resetEmailParams: function resetEmailParams(appId) {
      return req["delete"](_urls["default"].mailSettings(appId));
    },
    getEmailParams: function getEmailParams(appId) {
      return req.get(_urls["default"].mailSettings(appId));
    },
    testSMTPConnection: function testSMTPConnection(appId, emailSettings) {
      return req.put("".concat(_urls["default"].mailSettings(appId), "/test"), emailSettings);
    },
    loadCustomTemplates: function loadCustomTemplates(appId) {
      return req.get(_urls["default"].emailTemplates(appId));
    },
    createCustomTemplate: function createCustomTemplate(appId, payload) {
      return req.post(_urls["default"].emailTemplates(appId), payload);
    },
    updateCustomTemplate: function updateCustomTemplate(appId, payload, templateName) {
      return req.put(_urls["default"].emailTemplates(appId, templateName), payload);
    },
    deleteCustomTemplate: function deleteCustomTemplate(appId, templateName) {
      return req["delete"](_urls["default"].emailTemplates(appId, templateName));
    },
    sendTestCustomEmail: function sendTestCustomEmail(appId, payload) {
      return req.post("".concat(_urls["default"].emailTemplates(appId), "/test"), payload);
    },
    parseCustomTemplateKeys: function parseCustomTemplateKeys(appId, payload) {
      return req.post("".concat(_urls["default"].emailTemplates(appId), "/customkeys"), payload);
    },
    installEmailTemplateFromMarketplace: function installEmailTemplateFromMarketplace(appId, productId, data) {
      return req.post(_urls["default"].installEmailTemplate(appId, productId), data);
    },
    resetSystemEmailTemplate: function resetSystemEmailTemplate(appId, eventId) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/email/events/").concat(eventId));
    }
  };
};
exports["default"] = _default;