"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _routes = require("./utils/routes");
var routes = (0, _routes.prepareRoutes)({
  chatCompletionCreate: '/:appId/console/open-ai/chat-completion/:featureName',
  info: '/:appId/console/open-ai/info/:featureName',
  dashboardDataVisualizations: '/:appId/console/open-ai/dashboards/data-visualizations'
});
var _default = function _default(req) {
  return {
    createChatCompletion: function createChatCompletion(appId, featureName, payload) {
      return req.post(routes.chatCompletionCreate(appId, featureName), payload);
    },
    getUsageInfo: function getUsageInfo(appId, featureName) {
      return req.get(routes.info(appId, featureName));
    },
    generateDashboardDataVisualizations: function generateDashboardDataVisualizations(appId, payload) {
      return req.post(routes.dashboardDataVisualizations(appId), payload);
    },
    getDashboardDataVisualizationsPrompt: function getDashboardDataVisualizationsPrompt(appId) {
      return req.get(routes.dashboardDataVisualizations(appId));
    }
  };
};
exports["default"] = _default;