"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _routes = require("./utils/routes");
var routes = (0, _routes.prepareRoutes)({
  generatePDF: '/api/app/:appId/pdf/generate',
  templates: '/:appId/console/pdf',
  template: '/:appId/console/pdf/:templateId'
});
var _default = function _default(req) {
  return {
    generatePDF: function generatePDF(appId, pdf, inputs) {
      return req.post(routes.generatePDF(appId), {
        pdf: pdf,
        inputs: inputs
      });
    },
    listTemplates: function listTemplates(appId) {
      return req.get(routes.templates(appId));
    },
    loadTemplate: function loadTemplate(appId, templateId) {
      return req.get(routes.template(appId, templateId));
    },
    createTemplate: function createTemplate(appId, template) {
      return req.post(routes.templates(appId), template);
    },
    updateTemplate: function updateTemplate(appId, template) {
      return req.put(routes.template(appId, template.id), template);
    },
    deleteTemplate: function deleteTemplate(appId, templateId) {
      return req["delete"](routes.template(appId, templateId));
    }
  };
};
exports["default"] = _default;