"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.users = exports.userActivity = exports.tableColumns = exports.serverCode = exports.securityRoles = exports.security = exports.oauth2 = exports.oauth1 = exports.oauth0Config = exports.oauth0Binding = exports.oauth0 = exports.mobileSettingsAndroid = exports.mobileSettings = exports.messagingPushTemplates = exports.messagingPushTemplate = exports.messagingPushRecipientsCount = exports.messagingPushChannelTemplates = exports.messagingPushChannelTemplate = exports.messagingPushButtonTemplates = exports.messagingPushButtonTemplate = exports.messagingPush = exports.messagingChannels = exports.messagingChannel = exports.messaging = exports.marketplace = exports.mailSettings = exports.landingPage = exports.installEmailTemplate = exports.geo = exports.gamificationApp = exports.gamification = exports.files = exports.fileView = exports.fileUpload = exports.fileRename = exports.fileMove = exports.fileExists = exports.fileEdit = exports.fileDownload = exports.fileDelete = exports.fileCreate = exports.fileCopy = exports.emailTemplates = exports.downloadComplianceFile = exports.directoryView = exports.devTeam = exports["default"] = exports.dataViews = exports.dataToVisualize = exports.dataTables = exports.dataTableGroupCount = exports.dataTableGroup = exports.dataTableBulkUpsert = exports.dataTableBulkCreate = exports.dataTable = exports.dataRecord = exports.dataHives = exports.dataHiveStoreKey = exports.dataHiveStore = exports.dataHive = exports.dataConnectors = exports.dataConnectorTemplates = exports.dataConnectorTables = exports.dataConnectorTableEntries = exports.dataConnectorStoredProcedures = exports.dataConnectorStoredProcedureExecution = exports.dataConnector = exports.dataConfigs = exports.dataCell = exports.data = exports.createDir = exports.console = exports.codelessFunctions = exports.codelessFunctionSource = exports.codelessDeployModel = exports.codelessApiServices = exports.codeless = exports.cache = exports.blueprints = exports.blServicesClientDownload = exports.blProd = exports.blHandlersChain = exports.blHandlersCategory = exports.blDraftsProjectDownload = exports.blDraft = exports.blBasePath = exports.billing = exports.atomicCounters = exports.appInfo = exports.appConsole = exports.apiDocsService = exports.apiDocsMessagingChannel = exports.apiDocsGeo = exports.apiDocsFiles = exports.apiDocsDataTable = exports.apiDocs = void 0;
var _path = require("./utils/path");
/* eslint-disable max-len */

var console = function console(authKey) {
  return "/console".concat((0, _path.optional)(authKey));
};
exports.console = console;
var appConsole = function appConsole(appId, authKey) {
  return "/".concat(appId).concat(console(authKey));
};
exports.appConsole = appConsole;
var consoleSection = function consoleSection(section) {
  return function (appId) {
    return "".concat(appConsole(appId), "/").concat(section);
  };
};
var mailSettings = consoleSection('mailsettings');
exports.mailSettings = mailSettings;
var security = consoleSection('security');
exports.security = security;
var serverCode = consoleSection('servercode');
exports.serverCode = serverCode;
var blBasePath = consoleSection('localservices');
exports.blBasePath = blBasePath;
var data = consoleSection('data');
exports.data = data;
var geo = consoleSection('geo');
exports.geo = geo;
var files = consoleSection('files');
exports.files = files;
var messaging = consoleSection('messaging');
exports.messaging = messaging;
var dataTables = function dataTables(appId) {
  return "".concat(data(appId), "/tables");
};
exports.dataTables = dataTables;
var dataTable = function dataTable(appId, tableName) {
  return "".concat(data(appId), "/").concat(encodeURI(tableName));
};
exports.dataTable = dataTable;
var dataTableBulkCreate = function dataTableBulkCreate(appId, tableName) {
  return "".concat(data(appId), "/bulk/").concat(encodeURI(tableName));
};
exports.dataTableBulkCreate = dataTableBulkCreate;
var dataTableBulkUpsert = function dataTableBulkUpsert(appId, tableName) {
  return "".concat(data(appId), "/bulkupsert/").concat(encodeURI(tableName));
};
exports.dataTableBulkUpsert = dataTableBulkUpsert;
var dataTableGroup = function dataTableGroup(appId, tableName) {
  return "".concat(data(appId), "/data-grouping/").concat(encodeURI(tableName));
};
exports.dataTableGroup = dataTableGroup;
var dataTableGroupCount = function dataTableGroupCount(appId, tableName) {
  return "".concat(dataTableGroup(appId, tableName), "/count");
};
exports.dataTableGroupCount = dataTableGroupCount;
var dataRecord = function dataRecord(appId, tableName, recordId) {
  return "".concat(dataTable(appId, tableName), "/").concat(recordId);
};
exports.dataRecord = dataRecord;
var dataCell = function dataCell(appId, tableName, recordId, columnName) {
  return "".concat(dataRecord(appId, tableName, recordId), "/").concat(columnName);
};
exports.dataCell = dataCell;
var dataConfigs = function dataConfigs(appId) {
  return "".concat(data(appId), "/config");
};
exports.dataConfigs = dataConfigs;
var tableColumns = function tableColumns(appId, tableName) {
  return "".concat(dataTables(appId), "/").concat(encodeURI(tableName), "/columns");
};
exports.tableColumns = tableColumns;
var securityRoles = function securityRoles(appId) {
  return "".concat(security(appId), "/roles");
};
exports.securityRoles = securityRoles;
var generalizeEventCategory = function generalizeEventCategory(category) {
  return !category || category === 'TIMER' ? 'timers' : 'events';
};
var blHandlersCategory = function blHandlersCategory(appId, mode, category) {
  return "".concat(serverCode(appId), "/").concat(mode.toLowerCase(), "/").concat(generalizeEventCategory(category));
};
exports.blHandlersCategory = blHandlersCategory;
var blHandlersChain = function blHandlersChain(appId, eventId, context) {
  return "".concat(serverCode(appId), "/chain/").concat(eventId, "/").concat(context);
};
exports.blHandlersChain = blHandlersChain;
var composeFileUrl = function composeFileUrl(appId, operation, filePath) {
  var routeParts = [files(appId)];
  if (operation) {
    routeParts.push(operation);
  }
  routeParts.push((0, _path.encodePath)(filePath), '');
  return routeParts.join('/');
};
var fileExists = function fileExists(appId, filePath) {
  return composeFileUrl(appId, 'exists', filePath);
};
exports.fileExists = fileExists;
var fileEdit = function fileEdit(appId, filePath) {
  return composeFileUrl(appId, 'edit', filePath);
};
exports.fileEdit = fileEdit;
var fileMove = function fileMove(appId, filePath) {
  return composeFileUrl(appId, 'move', filePath);
};
exports.fileMove = fileMove;
var fileCopy = function fileCopy(appId, filePath) {
  return composeFileUrl(appId, 'copy', filePath);
};
exports.fileCopy = fileCopy;
var fileRename = function fileRename(appId, filePath) {
  return composeFileUrl(appId, 'rename', filePath);
};
exports.fileRename = fileRename;
var fileDelete = function fileDelete(appId, filePath) {
  return composeFileUrl(appId, null, filePath);
};
exports.fileDelete = fileDelete;
var fileCreate = function fileCreate(appId, filePath) {
  return composeFileUrl(appId, 'create', filePath);
};
exports.fileCreate = fileCreate;
var fileUpload = function fileUpload(appId, filePath) {
  return composeFileUrl(appId, 'upload', filePath);
};
exports.fileUpload = fileUpload;
var fileView = function fileView(appId, filePath) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (filePath && !filePath.startsWith('/')) {
    filePath = "/".concat(filePath);
  }
  return "".concat(options.host || '').concat(appConsole(appId), "/files/view").concat((0, _path.encodePath)(filePath));
};
exports.fileView = fileView;
var fileDownload = function fileDownload(appId, filePath) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return "".concat(options.host || '').concat(appConsole(appId), "/files/download/").concat((0, _path.encodePath)(filePath));
};
exports.fileDownload = fileDownload;
var createDir = function createDir(appId, path, folderName) {
  path = path ? "".concat(path, "/") : '';
  var dirPath = (0, _path.encodePath)(path + folderName);
  return "".concat(files(appId), "/createdir/").concat(dirPath, "/");
};
exports.createDir = createDir;
var directoryView = function directoryView(appId, filePath) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (filePath && filePath.startsWith('/')) {
    filePath = filePath.slice(1);
  }
  if (filePath.endsWith('/')) {
    filePath = filePath.slice(0, -1);
  }
  return "".concat(options.host || '').concat(appConsole(appId), "/files/directory/view").concat((0, _path.optional)((0, _path.encodePath)(filePath)));
};
exports.directoryView = directoryView;
var blProd = function blProd(appId, language, model) {
  return "".concat(serverCode(appId), "/").concat(model, "/production/").concat(language);
};
exports.blProd = blProd;
var blDraft = function blDraft(appId, language, model) {
  return "".concat(serverCode(appId), "/").concat(model, "/draft/").concat(language);
};
exports.blDraft = blDraft;
var blDraftsProjectDownload = function blDraftsProjectDownload(appId, authKey, language, model) {
  return "".concat(appConsole(appId, authKey), "/servercode/").concat(model, "/draft/").concat(language, "/download");
};
exports.blDraftsProjectDownload = blDraftsProjectDownload;
var blServicesClientDownload = function blServicesClientDownload(appId, authKey, serviceId, language) {
  return "".concat(appConsole(appId, authKey), "/localservices/").concat(serviceId, "/").concat(language, "/download");
};
exports.blServicesClientDownload = blServicesClientDownload;
var messagingChannels = function messagingChannels(appId) {
  return "".concat(messaging(appId), "/channels");
};
exports.messagingChannels = messagingChannels;
var messagingPush = function messagingPush(appId) {
  return "".concat(messaging(appId), "/push");
};
exports.messagingPush = messagingPush;
var messagingPushRecipientsCount = function messagingPushRecipientsCount(appId) {
  return "".concat(messaging(appId), "/pushsize");
};
exports.messagingPushRecipientsCount = messagingPushRecipientsCount;
var messagingPushTemplates = function messagingPushTemplates(appId) {
  return "".concat(messagingPush(appId), "/templates");
};
exports.messagingPushTemplates = messagingPushTemplates;
var messagingPushTemplate = function messagingPushTemplate(appId, name) {
  return "".concat(messagingPushTemplates(appId), "/").concat(name);
};
exports.messagingPushTemplate = messagingPushTemplate;
var messagingPushButtonTemplates = function messagingPushButtonTemplates(appId) {
  return "".concat(messaging(appId), "/button-templates");
};
exports.messagingPushButtonTemplates = messagingPushButtonTemplates;
var messagingPushButtonTemplate = function messagingPushButtonTemplate(appId, name) {
  return "".concat(messagingPushButtonTemplates(appId), "/").concat(name);
};
exports.messagingPushButtonTemplate = messagingPushButtonTemplate;
var messagingPushChannelTemplates = function messagingPushChannelTemplates(appId) {
  return "".concat(messaging(appId), "/channel-templates");
};
exports.messagingPushChannelTemplates = messagingPushChannelTemplates;
var messagingPushChannelTemplate = function messagingPushChannelTemplate(appId, name) {
  return "".concat(messagingPushChannelTemplates(appId), "/").concat(name);
};
exports.messagingPushChannelTemplate = messagingPushChannelTemplate;
var messagingChannel = function messagingChannel(appId, channelId) {
  return "".concat(messagingChannels(appId), "/").concat(channelId);
};
exports.messagingChannel = messagingChannel;
var mobileSettings = function mobileSettings(appId) {
  return "".concat(appConsole(appId), "/mobilesettings");
};
exports.mobileSettings = mobileSettings;
var mobileSettingsAndroid = function mobileSettingsAndroid(appId, id) {
  return "".concat(mobileSettings(appId), "/android").concat((0, _path.optional)(id));
};
exports.mobileSettingsAndroid = mobileSettingsAndroid;
var billing = function billing(appId) {
  console.warn('DO NOT USE THE FUNCTION');
  return "".concat(appConsole(appId), "/billing");
};
exports.billing = billing;
var marketplace = function marketplace(appId, name) {
  return "".concat(appConsole(appId), "/marketplace/").concat(name);
};
exports.marketplace = marketplace;
var appInfo = function appInfo(appId) {
  return "".concat(appConsole(appId), "/app-info");
};
exports.appInfo = appInfo;
var blueprints = function blueprints(id) {
  return "".concat(console(), "/blueprints").concat((0, _path.optional)(id));
};
exports.blueprints = blueprints;
var landingPage = function landingPage(appId) {
  return "".concat(appConsole(appId), "/landing-page");
};
exports.landingPage = landingPage;
var codeless = function codeless(appId) {
  return "".concat(appConsole(appId), "/codeless");
};
exports.codeless = codeless;
var codelessApiServices = function codelessApiServices(appId) {
  return "".concat(codeless(appId), "/api-services");
};
exports.codelessApiServices = codelessApiServices;
var codelessFunctions = function codelessFunctions(appId) {
  return "".concat(codeless(appId), "/functions");
};
exports.codelessFunctions = codelessFunctions;
var codelessFunctionSource = function codelessFunctionSource(appId, name) {
  return "".concat(codelessFunctions(appId), "/").concat(name);
};
exports.codelessFunctionSource = codelessFunctionSource;
var codelessDeployModel = function codelessDeployModel(appId, model) {
  return "".concat(codeless(appId), "/deploy/").concat(model);
};
exports.codelessDeployModel = codelessDeployModel;
var dataViews = function dataViews(appId, id) {
  return "".concat(appConsole(appId), "/data/table-views").concat((0, _path.optional)(id));
};
exports.dataViews = dataViews;
var dataHives = function dataHives(appId) {
  return "".concat(appConsole(appId), "/hive");
};
exports.dataHives = dataHives;
var dataHive = function dataHive(appId, hiveName) {
  return "".concat(dataHives(appId), "/").concat(hiveName);
};
exports.dataHive = dataHive;
var dataHiveStore = function dataHiveStore(appId, hiveName, storeType) {
  return "".concat(dataHive(appId, hiveName), "/").concat(storeType);
};
exports.dataHiveStore = dataHiveStore;
var dataHiveStoreKey = function dataHiveStoreKey(appId, hiveName, storeType, keyName) {
  return "".concat(dataHiveStore(appId, hiveName, storeType), "/").concat(keyName);
};
exports.dataHiveStoreKey = dataHiveStoreKey;
var dataToVisualize = function dataToVisualize(appId) {
  return "".concat(appConsole(appId), "/data-to-visualize");
};
exports.dataToVisualize = dataToVisualize;
var dataConnectors = function dataConnectors(appId) {
  return "".concat(appConsole(appId), "/dataconnectors");
};
exports.dataConnectors = dataConnectors;
var dataConnectorTemplates = function dataConnectorTemplates(appId) {
  return "".concat(dataConnectors(appId), "/templates");
};
exports.dataConnectorTemplates = dataConnectorTemplates;
var dataConnector = function dataConnector(appId, connectorId) {
  return "".concat(dataConnectors(appId), "/").concat(connectorId);
};
exports.dataConnector = dataConnector;
var dataConnectorTables = function dataConnectorTables(appId, connectorId) {
  return "".concat(dataConnector(appId, connectorId), "/tables");
};
exports.dataConnectorTables = dataConnectorTables;
var dataConnectorTableEntries = function dataConnectorTableEntries(appId, connectorId, tableName) {
  return "".concat(dataConnectorTables(appId, connectorId), "/").concat(tableName, "/entries");
};
exports.dataConnectorTableEntries = dataConnectorTableEntries;
var dataConnectorStoredProcedures = function dataConnectorStoredProcedures(appId, connectorId) {
  return "".concat(dataConnector(appId, connectorId), "/storedprocs");
};
exports.dataConnectorStoredProcedures = dataConnectorStoredProcedures;
var dataConnectorStoredProcedureExecution = function dataConnectorStoredProcedureExecution(appId, connectorId, procedureId) {
  return "".concat(dataConnectorStoredProcedures(appId, connectorId), "/").concat(procedureId, "/execution");
};
exports.dataConnectorStoredProcedureExecution = dataConnectorStoredProcedureExecution;
var emailTemplates = function emailTemplates(appId, templateName) {
  return "".concat(appConsole(appId), "/emailtemplate").concat((0, _path.optional)(templateName));
};
exports.emailTemplates = emailTemplates;
var installEmailTemplate = function installEmailTemplate(appId, productId) {
  return "".concat(appConsole(appId), "/email-templates/install/").concat(productId);
};
exports.installEmailTemplate = installEmailTemplate;
var apiDocs = function apiDocs(appId) {
  return "".concat(appConsole(appId), "/api-docs");
};
exports.apiDocs = apiDocs;
var apiDocsDataTable = function apiDocsDataTable(appId, tableName) {
  return "".concat(apiDocs(appId), "/data/table/").concat(tableName);
};
exports.apiDocsDataTable = apiDocsDataTable;
var apiDocsMessagingChannel = function apiDocsMessagingChannel(appId, channelName) {
  return "".concat(apiDocs(appId), "/messaging/channel/").concat(channelName);
};
exports.apiDocsMessagingChannel = apiDocsMessagingChannel;
var apiDocsFiles = function apiDocsFiles(appId) {
  return "".concat(apiDocs(appId), "/files");
};
exports.apiDocsFiles = apiDocsFiles;
var apiDocsService = function apiDocsService(appId, serviceId, model) {
  return "".concat(apiDocs(appId), "/services/").concat(serviceId, "/").concat(model);
};
exports.apiDocsService = apiDocsService;
var apiDocsGeo = function apiDocsGeo(appId) {
  return "".concat(apiDocs(appId), "/geo");
};
exports.apiDocsGeo = apiDocsGeo;
var cache = function cache(appId, key) {
  return "".concat(appConsole(appId), "/cache").concat((0, _path.optional)(key));
};
exports.cache = cache;
var atomicCounters = function atomicCounters(appId) {
  return "".concat(appConsole(appId), "/counters");
};
exports.atomicCounters = atomicCounters;
var gamification = function gamification() {
  return "".concat(console(), "/gamification");
};
exports.gamification = gamification;
var gamificationApp = function gamificationApp(appId) {
  return "".concat(appConsole(appId), "/gamification");
};
exports.gamificationApp = gamificationApp;
var userActivity = function userActivity(appId) {
  return "".concat(appConsole(appId), "/user-activity");
};
exports.userActivity = userActivity;
var devTeam = function devTeam(appId, devId) {
  return "".concat(appConsole(appId), "/devteam").concat((0, _path.optional)(devId));
};
exports.devTeam = devTeam;
var users = function users(appId) {
  return "".concat(appConsole(appId), "/users");
};
exports.users = users;
var oauth1 = function oauth1(appId) {
  return "".concat(users(appId), "/oauth1");
};
exports.oauth1 = oauth1;
var oauth2 = function oauth2(appId) {
  return "".concat(users(appId), "/oauth2");
};
exports.oauth2 = oauth2;
var oauth0 = function oauth0(appId) {
  return "".concat(appConsole(appId), "/security/auth0");
};
exports.oauth0 = oauth0;
var oauth0Config = function oauth0Config(appId) {
  return "".concat(oauth0(appId), "/config");
};
exports.oauth0Config = oauth0Config;
var oauth0Binding = function oauth0Binding(appId) {
  return "".concat(oauth0(appId), "/scope-to-role");
};
exports.oauth0Binding = oauth0Binding;
var downloadComplianceFile = function downloadComplianceFile(appId, complianceName) {
  return "".concat(security(appId), "/compliances/").concat(complianceName, "/download");
};
exports.downloadComplianceFile = downloadComplianceFile;
var _default = {
  appConsole: appConsole,
  appInfo: appInfo,
  atomicCounters: atomicCounters,
  billing: billing,
  blBasePath: blBasePath,
  blDraft: blDraft,
  blDraftsProjectDownload: blDraftsProjectDownload,
  blHandlersCategory: blHandlersCategory,
  blHandlersChain: blHandlersChain,
  blProd: blProd,
  blServicesClientDownload: blServicesClientDownload,
  blueprints: blueprints,
  cache: cache,
  codelessApiServices: codelessApiServices,
  codelessDeployModel: codelessDeployModel,
  codelessFunctionSource: codelessFunctionSource,
  codelessFunctions: codelessFunctions,
  console: console,
  createDir: createDir,
  data: data,
  dataConfigs: dataConfigs,
  dataCell: dataCell,
  dataRecord: dataRecord,
  dataTable: dataTable,
  dataTableBulkCreate: dataTableBulkCreate,
  dataTableBulkUpsert: dataTableBulkUpsert,
  dataTables: dataTables,
  devTeam: devTeam,
  emailTemplates: emailTemplates,
  fileCopy: fileCopy,
  fileCreate: fileCreate,
  fileDelete: fileDelete,
  fileDownload: fileDownload,
  fileEdit: fileEdit,
  fileExists: fileExists,
  fileMove: fileMove,
  fileRename: fileRename,
  fileUpload: fileUpload,
  fileView: fileView,
  gamification: gamification,
  gamificationApp: gamificationApp,
  directoryView: directoryView,
  geo: geo,
  installEmailTemplate: installEmailTemplate,
  landingPage: landingPage,
  mailSettings: mailSettings,
  marketplace: marketplace,
  messaging: messaging,
  messagingChannel: messagingChannel,
  messagingChannels: messagingChannels,
  messagingPush: messagingPush,
  messagingPushRecipientsCount: messagingPushRecipientsCount,
  messagingPushTemplates: messagingPushTemplates,
  messagingPushTemplate: messagingPushTemplate,
  messagingPushButtonTemplates: messagingPushButtonTemplates,
  messagingPushButtonTemplate: messagingPushButtonTemplate,
  messagingPushChannelTemplates: messagingPushChannelTemplates,
  messagingPushChannelTemplate: messagingPushChannelTemplate,
  mobileSettings: mobileSettings,
  mobileSettingsAndroid: mobileSettingsAndroid,
  security: security,
  securityRoles: securityRoles,
  serverCode: serverCode,
  tableColumns: tableColumns,
  userActivity: userActivity,
  users: users,
  dataViews: dataViews,
  dataHives: dataHives,
  dataToVisualize: dataToVisualize,
  dataConnectors: dataConnectors,
  dataConnectorTemplates: dataConnectorTemplates,
  dataConnector: dataConnector,
  dataConnectorTables: dataConnectorTables,
  dataConnectorTableEntries: dataConnectorTableEntries,
  dataConnectorStoredProcedures: dataConnectorStoredProcedures,
  dataConnectorStoredProcedureExecution: dataConnectorStoredProcedureExecution,
  apiDocsDataTable: apiDocsDataTable,
  apiDocsMessagingChannel: apiDocsMessagingChannel,
  apiDocsFiles: apiDocsFiles,
  apiDocsService: apiDocsService,
  apiDocsGeo: apiDocsGeo,
  downloadComplianceFile: downloadComplianceFile
};
exports["default"] = _default;