"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prepareRoutes = prepareRoutes;
function prepareRoutes(routes) {
  var result = {};
  Object.keys(routes).forEach(function (key) {
    var tokens = routes[key].split('/');
    result[key] = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      var lastArgIndex = 0;
      var targetTokens = tokens.map(function (pathToken) {
        return pathToken.startsWith(':') ? args[lastArgIndex++] : pathToken;
      });
      var route = targetTokens.join('/');
      if (route.indexOf('/:') >= 0) {
        throw new Error("Invalid path params in route [".concat(key, "], arguments: ").concat(args));
      }
      return route;
    };
  });
  return result;
}