"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _routes = require("./utils/routes");
var routes = (0, _routes.prepareRoutes)({
  visualizations: '/:appId/console/visualizations',
  visualization: '/:appId/console/visualizations/:visualizationId',
  visualizationResources: '/:appId/console/visualizations/:visualizationId/resources',
  publishedUIBuilderContainers: '/:appId/console/visualizations/ui-builder/containers/published'
});
var _default = function _default(req) {
  return {
    getVisualizations: function getVisualizations(appId) {
      return req.get(routes.visualizations(appId));
    },
    createVisualization: function createVisualization(appId, visualization) {
      return req.post(routes.visualizations(appId), visualization);
    },
    updateVisualization: function updateVisualization(appId, visualizationId, visualization) {
      return req.put(routes.visualization(appId, visualizationId), visualization);
    },
    deleteVisualizations: function deleteVisualizations(appId, visualizationIds) {
      return req["delete"](routes.visualizations(appId)).query({
        visualizationIds: visualizationIds
      });
    },
    updateVisualizationResources: function updateVisualizationResources(appId, visualizationId) {
      return req.put(routes.visualizationResources(appId, visualizationId));
    },
    loadPublishedUIBuilderContainers: function loadPublishedUIBuilderContainers(appId) {
      return req.get(routes.publishedUIBuilderContainers(appId));
    }
  };
};
exports["default"] = _default;