(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("form-data"));
	else if(typeof define === 'function' && define.amd)
		define(["form-data"], factory);
	else if(typeof exports === 'object')
		exports["BackendlessConsoleSDK"] = factory(require("form-data"));
	else
		root["BackendlessConsoleSDK"] = factory(root["form-data"]);
})(global, (__WEBPACK_EXTERNAL_MODULE_form_data__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./src/activity-manager.js":
/*!*********************************!*\
  !*** ./src/activity-manager.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return {
    send: function send(appId, event) {
      return req.post(_urls["default"].userActivity(appId), event);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/analytics.js":
/*!**************************!*\
  !*** ./src/analytics.js ***!
  \**************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var year = 'YEAR';
var month = 'MONTH';
var lastDay = 'MONTH'; //no server analogue for now
var sixmo = 'HALF_YEAR';
var periods = {
  lastDay: lastDay,
  year: year,
  month: month,
  sixmo: sixmo
};
var transformPeriod = function transformPeriod(period) {
  return periods[period] || month;
};
var buildSegmentsQuery = function buildSegmentsQuery(key, segments) {
  var result = {};
  if (segments) {
    segments.forEach(function (segment) {
      result["".concat(key, "[").concat(segment, "]")] = true;
    });
  }
  return result;
};
var buildClientTypeSegmentsQuery = function buildClientTypeSegmentsQuery(clientTypes) {
  return buildSegmentsQuery('apiKeyName', clientTypes);
};
var buildMessagingTypeSegmentsQuery = function buildMessagingTypeSegmentsQuery(messagingType) {
  return buildSegmentsQuery('messagingType', messagingType);
};
var _default = function _default(req) {
  return {
    getAppStats: function getAppStats(appId, period) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/application/stats")).query({
        period: transformPeriod(period)
      });
    },
    performance: function performance(appId, _ref) {
      var aggInterval = _ref.aggInterval,
        from = _ref.from,
        to = _ref.to;
      var params = {
        aggregationPeriod: aggInterval.name,
        startEpochSecond: from / 1000,
        // the server expects timestamp in seconds, not in milliseconds
        endEpochSecond: to / 1000
      };
      return req.get("".concat(_urls["default"].appConsole(appId), "/performance")).query(params).then(function (points) {
        var result = {};
        for (var i = from; i <= to; i += aggInterval.value) {
          result[i] = points[i / 1000]; // the server return timestamp in seconds, not in milliseconds
        }

        return result;
      });
    },
    concurrentRequests: function concurrentRequests(appId, _ref2) {
      var aggInterval = _ref2.aggInterval,
        from = _ref2.from,
        to = _ref2.to;
      var params = {
        aggregationPeriod: aggInterval.name,
        startEpochSecond: from / 1000,
        // the server expects timestamp in seconds, not in milliseconds
        endEpochSecond: to / 1000
      };
      return req.get("".concat(_urls["default"].appConsole(appId), "/concurrent-requests")).query(params).then(function (points) {
        var result = {};
        for (var i = from; i <= to; i += aggInterval.value) {
          result[i] = points[i / 1000]; // the server return timestamp in seconds, not in milliseconds
        }

        return result;
      });
    },
    apiCalls: function apiCalls(appId, _ref3) {
      var clientTypes = _ref3.clientTypes,
        _ref3$columns = _ref3.columns,
        columns = _ref3$columns === void 0 ? {} : _ref3$columns,
        period = _ref3.period,
        from = _ref3.from,
        to = _ref3.to;
      period = period.toUpperCase();
      var params = _objectSpread(_objectSpread({}, buildClientTypeSegmentsQuery(clientTypes)), {}, {
        'withServiceName': columns.services,
        'withMethodName': columns.methods,
        'withSuccessCallCount': true,
        //TODO: the server always return SuccessCallCount values
        'withErrorCount': true,
        //TODO: the server always return ErrorCount values

        period: period
      });
      if (period === 'CUSTOM') {
        params.dateFrom = from;
        params.dateTo = to;
      }
      return req.get("".concat(_urls["default"].appConsole(appId), "/apicalls")).query(params);
    },
    messages: function messages(appId, _ref4) {
      var clientTypes = _ref4.clientTypes,
        messagingTypes = _ref4.messagingTypes,
        period = _ref4.period,
        from = _ref4.from,
        to = _ref4.to;
      period = period.toUpperCase();
      var params = _objectSpread(_objectSpread(_objectSpread({}, buildClientTypeSegmentsQuery(clientTypes)), buildMessagingTypeSegmentsQuery(messagingTypes)), {}, {
        period: period
      });
      if (period === 'CUSTOM') {
        params.dateFrom = from;
        params.dateTo = to;
      }
      return req.get("".concat(_urls["default"].appConsole(appId), "/messaging")).query(params);
    },
    users: function users(appId, _ref5) {
      var period = _ref5.period,
        from = _ref5.from,
        to = _ref5.to;
      period = period.toUpperCase();
      var params = {
        withActiveUsers: true,
        //TODO: the server always return ActiveUsers values
        withNewUsers: true,
        //TODO: the server always return NewUsers values
        withRegisteredUsers: true,
        //TODO: the server always return RegisteredUsers values
        withReturningUsers: true,
        //TODO: the server always return ReturningUsers values

        period: period
      };
      if (period === 'CUSTOM') {
        params.dateFrom = from;
        params.dateTo = to;
      }
      return req.get("".concat(_urls["default"].appConsole(appId), "/userstats")).query(params);
    },
    workers: function workers(appId, query) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/workers")).query(query);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/api-docs.js":
/*!*************************!*\
  !*** ./src/api-docs.js ***!
  \*************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return {
    generateDataTableApi: function generateDataTableApi(appId, tableName, options) {
      return req.post(_urls["default"].apiDocsDataTable(appId, tableName), options);
    },
    generateMessagingChannelApi: function generateMessagingChannelApi(appId, channelName, options) {
      return req.post(_urls["default"].apiDocsMessagingChannel(appId, channelName), options);
    },
    generateFilesApi: function generateFilesApi(appId, options) {
      return req.post(_urls["default"].apiDocsFiles(appId), options);
    },
    generateServiceApi: function generateServiceApi(appId, serviceId, model, options) {
      return req.post(_urls["default"].apiDocsService(appId, serviceId, model), options);
    },
    generateGeoApi: function generateGeoApi(appId, options) {
      return req.post(_urls["default"].apiDocsGeo(appId), options);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/apps.js":
/*!*********************!*\
  !*** ./src/apps.js ***!
  \*********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  apps: '/console/applications',
  appFromZip: '/console/applications/from-zip',
  appFromZipURL: '/console/applications/from-zip-url',
  app: '/:appId/console/application',
  appDevOptions: '/:appId/console/developer/options',
  appReset: '/:appId/console/appreset',
  appClone: '/:appId/console/cloneApp',
  appCloneProcess: '/:appId/console/cloneApp/:processId',
  appTransfer: '/:appId/console/application/transfer',
  appsInfo: '/console/apps-info',
  appInfo: '/:appId/console/app-info',
  appInfoLogo: '/:appId/console/app-info/logos',
  suggestedGeneratedDomains: '/console/applications/suggested-generated-domains'
});
var _default = function _default(req) {
  return {
    createApp: function createApp(app, query) {
      return req.post(routes.apps(), app).query(query);
    },
    createAppFromZIP: function createAppFromZIP(app) {
      return req.post(routes.appFromZip(), app);
    },
    createAppFromZipUrl: function createAppFromZipUrl(data) {
      return req.post(routes.appFromZipURL(), data);
    },
    getApps: function getApps(zone) {
      return req.get(routes.apps()).query({
        zone: zone
      });
    },
    resetApp: function resetApp(appId, resets) {
      return req.post(routes.appReset(appId), resets);
    },
    renameApp: function renameApp(appId, appName) {
      return req.put(routes.app(appId), {
        appName: appName
      });
    },
    deleteApp: function deleteApp(appId) {
      return req["delete"](routes.app(appId));
    },
    cloneApp: function cloneApp(appId, newApp) {
      return req.post(routes.appClone(appId), newApp);
    },
    generateAppZIP: function generateAppZIP(appId) {
      return req.post(routes.appTransfer(appId));
    },
    getCloningAppStatus: function getCloningAppStatus(appId, processId) {
      return req.get(routes.appCloneProcess(appId, processId));
    },
    loadAppsMenuItems: function loadAppsMenuItems() {
      return req.get('/console/applications/menu-items');
    },
    loadAppFavorites: function loadAppFavorites(appId, devId) {
      return req.get('/console/applications/app-favorites').query({
        appId: appId,
        devId: devId
      });
    },
    loadAppsInfo: function loadAppsInfo(appsIds) {
      return req.get(routes.appsInfo()).query({
        appsIds: appsIds
      });
    },
    updateAppInfo: function updateAppInfo(appId, info) {
      return req.post(routes.appInfo(appId), info);
    },
    updateAppLogo: function updateAppLogo(appId, logo) {
      return req.post(routes.appInfoLogo(appId), logo);
    },
    generateSubdomains: function generateSubdomains(zone) {
      return req.get(routes.suggestedGeneratedDomains()).query({
        zone: zone
      });
    },
    getAppDevOptions: function getAppDevOptions(appId) {
      return req.get(routes.appDevOptions(appId));
    },
    updateAppDevOptions: function updateAppDevOptions(appId, options) {
      return req.put(routes.appDevOptions(appId), options);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/automation.js":
/*!***************************!*\
  !*** ./src/automation.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  flows: '/api/app/:appId/automation/flow/version',
  flowsWithElements: '/api/app/:appId/automation/flow/version/with-elements',
  flowsElements: '/api/app/:appId/automation/flows/versions/elements',
  flow: '/api/app/:appId/automation/flow/version/:versionId',
  flowSchedule: '/api/app/:appId/automation/flow/version/:versionId/schedule',
  newFlowVersion: '/api/app/:appId/automation/flow/version/:versionId/new-version',
  flowState: '/api/app/:appId/automation/flow/version/:versionId/:state',
  flowGroupName: '/api/app/:appId/automation/flow/:flowId/name',
  flowDescription: '/api/app/:appId/automation/flow/version/:versionId/description',
  flowGroup: '/api/app/:appId/automation/flow/:flowId',
  flowVersionMetrics: '/api/app/:appId/automation/flow/:flowId/version/:versionId/analytics/version-metrics',
  stepsMetrics: '/api/app/:appId/automation/flow/:flowId/version/:versionId/analytics/step-metrics',
  flowInstances: '/api/app/:appId/automation/flow/:flowId/version/:versionId/analytics/instances/find',
  countInstances: '/api/app/:appId/automation/flow/:flowId/version/:versionId/analytics/instances/count',
  flowInstance: '/api/app/:appId/automation/flow/:flowId/version/:versionId/analytics/instances/:executionId',
  // eslint-disable-next-line max-len
  elementExecutionInfo: '/api/app/:appId/automation/flow/:flowId/version/:versionId/analytics/instances/:executionId/element/:elementId',
  flowSlA: '/api/app/:appId/automation/flow/:flowId/version/:versionId/sla/goals',
  flowSlAGoal: '/api/app/:appId/automation/flow/:flowId/version/:versionId/sla/goals/:id',
  SLACalendars: '/api/app/:appId/automation/flow/sla/calendar',
  SLACalendar: '/api/app/:appId/automation/flow/sla/calendar/:id',
  // eslint-disable-next-line max-len
  errorHandlerAnalytics: '/api/app/:appId/automation/flow/:flowId/version/:versionId/analytics/error-handler/:errorHandlerId/recorded-errors',
  customElements: '/api/node-server/manage/app/:appId/flowrunner/custom-elements',
  startDebugSession: '/api/app/:appId/automation/flow/:flowId/version/:versionId/debug/test-monitor/start-session',
  stopDebugSession: '/api/app/:appId/automation/flow/:flowId/version/:versionId/debug/test-monitor/stop-session',
  testMonitorHistory: '/api/app/:appId/automation/flow/:flowId/version/:versionId/debug/test-monitor/history',
  // eslint-disable-next-line max-len
  debugExecutionContext: '/api/app/:appId/automation/flow/:flowId/version/:versionId/debug/test-monitor/execution-context',
  runElementInDebugMode: '/api/app/:appId/automation/flow/:flowId/version/:versionId/debug/run/element/:elementId',
  allowedAIModels: '/api/app/:appId/automation/ai/assistants/allowed-models',
  registerAIAssistant: '/api/app/:appId/automation/ai/assistants/register',
  aiAssistants: '/api/app/:appId/automation/ai/assistants',
  aiAssistant: '/api/app/:appId/automation/ai/assistants/:id',
  flowLogs: '/api/app/:appId/automation/flow/version/:id/logs/find',
  flowLogsLevel: '/api/app/:appId/automation/:flowId/logging/level',
  exportFlowVersion: '/api/app/:appId/automation/flow/version/:id/export',
  importFlowVersion: '/api/app/:appId/automation/flow/:flowId/import',
  createFlowFromJSON: '/api/app/:appId/automation/flow/import'
});
var _default = function _default(req) {
  return {
    getFlows: function getFlows(appId) {
      return req.automation.get(routes.flows(appId));
    },
    getFlowsElements: function getFlowsElements(appId, elementType, elementSubtype) {
      return req.automation.get(routes.flowsElements(appId)).query({
        elementType: elementType,
        elementSubtype: elementSubtype
      });
    },
    getFlowsWithElements: function getFlowsWithElements(appId) {
      return req.automation.get(routes.flowsWithElements(appId));
    },
    getFlow: function getFlow(appId, id) {
      return req.automation.get(routes.flow(appId, id));
    },
    createFlow: function createFlow(appId, flow) {
      return req.automation.post(routes.flows(appId), flow);
    },
    updateFlow: function updateFlow(appId, flow) {
      return req.automation.put(routes.flow(appId, flow.id), flow);
    },
    deleteFlow: function deleteFlow(appId, id) {
      return req.automation["delete"](routes.flow(appId, id));
    },
    enableFlow: function enableFlow(appId, id) {
      return req.automation.post(routes.flowState(appId, id, 'enable'));
    },
    pauseFlow: function pauseFlow(appId, id) {
      return req.automation.post(routes.flowState(appId, id, 'pause'));
    },
    terminateFlow: function terminateFlow(appId, id) {
      return req.automation.post(routes.flowState(appId, id, 'terminate'));
    },
    createNewVersion: function createNewVersion(appId, id) {
      return req.automation.post(routes.newFlowVersion(appId, id));
    },
    editFlowsGroupName: function editFlowsGroupName(appId, groupId, name) {
      return req.automation.put(routes.flowGroupName(appId, groupId), {
        name: name
      });
    },
    deleteFlowsGroup: function deleteFlowsGroup(appId, groupId) {
      return req.automation["delete"](routes.flowGroup(appId, groupId));
    },
    updateFlowDescription: function updateFlowDescription(appId, versionId, description) {
      return req.put(routes.flowDescription(appId, versionId, description), {
        description: description
      });
    },
    getFlowVersionMetrics: function getFlowVersionMetrics(appId, flowId, versionId, fromDate, toDate) {
      return req.automation.get(routes.flowVersionMetrics(appId, flowId, versionId)).query({
        fromDate: fromDate,
        toDate: toDate
      });
    },
    getFlowStepsMetrics: function getFlowStepsMetrics(appId, flowId, versionId, fromDate, toDate) {
      return req.automation.get(routes.stepsMetrics(appId, flowId, versionId)).query({
        fromDate: fromDate,
        toDate: toDate
      });
    },
    getFlowInstances: function getFlowInstances(appId, flowId, versionId, body) {
      return req.automation.post(routes.flowInstances(appId, flowId, versionId), body);
    },
    countFlowInstances: function countFlowInstances(appId, flowId, versionId, body) {
      return req.automation.post(routes.countInstances(appId, flowId, versionId), body);
    },
    getFlowInstanceAnalytics: function getFlowInstanceAnalytics(appId, flowId, versionId, executionId) {
      return req.automation.get(routes.flowInstance(appId, flowId, versionId, executionId));
    },
    getElementExecutionInfo: function getElementExecutionInfo(appId, flowId, versionId, executionId, elementId) {
      return req.automation.get(routes.elementExecutionInfo(appId, flowId, versionId, executionId, elementId));
    },
    loadErrorHandlerAnalytics: function loadErrorHandlerAnalytics(appId, flowId, versionId, errorHandlerId, fromDate, toDate) {
      return req.automation.get(routes.errorHandlerAnalytics(appId, flowId, versionId, errorHandlerId)).query({
        fromDate: fromDate,
        toDate: toDate
      });
    },
    getCustomElements: function getCustomElements(appId) {
      return req.automation.get(routes.customElements(appId));
    },
    startDebugSession: function startDebugSession(appId, flowId, versionId, forceStart) {
      return req.automation.post(routes.startDebugSession(appId, flowId, versionId)).query({
        forceStart: forceStart
      });
    },
    stopDebugSession: function stopDebugSession(appId, flowId, versionId, sessionId) {
      return req.automation["delete"](routes.stopDebugSession(appId, flowId, versionId)).query({
        sessionId: sessionId
      });
    },
    loadTestMonitorHistory: function loadTestMonitorHistory(appId, flowId, versionId, sessionId) {
      return req.automation.get(routes.testMonitorHistory(appId, flowId, versionId)).query({
        sessionId: sessionId
      });
    },
    clearTestMonitorHistory: function clearTestMonitorHistory(appId, flowId, versionId, sessionId) {
      return req.automation["delete"](routes.testMonitorHistory(appId, flowId, versionId)).query({
        sessionId: sessionId
      });
    },
    loadDebugExecutionContext: function loadDebugExecutionContext(appId, flowId, versionId, sessionId) {
      return req.automation.get(routes.debugExecutionContext(appId, flowId, versionId)).query({
        sessionId: sessionId
      });
    },
    updateDebugExecutionContext: function updateDebugExecutionContext(appId, flowId, versionId, context, sessionId) {
      return req.automation.put(routes.debugExecutionContext(appId, flowId, versionId), context).query({
        sessionId: sessionId
      });
    },
    runElementInDebugMode: function runElementInDebugMode(appId, flowId, versionId, elementId, body, sessionId) {
      return req.automation.post(routes.runElementInDebugMode(appId, flowId, versionId, elementId), body, sessionId).query({
        sessionId: sessionId
      });
    },
    getFlowSLAGoals: function getFlowSLAGoals(appId, flowId, versionId) {
      return req.automation.get(routes.flowSlA(appId, flowId, versionId));
    },
    createFlowSLAGoal: function createFlowSLAGoal(appId, flowId, versionId, data) {
      return req.automation.post(routes.flowSlA(appId, flowId, versionId), data);
    },
    updateFlowSLAGoal: function updateFlowSLAGoal(appId, flowId, versionId, data, id) {
      return req.automation.put(routes.flowSlAGoal(appId, flowId, versionId, id), data);
    },
    deleteFlowSLAGoal: function deleteFlowSLAGoal(appId, flowId, versionId, id) {
      return req.automation["delete"](routes.flowSlAGoal(appId, flowId, versionId, id));
    },
    getSLACalendars: function getSLACalendars(appId) {
      return req.automation.get(routes.SLACalendars(appId));
    },
    createSLACalendar: function createSLACalendar(appId, data) {
      return req.automation.post(routes.SLACalendars(appId), data);
    },
    updateSLACalendar: function updateSLACalendar(appId, data, id) {
      return req.automation.put(routes.SLACalendar(appId, id), data);
    },
    deleteSLACalendar: function deleteSLACalendar(appId, id) {
      return req.automation["delete"](routes.SLACalendar(appId, id));
    },
    getAllowedAIModels: function getAllowedAIModels(appId) {
      return req.automation.get(routes.allowedAIModels(appId));
    },
    registerAIAssistant: function registerAIAssistant(appId, openAiAssistantId) {
      return req.automation.post(routes.registerAIAssistant(appId), {
        openAiAssistantId: openAiAssistantId
      });
    },
    createAIAssistant: function createAIAssistant(appId, assistant) {
      return req.automation.post(routes.aiAssistants(appId), assistant);
    },
    updateAIAssistant: function updateAIAssistant(appId, assistant) {
      return req.automation.put(routes.aiAssistant(appId, assistant.id), assistant);
    },
    deleteAIAssistant: function deleteAIAssistant(appId, assistantId) {
      return req.automation["delete"](routes.aiAssistant(appId, assistantId));
    },
    getAIAssistants: function getAIAssistants(appId) {
      return req.automation.get(routes.aiAssistants(appId));
    },
    loadFlowLogs: function loadFlowLogs(appId, versionId, data) {
      return req.automation.post(routes.flowLogs(appId, versionId), data);
    },
    getFlowLogsLevel: function getFlowLogsLevel(appId, flowId) {
      return req.automation.get(routes.flowLogsLevel(appId, flowId));
    },
    updateFlowLogsLevel: function updateFlowLogsLevel(appId, flowId, data) {
      return req.automation.put(routes.flowLogsLevel(appId, flowId), data);
    },
    exportFlowVersion: function exportFlowVersion(appId, versionId) {
      return req.automation.get(routes.exportFlowVersion(appId, versionId));
    },
    importFlowVersion: function importFlowVersion(appId, versionId, flow) {
      return req.automation.post(routes.importFlowVersion(appId, versionId), flow);
    },
    createFlowFromJSON: function createFlowFromJSON(appId, flow) {
      return req.automation.post(routes.createFlowFromJSON(appId), flow);
    },
    updateFlowSchedule: function updateFlowSchedule(appId, versionId, data) {
      return req.automation.put(routes.flowSchedule(appId, versionId), data);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/billing/index.js":
/*!******************************!*\
  !*** ./src/billing/index.js ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.billingAPI = billingAPI;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _routes = __webpack_require__(/*! ./routes */ "./src/billing/routes.js");
var _payments = __webpack_require__(/*! ./payments */ "./src/billing/payments.js");
var _limits = __webpack_require__(/*! ./limits */ "./src/billing/limits.js");
var _plans = __webpack_require__(/*! ./plans */ "./src/billing/plans.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function billingAPI(req) {
  return _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, (0, _payments.billingPaymentsAPI)(req)), (0, _limits.billingLimitsAPI)(req)), (0, _plans.billingPlansAPI)(req)), {}, {
    getAppBillingInfo: function getAppBillingInfo(appId) {
      return req.billing.get(_routes.routes.appBillingInfo(appId));
    },
    getAutomationBillingInfo: function getAutomationBillingInfo(appId) {
      return req.billing.get(_routes.routes.automationBillingInfo(appId));
    },
    getSubscriptionStatus: function getSubscriptionStatus(appId) {
      return req.billing.get(_routes.routes.subscriptionStatus(appId));
    },
    loadSubscriptionsInfo: function loadSubscriptionsInfo() {
      return req.billing.get(_routes.routes.devSubscriptionsInfo());
    },
    getAppBillingPeriodInfo: function getAppBillingPeriodInfo(appId) {
      return req.billing.get(_routes.routes.appBillingPeriodInfo(appId));
    },
    getAutomationBillingPeriodInfo: function getAutomationBillingPeriodInfo(appId) {
      return req.billing.get(_routes.routes.automationBillingPeriodInfo(appId));
    } // TODO: seems like we do not use the function
    // getInviteCode(appId) {
    //   return req.billing.get(routes.inviteCode(appId))
    // },
  });
}

/***/ }),

/***/ "./src/billing/limits.js":
/*!*******************************!*\
  !*** ./src/billing/limits.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.billingLimitsAPI = billingLimitsAPI;
var _routes = __webpack_require__(/*! ./routes */ "./src/billing/routes.js");
function billingLimitsAPI(req) {
  return {
    getAppPlanComponentsData: function getAppPlanComponentsData(appId, planId, billingPeriod) {
      return req.billing.get(_routes.routes.appPlanComponentsData(appId, planId, billingPeriod));
    },
    getAppCurrentPlanComponentData: function getAppCurrentPlanComponentData(appId) {
      return req.billing.get(_routes.routes.appPlanComponentsData(appId, 'current', 'current'));
    },
    getAutomationPlanComponentsData: function getAutomationPlanComponentsData(appId, planId, billingPeriod) {
      return req.billing.get(_routes.routes.automationPlanComponentsData(appId, planId, billingPeriod));
    },
    getAutomationCurrentPlanComponentData: function getAutomationCurrentPlanComponentData(appId) {
      return req.billing.get(_routes.routes.automationPlanComponentsData(appId, 'current', 'current'));
    },
    getComponentLimit: function getComponentLimit(appId, componentId) {
      return req.billing.get(_routes.routes.componentLimit(appId, componentId));
    },
    apiCallsBlocked: function apiCallsBlocked(appId) {
      return req.billing.get(_routes.routes.apiCallsBlocked(appId));
    },
    loadHiveUsage: function loadHiveUsage(appId) {
      var cached = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      return req.billing.get(_routes.routes.hiveUsage(appId)).query({
        cached: cached
      });
    },
    loadHiveLimit: function loadHiveLimit(appId) {
      return req.billing.get(_routes.routes.hiveLimits(appId));
    },
    scalePlanePricingEstimate: function scalePlanePricingEstimate(appId, query) {
      return req.billing.get(_routes.routes.tiersFloatPriceEstimation(appId)).query(query);
    },
    scaleFixedPlanePricingEstimate: function scaleFixedPlanePricingEstimate(appId, tierId, query) {
      return req.billing.get(_routes.routes.tiersFixedPriceEstimation(appId, tierId)).query(query);
    },
    getMaxTier: function getMaxTier(appId) {
      return req.billing.get(_routes.routes.maxTier(appId));
    },
    setMaxTier: function setMaxTier(appId, tierId) {
      return req.billing.put(_routes.routes.maxTier(appId), {
        tierId: tierId
      });
    },
    getTiersList: function getTiersList(appId) {
      return req.billing.get(_routes.routes.tiers(appId));
    }
  };
}

/***/ }),

/***/ "./src/billing/payments.js":
/*!*********************************!*\
  !*** ./src/billing/payments.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.billingPaymentsAPI = billingPaymentsAPI;
var _routes = __webpack_require__(/*! ./routes */ "./src/billing/routes.js");
function billingPaymentsAPI(req) {
  return {
    loadPaymentProfilesForCloneApp: function loadPaymentProfilesForCloneApp(appId) {
      return req.billing.get(_routes.routes.paymentProfilesForCloneApp(appId));
    },
    confirmConsolidateApp: function confirmConsolidateApp(appId, _ref) {
      var paymentProfileId = _ref.paymentProfileId,
        newBillingPlan = _ref.newBillingPlan,
        newBillingPeriod = _ref.newBillingPeriod;
      return req.billing.put(_routes.routes.consolidateApp(appId, paymentProfileId)).query({
        newBillingPlan: newBillingPlan,
        newBillingPeriod: newBillingPeriod
      });
    },
    loadPaymentProfiles: function loadPaymentProfiles() {
      return req.billing.get(_routes.routes.devPaymentProfile());
    },
    setAppPaymentProfile: function setAppPaymentProfile(appId, paymentProfileId) {
      return req.billing.put(_routes.routes.appPaymentProfileCard(appId, paymentProfileId));
    },
    setAutomationPaymentProfile: function setAutomationPaymentProfile(appId, paymentProfileId) {
      return req.billing.put(_routes.routes.automationPaymentProfileCard(appId, paymentProfileId));
    },
    addPaymentProfile: function addPaymentProfile(data) {
      return req.billing.post(_routes.routes.devPaymentProfile(), data);
    },
    updatePaymentProfile: function updatePaymentProfile(id, data) {
      return req.billing.put(_routes.routes.devPaymentProfileById(id), data);
    },
    deletePaymentProfile: function deletePaymentProfile(id) {
      return req.billing["delete"](_routes.routes.devPaymentProfileById(id));
    },
    exchangeBBtoUSD: function exchangeBBtoUSD(appId, bbAmount) {
      return req.billing.post(_routes.routes.exchangeBB(appId), bbAmount).set({
        'Content-Type': 'application/json'
      });
    }
  };
}

/***/ }),

/***/ "./src/billing/plans.js":
/*!******************************!*\
  !*** ./src/billing/plans.js ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.billingPlansAPI = billingPlansAPI;
var _routes = __webpack_require__(/*! ./routes */ "./src/billing/routes.js");
function billingPlansAPI(req) {
  return {
    getAppPlans: function getAppPlans(appId) {
      return req.billing.get(_routes.routes.appBillingPlans(appId));
    },
    getAutomationPlans: function getAutomationPlans(appId) {
      return req.billing.get(_routes.routes.automationBillingPlans(appId));
    },
    switchToAppPlan: function switchToAppPlan(appId, planId, billingPeriod) {
      return req.billing.put(_routes.routes.switchAppPlan(appId, planId, billingPeriod));
    },
    switchToAutomationPlan: function switchToAutomationPlan(appId, planId, billingPeriod) {
      return req.billing.put(_routes.routes.switchAutomationPlan(appId, planId, billingPeriod));
    },
    unlockPlan: function unlockPlan(appId, planId) {
      return req.billing.put(_routes.routes.unlockPlan(appId, planId));
    }
  };
}

/***/ }),

/***/ "./src/billing/routes.js":
/*!*******************************!*\
  !*** ./src/billing/routes.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.routes = void 0;
var _routes = __webpack_require__(/*! ../utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  appBillingInfo: '/:appId/console/billing/application/accountinfo',
  automationBillingInfo: '/:appId/console/billing/automation/accountinfo',
  appBillingPlans: '/:appId/console/billing/application/plans',
  automationBillingPlans: '/:appId/console/billing/automation/plans',
  appPlanComponentsData: '/:appId/console/billing/application/plans/:planId/:billingPeriod/components',
  automationPlanComponentsData: '/:appId/console/billing/automation/plans/:planId/:billingPeriod/components',
  switchAppPlan: '/:appId/console/billing/application/subscriptions/:planId/:billingPeriod',
  switchAutomationPlan: '/:appId/console/billing/automation/subscriptions/:planId/:billingPeriod',
  componentLimit: '/:appId/console/billing/application/limits/:componentId',
  appBillingPeriodInfo: '/:appId/console/billing/application/billing-period-info',
  automationBillingPeriodInfo: '/:appId/console/billing/automation/billing-period-info',
  exchangeBB: '/:appId/console/billing/application/bb/exchange',
  consolidateApp: '/:appId/console/billing/application/consolidate/:paymentProfileId',
  tiers: '/:appId/console/billing/application/tiers',
  maxTier: '/:appId/console/billing/application/tiers/max',
  tiersFloatPriceEstimation: '/:appId/console/billing/application/tiers/price-estimation',
  tiersFixedPriceEstimation: '/:appId/console/billing/application/tiers/price-estimation/:tierId',
  paymentProfilesForCloneApp: '/:appId/console/billing/application/payment-profiles-for-clone-operation',
  appPaymentProfileCard: '/:appId/console/billing/application/creditcard/:paymentProfileId',
  automationPaymentProfileCard: '/:appId/console/billing/automation/creditcard/:paymentProfileId',
  apiCallsBlocked: '/:appId/console/billing/apicalls/blocked',
  // inviteCode                : '/:appId/console/billing/refcode',

  devSubscriptionsInfo: '/console/billing/developer/subscriptions-info',
  devPaymentProfile: '/console/billing/developer/payment-profile',
  devPaymentProfileById: '/console/billing/developer/payment-profile/:id',
  subscriptionStatus: '/:appId/billing/subscriptions/status',
  unlockPlan: '/:appId/billing/plan/:planId/unlock',
  hiveLimits: '/:appId/billing/limits/hive',
  hiveUsage: '/:appId/service/billing/usage/hive'
});
exports.routes = routes;

/***/ }),

/***/ "./src/bl.js":
/*!*******************!*\
  !*** ./src/bl.js ***!
  \*******************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _objectWithoutProperties2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/objectWithoutProperties */ "./node_modules/@babel/runtime/helpers/objectWithoutProperties.js"));
var _each2 = _interopRequireDefault(__webpack_require__(/*! lodash/each */ "./node_modules/lodash/each.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _cacheTags = __webpack_require__(/*! ./utils/cache-tags */ "./src/utils/cache-tags.js");
var _path = __webpack_require__(/*! ./utils/path */ "./src/utils/path.js");
var _excluded = ["paths"],
  _excluded2 = ["category", "mode"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var hostedServices = function hostedServices(appId) {
  return "".concat(_urls["default"].blBasePath(appId), "/generic");
};
var codelessServices = function codelessServices(appId) {
  return "".concat(_urls["default"].blBasePath(appId), "/codeless");
};
var jsServices = function jsServices(appId) {
  return "".concat(_urls["default"].blBasePath(appId), "/js");
};
var marketplaceServices = function marketplaceServices(appId) {
  return "".concat(_urls["default"].blBasePath(appId), "/marketplace");
};
var hostedServiceConfig = function hostedServiceConfig(appId, serviceId) {
  return "".concat(hostedServices(appId), "/configure/").concat(serviceId);
};
var marketplaceServiceConfig = function marketplaceServiceConfig(appId, serviceName) {
  return "".concat(marketplaceServices(appId), "/configure/").concat(serviceName);
};
var MODES = {
  MARKETPLACE: 'MARKETPLACE',
  PROD: 'PRODUCTION',
  DEBUG: 'DEBUG',
  DRAFT: 'DRAFT'
};

// TODO: remove this transformation when the format of config will be changed [CONSOLE-599]
var CONFIG_NAMES_MAP = {
  displayName: 'label'
};

// TODO: remove this transformation when the format of config will be changed [CONSOLE-599]
var normalizeService = function normalizeService(service) {
  if (service.configuration) {
    service.configDescriptions = service.configuration.map(normalizeServiceConfigDescription);
    delete service.configuration;
  }
  return service;
};

// TODO: remove this transformation when the format of config will be changes [CONSOLE-599]
var normalizeServiceConfigDescription = function normalizeServiceConfigDescription(configDescription) {
  for (var key in configDescription) {
    var normalizeName = CONFIG_NAMES_MAP[key];
    if (normalizeName) {
      configDescription[normalizeName] = configDescription[key];
      delete configDescription[key];
    }
  }
  return configDescription;
};
var parseServiceSpec = function parseServiceSpec(spec) {
  var paths = spec.paths,
    summary = (0, _objectWithoutProperties2["default"])(spec, _excluded);
  var methods = {};
  (0, _each2["default"])(paths, function (pathBody, path) {
    (0, _each2["default"])(pathBody, function (methodBody, type) {
      var id = methodBody.operationId;
      methods[id] = _objectSpread(_objectSpread({}, methodBody), {}, {
        path: path,
        type: type,
        id: id
      });
    });
  });
  return {
    summary: summary,
    methods: methods
  };
};
var normalizeHandler = function normalizeHandler(handler) {
  if (handler.mode === MODES.MARKETPLACE) {
    handler.mode = MODES.PROD;
    handler.fromMarketplace = true;
  }
  return handler;
};
var normalizeHandlers = function normalizeHandlers(handlers) {
  return handlers.map(normalizeHandler);
};
var _default = function _default(req) {
  return {
    getServices: function getServices(appId) {
      return req.get(_urls["default"].blBasePath(appId)).then(function (services) {
        return services.map(normalizeService);
      });
      // TODO: remove this transformation when the format of config will be changes [CONSOLE-599]
    },
    getServiceSpec: function getServiceSpec(appId, serviceId) {
      var transformSpec = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var result = req.get("".concat(_urls["default"].blBasePath(appId), "/").concat(serviceId, "/api-docs"));
      if (transformSpec) {
        return result.then(parseServiceSpec);
      }
      return result;
    },
    getServiceMethods: function getServiceMethods(appId, serviceId) {
      return req.get("".concat(_urls["default"].blBasePath(appId), "/").concat(serviceId, "/methods"));
    },
    importService: function importService(appId, _ref) {
      var service = _ref.service,
        serviceURL = _ref.serviceURL,
        file = _ref.file;
      var data;
      if (file) {
        data = new FormData();
        data.append('file', file);
      } else {
        data = service ? {
          appId: appId,
          service: service
        } : {
          serviceURL: serviceURL
        };
      }
      return req.post("".concat(_urls["default"].blBasePath(appId), "/import"), data);
    },
    createService: function createService(appId, data) {
      var formData = data;
      if (!data.createFromSample) {
        formData = new FormData();
        formData.append('files', data.file);
        formData.append('createFromSample', false);
        formData.append('model', data.model);
      }
      return req.post("".concat(_urls["default"].blBasePath(appId), "/generic"), formData).then(function (services) {
        return services.map(normalizeService);
      });
      // TODO: remove this transformation when the format of config will be changed [CONSOLE-599]
    },
    createAWSLambdaService: function createAWSLambdaService(appId, credentials) {
      return req.post("".concat(_urls["default"].blBasePath(appId), "/aws-lambda"), _objectSpread(_objectSpread({}, credentials), {}, {
        appId: appId
      }));
    },
    createCodelessService: function createCodelessService(appId, service) {
      return req.post(codelessServices(appId), service).cacheTags((0, _cacheTags.BL_MODELS)(appId, 'CODELESS'));
    },
    createJsService: function createJsService(appId, service) {
      return req.post(jsServices(appId), service).cacheTags((0, _cacheTags.BL_MODELS)(appId, 'JS'));
    },
    updateCodelessService: function updateCodelessService(appId, serviceId, updates) {
      return req.put("".concat(codelessServices(appId), "/").concat(serviceId), updates);
    },
    deleteCodelessService: function deleteCodelessService(appId, serviceId) {
      return req["delete"]("".concat(codelessServices(appId), "/").concat(serviceId));
    },
    createCodelessMethod: function createCodelessMethod(appId, serviceId, method) {
      return req.post("".concat(codelessServices(appId), "/").concat(serviceId, "/"), method);
    },
    updateCodelessMethod: function updateCodelessMethod(appId, serviceId, methodId, method) {
      return req.put("".concat(codelessServices(appId), "/").concat(serviceId, "/").concat(methodId), method);
    },
    deleteCodelessMethod: function deleteCodelessMethod(appId, serviceId, methodId) {
      return req["delete"]("".concat(codelessServices(appId), "/").concat(serviceId, "/").concat(methodId));
    },
    getCodelessMethodLogic: function getCodelessMethodLogic(appId, serviceId, methodId) {
      return req.get("".concat(codelessServices(appId), "/").concat(serviceId, "/").concat(methodId, "/logic"));
    },
    deployCodelessMethodLogic: function deployCodelessMethodLogic(appId, serviceId, methodId, logic, params) {
      return req.put("".concat(codelessServices(appId), "/").concat(serviceId, "/").concat(methodId, "/logic"), logic).query(params);
    },
    deleteService: function deleteService(appId, serviceId) {
      return req["delete"](hostedServices(appId), [serviceId]);
    },
    updateService: function updateService(appId, serviceId, updates) {
      return req.put("".concat(hostedServices(appId), "/").concat(serviceId, "/update"), updates);
    },
    updateServiceDefaultModel: function updateServiceDefaultModel(appId, updates) {
      return req.put("".concat(_urls["default"].blBasePath(appId), "/default-model"), updates);
    },
    loadServiceConfig: function loadServiceConfig(appId, serviceId) {
      return req.get(hostedServiceConfig(appId, serviceId));
    },
    setServiceConfig: function setServiceConfig(appId, serviceId, config) {
      return req.post(hostedServiceConfig(appId, serviceId), config);
    },
    setMarketplaceServiceConfig: function setMarketplaceServiceConfig(appId, serviceName, config) {
      return req.post(marketplaceServiceConfig(appId, serviceName), config);
    },
    testServiceConfig: function testServiceConfig(appId, serviceId, config) {
      return req.post(hostedServiceConfig(appId, "test/".concat(serviceId)), config);
    },
    getDraftFiles: function getDraftFiles(appId, language, model) {
      return req.get(_urls["default"].blDraft(appId, language, model));
    },
    saveDraftFiles: function saveDraftFiles(appId, language, model, files) {
      var sync = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : true;
      return req.put(_urls["default"].blDraft(appId, language, model), files).query({
        sync: sync
      });
    },
    deployDraftFiles: function deployDraftFiles(appId, language, model, files) {
      var sync = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : true;
      return req.put(_urls["default"].blProd(appId, language, model), files).query({
        sync: sync
      });
    },
    getDraftFileContent: function getDraftFileContent(appId, language, model, fileId) {
      return req.get("".concat(_urls["default"].blDraft(appId, language, model), "/").concat((0, _path.encodePath)(fileId)));
    },
    getLanguages: function getLanguages() {
      return req.get("".concat(_urls["default"].console(), "/servercode/languages"));
    },
    getModels: function getModels(appId, language) {
      return req.get("".concat(_urls["default"].serverCode(appId), "/models/").concat(language)).cacheTags((0, _cacheTags.BL_MODELS)(appId, language));
    },
    getAllModels: function getAllModels(appId) {
      return req.get("".concat(_urls["default"].serverCode(appId), "/models"));
    },
    createModel: function createModel(appId, language, model) {
      var data = {
        appId: appId,
        language: language,
        model: model
      };
      return req.post("".concat(_urls["default"].serverCode(appId), "/models/create"), data);
    },
    createEventHandler: function createEventHandler(appId, handler) {
      var category = handler.category,
        mode = handler.mode,
        data = (0, _objectWithoutProperties2["default"])(handler, _excluded2);
      return req.post(_urls["default"].blHandlersCategory(appId, mode, category), data).cacheTags((0, _cacheTags.BL_MODELS)(appId, handler.language));
    },
    updateEventHandler: function updateEventHandler(appId, handler) {
      var id = handler.id,
        category = handler.category,
        fromMarketplace = handler.fromMarketplace;
      if (fromMarketplace) {
        handler.mode = MODES.MARKETPLACE;
      }
      var url = "".concat(_urls["default"].blHandlersCategory(appId, handler.mode, category), "/").concat(id);
      return req.put(url, handler).then(normalizeHandler);
    },
    getEventHandlers: function getEventHandlers(appId) {
      var modes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      return req.get(_urls["default"].serverCode(appId)).query({
        mode: modes
      }).then(normalizeHandlers);
    },
    deleteEventHandler: function deleteEventHandler(appId, handler) {
      var id = handler.id,
        mode = handler.mode,
        category = handler.category;
      var url = "".concat(_urls["default"].blHandlersCategory(appId, mode, category), "/").concat(id);
      return req["delete"](url);
    },
    getHandlerInvocationChain: function getHandlerInvocationChain(appId, eventId, context) {
      return req.get(_urls["default"].blHandlersChain(appId, eventId, context)).cacheTags((0, _cacheTags.BL_CHAIN)(appId, eventId, context));
    },
    updateHandlerInvocationChain: function updateHandlerInvocationChain(appId, eventId, context, updates) {
      return req.put(_urls["default"].blHandlersChain(appId, eventId, context), updates).cacheTags((0, _cacheTags.BL_CHAIN)(appId, eventId, context));
    },
    invokeTimer: function invokeTimer(appId, timer) {
      var timername = timer.timername,
        mode = timer.mode,
        category = timer.category;

      //POST /:applicationId/console/servercode/:mode/timers/:timerName/run
      return req.post("".concat(_urls["default"].blHandlersCategory(appId, mode, category), "/").concat(timername, "/run"));
    },
    changeHandlerState: function changeHandlerState(appId, mode, category, timerId, enabled) {
      return req.put("".concat(_urls["default"].blHandlersCategory(appId, mode, category), "/").concat(timerId, "/state"), {
        enabled: enabled
      });
    },
    getCategories: function getCategories(appId) {
      return req.get("".concat(_urls["default"].serverCode(appId), "/categories"));
    },
    getEvents: function getEvents(appId) {
      return req.get("".concat(_urls["default"].serverCode(appId), "/events"));
    },
    getTimerLogs: function getTimerLogs(appId, query) {
      return req.get("".concat(_urls["default"].serverCode(appId), "/timers/logs")).query(query);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/blueprints.js":
/*!***************************!*\
  !*** ./src/blueprints.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return {
    get: function get(id) {
      return req.get(_urls["default"].blueprints(id));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/cache-control.js":
/*!******************************!*\
  !*** ./src/cache-control.js ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  service: '/:appId/console/cachecontrol/:service',
  serviceTarget: '/:appId/console/cachecontrol/:service/:target'
});
var _default = function _default(req) {
  return {
    loadAllServiceItems: function loadAllServiceItems(appId, service) {
      return req.get(routes.service(appId, service));
    },
    loadServiceItem: function loadServiceItem(appId, service, target) {
      return req.get(routes.serviceTarget(appId, service, target));
    },
    createServiceItem: function createServiceItem(appId, service, target, data) {
      return req.post(routes.serviceTarget(appId, service, target), data);
    },
    updateServiceItem: function updateServiceItem(appId, service, target, data) {
      return req.put(routes.serviceTarget(appId, service, target), data);
    },
    deleteServiceItem: function deleteServiceItem(appId, service, target) {
      return req["delete"](routes.serviceTarget(appId, service, target));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/cache.js":
/*!**********************!*\
  !*** ./src/cache.js ***!
  \**********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/slicedToArray */ "./node_modules/@babel/runtime/helpers/slicedToArray.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var normalizeValue = function normalizeValue(value) {
  return typeof value === 'string' ? value : JSON.stringify(value);
};
var normalizeResponse = function normalizeResponse(res) {
  return Object.keys(res).map(function (key) {
    var _res$key = res[key],
      expireAt = _res$key.expireAt,
      value = _res$key.value;
    return {
      objectId: key,
      value: normalizeValue(value),
      expireAt: expireAt,
      key: key
    };
  });
};
var _default = function _default(req) {
  return {
    get: function get(appId, _ref) {
      var pageSize = _ref.pageSize,
        offset = _ref.offset;
      return Promise.all([req.get(_urls["default"].cache(appId)).query({
        pagesize: pageSize,
        offset: offset
      }).then(normalizeResponse), this.count(appId)]).then(function (_ref2) {
        var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
          data = _ref3[0],
          totalRows = _ref3[1];
        return {
          data: data,
          totalRows: totalRows
        };
      });
    },
    count: function count(appId) {
      return req.get("".concat(_urls["default"].cache(appId), "/count"));
    },
    update: function update(appId, record) {
      var key = record.key,
        value = record.value,
        expireAt = record.expireAt,
        objectId = record.objectId;
      var id = key || objectId;
      return req.put(_urls["default"].cache(appId, id), JSON.stringify(value)).query({
        expireAt: expireAt
      }).type('application/json');
    },
    remove: function remove(appId, key) {
      return req["delete"](_urls["default"].cache(appId, key));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/chart-builder.js":
/*!******************************!*\
  !*** ./src/chart-builder.js ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return {
    getCharts: function getCharts(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/chart-builder"));
    },
    createChart: function createChart(appId, chartSource, chartTarget) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/chart-builder/chart"), {
        chartSource: chartSource,
        chartTarget: chartTarget
      });
    },
    updateChart: function updateChart(appId, chartSource, chartTarget) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/chart-builder/chart/").concat(chartSource.name), {
        chartSource: chartSource,
        chartTarget: chartTarget
      });
    },
    deleteChart: function deleteChart(appId, chartName) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/chart-builder/chart/").concat(chartName));
    },
    renameChart: function renameChart(appId, oldChartName, newChartName) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/chart-builder/rename-chart"), {
        oldChartName: oldChartName,
        newChartName: newChartName
      });
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/cloud-code.js":
/*!***************************!*\
  !*** ./src/cloud-code.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  installDM: '/:appId/console/cloud-code/deployment-models/marketplace/install/:productId',
  uninstallDM: '/:appId/console/cloud-code/deployment-models/marketplace/uninstall/:productId'
});
var _default = function _default(req) {
  return {
    installMarketplaceDeploymentModel: function installMarketplaceDeploymentModel(appId, productId, version) {
      return req.post(routes.installDM(appId, productId)).query({
        version: version
      });
    },
    uninstallMarketplaceDeploymentModel: function uninstallMarketplaceDeploymentModel(appId, productId) {
      return req.post(routes.uninstallDM(appId, productId));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/codegen.js":
/*!************************!*\
  !*** ./src/codegen.js ***!
  \************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = exports.CACHE_PATH = void 0;
var _isObject2 = _interopRequireDefault(__webpack_require__(/*! lodash/isObject */ "./node_modules/lodash/isObject.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var GENERATORS_PATH = 'codegen/features/generators';
var JSON_PATTERN = '*.json';
var PAGE_SIZE = 100;
var CACHE_PATH = 'codegen/cache.json';

// TODO: remove this transformation when the format of options will be changed
exports.CACHE_PATH = CACHE_PATH;
var OPTION_NAMES_MAP = {
  'selections': 'options',
  'default': 'defaultValue',
  'tooltip': 'hint'
};
// TODO: remove this transformation when the format of options will be changed
var normalizeOptions = function normalizeOptions(options) {
  return options && options.map(normalizeOption);
};
// TODO: remove this transformation when the format of options will be changed
var normalizeOption = function normalizeOption(option) {
  for (var key in option) {
    var normalizeName = OPTION_NAMES_MAP[key];
    if (normalizeName) {
      option[normalizeName] = option[key];
      delete option[key];
    }
  }
  return option;
};
var _default = function _default(req) {
  return {
    getGeneratedProject: function getGeneratedProject(appId, codegenData) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/codegen"), codegenData);
    },
    getGenerators: function getGenerators(appId) {
      var listGenerators = function listGenerators(appId) {
        return req.api.files.loadDirectory(appId, GENERATORS_PATH, {
          pattern: JSON_PATTERN,
          sub: false,
          pageSize: PAGE_SIZE
        });
      };
      var getFeatureFile = function getFeatureFile(file) {
        return req.get(_urls["default"].fileView(appId, file.url)).then(function (feature) {
          if ((0, _isObject2["default"])(feature) && !Array.isArray(feature)) {
            // TODO: remove this transformation when the format of options will be changes
            feature.options = normalizeOptions(feature.options);
            return feature;
          } else {
            return {
              error: file.name
            };
          }
        })["catch"](function () {
          return undefined;
        });
      };
      return listGenerators(appId).then(function (_ref) {
        var data = _ref.data;
        return Promise.all(data.map(getFeatureFile));
      }).then(function (features) {
        return features.filter(function (feature) {
          return !!feature;
        });
      });
    },
    getCache: function getCache(appId) {
      return req.get(_urls["default"].fileView(appId, CACHE_PATH));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/codeless.js":
/*!*************************!*\
  !*** ./src/codeless.js ***!
  \*************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return {
    loadApiServices: function loadApiServices(appId) {
      return req.get(_urls["default"].codelessApiServices(appId));
    },
    loadFunctions: function loadFunctions(appId) {
      return req.get(_urls["default"].codelessFunctions(appId));
    },
    createFunction: function createFunction(appId, fn) {
      return req.post(_urls["default"].codelessFunctions(appId), fn);
    },
    loadFunctionSource: function loadFunctionSource(appId, functionId) {
      return req.get(_urls["default"].codelessFunctionSource(appId, functionId));
    },
    updateFunctionSource: function updateFunctionSource(appId, functionId, xml, code, definition) {
      return req.put(_urls["default"].codelessFunctionSource(appId, functionId), {
        xml: xml,
        code: code,
        definition: definition
      });
    },
    removeFunctionSource: function removeFunctionSource(appId, functionId) {
      return req["delete"](_urls["default"].codelessFunctionSource(appId, functionId));
    },
    deployCodelessModel: function deployCodelessModel(appId, model, items) {
      return req.post(_urls["default"].codelessDeployModel(appId, model), items);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/community.js":
/*!**************************!*\
  !*** ./src/community.js ***!
  \**************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.community = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  comments: '/console/community/comments',
  comment: '/console/community/comments/:commentId',
  commentAction: '/console/community/comments/:commentId/:action',
  reviews: '/console/community/reviews',
  review: '/console/community/reviews/:reviewId',
  vote: '/console/community/vote/like',
  likers: '/console/community/vote/likers',
  blacklistStatus: '/console/community/blacklist/status',
  onProductInstall: '/console/community/activity/products/install',
  reportUserActivity: '/console/community/activity/report',
  devSuicide: '/console/community/dev/suicide'
});
var activeCampaignRoutes = (0, _routes.prepareRoutes)({
  registerDeveloper: '/console/community/active-campaign/registration'
});
var community = function community(req) {
  return {
    //---- COMMENTS ----//
    getComments: function getComments(context, itemId, sorting) {
      return req.community.get(routes.comments()).query({
        context: context,
        itemId: itemId,
        sorting: sorting
      });
    },
    createComments: function createComments(comment) {
      return req.community.post(routes.comments(), comment);
    },
    editComment: function editComment(commentId, body) {
      return req.community.put(routes.comment(commentId), {
        commentId: commentId,
        body: body
      });
    },
    deleteComment: function deleteComment(commentId) {
      return req.community["delete"](routes.comment(commentId));
    },
    hideComment: function hideComment(commentId) {
      return req.community.put(routes.commentAction(commentId, 'hide'));
    },
    displayComment: function displayComment(commentId) {
      return req.community.put(routes.commentAction(commentId, 'display'));
    },
    //---- REVIEWS ----//
    getReviews: function getReviews(context, itemId, sorting) {
      return req.community.get(routes.reviews()).query({
        context: context,
        itemId: itemId,
        sorting: sorting
      });
    },
    createReview: function createReview(review) {
      return req.community.post(routes.reviews(), review);
    },
    editReview: function editReview(reviewId, body, rating) {
      return req.community.put(routes.review(reviewId), {
        body: body,
        rating: rating
      });
    },
    deleteReview: function deleteReview(reviewId) {
      return req.community["delete"](routes.review(reviewId));
    },
    //---- VOTES ----//
    vote: function vote(_vote) {
      return req.community.post(routes.vote(), _vote);
    },
    getLikers: function getLikers(type, itemId) {
      return req.community.get(routes.likers()).query({
        type: type,
        itemId: itemId
      });
    },
    getUserBlacklistStatus: function getUserBlacklistStatus() {
      return req.community.get(routes.blacklistStatus());
    },
    //---- ACTIVITY ----//
    onProductInstall: function onProductInstall(productId) {
      return req.community.post(routes.onProductInstall(), {
        productId: productId
      });
    },
    reportUserActivity: function reportUserActivity() {
      return req.community.post(routes.reportUserActivity());
    },
    //---- ACTIVE CAMPAIGN ----//
    onRegisterDeveloper: function onRegisterDeveloper(dev) {
      return req.community.post(activeCampaignRoutes.registerDeveloper(), {
        dev: dev
      });
    },
    onDeveloperSuicide: function onDeveloperSuicide() {
      return req.community["delete"](routes.devSuicide());
    }
  };
};
exports.community = community;

/***/ }),

/***/ "./src/console-preview.js":
/*!********************************!*\
  !*** ./src/console-preview.js ***!
  \********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  previewInitToken: '/:applicationId/console/preview/preview-init-token'
});
var _default = function _default(req) {
  return {
    getPreviewInitToken: function getPreviewInitToken(appId) {
      return req.get(routes.previewInitToken(appId));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/constants/data.js":
/*!*******************************!*\
  !*** ./src/constants/data.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.USERS_TABLE = exports.PRIMITIVES = exports.NON_SEARCHABLE_USERS_COLUMNS = exports.NON_SEARCHABLE_COLUMNS = exports.DataTypes = void 0;
var DataTypes = {
  INT: 'INT',
  DOUBLE: 'DOUBLE',
  BOOLEAN: 'BOOLEAN',
  STRING: 'STRING',
  DATETIME: 'DATETIME',
  TEXT: 'TEXT',
  STRING_ID: 'STRING_ID',
  EXTENDED_STRING: 'EXTENDED_STRING',
  FILE_REF: 'FILE_REF',
  DATA_REF: 'DATA_REF',
  GEO_REF: 'GEO_REF',
  CHILD_OF: 'CHILD_OF',
  UNKNOWN: 'UNKNOWN'
};
exports.DataTypes = DataTypes;
var PRIMITIVES = [DataTypes.STRING, DataTypes.STRING_ID, DataTypes.EXTENDED_STRING, DataTypes.TEXT, DataTypes.INT, DataTypes.DOUBLE];
exports.PRIMITIVES = PRIMITIVES;
var USERS_TABLE = 'Users';
exports.USERS_TABLE = USERS_TABLE;
var NON_SEARCHABLE_COLUMNS = ['objectId'];
exports.NON_SEARCHABLE_COLUMNS = NON_SEARCHABLE_COLUMNS;
var NON_SEARCHABLE_USERS_COLUMNS = [].concat(NON_SEARCHABLE_COLUMNS, ['password', 'socialAccount', 'userStatus', 'lastLogin', 'isEmailConfirmed']);
exports.NON_SEARCHABLE_USERS_COLUMNS = NON_SEARCHABLE_USERS_COLUMNS;

/***/ }),

/***/ "./src/constants/security.js":
/*!***********************************!*\
  !*** ./src/constants/security.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.SYSTEM_ROLES = exports.PermissionServices = exports.PermissionPolicies = exports.ALL_OBJECTS = void 0;
var ALL_OBJECTS = 'all';
exports.ALL_OBJECTS = ALL_OBJECTS;
var PermissionServices = {
  DATA: 'data',
  MESSAGING: 'messaging',
  GEO: 'geo',
  FILES: 'files',
  API_SERVICES: 'localservices'
};
exports.PermissionServices = PermissionServices;
var PermissionPolicies = {
  USERS: 'users',
  ROLES: 'roles',
  OWNER: 'owner',
  COLUMNS: 'columns'
};
exports.PermissionPolicies = PermissionPolicies;
var SYSTEM_ROLES = ['ASUser', 'GooglePlusUser', 'NotAuthenticatedUser', 'DotNetUser', 'SocialUser', 'AndroidUser', 'FacebookUser', 'IOSUser', 'TwitterUser', 'AuthenticatedUser', 'RestUser', 'ServerCodeUser', 'JSUser', 'GuestUser'];
exports.SYSTEM_ROLES = SYSTEM_ROLES;

/***/ }),

/***/ "./src/counters.js":
/*!*************************!*\
  !*** ./src/counters.js ***!
  \*************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var DEFAULT_NAME_PATTERN = '*';
var normalizeResponse = function normalizeResponse(item) {
  return _objectSpread(_objectSpread({}, item), {}, {
    objectId: item.name
  });
};
var _default = function _default(req) {
  return {
    get: function get(appId, _ref) {
      var pageSize = _ref.pageSize,
        offset = _ref.offset,
        sortField = _ref.sortField,
        sortDir = _ref.sortDir,
        _ref$pattern = _ref.pattern,
        pattern = _ref$pattern === void 0 ? DEFAULT_NAME_PATTERN : _ref$pattern;
      return req.get(_urls["default"].atomicCounters(appId)).query({
        pageSize: pageSize,
        offset: offset,
        sortField: sortField,
        sortDir: sortDir,
        pattern: pattern
      });
    },
    listNames: function listNames(appId) {
      var pattern = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_NAME_PATTERN;
      return req.get("".concat(_urls["default"].atomicCounters(appId), "/").concat(pattern, "/list-names"));
    },
    listCounters: function listCounters(appId, names) {
      return req.post("".concat(_urls["default"].atomicCounters(appId), "/list-by-names"), names);
    },
    create: function create(appId, name, value) {
      return req.post("".concat(_urls["default"].atomicCounters(appId), "/").concat(encodeURIComponent(name)), {
        value: value
      }).then(normalizeResponse);
    },
    update: function update(appId, name, currentValue, newValue) {
      return req.put("".concat(_urls["default"].atomicCounters(appId), "/").concat(encodeURIComponent(name)), {
        currentValue: currentValue,
        newValue: newValue
      });
    },
    remove: function remove(appId, name) {
      return req["delete"]("".concat(_urls["default"].atomicCounters(appId), "/").concat(encodeURIComponent(name)));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/data-connectors.js":
/*!********************************!*\
  !*** ./src/data-connectors.js ***!
  \********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _totalRows = _interopRequireDefault(__webpack_require__(/*! ./utils/total-rows */ "./src/utils/total-rows.js"));
var _table = __webpack_require__(/*! ./utils/table */ "./src/utils/table.js");
var recordsReq = function recordsReq(req, appId, connectorId, table, query, resetCache) {
  var url = "".concat(_urls["default"].dataConnectorTableEntries(appId, connectorId, table.name), "/find");
  return (0, _table.tableRecordsReq)(req, url, table, query, resetCache);
};
var recordsCountReq = function recordsCountReq(req, appId, connectorId, table, query, resetCache) {
  var url = _urls["default"].dataConnectorTableEntries(appId, connectorId, table.name);
  return (0, _table.tableRecordsReq)(req, url, table, query, resetCache);
};
var _default = function _default(req) {
  return {
    getTemplates: function getTemplates(appId) {
      return req.get(_urls["default"].dataConnectorTemplates(appId));
    },
    getConnectors: function getConnectors(appId, forceRefresh) {
      return req.get(_urls["default"].dataConnectors(appId)).query({
        forceRefresh: forceRefresh
      });
    },
    activateConnector: function activateConnector(appId, connector) {
      return req.post(_urls["default"].dataConnectors(appId), connector);
    },
    deleteConnector: function deleteConnector(appId, connectorId) {
      return req["delete"](_urls["default"].dataConnector(appId, connectorId));
    },
    updateConnector: function updateConnector(appId, connector) {
      return req.put(_urls["default"].dataConnector(appId, connector.id), connector);
    },
    getConnectorTables: function getConnectorTables(appId, connectorId, query) {
      return req.get(_urls["default"].dataConnectorTables(appId, connectorId)).query(query);
    },
    getConnectorTableEntries: function getConnectorTableEntries(appId, connectorId, table, query) {
      return recordsReq(req, appId, connectorId, table, query);
    },
    getConnectorTableEntriesCount: function getConnectorTableEntriesCount(appId, connectorId, table, query, resetCache) {
      return (0, _totalRows["default"])(req).getFor(recordsCountReq(req, appId, connectorId, table, query, resetCache));
    },
    getConnectorStoredProcedures: function getConnectorStoredProcedures(appId, connectorId) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      return req.get(_urls["default"].dataConnectorStoredProcedures(appId, connectorId)).query({
        forceRefresh: options.forceRefresh
      });
    },
    executeConnectorStoredProcedure: function executeConnectorStoredProcedure(appId, connectorId, procedureId, params) {
      return req.post(_urls["default"].dataConnectorStoredProcedureExecution(appId, connectorId, procedureId), params);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/data-hives.js":
/*!***************************!*\
  !*** ./src/data-hives.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = __webpack_require__(/*! ./urls */ "./src/urls.js");
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  setKeyExpire: '/:appId/console/hive/:hiveName/:store/:key/expire',
  setKeyExpireAt: '/:appId/console/hive/:hiveName/:store/:key/expire-at',
  keyExpirationTTL: '/:appId/console/hive/:hiveName/:store/:key/get-expiration-ttl',
  clearKeyExpiration: '/:appId/console/hive/:hiveName/:store/:key/clear-expiration',
  keySecondsSinceLastOperation: '/:appId/console/hive/:hiveName/:store/:key/seconds-since-last-operation',
  //
  addListStoreItems: '/:appId/console/hive/:hiveName/list/:key/add-last',
  removeListStoreItemByValue: '/:appId/console/hive/:hiveName/list/:key/delete-value',
  listStoreItemByIndex: '/:appId/console/hive/:hiveName/list/:key/:index',
  addSetStoreItems: '/:appId/console/hive/:hiveName/set/:key/add',
  removeSetStoreItemByValue: '/:appId/console/hive/:hiveName/set/:key/values'
});
var HiveDataTypesMap = {
  KEY_VALUE: 'key-value',
  LIST: 'list',
  MAP: 'map',
  SET: 'set',
  SORTED_SET: 'sorted-set'
};
var _default = function _default(req) {
  return {
    getHiveNames: function getHiveNames(appId) {
      return req.get((0, _urls.dataHives)(appId));
    },
    createHive: function createHive(appId, hiveName) {
      return req.post("".concat((0, _urls.dataHive)(appId, hiveName)));
    },
    renameHive: function renameHive(appId, oldName, newName) {
      return req.put((0, _urls.dataHive)(appId, oldName)).query({
        newName: newName
      });
    },
    deleteHive: function deleteHive(appId, hiveName) {
      return req["delete"]("".concat((0, _urls.dataHive)(appId, hiveName)));
    },
    loadHiveStoreKeys: function loadHiveStoreKeys(appId, hiveName, storeType, _ref) {
      var pageSize = _ref.pageSize,
        cursor = _ref.cursor;
      return req.get("".concat((0, _urls.dataHive)(appId, hiveName), "/").concat(storeType, "/keys")).query({
        pageSize: pageSize,
        cursor: cursor
      });
    },
    loadHiveStoreValues: function loadHiveStoreValues(appId, hiveName, storeType, keys) {
      if (storeType === HiveDataTypesMap.KEY_VALUE) {
        return [req.post((0, _urls.dataHiveStore)(appId, hiveName, storeType), keys)];
      }
      if (storeType === HiveDataTypesMap.SORTED_SET) {
        return keys.map(function (key) {
          return req.get("".concat((0, _urls.dataHiveStoreKey)(appId, hiveName, storeType, key), "/get-range-by-rank")).query({
            startRank: 0,
            stopRank: 99,
            withScores: true
          });
        });
      }
      return keys.map(function (key) {
        return req.get((0, _urls.dataHiveStoreKey)(appId, hiveName, storeType, key));
      });
    },
    setHiveStoreValue: function setHiveStoreValue(appId, hiveName, storeType, keyName, payload) {
      return req.put((0, _urls.dataHiveStoreKey)(appId, hiveName, storeType, keyName), payload);
    },
    addHiveStoreValue: function addHiveStoreValue(appId, hiveName, storeType, keyName, payload) {
      return req.put("".concat((0, _urls.dataHiveStoreKey)(appId, hiveName, storeType, keyName), "/add"), payload);
    },
    removeHiveStoreRecords: function removeHiveStoreRecords(appId, hiveName, storeType, keys) {
      return req["delete"]((0, _urls.dataHiveStore)(appId, hiveName, storeType), keys);
    },
    removeHiveStoreValue: function removeHiveStoreValue(appId, hiveName, storeType, keyName, values) {
      return req["delete"]("".concat((0, _urls.dataHiveStoreKey)(appId, hiveName, storeType, keyName), "/values"), values);
    },
    //---- Base Type -------------------------//
    setKeyExpiration: function setKeyExpiration(appId, hiveName, storeType, key, _ref2) {
      var ttl = _ref2.ttl,
        unixTime = _ref2.unixTime;
      if (ttl !== undefined) {
        return req.put(routes.setKeyExpire(appId, hiveName, storeType, key)).query({
          ttl: ttl
        });
      }
      return req.put(routes.setKeyExpireAt(appId, hiveName, storeType, key)).query({
        unixTime: unixTime
      });
    },
    getKeyExpirationTTL: function getKeyExpirationTTL(appId, hiveName, storeType, key) {
      return req.get(routes.keyExpirationTTL(appId, hiveName, storeType, key));
    },
    clearKeyExpiration: function clearKeyExpiration(appId, hiveName, storeType, key) {
      return req.put(routes.clearKeyExpiration(appId, hiveName, storeType, key));
    },
    getKeySecondsSinceLastOperation: function getKeySecondsSinceLastOperation(appId, hiveName, storeType, key) {
      return req.get(routes.keySecondsSinceLastOperation(appId, hiveName, storeType, key));
    },
    //---- Base Type -------------------------//
    //---- LIST Type -------------------------//
    addHiveListStoreItems: function addHiveListStoreItems(appId, hiveName, key, items) {
      return req.put(routes.addListStoreItems(appId, hiveName, key), items);
    },
    removeHiveListStoreItemByValue: function removeHiveListStoreItemByValue(appId, hiveName, key, value) {
      return req.put(routes.removeListStoreItemByValue(appId, hiveName, key), {
        value: value
      });
    },
    updateHiveListStoreItemByIndex: function updateHiveListStoreItemByIndex(appId, hiveName, key, index, value) {
      return req.put(routes.listStoreItemByIndex(appId, hiveName, key, index), {
        value: value
      });
    },
    //---- LIST Type -------------------------//
    //---- SET Type -------------------------//
    addHiveSetStoreItems: function addHiveSetStoreItems(appId, hiveName, key, items) {
      return req.put(routes.addSetStoreItems(appId, hiveName, key), items);
    },
    removeHiveSetStoreItemByValue: function removeHiveSetStoreItemByValue(appId, hiveName, key, value) {
      return req["delete"](routes.removeSetStoreItemByValue(appId, hiveName, key), [value]);
    } //---- SET Type -------------------------//
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/data-to-visualize.js":
/*!**********************************!*\
  !*** ./src/data-to-visualize.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
/* eslint-disable max-len */
var routes = (0, _routes.prepareRoutes)({
  dashboards: '/:appId/console/data-to-visualize/dashboards',
  dashboard: '/:appId/console/data-to-visualize/dashboards/:dashboardId',
  dashboardClone: '/:appId/console/data-to-visualize/dashboards/:dashboardId/clone',
  dashboardSettings: '/:appId/console/data-to-visualize/dashboards/:dashboardId/settings',
  dashlets: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlets',
  createDashlets: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlets/create',
  dashlet: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlets/:dashletId',
  dashletComponents: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components',
  dashletComponentInstall: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components/install',
  dashletComponentCreate: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components/create',
  dashletComponentUpgrade: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components/upgrade',
  dashletComponent: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components/:componentId/',
  dashletComponentFiles: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components/:componentId/files',
  dashletComponentFile: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components/:componentId/files/:fileId',
  dashletComponentFilesDownloadLink: '/:appId/console/data-to-visualize/dashboards/:dashboardId/dashlet-components/:componentId/files/sign'
});
var _default = function _default(req) {
  return {
    getDashboards: function getDashboards(appId, query) {
      return req.get(routes.dashboards(appId)).query(query);
    },
    createDashboard: function createDashboard(appId, dashboard) {
      return req.post(routes.dashboards(appId), dashboard);
    },
    cloneDashboard: function cloneDashboard(appId, dashboardId) {
      return req.post(routes.dashboardClone(appId, dashboardId));
    },
    updateDashboard: function updateDashboard(appId, dashboardId, changes) {
      return req.put(routes.dashboard(appId, dashboardId), changes);
    },
    updateDashboards: function updateDashboards(appId, changes) {
      return req.put(routes.dashboards(appId), changes);
    },
    updateDashboardSettings: function updateDashboardSettings(appId, dashboardId, settings) {
      return req.put(routes.dashboardSettings(appId, dashboardId), settings);
    },
    deleteDashboard: function deleteDashboard(appId, name) {
      return req["delete"](routes.dashboard(appId, name));
    },
    addDashboardDashlet: function addDashboardDashlet(appId, dashboardId, dashletComponent) {
      return req.post(routes.dashlets(appId, dashboardId), dashletComponent);
    },
    createDashboardDashlets: function createDashboardDashlets(appId, dashboardId, dashlets) {
      return req.post(routes.createDashlets(appId, dashboardId), dashlets);
    },
    deleteDashboardDashlet: function deleteDashboardDashlet(appId, dashboardId, dashletId) {
      return req["delete"](routes.dashlet(appId, dashboardId, dashletId));
    },
    updateDashboardDashlet: function updateDashboardDashlet(appId, dashboardId, dashletId, changes) {
      return req.put(routes.dashlet(appId, dashboardId, dashletId), changes);
    },
    loadDashletComponents: function loadDashletComponents(appId, dashboardId) {
      return req.get(routes.dashletComponents(appId, dashboardId));
    },
    installDashletComponent: function installDashletComponent(appId, dashboardId, product) {
      return req.post(routes.dashletComponentInstall(appId, dashboardId), product);
    },
    upgradeDashletComponent: function upgradeDashletComponent(appId, dashboardId, product, versionId) {
      return req.post(routes.dashletComponentUpgrade(appId, dashboardId), {
        product: product,
        versionId: versionId
      });
    },
    createDashletComponent: function createDashletComponent(appId, dashboardId, dashlet) {
      return req.post(routes.dashletComponentCreate(appId, dashboardId), dashlet);
    },
    deleteDashletComponent: function deleteDashletComponent(appId, dashboardId, componentId) {
      return req["delete"](routes.dashletComponent(appId, dashboardId, componentId));
    },
    updateDashletComponent: function updateDashletComponent(appId, dashboardId, componentId, changes) {
      return req.put(routes.dashletComponent(appId, dashboardId, componentId), changes);
    },
    getDashletComponentFileDownloadLink: function getDashletComponentFileDownloadLink(appId, dashboardId, componentId, fileId) {
      return req.get(routes.dashletComponentFilesDownloadLink(appId, dashboardId, componentId)).query({
        fileId: fileId
      });
    },
    loadDashletComponentFilesList: function loadDashletComponentFilesList(appId, dashboardId, componentId) {
      return req.get(routes.dashletComponentFiles(appId, dashboardId, componentId));
    },
    loadDashletComponentFileContent: function loadDashletComponentFileContent(appId, dashboardId, componentId, fileName) {
      return req.get(routes.dashletComponentFile(appId, dashboardId, componentId, fileName));
    },
    uploadDashletComponentFiles: function uploadDashletComponentFiles(appId, dashboardId, componentId, files) {
      return req.post(routes.dashletComponentFiles(appId, dashboardId, componentId), files);
    },
    updateDashletComponentFiles: function updateDashletComponentFiles(appId, dashboardId, componentId, files) {
      return req.put(routes.dashletComponentFiles(appId, dashboardId, componentId), files);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/data-views.js":
/*!***************************!*\
  !*** ./src/data-views.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
var _typeof = __webpack_require__(/*! @babel/runtime/helpers/typeof */ "./node_modules/@babel/runtime/helpers/typeof.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.recordsReq = exports.recordsCountReq = exports.groupRecordsReq = exports.groupRecordsCountReq = exports["default"] = void 0;
var _urls = _interopRequireWildcard(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _views = __webpack_require__(/*! ./utils/views */ "./src/utils/views.js");
var _totalRows = _interopRequireDefault(__webpack_require__(/*! ./utils/total-rows */ "./src/utils/total-rows.js"));
var _table = __webpack_require__(/*! ./utils/table */ "./src/utils/table.js");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var dataTableFindUrl = function dataTableFindUrl(appId, tableName) {
  return "".concat((0, _urls.dataTable)(appId, tableName), "/find");
};
var recordsReq = function recordsReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var resetCache = arguments.length > 4 ? arguments[4] : undefined;
  return (0, _views.viewRecordsReq)(req, dataTableFindUrl(appId, view.name), view, query, resetCache);
};
exports.recordsReq = recordsReq;
var recordsCountReq = function recordsCountReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var resetCache = arguments.length > 4 ? arguments[4] : undefined;
  return (0, _views.viewRecordsCountReq)(req, (0, _urls.dataTable)(appId, view.name), view, query, resetCache);
};
exports.recordsCountReq = recordsCountReq;
var groupRecordsReq = function groupRecordsReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  return (0, _views.viewRecordsGroupReq)(req, (0, _urls.dataTableGroup)(appId, view.name), view.viewId, query);
};
exports.groupRecordsReq = groupRecordsReq;
var groupRecordsCountReq = function groupRecordsCountReq(req, appId, view) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  return (0, _views.viewRecordsGroupCountReq)(req, (0, _urls.dataTableGroupCount)(appId, view.name), query);
};
exports.groupRecordsCountReq = groupRecordsCountReq;
var _default = function _default(req) {
  return {
    getViews: function getViews(appId) {
      return req.get((0, _urls.dataViews)(appId));
    },
    getViewRecords: function getViewRecords(appId, viewName) {
      return req.get("".concat((0, _urls.dataViews)(appId), "/").concat(viewName));
    },
    createView: function createView(appId, view) {
      return req.post((0, _urls.dataViews)(appId), view);
    },
    updateView: function updateView(appId, view) {
      return req.put((0, _urls.dataViews)(appId, view.viewId), view);
    },
    renameView: function renameView(appId, viewId, name) {
      return req.put("".concat((0, _urls.dataViews)(appId, viewId), "/name"), {
        name: name
      });
    },
    deleteView: function deleteView(appId, viewId) {
      return req["delete"]((0, _urls.dataViews)(appId, viewId));
    },
    loadRecords: function loadRecords(appId, view, query) {
      return recordsReq(req, appId, view, query);
    },
    getRecordsCount: function getRecordsCount(appId, view, query, resetCache) {
      return (0, _totalRows["default"])(req).getViaPostFor(recordsCountReq(req, appId, view, query, resetCache));
    },
    getRecordsCounts: function getRecordsCounts(appId, views, resetCache) {
      return req.post("".concat(_urls["default"].data(appId), "/tables-counters"), {
        tables: views,
        resetCache: resetCache
      });
    },
    loadGroupRecords: function loadGroupRecords(appId, view, query) {
      return groupRecordsReq(req, appId, view, query);
    },
    getGroupRecordsCount: function getGroupRecordsCount(appId, view, query) {
      return groupRecordsCountReq(req, appId, view, query);
    },
    loadSampleRecords: function loadSampleRecords(appId, table) {
      var query = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var params = (0, _table.composeRequestParams)(table, query);
      return req.post("".concat(_urls["default"].data(appId), "/table-pre-view/").concat(encodeURI(table.name), "/find"), params);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/dev-permissions.js":
/*!********************************!*\
  !*** ./src/dev-permissions.js ***!
  \********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = exports.DevPermissions = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var AccessTypes = {
  GRANT: 'GRANT',
  DENY: 'DENY'
};
var OperationsTypes = {
  /** App Access Security */
  INVITE_OR_REMOVE_TEAM_MEMBER: 1,
  // Add/remove developer
  ASSIGN_TEAM_MEMBER_PERMISSION: 3,
  // Modify permission
  DELETE_AUDIT_LOGS: 115,
  // Delete Audit Logs
  ACTIVATE_HIPAA_COMPLIANCE: 114,
  // Activate HIPAA Compliance
  ENABLE_PANIC_MODE: 112,
  // Enable Panic Mode

  /** App Settings */
  APP_RESET: 13,
  // Application reset
  MODIFY_CORS_DOMAIN_CONTROL: 8,
  // Modify CORS/domain control
  MODIFY_CUSTOM_DOMAIN: 9,
  // Modify custom domain
  MODIFY_EMAIL_SETTINGS: 7,
  // Modify email settings
  MODIFY_LIMIT_NOTIFICATION: 14,
  // Modify limit notification
  MODIFY_MOBILE_SETTINGS: 6,
  // Modify mobile settings
  MANAGE_OAUTH_PROVIDERS: 5,
  // Manage OAuth2 providers
  DELETE_APPLICATION: 11,
  // Delete application
  MANAGE_API_KEYS: 4,
  // Manage API keys
  RENAME_APP: 110,
  // Rename App

  /** Billing */
  BILLING_SECTION: 'Billing section',
  ADD_UPDATE_CREDIT_CARD: 20,
  // Add/update credit card
  MODIFY_BILLING_PLAN: 21,
  // Modify billing plan
  MARKETPLACE_DELETE_PURCHASE: 23,
  // Delete Marketplace purchases
  MARKETPLACE_PURCHASE: 22,
  // Purchase from the Marketplace

  /** Cache-Control **/
  CACHE_CONTROL_SECTION: 'Cache-Control settings',
  MODIFY_CACHE_CONTROL_RULES: 116,
  // Modify Cache-Control rules

  /** AUTOMATION **/
  AUTOMATION_SECTION: 'Automation',
  CREATE_MODIFY_DELETE_FLOWS: 117,
  // Create/Rename/Delete flows

  /** Cloud Code */
  CLOUD_CODE_SECTION: 'Cloud Code section',
  DELETE_FROM_MARKETPLACE: 98,
  // Delete from marketplace
  INVOKE_EVENT_WITH_MODEL: 97,
  // Invoke event with model
  MODIFY_BL: 93,
  // Modify Cloud Code
  PUBLISH_TO_MARKETPLACE: 94,
  // Publish to Marketplace
  RUN_TIMER: 96,
  // Run timer

  /** Data Service */
  DATA_SERVICE_SECTION: 'Data Service section',
  MODIFY_DYNAMIC_SCHEMA_DEFINITION: 47,
  // Modify "Dynamic Schema Definition" configuration
  CREATE_MODIFY_DELETE_COLUMN: 42,
  // Create/Rename/Delete columns
  CREATE_MODIFY_DELETE_TABLE: 40,
  // Create/Rename/Delete tables
  CREATE_DELETE_UPDATE_OBJECTS: 46,
  // Create/delete/update objects
  CREATE_MODIFY_DELETE_TABLE_PERMISSIONS: 44,
  // Manage permissions for tables (including ACL)
  CREATE_MODIFY_DELETE_OWNER_PERMISSIONS: 54,
  // Manage global owner permissions
  CREATE_MODIFY_DELETE_COLUMNS_VISIBILITY_PERMISSIONS: 109,
  // Manage columns visibility permissions

  /** Data connector */
  DATA_CONNECTOR_SECTION: 'Data Connector section',
  CREATE_MODIFY_DELETE_DATA_CONNECTOR: 99,
  // Manage data connectors
  STORED_PROCEDURE: 102,
  // Call stored procedure

  /** Email Templates */
  EMAIL_TEMPLATES_SECTION: 'Email Templates section',
  CREATE_MODIFY_DELETE_TEMPLATE: 33,
  // Manage email templates. Send test email

  /** File Service */
  FILES_SECTION: 'Files section',
  MODIFY_FILE_PERMISSIONS: 60,
  // Manage directories/files permissions
  MANAGE_DIRECTORIES_AND_FILES: 57,
  // Manage directories and files
  UPLOAD_CREATE_FILES: 59,
  // Upload/create files
  VIEW_DIRECTORY_CONTENT: 106,
  // View directory content

  /** Geolocation */
  GEOLOCATION_SECTION: 'Geolocation section',
  MODIFY_GEO_CATEGORY_PERMISSIONS: 83,
  // Manage user/role permissions for geo category
  CREATE_MODIFY_DELETE_GEOFENCE: 85,
  // Create/Rename/Delete geofences
  MODIFY_GEO_POINT_METADATA: 84,
  // Modify geopoint metadata
  CREATE_MODIFY_DELETE_GEO_CATEGORY: 81,
  // Create/Rename/Delete geo category
  CREATE_MODIFY_DELETE_GEO_POINT: 88,
  // Create/Modify/Delete/Copy geo points

  /** Import/Export */
  IMPORT_EXPORT_SECTION: 'Import/Export section',
  CLONE_APP: 27,
  // Clone application
  EXPORT_APP: 24,
  // Export app settings/app data
  IMPORT: 25,
  // Import

  /** Landing Page */
  LANDING_PAGE_SECTION: 'Landing Page section',
  MODIFY_LANDING_PAGE: 29,
  // Modify landing page
  PUBLISH_LANDING_PAGE: 30,
  // Publish landing page

  /** Log Management */
  LOG_MANAGEMENT_SECTION: 'Log Management section',
  MODIFY_LOG_CONFIG: 17,
  // Modify logging configuration
  MODIFY_LOG_INTEGRATIONS: 19,
  // Modify logging integrations
  DELETE_LOGGERS: 18,
  // Delete log files

  /** Messaging/Push Notifications */
  MESSAGING_SECTION: 'Messaging section',
  MODIFY_MESSAGING_CHANNEL_PERMISSIONS: 70,
  // Manage user/role permissions for messaging channel
  CREATE_MODIFY_DELETE_BUTTON: 73,
  // Create/Rename/Delete button options
  CREATE_MODIFY_DELETE_CHANEL_OPTIONS: 75,
  // Create/Rename/Delete channel options
  CREATE_MODIFY_DELETE_CHANEL: 67,
  // Create/Rename/Delete messaging channels
  CREATE_MODIFY_DELETE_PUSH_TEMPLATE: 71,
  // Create/Rename/Delete push template
  SEND_MESSAGE_TO_CHANNEL: 69,
  // Send a message to a channel
  SEND_PUSH_BY_TEMPLATE: 77,
  // Send push notification with template

  /** Security Roles */
  SECURITY_ROLES_SECTION: 'Security Roles section',
  ADD_MODIFY_ASSIGN_ROLE: 37,
  // Manage security roles
  ASSIGN_ROLE_PERMISSIONS: 39,
  // Map users to roles

  /** User Management */
  USERS_SECTION: 'Users section',
  MODIFY_LOGIN_PROPS: 32,
  // Modify login properties
  MODIFY_USER_REGISTRATION_PROPS: 31,
  // Modify user registration properties
  LOGOUT_ALL_USERS: 107,
  // Logout all users

  /** UI Builder */
  ACCESS_UI_BUILDER: 'Access UI Builder',
  PUBLISH_UI_CONTAINERS: 111,
  /** FLOWRUNNER */
  FLOWRUNNER_SECTION: 'FlowRunner',
  EDIT_FLOW_VERSION: 117,
  // Edit Flow Version
  ACCESS_FLOW_PERMISSIONS: 118,
  // Access Flow Permissions
  LAUNCH_FLOW_VERSION: 119,
  // Launch Flow Version (via console)
  ACCESS_VERSION_ADMIN: 120 // Access Version Admin
};

var OperationsLabels = {};
Object.keys(OperationsTypes).forEach(function (operation) {
  OperationsLabels[operation] = OperationsTypes[operation];
  OperationsTypes[operation] = operation;
});
var DevPermissions = {
  OperationsTypes: OperationsTypes,
  OperationsLabels: OperationsLabels,
  AccessTypes: AccessTypes
};
exports.DevPermissions = DevPermissions;
var _default = function _default(req) {
  return {
    get: function get(appId, operation) {
      return req.get("".concat(_urls["default"].security(appId), "/").concat(operation));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/dev-team.js":
/*!*************************!*\
  !*** ./src/dev-team.js ***!
  \*************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _typeof = __webpack_require__(/*! @babel/runtime/helpers/typeof */ "./node_modules/@babel/runtime/helpers/typeof.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireWildcard(__webpack_require__(/*! ./urls */ "./src/urls.js"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var _default = function _default(req) {
  return {
    getDevelopers: function getDevelopers(appId) {
      return req.get((0, _urls.devTeam)(appId));
    },
    updateDevPermissions: function updateDevPermissions(appId, devId, permissions) {
      return req.put("".concat((0, _urls.devTeam)(appId, devId), "/permissions"), permissions);
    },
    updateDevPermissionGroups: function updateDevPermissionGroups(appId, devId, groups) {
      return req.put("".concat((0, _urls.devTeam)(appId, devId), "/permission/groups"), groups);
    },
    inviteDeveloper: function inviteDeveloper(appId, email) {
      return req.post((0, _urls.devTeam)(appId), email);
    },
    removeDeveloper: function removeDeveloper(appId, devId) {
      return req["delete"]("".concat((0, _urls.devTeam)(appId, devId)));
    },
    updateNotificationSettings: function updateNotificationSettings(appId, settings) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/notifications/limits"), settings);
    },
    transferOwnership: function transferOwnership(appId, developerId) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/devteam/owner"), {
        developerId: developerId
      });
    },
    loadOwnershipTransferProposals: function loadOwnershipTransferProposals() {
      return req.get('/console/devteam/application-owner-change/pending-received-proposal');
    },
    confirmOwnershipChange: function confirmOwnershipChange(appId, data) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/devteam/owner-confirm"), data);
    },
    loadSentOwnershipTransfer: function loadSentOwnershipTransfer(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/devteam/application-owner-change/pending-sent-proposal"));
    },
    cancelSentOwnershipTransfer: function cancelSentOwnershipTransfer(appId) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/devteam/application-owner-change/pending-sent-proposal"));
    },
    generateDeveloperSignature: function generateDeveloperSignature() {
      return req.get("".concat(_urls["default"].console(), "/developer/signature"));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/developer-profile.js":
/*!**********************************!*\
  !*** ./src/developer-profile.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  getProfile: '/console/community/profile/me',
  removeProfile: '/console/community/profile/me',
  removeApp: '/console/community/profile/app',
  setProfile: '/console/community/profile',
  getCountries: '/console/community/countries',
  checkUsername: '/console/community/profile/username/check'
});
var _default = function _default(req) {
  return {
    getMyProfile: function getMyProfile() {
      return req.community.get(routes.getProfile());
    },
    createProfile: function createProfile(profileData) {
      return req.community.post(routes.setProfile(), profileData);
    },
    updateProfile: function updateProfile(profileData) {
      return req.community.put(routes.setProfile(), profileData);
    },
    getCountries: function getCountries() {
      return req.community.get(routes.getCountries());
    },
    updateProfilePhoto: function updateProfilePhoto(profilePhoto) {
      return req.community.post(routes.setProfile(), profilePhoto);
    },
    checkUsernameAvailable: function checkUsernameAvailable(userName) {
      return req.community.get(routes.checkUsername()).query({
        userName: userName
      });
    },
    updateProfileBackground: function updateProfileBackground(background) {
      return req.community.post(routes.setProfile(), background);
    },
    remove: function remove() {
      return req.community["delete"](routes.removeProfile());
    },
    removeApp: function removeApp(appId) {
      return req.community["delete"](routes.removeApp()).query({
        appId: appId
      });
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/email.js":
/*!**********************!*\
  !*** ./src/email.js ***!
  \**********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return {
    loadEmailTemplates: function loadEmailTemplates(appId) {
      return this.loadTemplates(appId);
    },
    loadTemplates: function loadTemplates(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/email"));
    },
    saveEmailTemplate: function saveEmailTemplate(appId, template) {
      return this.saveTemplate(appId, template);
    },
    saveTemplate: function saveTemplate(appId, template) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/email/events"), template);
    },
    sendTestEmail: function sendTestEmail(appId, emailData) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/email/events/test"), emailData);
    },
    updateEmailParams: function updateEmailParams(appId, emailSettings) {
      return req.put(_urls["default"].mailSettings(appId), emailSettings);
    },
    resetEmailParams: function resetEmailParams(appId) {
      return req["delete"](_urls["default"].mailSettings(appId));
    },
    getEmailParams: function getEmailParams(appId) {
      return req.get(_urls["default"].mailSettings(appId));
    },
    testSMTPConnection: function testSMTPConnection(appId, emailSettings) {
      return req.put("".concat(_urls["default"].mailSettings(appId), "/test"), emailSettings);
    },
    loadCustomTemplates: function loadCustomTemplates(appId) {
      return req.get(_urls["default"].emailTemplates(appId));
    },
    createCustomTemplate: function createCustomTemplate(appId, payload) {
      return req.post(_urls["default"].emailTemplates(appId), payload);
    },
    updateCustomTemplate: function updateCustomTemplate(appId, payload, templateName) {
      return req.put(_urls["default"].emailTemplates(appId, templateName), payload);
    },
    deleteCustomTemplate: function deleteCustomTemplate(appId, templateName) {
      return req["delete"](_urls["default"].emailTemplates(appId, templateName));
    },
    sendTestCustomEmail: function sendTestCustomEmail(appId, payload) {
      return req.post("".concat(_urls["default"].emailTemplates(appId), "/test"), payload);
    },
    parseCustomTemplateKeys: function parseCustomTemplateKeys(appId, payload) {
      return req.post("".concat(_urls["default"].emailTemplates(appId), "/customkeys"), payload);
    },
    installEmailTemplateFromMarketplace: function installEmailTemplateFromMarketplace(appId, productId, data) {
      return req.post(_urls["default"].installEmailTemplate(appId, productId), data);
    },
    resetSystemEmailTemplate: function resetSystemEmailTemplate(appId, eventId) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/email/events/").concat(eventId));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/files.js":
/*!**********************!*\
  !*** ./src/files.js ***!
  \**********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/regenerator */ "./node_modules/@babel/runtime/regenerator/index.js"));
var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/toConsumableArray */ "./node_modules/@babel/runtime/helpers/toConsumableArray.js"));
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/asyncToGenerator */ "./node_modules/@babel/runtime/helpers/asyncToGenerator.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _totalRows = _interopRequireDefault(__webpack_require__(/*! ./utils/total-rows */ "./src/utils/total-rows.js"));
var _cacheTags = __webpack_require__(/*! ./utils/cache-tags */ "./src/utils/cache-tags.js");
var _path = __webpack_require__(/*! ./utils/path */ "./src/utils/path.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var getFileFolder = function getFileFolder(file) {
  var tokens = file.split('/');
  if (tokens.length > 1) {
    tokens.pop();
    return tokens.join('/');
  }
  return '';
};
var _default = function _default(req) {
  return {
    loadDirectory: function loadDirectory(appId, path, params) {
      path = path || '/';
      var _ref = params || {},
        pattern = _ref.pattern,
        sub = _ref.sub,
        sortBy = _ref.sortBy,
        sortDirection = _ref.sortDirection,
        pageSize = _ref.pageSize,
        offset = _ref.offset;
      var dataReq = req.get(_urls["default"].directoryView(appId, path)).query({
        pattern: pattern,
        sub: sub,
        sortBy: sortBy,
        sortDirection: sortDirection,
        pageSize: pageSize,
        offset: offset
      }).cacheTags((0, _cacheTags.FOLDER)(appId, path));
      return (0, _totalRows["default"])(req).getWithData(dataReq);
    },
    loadFullDirectory: function loadFullDirectory(appId, path, params) {
      return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var currentQuery, url, totalCount, filesList, requests, results;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              currentQuery = _objectSpread(_objectSpread({}, params), {}, {
                pageSize: 100,
                offset: 0
              });
              url = _urls["default"].directoryView(appId, path);
              _context.next = 4;
              return (0, _totalRows["default"])(req).get(url);
            case 4:
              totalCount = _context.sent;
              filesList = [];
              requests = [];
              while (currentQuery.offset < totalCount) {
                requests.push(req.get(url).query(currentQuery));
                currentQuery = _objectSpread(_objectSpread({}, currentQuery), {}, {
                  offset: currentQuery.offset + 100
                });
              }
              _context.next = 10;
              return Promise.all(requests);
            case 10:
              results = _context.sent;
              results.forEach(function (files) {
                return filesList.push.apply(filesList, (0, _toConsumableArray2["default"])(files));
              });
              return _context.abrupt("return", filesList);
            case 13:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    createDir: function createDir(appId, path, folderName) {
      return req.post(_urls["default"].createDir(appId, path, folderName)).cacheTags((0, _cacheTags.FOLDER)(appId, path));
    },
    getFileContent: function getFileContent(appId, filePath) {
      return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", req.get(_urls["default"].fileDownload(appId, filePath)));
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }))();
    },
    performOperation: function performOperation(appId, filePath, operation) {
      //for root directory operations it has send '/' as path
      var path = filePath ? (0, _path.encodePath)(filePath) : encodeURIComponent('/');
      return req.put("".concat(_urls["default"].appConsole(appId), "/files/").concat(path)).query({
        operation: operation
      }).cacheTags((0, _cacheTags.FOLDER)(appId, getFileFolder(path)));
    },
    fileExists: function fileExists(appId, filePath) {
      return req.get(_urls["default"].fileExists(appId, filePath));
    },
    editFile: function editFile(appId, filePath, fileContent) {
      return req.post(_urls["default"].fileEdit(appId, filePath), {
        file: fileContent
      });
    },
    createFile: function createFile(appId, filePath, fileContent) {
      return req.post(_urls["default"].fileCreate(appId, filePath), {
        file: fileContent
      }).set('Accept', '*/*') //workarround for BKNDLSS-13702
      .cacheTags((0, _cacheTags.FOLDER)(appId, getFileFolder(filePath)));
    },
    moveFile: function moveFile(appId, filePath, newFilePath) {
      return req.post(_urls["default"].fileMove(appId, filePath), (0, _path.encodePath)(newFilePath)).cacheTags((0, _cacheTags.FOLDER)(appId, getFileFolder(filePath)));
    },
    copyFile: function copyFile(appId, filePath, newFilePath) {
      return req.post(_urls["default"].fileCopy(appId, filePath), (0, _path.encodePath)(newFilePath)).cacheTags((0, _cacheTags.FOLDER)(appId, getFileFolder(filePath)));
    },
    renameFile: function renameFile(appId, filePath, newFileName) {
      return req.post(_urls["default"].fileRename(appId, filePath), encodeURIComponent(newFileName)).cacheTags((0, _cacheTags.FOLDER)(appId, getFileFolder(filePath)));
    },
    deleteFile: function deleteFile(appId, filePath) {
      return req["delete"](_urls["default"].fileDelete(appId, filePath)).cacheTags((0, _cacheTags.FOLDER)(appId, getFileFolder(filePath)));
    },
    uploadFile: function uploadFile(appId, file, path, fileName) {
      var overwrite = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
      return req.post(_urls["default"].fileUpload(appId, "".concat(path, "/").concat(fileName)), file).query({
        overwrite: overwrite
      }).cacheTags((0, _cacheTags.FOLDER)(appId, path));
    },
    createConsoleFile: function createConsoleFile(appId, path, content) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/files/create/").concat((0, _path.encodePath)(path)), content).set('Accept', '*/*') //workarround for BKNDLSS-13702
      .cacheTags((0, _cacheTags.FOLDER)(appId, getFileFolder(path)));
    },
    viewFiles: function viewFiles(appId) {
      var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      return req.get(_urls["default"].fileView(appId, path));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/fr-extensions.js":
/*!******************************!*\
  !*** ./src/fr-extensions.js ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
/* eslint-disable max-len */

var routes = (0, _routes.prepareRoutes)({
  integrationConnections: '/api/node-server/manage/app/:appId/integration/connections',
  integrationConnectionsById: '/api/node-server/manage/app/:appId/integration/connections/:connectionId',
  integrationConnectionName: '/api/node-server/manage/app/:appId/integration/connections/:connectionId/name',
  integrationConnectionsUsages: '/api/node-server/manage/app/:appId/integration/connections/usages',
  integrationConnectionURL: '/api/node-server/manage/app/:appId/integration/connection/oauth/url',
  integrationConnectionToken: '/api/node-server/manage/app/:appId/integration/connection/:connectionId/token',
  integrationServiceAppConfigs: '/api/node-server/manage/app/:appId/integration/service/:serviceId/app-configs',
  elementParamDictionary: '/api/node-server/manage/app/:appId/integration/block/:serviceName/param-dictionary/:dictionaryName',
  elementParamSchema: '/api/node-server/manage/app/:appId/integration/block/:serviceName/param-schema/:schemaLoaderName',
  elementSampleResult: '/api/node-server/manage/app/:appId/integration/block/:serviceName/sample-result/:sampleResultMethodName',
  sharedElements: '/api/node-server/manage/integration/shared/elements',
  sharedProductStatus: '/api/node-server/manage/integration/shared/product/:productId/status',
  sharedProductInstall: '/api/node-server/manage/integration/shared/product/:productId/install'
});
var _default = function _default(req) {
  return {
    getAllIntegrationConnections: function getAllIntegrationConnections(appId) {
      return req.nodeAPI.get(routes.integrationConnections(appId));
    },
    getIntegrationConnectionAccessToken: function getIntegrationConnectionAccessToken(appId, connectionId) {
      return req.nodeAPI.get(routes.integrationConnectionToken(appId, connectionId));
    },
    deleteIntegrationConnectionById: function deleteIntegrationConnectionById(appId, connectionId) {
      return req.nodeAPI["delete"](routes.integrationConnectionsById(appId, connectionId));
    },
    updateIntegrationConnectionName: function updateIntegrationConnectionName(appId, connectionId, updatedName) {
      return req.nodeAPI.put(routes.integrationConnectionName(appId, connectionId), {
        updatedName: updatedName
      });
    },
    getConnectionsUsages: function getConnectionsUsages(appId) {
      return req.nodeAPI.get(routes.integrationConnectionsUsages(appId));
    },
    getConnectionURL: function getConnectionURL(_ref) {
      var appId = _ref.appId,
        serviceName = _ref.serviceName,
        serviceId = _ref.serviceId;
      return req.nodeAPI.get(routes.integrationConnectionURL(appId)).query({
        serviceName: serviceName,
        serviceId: serviceId
      });
    },
    getSharedElements: function getSharedElements() {
      return req.nodeAPI.get(routes.sharedElements());
    },
    getElementParamDictionary: function getElementParamDictionary(appId, serviceName, dictionaryName, payload) {
      return req.nodeAPI.post(routes.elementParamDictionary(appId, serviceName, dictionaryName), payload);
    },
    getElementParamSchema: function getElementParamSchema(appId, serviceName, schemaLoaderName, payload) {
      return req.nodeAPI.post(routes.elementParamSchema(appId, serviceName, schemaLoaderName), payload);
    },
    getElementSampleResult: function getElementSampleResult(appId, serviceName, schemaLoaderName, payload) {
      return req.nodeAPI.post(routes.elementSampleResult(appId, serviceName, schemaLoaderName), payload);
    },
    getSharedProductStatus: function getSharedProductStatus(productId) {
      return req.nodeAPI.get(routes.sharedProductStatus(productId));
    },
    installSharedProduct: function installSharedProduct(_ref2) {
      var productId = _ref2.productId,
        versionId = _ref2.versionId,
        configs = _ref2.configs;
      return req.nodeAPI.post(routes.sharedProductInstall(productId), {
        versionId: versionId,
        configs: configs
      });
    },
    loadSharedAppConfigs: function loadSharedAppConfigs(appId, serviceId) {
      return req.nodeAPI.get(routes.integrationServiceAppConfigs(appId, encodeURIComponent(serviceId)));
    },
    saveSharedAppConfigs: function saveSharedAppConfigs(appId, serviceId, configs) {
      return req.nodeAPI.put(routes.integrationServiceAppConfigs(appId, encodeURIComponent(serviceId)), configs);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/gamification.js":
/*!*****************************!*\
  !*** ./src/gamification.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return {
    loadPacks: function loadPacks() {
      return req.get("".concat(_urls["default"].gamification(), "/packs"));
    },
    getMapItems: function getMapItems(packId) {
      return req.get("".concat(_urls["default"].gamification(), "/map-items")).query({
        packId: packId
      });
    },
    getProgress: function getProgress() {
      return req.get("".concat(_urls["default"].gamification(), "/progress"));
    },
    loadLevels: function loadLevels() {
      return req.get("".concat(_urls["default"].gamification(), "/levels"));
    },
    loadBadges: function loadBadges() {
      return req.get("".concat(_urls["default"].gamification(), "/badges"));
    },
    loadEarnBBItems: function loadEarnBBItems() {
      return req.get("".concat(_urls["default"].gamification(), "/earn"));
    },
    loadRedeemBBItems: function loadRedeemBBItems() {
      return req.get("".concat(_urls["default"].gamification(), "/redeem"));
    },
    loadActivityHistory: function loadActivityHistory() {
      return req.get("".concat(_urls["default"].gamification(), "/activity-history"));
    },
    loadTrivia: function loadTrivia() {
      return req.get("".concat(_urls["default"].gamification(), "/trivia"));
    },
    checkTriviaAnswer: function checkTriviaAnswer(triviaId, answerId, taskId) {
      return req.post("".concat(_urls["default"].gamification(), "/trivia"), {
        triviaId: triviaId,
        answerId: answerId,
        taskId: taskId
      });
    },
    submitSocialSharing: function submitSocialSharing(data) {
      return req.post("".concat(_urls["default"].gamification(), "/social-share"), data);
    },
    reportSocialActivity: function reportSocialActivity(data) {
      return req.post("".concat(_urls["default"].gamification(), "/social-link"), data);
    },
    getLastUpdates: function getLastUpdates() {
      return req.get("".concat(_urls["default"].gamification(), "/updates"));
    },
    markEventPlayed: function markEventPlayed(taskId) {
      return req.put("".concat(_urls["default"].gamification(), "/mark-event-played"), {
        taskId: taskId
      });
    },
    enableAppAPITracking: function enableAppAPITracking(appId) {
      return req.put("".concat(_urls["default"].gamificationApp(appId), "/enable"));
    },
    disableAppAPITracking: function disableAppAPITracking(appId) {
      return req.put("".concat(_urls["default"].gamificationApp(appId), "/disable"));
    },
    isAppAPITrackingEnabled: function isAppAPITrackingEnabled(appId) {
      return req.get("".concat(_urls["default"].gamificationApp(appId), "/enabled"));
    },
    enableAccountAPITracking: function enableAccountAPITracking() {
      // enable API monitoring for all developer's apps
      return req.put("".concat(_urls["default"].gamification(), "/enable"));
    },
    disableAccountAPITracking: function disableAccountAPITracking() {
      // disable API monitoring for all developer's apps
      return req.put("".concat(_urls["default"].gamification(), "/disable"));
    },
    isAccountAPITrackingEnabled: function isAccountAPITrackingEnabled() {
      return req.get("".concat(_urls["default"].gamification(), "/enabled"));
    },
    unlockSpringboardPlan: function unlockSpringboardPlan(appId) {
      return req.put("".concat(_urls["default"].gamification(), "/unlock-springboard")).query({
        appId: appId
      });
    },
    getFreeMilestoneProgress: function getFreeMilestoneProgress() {
      return req.get("".concat(_urls["default"].gamification(), "/free-plan-milestone-progress"));
    },
    getUnlockedFreePlanAppId: function getUnlockedFreePlanAppId() {
      return req.get("".concat(_urls["default"].gamification(), "/free-plan-status"));
    },
    getSettings: function getSettings() {
      return req.get("".concat(_urls["default"].gamification(), "/settings"));
    },
    saveSettings: function saveSettings(settings) {
      return req.put("".concat(_urls["default"].gamification(), "/settings"), settings);
    },
    getSocialPostsCollection: function getSocialPostsCollection() {
      return req.get("".concat(_urls["default"].gamification(), "/social-posts-templates"));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/geo.js":
/*!********************!*\
  !*** ./src/geo.js ***!
  \********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _totalRows = _interopRequireDefault(__webpack_require__(/*! ./utils/total-rows */ "./src/utils/total-rows.js"));
var _sqlBuilder = _interopRequireDefault(__webpack_require__(/*! ./utils/sql-builder */ "./src/utils/sql-builder.js"));
var _cacheTags = __webpack_require__(/*! ./utils/cache-tags */ "./src/utils/cache-tags.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var toServerFence = function toServerFence(_ref) {
  var objectId = _ref.objectId,
    name = _ref.name,
    qualCriteria = _ref.qualCriteria,
    type = _ref.type,
    nodes = _ref.nodes;
  return {
    name: name,
    objectId: objectId,
    qualCriteria: qualCriteria,
    fence: {
      nodes: nodes,
      type: type
    }
  };
};
var fromServerFence = function fromServerFence(_ref2) {
  var objectId = _ref2.objectId,
    name = _ref2.name,
    qualCriteria = _ref2.qualCriteria,
    fence = _ref2.fence,
    events = _ref2.events,
    isActive = _ref2.isActive;
  return _objectSpread({
    name: name,
    events: events,
    objectId: objectId,
    qualCriteria: qualCriteria,
    isActive: isActive
  }, fence);
};
var categoriesUrl = function categoriesUrl(appId) {
  return _urls["default"].geo(appId) + '/categories';
};
var pointsUrl = function pointsUrl(appId) {
  return _urls["default"].geo(appId) + '/points';
};
var rectUrl = function rectUrl(appId) {
  return _urls["default"].geo(appId) + '/rect';
};
var categoryPointsUrl = function categoryPointsUrl(appId, category) {
  return "".concat(_urls["default"].geo(appId), "/").concat(category, "/points");
};
var fenceUrl = function fenceUrl(appId, fenceId) {
  return _urls["default"].geo(appId) + '/fence' + (fenceId ? "/".concat(fenceId) : '');
};
var _default = function _default(req) {
  var getCategories = function getCategories(appId) {
    return req.get(categoriesUrl(appId));
  };
  var addCategory = function addCategory(appId, name) {
    return req.post(categoriesUrl(appId) + '/' + name, {
      name: name
    }).cacheTags((0, _cacheTags.GEO_CATEGORY)(appId, name));
  };
  var deleteCategory = function deleteCategory(appId, name) {
    return req["delete"](categoriesUrl(appId) + '/' + name).cacheTags((0, _cacheTags.GEO_CATEGORY)(appId, name));
  };
  var renameCategory = function renameCategory(appId, category, name) {
    var objectId = category.objectId;
    return req.put(categoriesUrl(appId) + '/' + category.name, {
      name: name,
      objectId: objectId
    });
  };
  var calculateDegreesPerPixel = function calculateDegreesPerPixel(bounds, zoomLevel, width) {
    var lonDistance = (bounds.east - bounds.west) * Math.pow(2, zoomLevel);
    var degree = lonDistance * Math.pow(2, -zoomLevel);
    if (degree < 0) {
      degree += 360;
    }
    return degree / width;
  };
  var getFences = function getFences(appId) {
    return req.get(_urls["default"].geo(appId) + '/fences').then(function (result) {
      return result.map(fromServerFence);
    });
  };
  var saveFence = function saveFence(appId, fence) {
    var body = toServerFence(fence); //TODO: create server ticket

    if (fence.objectId) {
      return req.put(_urls["default"].geo(appId) + '/fence/' + fence.objectId, body).then(fromServerFence);
    }
    return req.post(fenceUrl(appId), body).then(fromServerFence);
  };
  var saveFenceAction = function saveFenceAction(appId, fenceId, event, action) {
    return req.post("".concat(fenceUrl(appId, fenceId), "/").concat(event.toLowerCase()), action || {});
  };
  var executeFenceEvent = function executeFenceEvent(appId, fenceId, event) {
    return req.post("".concat(fenceUrl(appId, fenceId), "/run/").concat(event.toLowerCase()));
  };
  var deleteFence = function deleteFence(appId, fenceId) {
    return req["delete"](fenceUrl(appId, fenceId));
  };
  var activateFence = function activateFence(appId, fenceId) {
    var applyOnStay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    return req.put("".concat(fenceUrl(appId, fenceId), "/activate"), {
      applyOnStay: applyOnStay
    });
  };
  var deactivateFence = function deactivateFence(appId, fenceId) {
    return req.put("".concat(fenceUrl(appId, fenceId), "/deactivate"));
  };
  var getPoints = function getPoints(appId, category) {
    var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var _params$offset = params.offset,
      offset = _params$offset === void 0 ? 0 : _params$offset,
      _params$pageSize = params.pageSize,
      pageSize = _params$pageSize === void 0 ? 15 : _params$pageSize,
      relationsParams = params.relationsParams;
    var pageParams = {
      offset: offset,
      pagesize: pageSize
    };
    if (relationsParams) {
      return loadPointsAsRelations(appId, params, pageParams);
    }
    return (0, _totalRows["default"])(req).getWithData(loadPoints(appId, category, params, pageParams));
  };
  var loadPoints = function loadPoints(appId, category, params, pageParams) {
    var where = params.where,
      _params$includemetada = params.includemetadata,
      includemetadata = _params$includemetada === void 0 ? true : _params$includemetada,
      filterString = params.filterString;
    var mapBounds = params.mapBounds,
      mapDriven = params.mapDriven,
      mapZoom = params.mapZoom,
      mapWidth = params.mapWidth,
      clustering = params.clustering;
    var radiusDriven = params.radiusDriven,
      radiusCenter = params.radiusCenter,
      radius = params.radius,
      radiusUnits = params.radiusUnits;
    var queryParams = _objectSpread(_objectSpread({}, pageParams), {}, {
      includemetadata: includemetadata,
      categories: category,
      where: _sqlBuilder["default"].and(where, filterString)
    });
    if (mapDriven) {
      if (radiusDriven) {
        queryParams.lat = radiusCenter.lat;
        queryParams.lon = radiusCenter.lng;
        queryParams.r = radius;
        queryParams.units = radiusUnits.toUpperCase();
      } else {
        queryParams.nwlat = mapBounds.north;
        queryParams.nwlon = mapBounds.west;
        queryParams.selat = mapBounds.south;
        queryParams.selon = mapBounds.east;
      }
      if (clustering) {
        queryParams.dpp = calculateDegreesPerPixel(mapBounds, mapZoom, mapWidth);
      }
    }
    var nonRadiusMapDrivenSearch = mapDriven && !radiusDriven;
    var url = nonRadiusMapDrivenSearch ? rectUrl(appId) : pointsUrl(appId);
    return req.get(url).query(queryParams).cacheTags((0, _cacheTags.GEO_CATEGORY)(appId, category));
  };
  var loadPointsAsRelations = function loadPointsAsRelations(appId, params, pageParams) {
    var where = params.where,
      filterString = params.filterString,
      relationsParams = params.relationsParams;
    var mapDriven = params.mapDriven,
      radiusDriven = params.radiusDriven,
      radiusCenter = params.radiusCenter,
      radius = params.radius,
      radiusUnits = params.radiusUnits;
    var tableName = relationsParams.tableName,
      objectId = relationsParams.objectId,
      name = relationsParams.name,
      related = relationsParams.related;
    var whereClauseParts = [where, filterString];
    if (mapDriven && radiusDriven) {
      var lat = radiusCenter.lat,
        lng = radiusCenter.lng;
      whereClauseParts.push(_sqlBuilder["default"].distance(lat, lng, radiusUnits, radius));
    }
    var queryParams = _objectSpread(_objectSpread({}, pageParams), {}, {
      where: _sqlBuilder["default"].and.apply(_sqlBuilder["default"], whereClauseParts),
      related: related
    });
    var dataReq = req.get("".concat(_urls["default"].dataRecord(appId, tableName, objectId), "/").concat(name)).query(queryParams);
    return (0, _totalRows["default"])(req).getWithData(dataReq).then(function (_ref3) {
      var totalRows = _ref3.totalRows,
        data = _ref3.data;
      var objectIds = [];
      data.forEach(function (point) {
        if (!objectIds.includes(point.objectId)) {
          objectIds.push(point.objectId);
        }
      });
      return loadPointsByIds(appId, objectIds, params.includemetadata).then(function (points) {
        var pointsMap = {};
        points.forEach(function (point) {
          return pointsMap[point.objectId] = point;
        });
        var data = objectIds.map(function (pointId) {
          return pointsMap[pointId];
        });
        return {
          totalRows: totalRows,
          data: data
        };
      });
    });
  };
  var loadPointsByIds = function loadPointsByIds(appId) {
    var objectIds = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var includemetadata = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    var queryParams = {
      pagesize: objectIds.length,
      includemetadata: includemetadata,
      where: _sqlBuilder["default"]["in"]('objectId', objectIds)
    };
    return req.get(pointsUrl(appId)).query(queryParams).cacheTags((0, _cacheTags.GEO_CATEGORY)(appId));
  };
  var getFencePoints = function getFencePoints(appId, fenceId) {
    return req.get("".concat(fenceUrl(appId, fenceId), "/geopoints")).then(function (data) {
      return {
        data: data,
        totalPoints: data.length
      };
    });
  };
  var deletePoints = function deletePoints(appId, category, pointsIds) {
    return req["delete"](categoryPointsUrl(appId, category), pointsIds).cacheTags((0, _cacheTags.GEO_CATEGORY)(appId, category));
  };
  var addPoint = function addPoint(appId, lat, lon) {
    return req.put(pointsUrl(appId)).query({
      lat: lat,
      lon: lon
    });
  };
  var copyPoints = function copyPoints(appId, pointsIds, targetCategory) {
    return req.put(_urls["default"].geo(appId) + '/' + targetCategory, pointsIds).cacheTags((0, _cacheTags.GEO_CATEGORY)(appId, targetCategory));
  };
  var setPointMeta = function setPointMeta(appId, pointId, meta) {
    return req.put("".concat(_urls["default"].geo(appId), "/").concat(pointId, "/meta"), meta);
  };
  var addPointMetaRelations = function addPointMetaRelations(appId, pointId, meta) {
    return req.patch("".concat(_urls["default"].geo(appId), "/").concat(pointId, "/meta"), meta);
  };
  var removePointMetaRelations = function removePointMetaRelations(appId, pointId, meta) {
    return req["delete"]("".concat(_urls["default"].geo(appId), "/").concat(pointId, "/meta"), meta);
  };
  var reset = function reset(appId) {
    return req["delete"](_urls["default"].geo(appId)).cacheTags((0, _cacheTags.GEO_CATEGORY)(appId));
  };
  var sampleSetup = function sampleSetup(appId) {
    return req.post(_urls["default"].geo(appId) + '/samplesetup').cacheTags((0, _cacheTags.GEO_CATEGORY)(appId));
  };
  return {
    getCategories: getCategories,
    addCategory: addCategory,
    renameCategory: renameCategory,
    deleteCategory: deleteCategory,
    getPoints: getPoints,
    getFencePoints: getFencePoints,
    getFences: getFences,
    saveFence: saveFence,
    saveFenceAction: saveFenceAction,
    executeFenceEvent: executeFenceEvent,
    deleteFence: deleteFence,
    activateFence: activateFence,
    deactivateFence: deactivateFence,
    addPoint: addPoint,
    deletePoints: deletePoints,
    copyPoints: copyPoints,
    sampleSetup: sampleSetup,
    setPointMeta: setPointMeta,
    addPointMetaRelations: addPointMetaRelations,
    removePointMetaRelations: removePointMetaRelations,
    reset: reset
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/initial-questionnaire.js":
/*!**************************************!*\
  !*** ./src/initial-questionnaire.js ***!
  \**************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.initialQuestionnaire = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  questions: '/console/community/initial-questionnaire/questions',
  answers: '/console/community/initial-questionnaire/answers',
  status: '/console/community/initial-questionnaire/status'
});
var initialQuestionnaire = function initialQuestionnaire(req) {
  return {
    loadQuestions: function loadQuestions() {
      return req.community.get(routes.questions());
    },
    sendAnswers: function sendAnswers(answers) {
      return req.community.post(routes.answers(), answers);
    },
    loadStatus: function loadStatus() {
      return req.community.get(routes.status());
    }
  };
};
exports.initialQuestionnaire = initialQuestionnaire;

/***/ }),

/***/ "./src/integrations.js":
/*!*****************************!*\
  !*** ./src/integrations.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  integrations: '/:appId/console/integrations',
  integration: '/:appId/console/integrations/:name'
});
var _default = function _default(req) {
  return {
    getIntegrations: function getIntegrations(appId) {
      return req.get(routes.integrations(appId));
    },
    saveIntegration: function saveIntegration(appId, configData) {
      return req.post(routes.integrations(appId), configData);
    },
    updateIntegration: function updateIntegration(appId, name, configData) {
      return req.put(routes.integration(appId, name), configData);
    },
    deleteIntegration: function deleteIntegration(appId, name) {
      return req["delete"](routes.integration(appId, name));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/license.js":
/*!************************!*\
  !*** ./src/license.js ***!
  \************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  license: '/console/license',
  replaceCluster: '/console/license/cluster/replace'
});
var _default = function _default(req) {
  return {
    get: function get() {
      return req.get(routes.license());
    },
    upload: function upload(file) {
      return req.post(routes.license(), file);
    },
    replaceCluster: function replaceCluster(data) {
      return req.post(routes.replaceCluster(), data);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/marketplace.js":
/*!****************************!*\
  !*** ./src/marketplace.js ***!
  \****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.marketplace = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  sections: '/console/community/marketplace/sections',
  categories: '/console/community/marketplace/categories',
  categoryProducts: '/console/community/marketplace/categories/:categoryId/products',
  products: '/console/community/marketplace/products',
  product: '/console/community/marketplace/products/:productId',
  productResources: '/console/community/marketplace/products/:productId/resources',
  productResourcesDetails: '/console/community/marketplace/products/:productId/resources/details',
  productVersions: '/console/community/marketplace/products/:productId/versions',
  productApprove: '/console/community/marketplace/products/:productId/approve',
  productReject: '/console/community/marketplace/products/:productId/reject',
  productConfigurations: '/console/community/marketplace/products/:productId/configurations',
  productPrivateDevs: '/console/community/marketplace/products/:productId/private-devs',
  submissions: '/console/community/marketplace/submissions',
  appPurchases: '/:appId/console/community/marketplace/app-purchases',
  appPurchasesProduct: '/:appId/console/community/marketplace/app-purchases/:productId',
  appPurchasesProductExists: '/:appId/console/community/marketplace/app-purchases/:productId/exists',
  appPurchasesProductPreview: '/:appId/console/community/marketplace/app-purchases/:productId/preview',
  accountPurchases: '/console/community/marketplace/account-purchases',
  accountPurchasesProduct: '/console/community/marketplace/account-purchases/:productId',
  accountPurchasesPaymentProfile: '/console/community/marketplace/account-purchases/update-payment-profile',
  accountPurchaseReactivate: '/console/community/marketplace/account-purchases/:productId/renew',
  developerPayoutHistory: '/console/community/marketplace/developer-sales/payouts',
  developerProductSales: '/console/community/marketplace/developer-sales/product-sales',
  developerGeneralSales: '/console/community/marketplace/developer-sales/general-sales',
  installDetails: '/console/community/marketplace/installs/details',
  appInstalls: '/api/app/:appId/marketplace/installs'
});
var marketplace = function marketplace(req) {
  return {
    //---- SECTIONS ==>
    getSections: function getSections() {
      return req.get(routes.sections());
    },
    //---- SECTIONS ----//
    //---- CATEGORIES ==>
    getCategories: function getCategories(query) {
      return req.get(routes.categories()).query(query);
    },
    getCategoryProducts: function getCategoryProducts(categoryId) {
      return req.get(routes.categoryProducts(categoryId));
    },
    //---- CATEGORIES ----//
    //---- PRODUCTS ==>
    getProducts: function getProducts(query) {
      return req.get(routes.products()).query(query);
    },
    //---- PRODUCTS ----//
    //---- PRODUCT ==>
    getProduct: function getProduct(productId) {
      return req.community.get(routes.product(productId));
    },
    getProductVersions: function getProductVersions(productId, query) {
      return req.community.get(routes.productVersions(productId)).query(query);
    },
    getProductResources: function getProductResources(productId, _ref) {
      var versionId = _ref.versionId,
        filePath = _ref.filePath;
      if (filePath) {
        filePath = encodeURIComponent(filePath);
      }
      return req.community.get(routes.productResources(productId)).query({
        versionId: versionId,
        filePath: filePath
      }).setEncoding(null);
    },
    getProductResourcesDetails: function getProductResourcesDetails(productId, versionId) {
      return req.community.get(routes.productResourcesDetails(productId)).query({
        versionId: versionId
      });
    },
    getProductConfigurations: function getProductConfigurations(productId, version) {
      return req.get(routes.productConfigurations(productId)).query({
        version: version
      });
    },
    getProductPrivateDevs: function getProductPrivateDevs(productId) {
      return req.community.get(routes.productPrivateDevs(productId));
    },
    updateProductPrivateDevs: function updateProductPrivateDevs(productId, privateDevs) {
      return req.community.put(routes.productPrivateDevs(productId), privateDevs);
    },
    publishProduct: function publishProduct(product) {
      return req.post(routes.products(), product);
    },
    approveProduct: function approveProduct(productId) {
      return req.put(routes.productApprove(productId));
    },
    rejectProduct: function rejectProduct(productId, reason) {
      return req.put(routes.productReject(productId), reason);
    },
    removeProduct: function removeProduct(productId, reason) {
      return req["delete"](routes.product(productId), reason);
    },
    //---- PRODUCT ----//
    //---- PURCHASES ==>
    getAppPurchases: function getAppPurchases(appId) {
      return req.get(routes.appPurchases(appId));
    },
    allocateAppProduct: function allocateAppProduct(appId, productId, options) {
      return req.post(routes.appPurchasesProduct(appId, productId), options);
    },
    isAppProductPurchased: function isAppProductPurchased(appId, productId) {
      return req.community.get(routes.appPurchasesProductExists(appId, productId));
    },
    // previewProduct(appId, productId, options) {
    //   return req.post(routes.appPurchasesProductPreview(appId, productId), options)
    // },
    //---- PURCHASES ----//
    //---- APP INSTALLS ==>
    getAppInstalls: function getAppInstalls(appId) {
      return req.get(routes.appInstalls(appId));
    },
    getInstallsDetails: function getInstallsDetails(productIds) {
      return req.community.get(routes.installDetails()).query({
        productIds: productIds
      });
    },
    //---- APP INSTALLS ----//
    //---- SUBMISSIONS ==>
    getSubmissions: function getSubmissions() {
      return req.get(routes.submissions());
    },
    getAccountPurchases: function getAccountPurchases() {
      return req.get(routes.accountPurchases());
    },
    allocateAccountProduct: function allocateAccountProduct(productId, options) {
      return req.post(routes.accountPurchasesProduct(productId), options);
    },
    updateAccountPurchasesPaymentProfile: function updateAccountPurchasesPaymentProfile(paymentProfileId) {
      return req.put(routes.accountPurchasesPaymentProfile(), {
        paymentProfileId: paymentProfileId
      });
    },
    reactivateAccountPurchase: function reactivateAccountPurchase(productId) {
      return req.post(routes.accountPurchaseReactivate(productId));
    },
    getDeveloperPayoutHistory: function getDeveloperPayoutHistory() {
      return req.get(routes.developerPayoutHistory());
    },
    getDeveloperProductSales: function getDeveloperProductSales() {
      return req.get(routes.developerProductSales());
    },
    getDeveloperGeneralSales: function getDeveloperGeneralSales(query) {
      return req.get(routes.developerGeneralSales()).query(query);
    }
  };
};
exports.marketplace = marketplace;

/***/ }),

/***/ "./src/messaging.js":
/*!**************************!*\
  !*** ./src/messaging.js ***!
  \**************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _totalRows = _interopRequireDefault(__webpack_require__(/*! ./utils/total-rows */ "./src/utils/total-rows.js"));
var _cacheTags = __webpack_require__(/*! ./utils/cache-tags */ "./src/utils/cache-tags.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
// This method is needed in perspective (c) Arthur Dzidoiev
var enrichChannelWithSettings = function enrichChannelWithSettings() {
  var channel = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return _objectSpread(_objectSpread({}, channel), {}, {
    settings: {
      polling: true,
      rtmp: 0,
      websocket: 8888
    }
  });
};
var _default = function _default(req) {
  return {
    loadChannels: function loadChannels(appId) {
      return req.get(_urls["default"].messagingChannels(appId));
    },
    createChannel: function createChannel(appId, channelName) {
      var channel = enrichChannelWithSettings({
        name: channelName
      });
      return req.post(_urls["default"].messagingChannels(appId), channel);
    },
    renameChannel: function renameChannel(appId, oldChannel, newName) {
      var channel = enrichChannelWithSettings(oldChannel);
      channel.name = newName;
      return req.put(_urls["default"].messagingChannel(appId, channel.channelid), channel);
    },
    deleteChannel: function deleteChannel(appId, channelId) {
      return req["delete"](_urls["default"].messagingChannel(appId, channelId)).cacheTags((0, _cacheTags.CHANNEL_DEVICES)(channelId));
    },
    loadDevices: function loadDevices(appId, channelId, params) {
      var dataReq = req.get("".concat(_urls["default"].messagingChannel(appId, channelId), "/devices")).query(params).cacheTags((0, _cacheTags.CHANNEL_DEVICES)(channelId));
      return (0, _totalRows["default"])(req).getWithData(dataReq);
    },
    deleteDevices: function deleteDevices(appId, channelId, devicesIds) {
      return req["delete"]("".concat(_urls["default"].messagingChannel(appId, channelId), "/devices"), devicesIds).cacheTags((0, _cacheTags.CHANNEL_DEVICES)(channelId));
    },
    loadMessages: function loadMessages(appId, channelId, params) {
      var dataReq = req.get("".concat(_urls["default"].messagingChannel(appId, channelId), "/messages")).query(params);

      //disable caching for count request
      return (0, _totalRows["default"])(req).getWithData(dataReq, 0);
    },
    // TODO: change after server fix: BKNDLSS-13298
    publishMessage: function publishMessage(appId, channelName, params) {
      return req.post("".concat(_urls["default"].messaging(appId), "/").concat(channelName), params);
    },
    getMessagingChannels: function getMessagingChannels(appId) {
      return req.get("".concat(_urls["default"].messaging(appId), "/channels"));
    },
    getPushTemplates: function getPushTemplates(appId) {
      return req.get(_urls["default"].messagingPushTemplates(appId));
    },
    createPushTemplate: function createPushTemplate(appId, pushTemplate) {
      return req.post(_urls["default"].messagingPushTemplates(appId), pushTemplate);
    },
    updatePushTemplate: function updatePushTemplate(appId, pushTemplateName, pushTemplate) {
      return req.put(_urls["default"].messagingPushTemplate(appId, pushTemplateName), pushTemplate);
    },
    getPushTemplate: function getPushTemplate(appId, pushTemplateName) {
      return req.get(_urls["default"].messagingPushTemplate(appId, pushTemplateName));
    },
    deletePushTemplates: function deletePushTemplates(appId, pushTemplateNames) {
      return req["delete"](_urls["default"].messagingPushTemplates(appId)).query({
        names: pushTemplateNames.join(',')
      });
    },
    getPushRecipientsCount: function getPushRecipientsCount(appId, where) {
      return req.get(_urls["default"].messagingPushRecipientsCount(appId)).query({
        where: where
      });
    },
    sendPush: function sendPush(appId, push) {
      return req.post(_urls["default"].messagingPush(appId), push);
    },
    getPushButtonTemplates: function getPushButtonTemplates(appId, platform) {
      return req.get(_urls["default"].messagingPushButtonTemplates(appId)).query({
        platform: platform
      });
    },
    createPushButtonTemplate: function createPushButtonTemplate(appId, templateData) {
      return req.post(_urls["default"].messagingPushButtonTemplates(appId), templateData);
    },
    updatePushButtonTemplate: function updatePushButtonTemplate(appId, templateName, templateData) {
      return req.put(_urls["default"].messagingPushButtonTemplate(appId, templateName), templateData);
    },
    deletePushButtonTemplate: function deletePushButtonTemplate(appId, templateName, platform) {
      return req["delete"](_urls["default"].messagingPushButtonTemplate(appId, templateName)).query({
        platform: platform
      });
    },
    getPushChannelTemplates: function getPushChannelTemplates(appId, platform) {
      return req.get(_urls["default"].messagingPushChannelTemplates(appId)).query({
        platform: platform
      });
    },
    createPushChannelTemplate: function createPushChannelTemplate(appId, templateData, platform) {
      return req.post(_urls["default"].messagingPushChannelTemplates(appId), templateData).query({
        platform: platform
      });
    },
    updatePushChannelTemplate: function updatePushChannelTemplate(appId, templateName, templateData, platform) {
      return req.put(_urls["default"].messagingPushChannelTemplate(appId, templateName), templateData).query({
        platform: platform
      });
    },
    deletePushChannelTemplate: function deletePushChannelTemplate(appId, templateName, platform) {
      return req["delete"](_urls["default"].messagingPushChannelTemplate(appId, templateName)).query({
        platform: platform
      });
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/navigator.js":
/*!**************************!*\
  !*** ./src/navigator.js ***!
  \**************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _default = function _default(req) {
  return {
    loadNavigatorOptions: function loadNavigatorOptions() {
      return req.get('/console/navigator');
    },
    log: function log(data) {
      return req.post('/console/navigator/log', data);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/open-ai.js":
/*!************************!*\
  !*** ./src/open-ai.js ***!
  \************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  chatCompletionCreate: '/:appId/console/open-ai/chat-completion/:featureName',
  info: '/:appId/console/open-ai/info/:featureName',
  dashboardDataVisualizations: '/:appId/console/open-ai/dashboards/data-visualizations'
});
var _default = function _default(req) {
  return {
    createChatCompletion: function createChatCompletion(appId, featureName, payload) {
      return req.post(routes.chatCompletionCreate(appId, featureName), payload);
    },
    getUsageInfo: function getUsageInfo(appId, featureName) {
      return req.get(routes.info(appId, featureName));
    },
    generateDashboardDataVisualizations: function generateDashboardDataVisualizations(appId, payload) {
      return req.post(routes.dashboardDataVisualizations(appId), payload);
    },
    getDashboardDataVisualizationsPrompt: function getDashboardDataVisualizationsPrompt(appId) {
      return req.get(routes.dashboardDataVisualizations(appId));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/pdf.js":
/*!********************!*\
  !*** ./src/pdf.js ***!
  \********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  generatePDF: '/api/app/:appId/pdf/generate',
  templates: '/:appId/console/pdf',
  template: '/:appId/console/pdf/:templateId'
});
var _default = function _default(req) {
  return {
    generatePDF: function generatePDF(appId, pdf, inputs) {
      return req.post(routes.generatePDF(appId), {
        pdf: pdf,
        inputs: inputs
      });
    },
    listTemplates: function listTemplates(appId) {
      return req.get(routes.templates(appId));
    },
    loadTemplate: function loadTemplate(appId, templateId) {
      return req.get(routes.template(appId, templateId));
    },
    createTemplate: function createTemplate(appId, template) {
      return req.post(routes.templates(appId), template);
    },
    updateTemplate: function updateTemplate(appId, template) {
      return req.put(routes.template(appId, template.id), template);
    },
    deleteTemplate: function deleteTemplate(appId, templateId) {
      return req["delete"](routes.template(appId, templateId));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/project-template.js":
/*!*********************************!*\
  !*** ./src/project-template.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = exports.XSLT_FILE = exports.IMAGE_FILE = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var IMAGE_FILE = /(\jpg|\jpeg|\png|\gif|\ico)$/;
exports.IMAGE_FILE = IMAGE_FILE;
var XSLT_FILE = /(\.xsl|\.xslt)$/;
exports.XSLT_FILE = XSLT_FILE;
var PROJECT_TEMPLATES_PATH = 'codegen/projecttemplates';
var PROMPT_FILE_NAME = 'prompt.json';
var DEFAULT_PROMPT = 'Make a selection';
var getFolders = function getFolders(folders) {
  return folders.filter(function (_ref) {
    var size = _ref.size;
    return !size;
  });
};
var _default = function _default(req) {
  return {
    loadTemplates: function loadTemplates(appId) {
      var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      var result = {};
      return loadDirectory(req, appId, "".concat(PROJECT_TEMPLATES_PATH, "/").concat(path)).then(function (children) {
        result.children = getFolders(children);
        var map = children.map(function (child) {
          if (child.name === PROMPT_FILE_NAME) {
            return loadDirectory(req, appId, child.url).then(function (_ref2) {
              var prompt = _ref2.prompt;
              return result.prompt = prompt;
            });
          } else {
            result.prompt = DEFAULT_PROMPT;
          }
          if (!child.size) {
            return loadDirectory(req, appId, child.url).then(function (children) {
              var icon = children.find(function (_ref3) {
                var name = _ref3.name;
                return IMAGE_FILE.test(name);
              });
              var readme = children.find(function (_ref4) {
                var name = _ref4.name;
                return name === 'README.md';
              });
              if (icon) {
                child.icon = _urls["default"].fileView(appId, icon.url);
              }
              var chain = Promise.resolve();
              if (readme) {
                chain = chain.then(function () {
                  return loadDirectory(req, appId, readme.url);
                }).then(function (readmeContent) {
                  return child.readme = readmeContent;
                });
              }
              chain = chain.then(function () {
                var xslt = children.find(function (_ref5) {
                  var name = _ref5.name;
                  return XSLT_FILE.test(name);
                });
                if (xslt) {
                  child.xslt = xslt.url;
                  return;
                }
                child.children = children;
              });
              return chain;
            });
          }
        });
        return Promise.all(map).then(function () {
          return result;
        });
      });
    },
    generateProject: function generateProject(appId, xsl) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/codegen"), {
        xsl: xsl
      });
    }
  };
};
exports["default"] = _default;
function loadDirectory(req, appId, path) {
  return req.get(_urls["default"].fileView(appId, path));
}

/***/ }),

/***/ "./src/quick-apps.js":
/*!***************************!*\
  !*** ./src/quick-apps.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
/* eslint-disable max-len */

var routes = (0, _routes.prepareRoutes)({
  containers: '/api/app/:appId/quick-apps/containers',
  container: '/api/app/:appId/quick-apps/containers/:containerId',
  deploy: '/api/app/:appId/quick-apps/deploy/:containerId'
});
var _default = function _default(req) {
  return {
    loadContainers: function loadContainers(appId) {
      return req.get(routes.containers(appId));
    },
    loadContainer: function loadContainer(appId, containerId) {
      return req.get(routes.container(appId, containerId));
    },
    createContainer: function createContainer(appId, data) {
      return req.post(routes.containers(appId), data);
    },
    deleteContainer: function deleteContainer(appId, containerId) {
      return req["delete"](routes.containers(appId, containerId));
    },
    deployContainer: function deployContainer(appId, containerId, data) {
      return req.post(routes.deploy(appId, containerId), data);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/referrals.js":
/*!**************************!*\
  !*** ./src/referrals.js ***!
  \**************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.referrals = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  inviteCode: '/console/community/referrals/invite-code',
  inviteId: '/console/community/referrals/invite-id',
  invites: '/console/community/referrals/invites',
  confirmUserRegistered: '/console/community/referrals/events/confirm-user-registered',
  confirmFirstAppCreated: '/console/community/referrals/events/confirm-first-app-created'
});
var referrals = function referrals(req) {
  return {
    loadInviteCode: function loadInviteCode() {
      return req.community.get(routes.inviteCode());
    },
    loadInvites: function loadInvites() {
      return req.community.get(routes.invites());
    },
    sendInvite: function sendInvite(inviteData) {
      return req.community.post(routes.invites(), inviteData);
    },
    checkInviteId: function checkInviteId(id) {
      return req.community.post(routes.inviteId(), id);
    },
    confirmUserRegistered: function confirmUserRegistered(inviteData) {
      return req.community.post(routes.confirmUserRegistered(), inviteData);
    },
    confirmFirstAppCreated: function confirmFirstAppCreated() {
      return req.community.post(routes.confirmFirstAppCreated());
    }
  };
};
exports.referrals = referrals;

/***/ }),

/***/ "./src/security-url-builder.js":
/*!*************************************!*\
  !*** ./src/security-url-builder.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
var _typeof = __webpack_require__(/*! @babel/runtime/helpers/typeof */ "./node_modules/@babel/runtime/helpers/typeof.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.buildPutUrl = exports.buildGetUrl = exports.buildDeleteUrl = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var qs = _interopRequireWildcard(__webpack_require__(/*! backendless-request/lib/qs */ "./node_modules/backendless-request/lib/qs.js"));
var _isEmpty2 = _interopRequireDefault(__webpack_require__(/*! lodash/isEmpty */ "./node_modules/lodash/isEmpty.js"));
var _security = __webpack_require__(/*! ./constants/security */ "./src/constants/security.js");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * This class is created to resolve a huge amount of inconsistency between various security REST endpoints
 * Someday, all these inconsistency, hopefully will be resolved on server and we will be able to delete
 * this class or some part of it
 */

var baseUrl = function baseUrl(appId) {
  return _urls["default"].security(appId);
};

/**
 * Returns calculated GET url in form of 'security/:stickingPoint?:queryParams'
 *
 * The stickingPoint value is calculated by the folliwing rules
 *
 * default                        =>  :service/:serviceItemId/:policy
 * service=files, policy=users    =>  :service/:policy/:serviceItemId   (BKNDLSS-13008)
 * service=files, policy=roles    =>  :policy/:service/:serviceItemId   (BKNDLSS-13008)
 * policy=owner                   =>  :service/ownerpolicy/:serviceItemId
 * policy=columns                 =>  :service/:serviceItemId/:policy/permissions
 * objectId != ALL_OBJECTS        =>  :service/:serviceItemName/objectAcl/:objectId/:policy
 *
 * @returns {string}
 */
var buildGetUrl = function buildGetUrl(appId, policy, service, serviceItemId, serviceItemName, objectId, filterParams) {
  var isFilesService = service === _security.PermissionServices.FILES;
  var isRolesPolicy = policy === _security.PermissionPolicies.ROLES;
  var isOwnerPolicy = policy === _security.PermissionPolicies.OWNER;
  var isColumnsPolicy = policy === _security.PermissionPolicies.COLUMNS;
  var isObjectACL = objectId !== _security.ALL_OBJECTS;
  var stickingPoint = "".concat(service, "/").concat(serviceItemId, "/").concat(policy);
  if (filterParams.identity != null) {
    filterParams.name = filterParams.identity;
  }
  if (isOwnerPolicy) {
    stickingPoint = "".concat(service, "/ownerpolicy/").concat(serviceItemId);
  } else if (isFilesService && isRolesPolicy) {
    stickingPoint = "roles/".concat(service, "/").concat(encodeURIComponent(serviceItemId));
  } else if (isFilesService) {
    if (filterParams.name) {
      stickingPoint = "users/search/".concat(encodeURI(filterParams.name), "/").concat(service, "/").concat(encodeURIComponent(serviceItemId));
    } else {
      stickingPoint = "".concat(service, "/users/").concat(encodeURIComponent(serviceItemId));
    }
  } else if (isColumnsPolicy) {
    stickingPoint = "".concat(service, "/").concat(serviceItemId, "/").concat(policy, "/permissions");
  } else if (isObjectACL) {
    stickingPoint = "".concat(service, "/").concat(serviceItemName, "/objectAcl/").concat(objectId, "/").concat(policy);
  }
  return "".concat(baseUrl(appId), "/").concat(stickingPoint).concat((0, _isEmpty2["default"])(filterParams) ? '' : "?".concat(qs.stringify(filterParams)));
};

/**
 * Returns calculated PUT url according to rules :
 *
 * default                      : 'security/:service/:serviceItemId/:policy/:policyItemId'
 * policy=owner                 : 'security/:service/ownerpolicy/{serviceItemId}
 * service=file & policy=users  : 'security/:policy/:policyItemId/file/:serviceItemId'
 * service=file & policy=roles  : 'security/:policy/:policyItemId/files/:serviceItemId'
 * objectId!=all                : 'security/:service/:serviceItemName/objectAcl/:objectID/users/:policyItemId'
 * service=api & operation=all  : 'security/:service/:serviceItemId/:policy/:policyItemId/:access'
 *
 * @returns {string}
 */
exports.buildGetUrl = buildGetUrl;
var buildPutUrl = function buildPutUrl(appId, policy, service, serviceItemId, serviceItemName, objectId, policyItemId, permission) {
  var OWNER = _security.PermissionPolicies.OWNER,
    USERS = _security.PermissionPolicies.USERS,
    ROLES = _security.PermissionPolicies.ROLES,
    COLUMNS = _security.PermissionPolicies.COLUMNS;
  var isOwnerPolicy = policy === OWNER;
  var isUserPolicy = policy === USERS;
  var isRolesPolicy = policy === ROLES;
  var isColumnsPolicy = policy === COLUMNS;
  var isFilesService = service === _security.PermissionServices.FILES;
  var isApiService = service === _security.PermissionServices.API_SERVICES;
  var isObjectACL = objectId !== _security.ALL_OBJECTS;
  var stickingPoint = "".concat(service, "/").concat(serviceItemId, "/").concat(policy, "/").concat(policyItemId);
  if (isOwnerPolicy) {
    stickingPoint = "".concat(service, "/ownerpolicy/").concat(serviceItemId);
  } else if (isObjectACL) {
    stickingPoint = "".concat(service, "/").concat(serviceItemName, "/objectAcl/").concat(objectId, "/").concat(policy, "/").concat(policyItemId);
  } else if (isFilesService) {
    if (isUserPolicy) {
      stickingPoint = "".concat(policy, "/").concat(policyItemId, "/file/").concat(serviceItemId);
    } else if (isRolesPolicy) {
      stickingPoint = "".concat(policy, "/").concat(policyItemId, "/files/").concat(serviceItemId);
    }
  } else if (isApiService && permission.operation === 'all') {
    stickingPoint += '/access/' + permission.access;
  } else if (isColumnsPolicy) {
    stickingPoint = "".concat(service, "/").concat(serviceItemId, "/").concat(policy, "/permissions/").concat(permission.operation, "/").concat(policyItemId);
  }
  return "".concat(baseUrl(appId), "/").concat(stickingPoint);
};

/**
 * Returns calculated DELETE url according to rules :
 *
 * default                      : security/:service/:serviceItemId/:policy/:policyItemId:(/:operation)
 * policy=owner                 : security/:service/ownerpolicy/:serviceItemId/:operation
 * objectId!=all & policy=roles : security/:service/:serviceItemName/objectAcl/:objectId/:policy/:operation
 * objectId!=all & policy=users : security/:service/:serviceItemName/objectAcl/:objectId/:policy/:policyItemId
 * service=files                : security/:policy/:policyItemId/:service/:serviceItemId
 *
 * @returns {string}
 */
exports.buildPutUrl = buildPutUrl;
var buildDeleteUrl = function buildDeleteUrl(appId, policy, policyItemId, service, serviceItemId, serviceItemName, objectId, operation) {
  var isFilesService = service === _security.PermissionServices.FILES;
  var isOwnerPolicy = policy === _security.PermissionPolicies.OWNER;
  var isRolesPolicy = policy === _security.PermissionPolicies.ROLES;
  var isObjectACL = objectId !== _security.ALL_OBJECTS;
  var operationEscaped = operation && encodeURIComponent(operation);
  if (isOwnerPolicy) {
    return "".concat(baseUrl(appId), "/").concat(service, "/ownerpolicy/").concat(serviceItemId, "/").concat(operationEscaped);
  }
  if (isObjectACL) {
    var stickingPoint = isRolesPolicy ? operationEscaped : encodeURIComponent(policyItemId);
    return "".concat(baseUrl(appId), "/").concat(service, "/").concat(serviceItemName, "/objectAcl/").concat(objectId, "/").concat(policy, "/").concat(stickingPoint);
  }
  if (isObjectACL && isRolesPolicy) {
    return "".concat(baseUrl(appId), "/").concat(service, "/").concat(serviceItemName, "/ownerpolicy/").concat(policyItemId, "/").concat(operationEscaped);
  }
  if (isFilesService) {
    if (isRolesPolicy) {
      return "".concat(baseUrl(appId), "/").concat(policy, "/").concat(policyItemId, "/").concat(service, "/").concat(serviceItemId);
    }
    return "".concat(baseUrl(appId), "/").concat(service, "/").concat(policy, "/").concat(policyItemId, "/").concat(serviceItemId);
  }
  var result = "".concat(baseUrl(appId), "/").concat(service, "/").concat(serviceItemId, "/").concat(policy, "/").concat(policyItemId);
  if (operationEscaped && operationEscaped !== 'all') {
    result += '/' + operationEscaped;
  }
  return result;
};
exports.buildDeleteUrl = buildDeleteUrl;

/***/ }),

/***/ "./src/security.js":
/*!*************************!*\
  !*** ./src/security.js ***!
  \*************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _sortBy2 = _interopRequireDefault(__webpack_require__(/*! lodash/sortBy */ "./node_modules/lodash/sortBy.js"));
var _totalRows = _interopRequireDefault(__webpack_require__(/*! ./utils/total-rows */ "./src/utils/total-rows.js"));
var _securityUrlBuilder = __webpack_require__(/*! ./security-url-builder */ "./src/security-url-builder.js");
var _security = __webpack_require__(/*! ./constants/security */ "./src/constants/security.js");
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var emptyResponse = {
  data: []
};
var sortEntitiesByName = function sortEntitiesByName(response) {
  response.data = (0, _sortBy2["default"])(response.data, 'name');
  return response;
};
var castArray = function castArray(items) {
  return Array.isArray(items) ? items : [items];
};
var transformOwnerResponse = function transformOwnerResponse(response) {
  return {
    data: [{
      permissions: response
    }]
  };
};
var transformRolesResponse = function transformRolesResponse(response) {
  return {
    data: response
  };
};
var transformUsersResponse = function transformUsersResponse(response) {
  return {
    data: response
  };
};
var transformColumnsResponse = function transformColumnsResponse(response) {
  return {
    data: response.map(function (item) {
      return {
        name: item.roleName,
        roleId: item.roleId,
        permissions: item.permissions
      };
    })
  };
};

/**
 * Transforms
 *      [{operationName, operationId, roles: [{roleId, roleName, access}, ...]}, ...]
 * into
 *      { data: [ { roleId, name, permissions: [{operation, access}, ..] }] }
 *
 * @param {Array} response
 * @returns {{data: Array}}
 */
var transformAclRolesResponse = function transformAclRolesResponse(response) {
  var rolesMap = {};
  response.forEach(function (operation) {
    operation.roles.forEach(function (role) {
      if (!rolesMap[role.roleId]) {
        rolesMap[role.roleId] = {
          roleId: role.roleId,
          name: role.roleName,
          permissions: []
        };
      }
      rolesMap[role.roleId].permissions.push({
        operation: operation.operationName,
        access: role.access
      });
    });
  });
  return transformRolesResponse(Object.keys(rolesMap).map(function (roleId) {
    return rolesMap[roleId];
  }));
};

/**
 * Here is the situation :
 *
 * for users the response is { data: [ { permissions: [{operation, access}, ..] }] }
 * for roles the response is [ {permissions: [{operation, access}, ...]} ]
 * for owner the response is [{ operation, access }, ...]
 *
 * for acl roles the response is absolute EVIL in absolutely CRAZY form :
 *      [{operationName, operationId, [roles: [{roleId, roleName, access}]]}]
 *
 *
 * Since, we want to store, handle and render all permissions using the same set of classes/components
 * we need to have the response to be the same for all policies :
 *
 * { data: [ { permissions: [{operation, access}, ..] }] }
 *
 * This method does exactly this
 *
 * @param {*} response
 * @returns {{data: Array.<{permissions: Array}>}}
 */
var alignGetResponseShape = function alignGetResponseShape(response) {
  if (response.data) {
    return response; //a normal response, nothing to do here
  }

  var empty = !response.length;
  var columnsResponse = !empty && !!response[0].permissions && !!response[0].permissions[0].columnId;
  var rolesResponse = !empty && !!response[0].permissions;
  var aclRolesResponse = !empty && !!response[0].operationId;
  var usersResponse = !empty && !!response[0].userId;
  return empty && emptyResponse || columnsResponse && transformColumnsResponse(response) || rolesResponse && transformRolesResponse(response) || aclRolesResponse && transformAclRolesResponse(response) || usersResponse && transformUsersResponse(response) || transformOwnerResponse(response);
};
var enrichPermissions = function enrichPermissions(result) {
  var _result$data$;
  var columnsResponse = !!((_result$data$ = result.data[0]) !== null && _result$data$ !== void 0 && (_result$data$ = _result$data$.permissions[0]) !== null && _result$data$ !== void 0 && _result$data$.columnId);
  result.data.forEach(function (item) {
    item.permissions = toPermissionsMap(item.permissions, columnsResponse);
  });
  return result;
};
var enrichEntities = function enrichEntities(result) {
  result.data.forEach(function (item) {
    item.id = item.userId || item.roleId || 'owner';
  });
  return result;
};

/**
 * For owner the response is 'GRANT_INHERIT'
 * for roles acl the response is complete GET response
 * for all other types the response is array of objects with two fields {operation, access}
 * possibly wrapped into 'permissions' field..  ︻デ═一
 *
 * We want to cast all these responses to the following structure
 *
 * {
 *  [policyItemId]: {
 *      [operation] : {access},
 *      ...
 *  },
 *  ...
 * }
 */
var alignModifyResponseShape = function alignModifyResponseShape(appId, policy, policyItemId, service, serviceItemId, serviceItemName, objectId, operation) {
  return function (response) {
    if (!response) {
      return {};
    }
    var isOwnerPolicy = policy === _security.PermissionPolicies.OWNER;
    var isRolesPolicy = policy === _security.PermissionPolicies.ROLES;
    var isColumnsPolicy = policy === _security.PermissionPolicies.COLUMNS;
    var isObjectACL = objectId !== _security.ALL_OBJECTS;
    var result = {};
    if (isOwnerPolicy) {
      result.owner = (0, _defineProperty2["default"])({}, operation, response);
    } else if (isObjectACL && isRolesPolicy) {
      response.forEach(function (operation) {
        operation.roles.forEach(function (role) {
          result[role.roleId] = result[role.roleId] || {};
          result[role.roleId][operation.operationName] = role.access;
        });
      });
    } else if (isColumnsPolicy) {
      return response;
    } else {
      if (response.permissions) {
        response = response.permissions;
      }
      var permissions = result[policyItemId] = {};
      response.forEach(function (permission) {
        return permissions[permission.operation] = permission.access;
      });
    }
    return result;
  };
};

/**
 * Converts permissions object to permissions map where key is operation and value is access
 * E.q.
 *     [{operation: 'Update', access: 'Grant}, {operation: 'Find', access: 'Deny'}]
 *     =>
 *     {Update: 'Grant', Find: 'Deny'}
 * @param permissions
 * @param columnsResponse
 * @returns {{}}
 */
var toPermissionsMap = function toPermissionsMap(permissions, columnsResponse) {
  var map = {};
  if (permissions) {
    permissions.forEach(function (permission) {
      if (columnsResponse) {
        map[permission.columnId] = permission.access;
      } else {
        map[permission.operation] = permission.access;
      }
    });
  }
  return map;
};

//TODO it will be removed when the server will be ready (CONSOLE-307)
var normalizeRolePropsNames = function normalizeRolePropsNames(role) {
  return _objectSpread({
    id: role.roleId,
    name: role.rolename
  }, role);
};
//TODO it will be removed when the server will be ready (CONSOLE-307)
var normalizeRolesPropsNames = function normalizeRolesPropsNames(roles) {
  return roles.map(normalizeRolePropsNames);
};
//TODO it will be removed when the server will be ready to provide this info (CONSOLE-307)

var enrichRolesProps = function enrichRolesProps(roles) {
  return roles.map(function (role) {
    return _objectSpread({
      system: _security.SYSTEM_ROLES.includes(role.name)
    }, role);
  });
};
var _default = function _default(req) {
  var loadPermissions = function loadPermissions(appId, policy, service, serviceItemId, serviceItemName, objectId) {
    var filterParams = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : {};
    var identityColumnName = arguments.length > 7 ? arguments[7] : undefined;
    var url = (0, _securityUrlBuilder.buildGetUrl)(appId, policy, service, serviceItemId, serviceItemName, objectId, filterParams);
    var addTotalRows = function addTotalRows(response) {
      if (policy === _security.PermissionPolicies.USERS) {
        filterParams.identity = filterParams.identity || filterParams.name;
        var usersCountReq = req.get(_urls["default"].dataTable(appId, 'Users')).query({
          where: filterParams.identity ? "".concat(identityColumnName, " like '%").concat(filterParams.identity, "%'") : undefined
        });
        return (0, _totalRows["default"])(req).getFor(usersCountReq).then(function (totalRows) {
          return _objectSpread(_objectSpread({}, response), {}, {
            totalRows: totalRows
          });
        });
      }
      return response;
    };
    return req.get(url).then(alignGetResponseShape) //transform all policies responses to the same shape with 'data' prop
    .then(enrichPermissions) //transform permissions array into permissions map
    .then(enrichEntities) //transform users and roles entities to the shape with 'id' property
    .then(addTotalRows) //resolve totalRows property
    .then(sortEntitiesByName);
  };
  var setPermission = function setPermission(appId, policy, policyItemId, service, serviceItemId, serviceItemName, objectId, permission) {
    var isOwnerPolicy = policy === _security.PermissionPolicies.OWNER;
    var isColumnPolicy = policy === _security.PermissionPolicies.COLUMNS;
    var isObjectACL = objectId !== _security.ALL_OBJECTS;

    //for owner and object acl the body should contain just {access, permission} object
    //for all other cases it must be wrapped into an array and object :
    //{ permissions: [{access,permission}, ...] }
    var body = isOwnerPolicy || isColumnPolicy || isObjectACL ? permission : {
      permissions: castArray(permission)
    };
    var url = (0, _securityUrlBuilder.buildPutUrl)(appId, policy, service, serviceItemId, serviceItemName, objectId, policyItemId, permission);
    return req.put(url, body).then(alignModifyResponseShape(appId, policy, policyItemId, service, serviceItemId, serviceItemName, objectId, permission));
  };
  var dropPermissions = function dropPermissions() {
    var url = _securityUrlBuilder.buildDeleteUrl.apply(void 0, arguments);
    return req["delete"](url).then(alignModifyResponseShape.apply(void 0, arguments));
  };
  var searchDataACLUsers = function searchDataACLUsers(appId, tableName, objectId, query) {
    return req.get("".concat(_urls["default"].security(appId), "/data/").concat(tableName, "/objectAcl/").concat(objectId, "/users/search/").concat(query)).then(function (result) {
      return {
        data: result
      };
    }).then(enrichPermissions).then(enrichEntities).then(sortEntitiesByName);
  };
  var loadRoles = function loadRoles(appId) {
    return req.get(_urls["default"].securityRoles(appId)).then(normalizeRolesPropsNames) //TODO it will be removed when the server will be ready (CONSOLE-307)
    .then(enrichRolesProps);
  }; //TODO it will be removed when the server will be ready (CONSOLE-307)

  var createRole = function createRole(appId, name) {
    return req.put("".concat(_urls["default"].securityRoles(appId), "/").concat(encodeURIComponent(name))).then(normalizeRolePropsNames);
  };
  var deleteRole = function deleteRole(appId, id) {
    return req["delete"]("".concat(_urls["default"].securityRoles(appId), "/").concat(id));
  };
  var loadRolePermissions = function loadRolePermissions(appId, id) {
    return req.get("".concat(_urls["default"].securityRoles(appId), "/permissions/").concat(id));
  };
  var setRolePermission = function setRolePermission(appId, id, permission) {
    return req.put("".concat(_urls["default"].securityRoles(appId), "/permissions/").concat(id), permission);
  };
  var loadColumnPermissions = function loadColumnPermissions(appId, tableId) {
    return req.get("".concat(_urls["default"].security(appId), "/data/").concat(tableId, "/columns/permissions"));
  };
  var loadAuditLogs = function loadAuditLogs(appId) {
    return req.get("".concat(_urls["default"].security(appId), "/audit-logs"));
  };
  var deleteAuditLogs = function deleteAuditLogs(appId) {
    return req["delete"]("".concat(_urls["default"].security(appId), "/audit-logs"));
  };
  var downloadAuditLogs = function downloadAuditLogs(appId, fromDate, toDate) {
    return req.get("".concat(_urls["default"].security(appId), "/audit-logs/download")).query({
      fromDate: fromDate,
      toDate: toDate
    });
  };
  var activatePanicMode = function activatePanicMode(appId, settings) {
    return req.put("".concat(_urls["default"].appConsole(appId), "/panic/enable"), settings);
  };
  var deactivatePanicMode = function deactivatePanicMode(appId, settings) {
    return req.put("".concat(_urls["default"].appConsole(appId), "/panic/disable"), settings);
  };
  var loadUsers = function loadUsers(appId, _ref) {
    var identityOrUserId = _ref.identityOrUserId,
      offset = _ref.offset,
      pageSize = _ref.pageSize,
      sortBy = _ref.sortBy;
    return req.get("".concat(_urls["default"].appConsole(appId), "/user/sessions/users")).query({
      identityOrUserId: identityOrUserId,
      offset: offset,
      pageSize: pageSize,
      sortBy: sortBy
    });
  };
  var loadUsersWithSessions = function loadUsersWithSessions(appId, _ref2) {
    var cursor = _ref2.cursor,
      pageSize = _ref2.pageSize;
    return req.get("".concat(_urls["default"].appConsole(appId), "/user/sessions/users-with-sessions")).query({
      pageSize: pageSize,
      cursor: cursor
    });
  };
  var loadUserSessions = function loadUserSessions(appId, userId, _ref3) {
    var cursor = _ref3.cursor,
      pageSize = _ref3.pageSize;
    return req.get("".concat(_urls["default"].appConsole(appId), "/user/sessions/").concat(userId)).query({
      pageSize: pageSize,
      cursor: cursor
    });
  };
  var logoutUserSessions = function logoutUserSessions(appId, userId) {
    return req.put("".concat(_urls["default"].appConsole(appId), "/user/sessions/logout"), userId);
  };
  var activateHIPAACompliance = function activateHIPAACompliance(appId) {
    return req.put("".concat(_urls["default"].appConsole(appId), "/compliance/hipaa/enable"));
  };
  var deactivateHIPAACompliance = function deactivateHIPAACompliance(appId) {
    return req.put("".concat(_urls["default"].appConsole(appId), "/compliance/hipaa/disable"));
  };
  return {
    loadRoles: loadRoles,
    createRole: createRole,
    deleteRole: deleteRole,
    loadRolePermissions: loadRolePermissions,
    loadPermissions: loadPermissions,
    setRolePermission: setRolePermission,
    setPermission: setPermission,
    dropPermissions: dropPermissions,
    searchDataACLUsers: searchDataACLUsers,
    loadColumnPermissions: loadColumnPermissions,
    loadAuditLogs: loadAuditLogs,
    deleteAuditLogs: deleteAuditLogs,
    downloadAuditLogs: downloadAuditLogs,
    activatePanicMode: activatePanicMode,
    deactivatePanicMode: deactivatePanicMode,
    loadUsers: loadUsers,
    loadUsersWithSessions: loadUsersWithSessions,
    loadUserSessions: loadUserSessions,
    logoutUserSessions: logoutUserSessions,
    activateHIPAACompliance: activateHIPAACompliance,
    deactivateHIPAACompliance: deactivateHIPAACompliance
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/settings.js":
/*!*************************!*\
  !*** ./src/settings.js ***!
  \*************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var SYSTEM_API_KEYS = ['ANDROID', 'IOS', 'JS', 'REST', 'WP', 'AS', 'BL'];
function normalizeAppSettings(result) {
  var _result$apiKeys;
  var systemAPIKeys = [];
  var customAPIKeys = [];
  result.apiKeysMap = {};
  result.apiKeys.forEach(function (apiKey) {
    var systemAPIKeyIndex = SYSTEM_API_KEYS.indexOf(apiKey.deviceType);
    if (systemAPIKeyIndex >= 0) {
      systemAPIKeys[systemAPIKeyIndex] = apiKey;
      result.apiKeysMap[apiKey.deviceType] = apiKey.apiKey;
    } else {
      customAPIKeys.push(apiKey);
    }
  });
  result.apiKeys = [];
  systemAPIKeys.forEach(function (apiKey) {
    if (apiKey) {
      result.apiKeys.push(apiKey);
    }
  });
  (_result$apiKeys = result.apiKeys).push.apply(_result$apiKeys, customAPIKeys);
  return result;
}
var _default = function _default(req) {
  return {
    createAndroidMobileSettings: function createAndroidMobileSettings(appId, settings) {
      return req.post(_urls["default"].mobileSettingsAndroid(appId), settings);
    },
    updateAndroidMobileSettings: function updateAndroidMobileSettings(appId, settings, id) {
      return req.put(_urls["default"].mobileSettingsAndroid(appId, id), settings);
    },
    deleteAndroidMobileSettings: function deleteAndroidMobileSettings(appId, id) {
      return req["delete"](_urls["default"].mobileSettingsAndroid(appId, id));
    },
    createAppleMobileSettings: function createAppleMobileSettings(appId, settings, deviceType) {
      return req.post("".concat(_urls["default"].mobileSettings(appId), "/").concat(deviceType), settings);
    },
    updateAppleMobileSettings: function updateAppleMobileSettings(appId, settings, id, deviceType) {
      return req.put("".concat(_urls["default"].mobileSettings(appId), "/").concat(deviceType, "/").concat(id), settings);
    },
    deleteAppleMobileCertificate: function deleteAppleMobileCertificate(appId, id, deviceType) {
      return req["delete"]("".concat(_urls["default"].mobileSettings(appId), "/").concat(deviceType, "/").concat(id));
    },
    /**
     * @deprecated
     * */
    updateDomainNames: function updateDomainNames(appId, domainNames) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/domaincontrolsettings"), domainNames.split(/\s+/));
    },
    /**
     * @deprecated
     * */
    updateCustomDomain: function updateCustomDomain(appId, domainName) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/dnsmapping"), domainName);
    },
    //--------------------------------//
    //-------- CUSTOM DOMAINS --------//
    getCustomDomains: function getCustomDomains(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/settings/custom-domain"));
    },
    createCustomDomain: function createCustomDomain(appId, domainData) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/settings/custom-domain"), domainData);
    },
    assignCustomDomain: function assignCustomDomain(appId, domainData) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/settings/custom-domain/assign-generated-domain"), domainData);
    },
    changeCustomDomain: function changeCustomDomain(appId, domainData) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/settings/custom-domain/").concat(domainData.id), domainData);
    },
    deleteCustomDomain: function deleteCustomDomain(appId, domainId) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/settings/custom-domain/").concat(domainId));
    },
    //-------- CUSTOM DOMAINS --------//
    //--------------------------------//
    updateIOSCert: function updateIOSCert(appId, data) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/ioscert"), data);
    },
    getDataValidators: function getDataValidators() {
      return req.get('/console/datavalidators');
    },
    getAppSettings: function getAppSettings(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/appsettings")).then(normalizeAppSettings);
    },
    regenerateAPIKey: function regenerateAPIKey(appId, apiKeyId) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/apikey/").concat(apiKeyId, "/regenerate"));
    },
    getAPIKey: function getAPIKey(appId, apiKeyId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/apikey/").concat(apiKeyId));
    },
    createAPIKey: function createAPIKey(appId, apiKey) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/apikey"), apiKey);
    },
    updateAPIKey: function updateAPIKey(appId, apiKeyId, apiKey) {
      return req.put("".concat(_urls["default"].appConsole(appId), "/apikey/").concat(apiKeyId), apiKey);
    },
    deleteAPIKey: function deleteAPIKey(appId, apiKeyId) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/apikey/").concat(apiKeyId));
    },
    getAppLogging: function getAppLogging(appId) {
      return req.get("".concat(_urls["default"].appConsole(appId), "/logging/config"));
    },
    setAppLogging: function setAppLogging(appId, logging) {
      console.warn('"ApiClient.settings.setAppLogging" is deprecated method, will be removed when fixed BKNDLSS-18585');
      return this.setAppLoggingConfig(appId, logging);
    },
    setAppLoggingConfig: function setAppLoggingConfig(appId, config) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/logging/config"), config);
    },
    setAppLoggingIntegration: function setAppLoggingIntegration(appId, integration) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/logging/integration"), integration);
    },
    clearLoggers: function clearLoggers(appId) {
      return req["delete"]("".concat(_urls["default"].appConsole(appId), "/logging/loggers"));
    },
    updateSocialParams: function updateSocialParams(appId, param) {
      return req.post("".concat(_urls["default"].appConsole(appId), "/socialparams"), param);
    },
    getLandingPageData: function getLandingPageData(appId) {
      return req.get(_urls["default"].landingPage(appId));
    },
    getLandingPageTemplates: function getLandingPageTemplates(appId) {
      return req.get("".concat(_urls["default"].landingPage(appId), "/templates"));
    },
    saveLandingPageData: function saveLandingPageData(appId, data) {
      return req.put(_urls["default"].landingPage(appId), data);
    },
    publishLandingPageData: function publishLandingPageData(appId, data) {
      return req.post("".concat(_urls["default"].landingPage(appId), "/publish"), data);
    },
    uploadLandingPageFile: function uploadLandingPageFile(appId, file, section, name) {
      return req.post("".concat(_urls["default"].landingPage(appId), "/file")).query({
        section: section,
        name: name
      }).form({
        file: file
      });
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/sql-service.js":
/*!****************************!*\
  !*** ./src/sql-service.js ***!
  \****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.sqlService = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  connections: '/:appId/console/sql/connection/',
  connection: '/:appId/console/sql/connection/:connectionId',
  connectionTables: '/:appId/console/sql/connection/:connectionId/tables',
  connectionRoutines: '/:appId/console/sql/connection/:connectionId/routines',
  connectionQueries: '/:appId/console/sql/:connectionName/query',
  connectionQuery: '/:appId/console/sql/:connectionName/query/:queryId',
  connectionDynamicSelect: '/:appId/console/sql/:connectionName/select',
  connectionNamedSelect: '/:appId/console/sql/:connectionName/select/:queryName'
});
var sqlService = function sqlService(req) {
  return {
    //---- CONNECTION-CONTROLLER ----//
    getConnections: function getConnections(appId) {
      return req.sqlService.get(routes.connections(appId));
    },
    createConnection: function createConnection(appId, data) {
      return req.sqlService.post(routes.connections(appId), data);
    },
    updateConnection: function updateConnection(appId, data) {
      return req.sqlService.put(routes.connection(appId, data.id), data);
    },
    getConnectionTables: function getConnectionTables(appId, connectionId) {
      return req.sqlService.get(routes.connectionTables(appId, connectionId));
    },
    getConnectionRoutines: function getConnectionRoutines(appId, connectionId) {
      return req.sqlService.get(routes.connectionRoutines(appId, connectionId));
    },
    //---- CONNECTION-CONTROLLER ----//
    //---- QUERY-CONTROLLER ----//
    getConnectionQueries: function getConnectionQueries(appId, connectionName) {
      return req.sqlService.get(routes.connectionQueries(appId, connectionName));
    },
    createConnectionQuery: function createConnectionQuery(appId, connectionName, data) {
      return req.sqlService.post(routes.connectionQueries(appId, connectionName), data);
    },
    updateConnectionQuery: function updateConnectionQuery(appId, connectionName, queryId, data) {
      return req.sqlService.put(routes.connectionQuery(appId, connectionName, queryId), data);
    },
    //---- QUERY-CONTROLLER ----//
    //---- CONSOLE-EXECUTE-CONTROLLER ----//
    runConnectionDynamicSelect: function runConnectionDynamicSelect(appId, connectionName, data) {
      return req.sqlService.post(routes.connectionDynamicSelect(appId, connectionName), data);
    },
    runConnectionNamedSelect: function runConnectionNamedSelect(appId, connectionName, queryName, data) {
      return req.sqlService.post(routes.connectionNamedSelect(appId, connectionName, queryName), data);
    } //---- CONSOLE-EXECUTE-CONTROLLER ----//
  };
};
exports.sqlService = sqlService;

/***/ }),

/***/ "./src/status.js":
/*!***********************!*\
  !*** ./src/status.js ***!
  \***********************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _default = function _default(req) {
  return function (force) {
    console.warn('apiClient.status(force) is deprecated, use apiClient.system.loadStatus(force)');
    return req.api.system.loadStatus(force);
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/system.js":
/*!***********************!*\
  !*** ./src/system.js ***!
  \***********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.systemAPI = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  status: '/console/status',
  mainManu: '/api/console/main-menu/items'
});
var systemAPI = function systemAPI(req) {
  return {
    loadStatus: function loadStatus(force) {
      if (force || !req.context.statusRequest) {
        var statusRequest = req.context.statusRequest = req.get('/console/status')["catch"](function (e) {
          if (statusRequest === req.context.statusRequest) {
            delete req.context.statusRequest;
            throw e;
          }
        });
      }
      return req.context.statusRequest;
    },
    loadMainMenu: function loadMainMenu() {
      return req.get(routes.mainManu());
    }
  };
};
exports.systemAPI = systemAPI;

/***/ }),

/***/ "./src/tables.js":
/*!***********************!*\
  !*** ./src/tables.js ***!
  \***********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = exports.dataTableFindUrl = void 0;
var _regenerator = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/regenerator */ "./node_modules/@babel/runtime/regenerator/index.js"));
var _slicedToArray2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/slicedToArray */ "./node_modules/@babel/runtime/helpers/slicedToArray.js"));
var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/asyncToGenerator */ "./node_modules/@babel/runtime/helpers/asyncToGenerator.js"));
var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/toConsumableArray */ "./node_modules/@babel/runtime/helpers/toConsumableArray.js"));
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _data = __webpack_require__(/*! ./constants/data */ "./src/constants/data.js");
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _totalRows = _interopRequireDefault(__webpack_require__(/*! ./utils/total-rows */ "./src/utils/total-rows.js"));
var _cacheTags = __webpack_require__(/*! ./utils/cache-tags */ "./src/utils/cache-tags.js");
var _table = __webpack_require__(/*! ./utils/table */ "./src/utils/table.js");
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var _COLUMNS_URL_SUFFIX;
/* eslint-disable max-len */
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var RELATION_URL_SUFFIX = 'relation';
var GEO_RELATION_URL_SUFFIX = 'georelation';
var COLUMNS_URL_SUFFIX = (_COLUMNS_URL_SUFFIX = {}, (0, _defineProperty2["default"])(_COLUMNS_URL_SUFFIX, _data.DataTypes.DATA_REF, RELATION_URL_SUFFIX), (0, _defineProperty2["default"])(_COLUMNS_URL_SUFFIX, _data.DataTypes.GEO_REF, GEO_RELATION_URL_SUFFIX), _COLUMNS_URL_SUFFIX);
var isRelType = function isRelType(dataType) {
  return dataType === _data.DataTypes.DATA_REF || dataType === _data.DataTypes.GEO_REF;
};
var tableColumnsUrl = function tableColumnsUrl(appId, table) {
  return _urls["default"].tableColumns(appId, table.name);
};
var tableUrl = function tableUrl(appId, table) {
  return "".concat(_urls["default"].dataTables(appId), "/").concat(encodeURI(table.name));
};
var removeRecordsUrl = function removeRecordsUrl(appId, table, removeAll) {
  return "".concat(tableUrl(appId, table), "/").concat(removeAll ? 'all' : 'records');
};
var assignedUserRoles = function assignedUserRoles(appId) {
  return "".concat(_urls["default"].security(appId), "/assignedroles");
};
var dataTableFindUrl = function dataTableFindUrl(appId, tableName) {
  return "".concat(_urls["default"].dataTable(appId, tableName), "/find");
};
exports.dataTableFindUrl = dataTableFindUrl;
var updateRelationsUrl = function updateRelationsUrl(appId, table, columnName, recordId) {
  return "".concat(_urls["default"].dataRecord(appId, table.name, recordId), "/").concat(columnName);
};
var removeRelationsUrl = function removeRelationsUrl(appId, table, columnName, recordId) {
  return "".concat(updateRelationsUrl(appId, table, columnName, recordId), "/relations");
};
var recordsReq = function recordsReq(req, appId, table, query, resetCache) {
  return (0, _table.tableRecordsReq)(req, dataTableFindUrl(appId, table.name), table, query, resetCache);
};
var recordsCountReq = function recordsCountReq(req, appId, table, query, resetCache) {
  var newQuery = _objectSpread({}, query);
  delete newQuery.property;
  return (0, _table.tableRecordsCountReq)(req, _urls["default"].dataTable(appId, table.name), table, newQuery, resetCache);
};
var getRelationColumn = function getRelationColumn(table, columnName) {
  return [].concat((0, _toConsumableArray2["default"])(table.relations), (0, _toConsumableArray2["default"])(table.geoRelations)).find(function (r) {
    return r.name === columnName;
  });
};
var routes = (0, _routes.prepareRoutes)({
  tableOwnerPolicyDelayCheck: '/:appId/console/data/tables/:tableName/acl/owner-policy-delay-check'
});
var _default = function _default(req) {
  return {
    get: function get(appId, query) {
      return req.get(_urls["default"].dataTables(appId)).query(query).then(function (resp) {
        return _objectSpread(_objectSpread({}, resp), {}, {
          tables: resp.tables.map(normalizeTable)
        });
      });
    },
    create: function create(appId, table) {
      return req.post(_urls["default"].dataTables(appId), table).then(normalizeTable);
    },
    update: function update(appId, table, props) {
      return req.put(tableUrl(appId, table), props).then(normalizeTable);
    },
    remove: function remove(appId, table) {
      return req["delete"](tableUrl(appId, table));
    },
    loadRecords: function loadRecords(appId, table, query, ignoreCounter) {
      return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var dataRequest, countRequest, _yield$Promise$all, _yield$Promise$all2, total, data;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              dataRequest = recordsReq(req, appId, table, query);
              if (!ignoreCounter) {
                _context.next = 3;
                break;
              }
              return _context.abrupt("return", dataRequest);
            case 3:
              countRequest = (0, _totalRows["default"])(req).getViaPostFor(recordsCountReq(req, appId, table, query));
              _context.next = 6;
              return Promise.all([countRequest, dataRequest]);
            case 6:
              _yield$Promise$all = _context.sent;
              _yield$Promise$all2 = (0, _slicedToArray2["default"])(_yield$Promise$all, 2);
              total = _yield$Promise$all2[0];
              data = _yield$Promise$all2[1];
              return _context.abrupt("return", {
                totalRows: total,
                data: data
              });
            case 11:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    exportRecords: function exportRecords(appId, connectorId, table, query) {
      var sqlSearch = query.sqlSearch,
        where = query.where,
        filterString = query.filterString,
        sortBy = query.sortBy,
        props = query.props;
      var tableName = connectorId ? "".concat(connectorId, ".").concat(table.name) : table.name;
      var search = (0, _table.buildRecordsSearch)(table, sqlSearch, where, filterString);
      var params = {
        sortBy: sortBy,
        props: props
      };
      if (search) {
        params.where = search;
      }
      if (Array.isArray(params.sortBy)) {
        params.sortBy = params.sortBy.join(',');
      }
      if (Array.isArray(params.props)) {
        params.props = params.props.join(',');
      }
      if (!params.sortBy) {
        delete params.sortBy;
      }
      if (!params.props) {
        delete params.props;
      }
      return req.post("".concat(_urls["default"].dataTable(appId, tableName), "/csv"), params);
    },
    getRecordsCount: function getRecordsCount(appId, table, query, resetCache) {
      return (0, _totalRows["default"])(req).getViaPostFor(recordsCountReq(req, appId, table, query, resetCache));
    },
    getCount: function getCount(appId, table, query) {
      return (0, _totalRows["default"])(req).getFor(recordsCountReq(req, appId, table, query));
    },
    getRecordsCountForTables: function getRecordsCountForTables(appId, tables, connectorId, resetCache) {
      return req.post("".concat(_urls["default"].data(appId), "/tables-counters"), {
        tables: tables,
        connectorId: connectorId,
        resetCache: resetCache
      });
    },
    getCellData: function getCellData(appId, tableName, recordId, columnName) {
      return req.get("".concat(_urls["default"].dataCell(appId, tableName, recordId, columnName), "/retrieve-value"));
    },
    createRecord: function createRecord(appId, table, record) {
      return req.post(_urls["default"].dataTable(appId, table.name), record).cacheTags((0, _cacheTags.TABLE_DATA)(table.tableId));
    },
    bulkCreateRecords: function bulkCreateRecords(appId, tableName, records) {
      return req.post(_urls["default"].dataTableBulkCreate(appId, tableName), records);
    },
    bulkUpsertRecords: function bulkUpsertRecords(appId, tableName, records) {
      return req.put(_urls["default"].dataTableBulkUpsert(appId, tableName), records);
    },
    updateRecord: function updateRecord(appId, table, record) {
      return req.put(_urls["default"].dataRecord(appId, table.name, record.objectId), record);
    },
    updateImageTypeRecord: function updateImageTypeRecord(appId, table, record) {
      return req.put("".concat(_urls["default"].dataTable(appId, table.name), "/file/").concat(record.columnName, "/").concat(record.objectId), record.value);
    },
    deleteRecords: function deleteRecords(appId, table, recordIds) {
      var url = removeRecordsUrl(appId, table, !recordIds);
      var removeItems = recordIds && recordIds.map(function (objectId) {
        return {
          objectId: objectId
        };
      });
      return req["delete"](url, removeItems).cacheTags((0, _cacheTags.TABLE_DATA)(table.tableId));
    },
    deleteImageTypeRecord: function deleteImageTypeRecord(appId, tableName, columnName, recordId) {
      return req["delete"]("".concat(_urls["default"].dataTable(appId, tableName), "/file/").concat(columnName, "/").concat(recordId));
    },
    updateRelations: function updateRelations(appId, table, columnName, recordId, relationIds) {
      var relationColumn = getRelationColumn(table, columnName);
      return req.put(updateRelationsUrl(appId, table, columnName, recordId), relationIds).cacheTags((0, _cacheTags.TABLE_DATA)(relationColumn.toTableId));
    },
    removeRelations: function removeRelations(appId, table, columnName, recordId, relationIds) {
      var relationColumn = getRelationColumn(table, columnName);
      return req["delete"](removeRelationsUrl(appId, table, columnName, recordId), relationIds).cacheTags((0, _cacheTags.TABLE_DATA)(relationColumn.toTableId));
    },
    createColumn: function createColumn(appId, table, column) {
      var url = tableColumnsUrl(appId, table);
      var urlSuffix = COLUMNS_URL_SUFFIX[column.dataType];
      return req.post(url + (urlSuffix ? "/".concat(urlSuffix) : ''), column).then(function (resp) {
        return _objectSpread(_objectSpread({}, resp), {}, {
          dataType: column.dataType
        });
      });
    },
    deleteColumn: function deleteColumn(appId, table, column) {
      var path = tableColumnsUrl(appId, table);
      var columnName = encodeURI(column.name);
      if (isRelType(column.dataType)) {
        return req["delete"]("".concat(path, "/").concat(RELATION_URL_SUFFIX, "/").concat(columnName));
      }
      return req["delete"]("".concat(path, "/").concat(columnName));
    },
    updateColumn: function updateColumn(appId, table, prevColumn, column) {
      var urlSuffix = COLUMNS_URL_SUFFIX[prevColumn.dataType] || prevColumn.name;
      var url = tableColumnsUrl(appId, table);
      return req.put("".concat(url, "/").concat(urlSuffix), column).then(function (resp) {
        return _objectSpread(_objectSpread({}, resp), {}, {
          dataType: resp.dataType || prevColumn.dataType
        });
      });
    },
    loadConfigs: function loadConfigs(appId) {
      return req.get(_urls["default"].dataConfigs(appId));
    },
    setConfigs: function setConfigs(appId, configs) {
      return req.put(_urls["default"].dataConfigs(appId), configs);
    },
    loadAssignedUserRoles: function loadAssignedUserRoles(appId, users) {
      return req.get(assignedUserRoles(appId)).query({
        users: users.join(',')
      });
    },
    updateAssignedUserRoles: function updateAssignedUserRoles(appId, roles, users) {
      return req.put(assignedUserRoles(appId), {
        roles: roles,
        users: users
      });
    },
    loadTableOwnerPolicyDelayCheck: function loadTableOwnerPolicyDelayCheck(appId, tableName) {
      return req.get(routes.tableOwnerPolicyDelayCheck(appId, tableName));
    },
    changeTableOwnerPolicyDelayCheck: function changeTableOwnerPolicyDelayCheck(appId, tableName, data) {
      return req.put(routes.tableOwnerPolicyDelayCheck(appId, tableName), data);
    }
  };
};
exports["default"] = _default;
var normalizeTable = function normalizeTable(table) {
  return _objectSpread(_objectSpread({}, table), {}, {
    relations: table.relations && table.relations.map(normalizeDataRelationTableColumn) || [],
    geoRelations: table.geoRelations && table.geoRelations.map(normalizeGEORelationTableColumn) || []
  });
};
var normalizeDataRelationTableColumn = function normalizeDataRelationTableColumn(relation) {
  return _objectSpread(_objectSpread({}, relation), {}, {
    dataType: _data.DataTypes.DATA_REF
  });
};
var normalizeGEORelationTableColumn = function normalizeGEORelationTableColumn(relation) {
  return _objectSpread(_objectSpread({}, relation), {}, {
    dataType: _data.DataTypes.GEO_REF
  });
};

/***/ }),

/***/ "./src/transfer.js":
/*!*************************!*\
  !*** ./src/transfer.js ***!
  \*************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  "export": '/:appId/console/export',
  singleStepImport: '/:appId/console/import/:type',
  multiStepImport: '/:appId/console/import/data/:step',
  firebaseUsers: '/:appId/console/import/firebase/users',
  airtableBases: '/:appId/console/airtable/bases/:baseId',
  airtableImport: '/:appId/console/airtable'
});
var _default = function _default(req) {
  return {
    getExportedData: function getExportedData(appId) {
      return req.get(routes["export"](appId));
    },
    startExport: function startExport(appId, data) {
      return req.post(routes["export"](appId), data);
    },
    startImport: function startImport(appId, data, type, query) {
      return req.post(routes.singleStepImport(appId, type), data).query(query);
    },
    importDataServiceFiles: function importDataServiceFiles(appId, data, step) {
      return req.post(routes.multiStepImport(appId, step), data);
    },
    importFirebaseUsers: function importFirebaseUsers(appId, data) {
      return req.post(routes.firebaseUsers(appId), data);
    },
    getAirtableBasesList: function getAirtableBasesList(appId, accessToken) {
      return req.get(routes.airtableBases(appId)).query({
        accessToken: accessToken
      });
    },
    getAirtableTablesList: function getAirtableTablesList(appId, accessToken, baseId) {
      return req.get(routes.airtableBases(appId, baseId)).query({
        accessToken: accessToken
      });
    },
    startAirtableImport: function startAirtableImport(appId, accessToken, baseId, tables) {
      return req.post(routes.airtableImport(appId, baseId), {
        accessToken: accessToken,
        baseId: baseId,
        tables: tables
      });
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/ui-builder.js":
/*!***************************!*\
  !*** ./src/ui-builder.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; } /* eslint-disable max-len */
var routes = (0, _routes.prepareRoutes)({
  init: '/:appId/console/ui-builder/init',
  sdkStyles: '/:appId/console/ui-builder/library/sdk/styles',
  sdkComponents: '/:appId/console/ui-builder/library/sdk/components',
  layoutTemplates: '/:appId/console/ui-builder/library/layout-templates',
  pageTemplates: '/:appId/console/ui-builder/library/page-templates',
  customComponentTemplates: '/:appId/console/ui-builder/library/custom-component-templates',
  themes: '/:appId/console/ui-builder/library/themes',
  theme: '/:appId/console/ui-builder/library/themes/:themeId',
  themeStyle: '/:appId/console/ui-builder/library/themes/:themeId/style',
  themeAction: '/:appId/console/ui-builder/library/themes/:themeId/:action',
  remoteThemes: '/:appId/console/ui-builder/library/remote/themes',
  remoteTheme: '/:appId/console/ui-builder/library/remote/themes/:themeId',
  containers: '/:appId/console/ui-builder/containers',
  container: '/:appId/console/ui-builder/containers/:containerName',
  containerSettings: '/:appId/console/ui-builder/containers/:containerName/settings',
  containerCustomConfigs: '/:appId/console/ui-builder/containers/:containerName/custom-configs',
  containerFavicon: '/:appId/console/ui-builder/containers/:containerName/favicon',
  containerViewport: '/:appId/console/ui-builder/containers/:containerName/viewport',
  containerMetaTags: '/:appId/console/ui-builder/containers/:containerName/meta-tags',
  containerCustomHeadContent: '/:appId/console/ui-builder/containers/:containerName/custom-head-content',
  containerExternalLibraries: '/:appId/console/ui-builder/containers/:containerName/external-libraries',
  containerDefaultI18n: '/:appId/console/ui-builder/containers/:containerName/i18n',
  containerPWASettings: '/:appId/console/ui-builder/containers/:containerName/pwa/settings',
  containerPWAIcon: '/:appId/console/ui-builder/containers/:containerName/pwa/icon',
  removedContainers: '/:appId/console/ui-builder/removed-containers',
  removedContainer: '/:appId/console/ui-builder/removed-containers/:containerName',
  containerBackups: '/:appId/console/ui-builder/containers/:containerName/backups',
  containerBackupsPolicy: '/:appId/console/ui-builder/containers/:containerName/backups/policy',
  containerBackupUpload: '/:appId/console/ui-builder/containers/:containerName/backups/upload',
  containerBackupDownloadLink: '/:appId/console/ui-builder/containers/:containerName/backups/download/sign/:backupId',
  containerI18ns: '/:appId/console/ui-builder/containers/:containerName/i18n/dictionary',
  containerI18n: '/:appId/console/ui-builder/containers/:containerName/i18n/dictionary/:dictionaryName',
  containerI18nKeys: '/:appId/console/ui-builder/containers/:containerName/i18n/key',
  containerI18nKey: '/:appId/console/ui-builder/containers/:containerName/i18n/key/:key',
  containerI18nKeyRename: '/:appId/console/ui-builder/containers/:containerName/i18n/key/:key/rename',
  containerAutomations: '/:appId/console/ui-builder/containers/:containerName/automations',
  containerAction: '/:appId/console/ui-builder/containers/:containerName/:action',
  containerStyles: '/:appId/console/ui-builder/containers/:containerName/styles',
  containerStyle: '/:appId/console/ui-builder/containers/:containerName/styles/:name',
  containerFunctions: '/:appId/console/ui-builder/containers/:containerName/functions',
  containerFunction: '/:appId/console/ui-builder/containers/:containerName/functions/:functionId',
  containerFunctionLogic: '/:appId/console/ui-builder/containers/:containerName/functions/:functionId/logic',
  installCustomFunctionsFromMarketplace: '/:appId/console/ui-builder/containers/:containerName/functions/install/:productId',
  removeFunctionsPack: '/:appId/console/ui-builder/containers/:containerName/functions/remove-functions-pack/:productId',
  containerPages: '/:appId/console/ui-builder/containers/:containerName/pages',
  containerPage: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName',
  containerPageUI: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName/ui',
  containerPageLogic: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName/logic/:componentUid/:handlerName',
  containerPageUnusedLogic: '/:appId/console/ui-builder/containers/:containerName/pages/:pageName/unused-logic',
  containerComponentAddReference: '/:appId/console/ui-builder/containers/:containerName/components/add-reference',
  containerComponentInstall: '/:appId/console/ui-builder/containers/:containerName/components/install/:productId',
  containerLayouts: '/:appId/console/ui-builder/containers/:containerName/layouts',
  containerLayout: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId',
  containerLayoutUI: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId/ui',
  containerLayoutLogic: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId/logic/:componentUid/:handlerName',
  containerLayoutUnusedLogic: '/:appId/console/ui-builder/containers/:containerName/layouts/:layoutId/unused-logic',
  containerReusableComponents: '/:appId/console/ui-builder/containers/:containerName/components/reusable',
  containerReusableComponent: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId',
  containerReusableComponentClone: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/clone',
  containerReusableComponentUpgrade: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/upgrade',
  containerReusableComponentUI: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/ui',
  containerReusableComponentLogic: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/logic/:componentUid/:handlerName',
  containerReusableComponentUnusedLogic: '/:appId/console/ui-builder/containers/:containerName/components/reusable/:componentId/unused-logic',
  containerCustomComponents: '/:appId/console/ui-builder/containers/:containerName/components/custom',
  containerCustomComponent: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId',
  containerCustomComponentPreview: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/preview',
  containerCustomComponentClone: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/clone',
  containerCustomComponentUpgrade: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/upgrade',
  containerCustomComponentModel: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/model',
  containerCustomComponentFiles: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/files',
  containerCustomComponentFilesDownloadLink: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/files/sign',
  containerCustomComponentFileContent: '/:appId/console/ui-builder/containers/:containerName/components/custom/:componentId/content/:fileId'
});
var _default = function _default(req) {
  return {
    init: function init(appId) {
      return req.post(routes.init(appId));
    },
    //-- SDK -----//
    loadSDKStyles: function loadSDKStyles(appId) {
      return req.get(routes.sdkStyles(appId));
    },
    loadSDKComponents: function loadSDKComponents(appId) {
      return req.get(routes.sdkComponents(appId));
    },
    //-- SDK -----//
    //-- LIBRARY -----//
    loadLayoutTemplates: function loadLayoutTemplates(appId) {
      return req.get(routes.layoutTemplates(appId));
    },
    loadPageTemplates: function loadPageTemplates(appId) {
      return req.get(routes.pageTemplates(appId));
    },
    loadCustomComponentTemplates: function loadCustomComponentTemplates(appId) {
      return req.get(routes.customComponentTemplates(appId));
    },
    //-- LIBRARY -----//
    //-- CONTAINER -----//
    createContainer: function createContainer(appId, container) {
      return req.post(routes.containers(appId), container);
    },
    updateContainer: function updateContainer(appId, containerName, container) {
      return req.put(routes.container(appId, containerName), container);
    },
    deleteContainer: function deleteContainer(appId, containerName) {
      return req["delete"](routes.container(appId, containerName));
    },
    loadContainer: function loadContainer(appId, containerName) {
      return req.get(routes.container(appId, containerName));
    },
    publishContainer: function publishContainer(appId, containerName, options) {
      return req.post(routes.containerAction(appId, containerName, 'publish'), options);
    },
    applyContainerTheme: function applyContainerTheme(appId, containerName, theme) {
      return req.post(routes.containerAction(appId, containerName, 'apply-theme'), theme);
    },
    loadContainerStyles: function loadContainerStyles(appId, containerName) {
      return req.get(routes.containerStyles(appId, containerName));
    },
    loadContainerStyle: function loadContainerStyle(appId, containerName, name) {
      return req.get(routes.containerStyle(appId, containerName, name));
    },
    updateContainerStyle: function updateContainerStyle(appId, containerName, name, style) {
      return req.put(routes.containerStyle(appId, containerName, name), style);
    },
    deleteContainerStyle: function deleteContainerStyle(appId, containerName, name) {
      return req["delete"](routes.containerStyle(appId, containerName, name));
    },
    //-- CONTAINER -----//
    //-- BACKUPS -----//
    loadRemovedContainers: function loadRemovedContainers(appId) {
      return req.get(routes.removedContainers(appId));
    },
    deleteRemovedContainer: function deleteRemovedContainer(appId, containerName) {
      return req["delete"](routes.removedContainer(appId, containerName));
    },
    loadContainerBackups: function loadContainerBackups(appId, containerName) {
      return req.get(routes.containerBackups(appId, containerName));
    },
    updateContainerBackupsPolicy: function updateContainerBackupsPolicy(appId, containerName, backupsPolicy) {
      return req.put(routes.containerBackupsPolicy(appId, containerName), backupsPolicy);
    },
    createContainerBackup: function createContainerBackup(appId, containerName, backup) {
      return req.post(routes.containerBackups(appId, containerName), backup);
    },
    deleteContainerBackups: function deleteContainerBackups(appId, containerName, backupsIds) {
      return req["delete"](routes.containerBackups(appId, containerName), backupsIds);
    },
    getBackupDownloadLink: function getBackupDownloadLink(appId, containerName, backupId) {
      return req.get(routes.containerBackupDownloadLink(appId, containerName, backupId));
    },
    uploadBackup: function uploadBackup(appId, containerName, file, data) {
      return req.post(routes.containerBackupUpload(appId, containerName)).form(_objectSpread(_objectSpread({}, data), {}, {
        file: file
      }));
    },
    //-- BACKUPS -----//
    //-- SETTINGS -----//
    updateContainerSettings: function updateContainerSettings(appId, containerName, settings) {
      return req.put(routes.containerSettings(appId, containerName), settings);
    },
    updateContainerCustomConfigs: function updateContainerCustomConfigs(appId, containerName, customConfigs) {
      return req.put(routes.containerCustomConfigs(appId, containerName), customConfigs);
    },
    updateContainerDefaultI18n: function updateContainerDefaultI18n(appId, containerName, defaultI18n) {
      return req.put(routes.containerDefaultI18n(appId, containerName), {
        defaultI18n: defaultI18n
      });
    },
    saveContainerI18n: function saveContainerI18n(appId, containerName, dictionaryName, dictionaryObject) {
      return req.put(routes.containerI18n(appId, containerName, dictionaryName), dictionaryObject);
    },
    deleteContainerI18n: function deleteContainerI18n(appId, containerName, dictionaryName) {
      return req["delete"](routes.containerI18n(appId, containerName, dictionaryName));
    },
    updateContainerI18nKey: function updateContainerI18nKey(appId, containerName, key, changes) {
      return req.put(routes.containerI18nKey(appId, containerName, key), changes);
    },
    renameContainerI18nKey: function renameContainerI18nKey(appId, containerName, oldKeyName, newKeyName) {
      return req.put(routes.containerI18nKeyRename(appId, containerName, oldKeyName)).query({
        newKeyName: newKeyName
      });
    },
    deleteContainerI18nKeys: function deleteContainerI18nKeys(appId, containerName, keys) {
      return req["delete"](routes.containerI18nKeys(appId, containerName), keys);
    },
    uploadContainerFavicon: function uploadContainerFavicon(appId, containerName, favicon) {
      return req.put(routes.containerFavicon(appId, containerName)).form({
        favicon: favicon
      });
    },
    removeContainerFavicon: function removeContainerFavicon(appId, containerName) {
      return req["delete"](routes.containerFavicon(appId, containerName));
    },
    updateContainerViewport: function updateContainerViewport(appId, containerName, viewport) {
      return req.put(routes.containerViewport(appId, containerName), viewport);
    },
    updateContainerMetaTags: function updateContainerMetaTags(appId, containerName, metaTags) {
      return req.put(routes.containerMetaTags(appId, containerName), metaTags);
    },
    updateContainerCustomHeadContent: function updateContainerCustomHeadContent(appId, containerName, data) {
      return req.put(routes.containerCustomHeadContent(appId, containerName), {
        data: data
      });
    },
    updateContainerExternalLibraries: function updateContainerExternalLibraries(appId, containerName, externalLibraries) {
      return req.put(routes.containerExternalLibraries(appId, containerName), externalLibraries);
    },
    updateContainerPWASettings: function updateContainerPWASettings(appId, containerName, settings) {
      return req.put(routes.containerPWASettings(appId, containerName), settings);
    },
    updateContainerPWAIcon: function updateContainerPWAIcon(appId, containerName, file) {
      return req.put(routes.containerPWAIcon(appId, containerName)).form({
        file: file
      });
    },
    //-- SETTINGS -----//
    //-- THEMES -----//
    searchThemes: function searchThemes(appId) {
      return req.get(routes.remoteThemes(appId));
    },
    loadThemes: function loadThemes(appId) {
      return req.get(routes.themes(appId));
    },
    createTheme: function createTheme(appId, theme) {
      return req.post(routes.themes(appId), theme);
    },
    updateTheme: function updateTheme(appId, themeId, theme) {
      return req.put(routes.theme(appId, themeId), theme);
    },
    deleteTheme: function deleteTheme(appId, themeId) {
      return req["delete"](routes.theme(appId, themeId));
    },
    publishTheme: function publishTheme(appId, themeId, data) {
      return req.post(routes.themeAction(appId, themeId, 'publish'), data);
    },
    loadThemeStyle: function loadThemeStyle(appId, themeId) {
      return req.get(routes.themeStyle(appId, themeId));
    },
    updateThemeStyle: function updateThemeStyle(appId, themeId, content) {
      return req.put(routes.themeStyle(appId, themeId), {
        content: content
      });
    },
    //-- THEMES -----//
    //-- PAGE -----//
    createPage: function createPage(appId, containerName, data) {
      return req.post(routes.containerPages(appId, containerName), data);
    },
    updatePage: function updatePage(appId, containerName, pageName, page) {
      return req.put(routes.containerPage(appId, containerName, pageName), page);
    },
    deletePage: function deletePage(appId, containerName, pageName) {
      return req["delete"](routes.containerPage(appId, containerName, pageName));
    },
    getPageUI: function getPageUI(appId, containerName, pageName) {
      return req.get(routes.containerPageUI(appId, containerName, pageName));
    },
    updatePageUI: function updatePageUI(appId, containerName, pageName, data) {
      return req.put(routes.containerPageUI(appId, containerName, pageName), data);
    },
    getPageLogic: function getPageLogic(appId, containerName, pageName, componentUid, handlerName) {
      return req.get(routes.containerPageLogic(appId, containerName, pageName, componentUid, handlerName));
    },
    createPageLogic: function createPageLogic(appId, containerName, pageName, componentUid, handlerName) {
      return req.post(routes.containerPageLogic(appId, containerName, pageName, componentUid, handlerName));
    },
    updatePageLogic: function updatePageLogic(appId, containerName, pageName, componentUid, data) {
      return req.put(routes.containerPageLogic(appId, containerName, pageName, componentUid), data);
    },
    deletePageLogic: function deletePageLogic(appId, containerName, pageName, componentUid, handlerName) {
      return req["delete"](routes.containerPageLogic(appId, containerName, pageName, componentUid, handlerName));
    },
    deletePageUnusedLogic: function deletePageUnusedLogic(appId, containerName, pageName, componentUids) {
      return req["delete"](routes.containerPageUnusedLogic(appId, containerName, pageName), {
        componentUids: componentUids
      });
    },
    //-- PAGE -----//
    addReferenceToMarketplaceProduct: function addReferenceToMarketplaceProduct(appId, containerName, data) {
      return req.post(routes.containerComponentAddReference(appId, containerName), data);
    },
    installComponentFromMarketplace: function installComponentFromMarketplace(appId, containerName, productId, data) {
      return req.post(routes.containerComponentInstall(appId, containerName, productId), data);
    },
    //-- LAYOUTS -----//
    createLayout: function createLayout(appId, containerName, data) {
      return req.post(routes.containerLayouts(appId, containerName), data);
    },
    updateLayout: function updateLayout(appId, containerName, layoutId, data) {
      return req.put(routes.containerLayout(appId, containerName, layoutId), data);
    },
    deleteLayout: function deleteLayout(appId, containerName, id) {
      return req["delete"](routes.containerLayout(appId, containerName, id));
    },
    getLayoutUI: function getLayoutUI(appId, containerName, id) {
      return req.get(routes.containerLayoutUI(appId, containerName, id));
    },
    updateLayoutUI: function updateLayoutUI(appId, containerName, id, data) {
      return req.put(routes.containerLayoutUI(appId, containerName, id), data);
    },
    getLayoutLogic: function getLayoutLogic(appId, containerName, id, componentUid, handlerName) {
      return req.get(routes.containerLayoutLogic(appId, containerName, id, componentUid, handlerName));
    },
    updateLayoutLogic: function updateLayoutLogic(appId, containerName, id, componentUid, data) {
      return req.put(routes.containerLayoutLogic(appId, containerName, id, componentUid), data);
    },
    createLayoutLogic: function createLayoutLogic(appId, containerName, id, componentUid, handlerName) {
      return req.post(routes.containerLayoutLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteLayoutLogic: function deleteLayoutLogic(appId, containerName, id, componentUid, handlerName) {
      return req["delete"](routes.containerLayoutLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteLayoutUnusedLogic: function deleteLayoutUnusedLogic(appId, containerName, id, componentUids) {
      return req["delete"](routes.containerLayoutUnusedLogic(appId, containerName, id), {
        componentUids: componentUids
      });
    },
    //-- LAYOUTS -----//
    //-- REUSABLE COMPONENTS -----//
    createReusableComponent: function createReusableComponent(appId, containerName, data) {
      return req.post(routes.containerReusableComponents(appId, containerName), data);
    },
    cloneReusableComponent: function cloneReusableComponent(appId, containerName, id, data) {
      return req.post(routes.containerReusableComponentClone(appId, containerName, id), data);
    },
    upgradeReusableComponent: function upgradeReusableComponent(appId, containerName, id, data) {
      return req.post(routes.containerReusableComponentUpgrade(appId, containerName, id), data);
    },
    loadReusableComponent: function loadReusableComponent(appId, containerName, id) {
      return req.get(routes.containerReusableComponent(appId, containerName, id));
    },
    updateReusableComponent: function updateReusableComponent(appId, containerName, data) {
      return req.put(routes.containerReusableComponent(appId, containerName, data.id), data);
    },
    deleteReusableComponent: function deleteReusableComponent(appId, containerName, id) {
      return req["delete"](routes.containerReusableComponent(appId, containerName, id));
    },
    updateReusableComponentUI: function updateReusableComponentUI(appId, containerName, id, data) {
      return req.put(routes.containerReusableComponentUI(appId, containerName, id), data);
    },
    getReusableComponentLogic: function getReusableComponentLogic(appId, containerName, id, componentUid, handlerName) {
      return req.get(routes.containerReusableComponentLogic(appId, containerName, id, componentUid, handlerName));
    },
    updateReusableComponentLogic: function updateReusableComponentLogic(appId, containerName, id, componentUid, data) {
      return req.put(routes.containerReusableComponentLogic(appId, containerName, id, componentUid), data);
    },
    createReusableComponentLogic: function createReusableComponentLogic(appId, containerName, id, componentUid, handlerName) {
      return req.post(routes.containerReusableComponentLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteReusableComponentLogic: function deleteReusableComponentLogic(appId, containerName, id, componentUid, handlerName) {
      return req["delete"](routes.containerReusableComponentLogic(appId, containerName, id, componentUid, handlerName));
    },
    deleteReusableComponentUnusedLogic: function deleteReusableComponentUnusedLogic(appId, containerName, id, componentUids) {
      return req["delete"](routes.containerReusableComponentUnusedLogic(appId, containerName, id), {
        componentUids: componentUids
      });
    },
    //-- REUSABLE COMPONENTS -----//
    //-- CUSTOM COMPONENTS -----//
    createCustomComponent: function createCustomComponent(appId, containerName, data) {
      return req.post(routes.containerCustomComponents(appId, containerName), data);
    },
    cloneCustomComponent: function cloneCustomComponent(appId, containerName, id, data) {
      return req.post(routes.containerCustomComponentClone(appId, containerName, id), data);
    },
    upgradeCustomComponent: function upgradeCustomComponent(appId, containerName, id, data) {
      return req.post(routes.containerCustomComponentUpgrade(appId, containerName, id), data);
    },
    loadCustomComponent: function loadCustomComponent(appId, containerName, id) {
      return req.get(routes.containerCustomComponent(appId, containerName, id));
    },
    deleteCustomComponent: function deleteCustomComponent(appId, containerName, id) {
      return req["delete"](routes.containerCustomComponent(appId, containerName, id));
    },
    updateCustomComponent: function updateCustomComponent(appId, containerName, data) {
      return req.put(routes.containerCustomComponent(appId, containerName, data.id), data);
    },
    updateCustomComponentPreview: function updateCustomComponentPreview(appId, containerName, id, data) {
      return req.put(routes.containerCustomComponentPreview(appId, containerName, id), data);
    },
    loadComponentFileContent: function loadComponentFileContent(appId, containerName, id, fileId) {
      return req.get(routes.containerCustomComponentFileContent(appId, containerName, id, fileId));
    },
    updateCustomComponentFiles: function updateCustomComponentFiles(appId, containerName, id, files) {
      return req.put(routes.containerCustomComponentFileContent(appId, containerName, id), {
        files: files
      });
    },
    uploadCustomComponentFiles: function uploadCustomComponentFiles(appId, containerName, id, data) {
      return req.post(routes.containerCustomComponentFiles(appId, containerName, id), data);
    },
    getCustomComponentFileDownloadLink: function getCustomComponentFileDownloadLink(appId, containerName, id, fileId) {
      return req.get(routes.containerCustomComponentFilesDownloadLink(appId, containerName, id)).query({
        fileId: fileId
      });
    },
    //-- CUSTOM COMPONENTS -----//
    //-- FUNCTIONS -----//
    loadContainerFunctions: function loadContainerFunctions(appId, containerName) {
      return req.get(routes.containerFunctions(appId, containerName));
    },
    createContainerFunction: function createContainerFunction(appId, containerName, fn) {
      return req.post(routes.containerFunctions(appId, containerName), fn);
    },
    updateContainerFunction: function updateContainerFunction(appId, containerName, id, definition) {
      return req.put(routes.containerFunction(appId, containerName, id), definition);
    },
    deleteContainerFunction: function deleteContainerFunction(appId, containerName, id) {
      return req["delete"](routes.containerFunction(appId, containerName, id));
    },
    deleteContainerFunctionsPack: function deleteContainerFunctionsPack(appId, containerName, productId) {
      return req["delete"](routes.removeFunctionsPack(appId, containerName, productId));
    },
    loadContainerFunctionLogic: function loadContainerFunctionLogic(appId, containerName, id) {
      return req.get(routes.containerFunctionLogic(appId, containerName, id));
    },
    updateContainerFunctionLogic: function updateContainerFunctionLogic(appId, containerName, id, data) {
      return req.put(routes.containerFunctionLogic(appId, containerName, id), data);
    },
    installCustomFunctionsFromMarketplace: function installCustomFunctionsFromMarketplace(appId, containerName, productId) {
      return req.post(routes.installCustomFunctionsFromMarketplace(appId, containerName, productId));
    },
    //-- FUNCTIONS -----//
    saveAutomationsTriggers: function saveAutomationsTriggers(appId, containerName, triggers) {
      return req.put(routes.containerAutomations(appId, containerName), triggers);
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/urls.js":
/*!*********************!*\
  !*** ./src/urls.js ***!
  \*********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.users = exports.userActivity = exports.tableColumns = exports.serverCode = exports.securityRoles = exports.security = exports.oauth2 = exports.oauth1 = exports.oauth0Config = exports.oauth0Binding = exports.oauth0 = exports.mobileSettingsAndroid = exports.mobileSettings = exports.messagingPushTemplates = exports.messagingPushTemplate = exports.messagingPushRecipientsCount = exports.messagingPushChannelTemplates = exports.messagingPushChannelTemplate = exports.messagingPushButtonTemplates = exports.messagingPushButtonTemplate = exports.messagingPush = exports.messagingChannels = exports.messagingChannel = exports.messaging = exports.marketplace = exports.mailSettings = exports.landingPage = exports.installEmailTemplate = exports.geo = exports.gamificationApp = exports.gamification = exports.files = exports.fileView = exports.fileUpload = exports.fileRename = exports.fileMove = exports.fileExists = exports.fileEdit = exports.fileDownload = exports.fileDelete = exports.fileCreate = exports.fileCopy = exports.emailTemplates = exports.downloadComplianceFile = exports.directoryView = exports.devTeam = exports["default"] = exports.dataViews = exports.dataToVisualize = exports.dataTables = exports.dataTableGroupCount = exports.dataTableGroup = exports.dataTableBulkUpsert = exports.dataTableBulkCreate = exports.dataTable = exports.dataRecord = exports.dataHives = exports.dataHiveStoreKey = exports.dataHiveStore = exports.dataHive = exports.dataConnectors = exports.dataConnectorTemplates = exports.dataConnectorTables = exports.dataConnectorTableEntries = exports.dataConnectorStoredProcedures = exports.dataConnectorStoredProcedureExecution = exports.dataConnector = exports.dataConfigs = exports.dataCell = exports.data = exports.createDir = exports.console = exports.codelessFunctions = exports.codelessFunctionSource = exports.codelessDeployModel = exports.codelessApiServices = exports.codeless = exports.cache = exports.blueprints = exports.blServicesClientDownload = exports.blProd = exports.blHandlersChain = exports.blHandlersCategory = exports.blDraftsProjectDownload = exports.blDraft = exports.blBasePath = exports.billing = exports.atomicCounters = exports.appInfo = exports.appConsole = exports.apiDocsService = exports.apiDocsMessagingChannel = exports.apiDocsGeo = exports.apiDocsFiles = exports.apiDocsDataTable = exports.apiDocs = void 0;
var _path = __webpack_require__(/*! ./utils/path */ "./src/utils/path.js");
/* eslint-disable max-len */

var console = function console(authKey) {
  return "/console".concat((0, _path.optional)(authKey));
};
exports.console = console;
var appConsole = function appConsole(appId, authKey) {
  return "/".concat(appId).concat(console(authKey));
};
exports.appConsole = appConsole;
var consoleSection = function consoleSection(section) {
  return function (appId) {
    return "".concat(appConsole(appId), "/").concat(section);
  };
};
var mailSettings = consoleSection('mailsettings');
exports.mailSettings = mailSettings;
var security = consoleSection('security');
exports.security = security;
var serverCode = consoleSection('servercode');
exports.serverCode = serverCode;
var blBasePath = consoleSection('localservices');
exports.blBasePath = blBasePath;
var data = consoleSection('data');
exports.data = data;
var geo = consoleSection('geo');
exports.geo = geo;
var files = consoleSection('files');
exports.files = files;
var messaging = consoleSection('messaging');
exports.messaging = messaging;
var dataTables = function dataTables(appId) {
  return "".concat(data(appId), "/tables");
};
exports.dataTables = dataTables;
var dataTable = function dataTable(appId, tableName) {
  return "".concat(data(appId), "/").concat(encodeURI(tableName));
};
exports.dataTable = dataTable;
var dataTableBulkCreate = function dataTableBulkCreate(appId, tableName) {
  return "".concat(data(appId), "/bulk/").concat(encodeURI(tableName));
};
exports.dataTableBulkCreate = dataTableBulkCreate;
var dataTableBulkUpsert = function dataTableBulkUpsert(appId, tableName) {
  return "".concat(data(appId), "/bulkupsert/").concat(encodeURI(tableName));
};
exports.dataTableBulkUpsert = dataTableBulkUpsert;
var dataTableGroup = function dataTableGroup(appId, tableName) {
  return "".concat(data(appId), "/data-grouping/").concat(encodeURI(tableName));
};
exports.dataTableGroup = dataTableGroup;
var dataTableGroupCount = function dataTableGroupCount(appId, tableName) {
  return "".concat(dataTableGroup(appId, tableName), "/count");
};
exports.dataTableGroupCount = dataTableGroupCount;
var dataRecord = function dataRecord(appId, tableName, recordId) {
  return "".concat(dataTable(appId, tableName), "/").concat(recordId);
};
exports.dataRecord = dataRecord;
var dataCell = function dataCell(appId, tableName, recordId, columnName) {
  return "".concat(dataRecord(appId, tableName, recordId), "/").concat(columnName);
};
exports.dataCell = dataCell;
var dataConfigs = function dataConfigs(appId) {
  return "".concat(data(appId), "/config");
};
exports.dataConfigs = dataConfigs;
var tableColumns = function tableColumns(appId, tableName) {
  return "".concat(dataTables(appId), "/").concat(encodeURI(tableName), "/columns");
};
exports.tableColumns = tableColumns;
var securityRoles = function securityRoles(appId) {
  return "".concat(security(appId), "/roles");
};
exports.securityRoles = securityRoles;
var generalizeEventCategory = function generalizeEventCategory(category) {
  return !category || category === 'TIMER' ? 'timers' : 'events';
};
var blHandlersCategory = function blHandlersCategory(appId, mode, category) {
  return "".concat(serverCode(appId), "/").concat(mode.toLowerCase(), "/").concat(generalizeEventCategory(category));
};
exports.blHandlersCategory = blHandlersCategory;
var blHandlersChain = function blHandlersChain(appId, eventId, context) {
  return "".concat(serverCode(appId), "/chain/").concat(eventId, "/").concat(context);
};
exports.blHandlersChain = blHandlersChain;
var composeFileUrl = function composeFileUrl(appId, operation, filePath) {
  var routeParts = [files(appId)];
  if (operation) {
    routeParts.push(operation);
  }
  routeParts.push((0, _path.encodePath)(filePath), '');
  return routeParts.join('/');
};
var fileExists = function fileExists(appId, filePath) {
  return composeFileUrl(appId, 'exists', filePath);
};
exports.fileExists = fileExists;
var fileEdit = function fileEdit(appId, filePath) {
  return composeFileUrl(appId, 'edit', filePath);
};
exports.fileEdit = fileEdit;
var fileMove = function fileMove(appId, filePath) {
  return composeFileUrl(appId, 'move', filePath);
};
exports.fileMove = fileMove;
var fileCopy = function fileCopy(appId, filePath) {
  return composeFileUrl(appId, 'copy', filePath);
};
exports.fileCopy = fileCopy;
var fileRename = function fileRename(appId, filePath) {
  return composeFileUrl(appId, 'rename', filePath);
};
exports.fileRename = fileRename;
var fileDelete = function fileDelete(appId, filePath) {
  return composeFileUrl(appId, null, filePath);
};
exports.fileDelete = fileDelete;
var fileCreate = function fileCreate(appId, filePath) {
  return composeFileUrl(appId, 'create', filePath);
};
exports.fileCreate = fileCreate;
var fileUpload = function fileUpload(appId, filePath) {
  return composeFileUrl(appId, 'upload', filePath);
};
exports.fileUpload = fileUpload;
var fileView = function fileView(appId, filePath) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (filePath && !filePath.startsWith('/')) {
    filePath = "/".concat(filePath);
  }
  return "".concat(options.host || '').concat(appConsole(appId), "/files/view").concat((0, _path.encodePath)(filePath));
};
exports.fileView = fileView;
var fileDownload = function fileDownload(appId, filePath) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return "".concat(options.host || '').concat(appConsole(appId), "/files/download/").concat((0, _path.encodePath)(filePath));
};
exports.fileDownload = fileDownload;
var createDir = function createDir(appId, path, folderName) {
  path = path ? "".concat(path, "/") : '';
  var dirPath = (0, _path.encodePath)(path + folderName);
  return "".concat(files(appId), "/createdir/").concat(dirPath, "/");
};
exports.createDir = createDir;
var directoryView = function directoryView(appId, filePath) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (filePath && filePath.startsWith('/')) {
    filePath = filePath.slice(1);
  }
  if (filePath.endsWith('/')) {
    filePath = filePath.slice(0, -1);
  }
  return "".concat(options.host || '').concat(appConsole(appId), "/files/directory/view").concat((0, _path.optional)((0, _path.encodePath)(filePath)));
};
exports.directoryView = directoryView;
var blProd = function blProd(appId, language, model) {
  return "".concat(serverCode(appId), "/").concat(model, "/production/").concat(language);
};
exports.blProd = blProd;
var blDraft = function blDraft(appId, language, model) {
  return "".concat(serverCode(appId), "/").concat(model, "/draft/").concat(language);
};
exports.blDraft = blDraft;
var blDraftsProjectDownload = function blDraftsProjectDownload(appId, authKey, language, model) {
  return "".concat(appConsole(appId, authKey), "/servercode/").concat(model, "/draft/").concat(language, "/download");
};
exports.blDraftsProjectDownload = blDraftsProjectDownload;
var blServicesClientDownload = function blServicesClientDownload(appId, authKey, serviceId, language) {
  return "".concat(appConsole(appId, authKey), "/localservices/").concat(serviceId, "/").concat(language, "/download");
};
exports.blServicesClientDownload = blServicesClientDownload;
var messagingChannels = function messagingChannels(appId) {
  return "".concat(messaging(appId), "/channels");
};
exports.messagingChannels = messagingChannels;
var messagingPush = function messagingPush(appId) {
  return "".concat(messaging(appId), "/push");
};
exports.messagingPush = messagingPush;
var messagingPushRecipientsCount = function messagingPushRecipientsCount(appId) {
  return "".concat(messaging(appId), "/pushsize");
};
exports.messagingPushRecipientsCount = messagingPushRecipientsCount;
var messagingPushTemplates = function messagingPushTemplates(appId) {
  return "".concat(messagingPush(appId), "/templates");
};
exports.messagingPushTemplates = messagingPushTemplates;
var messagingPushTemplate = function messagingPushTemplate(appId, name) {
  return "".concat(messagingPushTemplates(appId), "/").concat(name);
};
exports.messagingPushTemplate = messagingPushTemplate;
var messagingPushButtonTemplates = function messagingPushButtonTemplates(appId) {
  return "".concat(messaging(appId), "/button-templates");
};
exports.messagingPushButtonTemplates = messagingPushButtonTemplates;
var messagingPushButtonTemplate = function messagingPushButtonTemplate(appId, name) {
  return "".concat(messagingPushButtonTemplates(appId), "/").concat(name);
};
exports.messagingPushButtonTemplate = messagingPushButtonTemplate;
var messagingPushChannelTemplates = function messagingPushChannelTemplates(appId) {
  return "".concat(messaging(appId), "/channel-templates");
};
exports.messagingPushChannelTemplates = messagingPushChannelTemplates;
var messagingPushChannelTemplate = function messagingPushChannelTemplate(appId, name) {
  return "".concat(messagingPushChannelTemplates(appId), "/").concat(name);
};
exports.messagingPushChannelTemplate = messagingPushChannelTemplate;
var messagingChannel = function messagingChannel(appId, channelId) {
  return "".concat(messagingChannels(appId), "/").concat(channelId);
};
exports.messagingChannel = messagingChannel;
var mobileSettings = function mobileSettings(appId) {
  return "".concat(appConsole(appId), "/mobilesettings");
};
exports.mobileSettings = mobileSettings;
var mobileSettingsAndroid = function mobileSettingsAndroid(appId, id) {
  return "".concat(mobileSettings(appId), "/android").concat((0, _path.optional)(id));
};
exports.mobileSettingsAndroid = mobileSettingsAndroid;
var billing = function billing(appId) {
  console.warn('DO NOT USE THE FUNCTION');
  return "".concat(appConsole(appId), "/billing");
};
exports.billing = billing;
var marketplace = function marketplace(appId, name) {
  return "".concat(appConsole(appId), "/marketplace/").concat(name);
};
exports.marketplace = marketplace;
var appInfo = function appInfo(appId) {
  return "".concat(appConsole(appId), "/app-info");
};
exports.appInfo = appInfo;
var blueprints = function blueprints(id) {
  return "".concat(console(), "/blueprints").concat((0, _path.optional)(id));
};
exports.blueprints = blueprints;
var landingPage = function landingPage(appId) {
  return "".concat(appConsole(appId), "/landing-page");
};
exports.landingPage = landingPage;
var codeless = function codeless(appId) {
  return "".concat(appConsole(appId), "/codeless");
};
exports.codeless = codeless;
var codelessApiServices = function codelessApiServices(appId) {
  return "".concat(codeless(appId), "/api-services");
};
exports.codelessApiServices = codelessApiServices;
var codelessFunctions = function codelessFunctions(appId) {
  return "".concat(codeless(appId), "/functions");
};
exports.codelessFunctions = codelessFunctions;
var codelessFunctionSource = function codelessFunctionSource(appId, name) {
  return "".concat(codelessFunctions(appId), "/").concat(name);
};
exports.codelessFunctionSource = codelessFunctionSource;
var codelessDeployModel = function codelessDeployModel(appId, model) {
  return "".concat(codeless(appId), "/deploy/").concat(model);
};
exports.codelessDeployModel = codelessDeployModel;
var dataViews = function dataViews(appId, id) {
  return "".concat(appConsole(appId), "/data/table-views").concat((0, _path.optional)(id));
};
exports.dataViews = dataViews;
var dataHives = function dataHives(appId) {
  return "".concat(appConsole(appId), "/hive");
};
exports.dataHives = dataHives;
var dataHive = function dataHive(appId, hiveName) {
  return "".concat(dataHives(appId), "/").concat(hiveName);
};
exports.dataHive = dataHive;
var dataHiveStore = function dataHiveStore(appId, hiveName, storeType) {
  return "".concat(dataHive(appId, hiveName), "/").concat(storeType);
};
exports.dataHiveStore = dataHiveStore;
var dataHiveStoreKey = function dataHiveStoreKey(appId, hiveName, storeType, keyName) {
  return "".concat(dataHiveStore(appId, hiveName, storeType), "/").concat(keyName);
};
exports.dataHiveStoreKey = dataHiveStoreKey;
var dataToVisualize = function dataToVisualize(appId) {
  return "".concat(appConsole(appId), "/data-to-visualize");
};
exports.dataToVisualize = dataToVisualize;
var dataConnectors = function dataConnectors(appId) {
  return "".concat(appConsole(appId), "/dataconnectors");
};
exports.dataConnectors = dataConnectors;
var dataConnectorTemplates = function dataConnectorTemplates(appId) {
  return "".concat(dataConnectors(appId), "/templates");
};
exports.dataConnectorTemplates = dataConnectorTemplates;
var dataConnector = function dataConnector(appId, connectorId) {
  return "".concat(dataConnectors(appId), "/").concat(connectorId);
};
exports.dataConnector = dataConnector;
var dataConnectorTables = function dataConnectorTables(appId, connectorId) {
  return "".concat(dataConnector(appId, connectorId), "/tables");
};
exports.dataConnectorTables = dataConnectorTables;
var dataConnectorTableEntries = function dataConnectorTableEntries(appId, connectorId, tableName) {
  return "".concat(dataConnectorTables(appId, connectorId), "/").concat(tableName, "/entries");
};
exports.dataConnectorTableEntries = dataConnectorTableEntries;
var dataConnectorStoredProcedures = function dataConnectorStoredProcedures(appId, connectorId) {
  return "".concat(dataConnector(appId, connectorId), "/storedprocs");
};
exports.dataConnectorStoredProcedures = dataConnectorStoredProcedures;
var dataConnectorStoredProcedureExecution = function dataConnectorStoredProcedureExecution(appId, connectorId, procedureId) {
  return "".concat(dataConnectorStoredProcedures(appId, connectorId), "/").concat(procedureId, "/execution");
};
exports.dataConnectorStoredProcedureExecution = dataConnectorStoredProcedureExecution;
var emailTemplates = function emailTemplates(appId, templateName) {
  return "".concat(appConsole(appId), "/emailtemplate").concat((0, _path.optional)(templateName));
};
exports.emailTemplates = emailTemplates;
var installEmailTemplate = function installEmailTemplate(appId, productId) {
  return "".concat(appConsole(appId), "/email-templates/install/").concat(productId);
};
exports.installEmailTemplate = installEmailTemplate;
var apiDocs = function apiDocs(appId) {
  return "".concat(appConsole(appId), "/api-docs");
};
exports.apiDocs = apiDocs;
var apiDocsDataTable = function apiDocsDataTable(appId, tableName) {
  return "".concat(apiDocs(appId), "/data/table/").concat(tableName);
};
exports.apiDocsDataTable = apiDocsDataTable;
var apiDocsMessagingChannel = function apiDocsMessagingChannel(appId, channelName) {
  return "".concat(apiDocs(appId), "/messaging/channel/").concat(channelName);
};
exports.apiDocsMessagingChannel = apiDocsMessagingChannel;
var apiDocsFiles = function apiDocsFiles(appId) {
  return "".concat(apiDocs(appId), "/files");
};
exports.apiDocsFiles = apiDocsFiles;
var apiDocsService = function apiDocsService(appId, serviceId, model) {
  return "".concat(apiDocs(appId), "/services/").concat(serviceId, "/").concat(model);
};
exports.apiDocsService = apiDocsService;
var apiDocsGeo = function apiDocsGeo(appId) {
  return "".concat(apiDocs(appId), "/geo");
};
exports.apiDocsGeo = apiDocsGeo;
var cache = function cache(appId, key) {
  return "".concat(appConsole(appId), "/cache").concat((0, _path.optional)(key));
};
exports.cache = cache;
var atomicCounters = function atomicCounters(appId) {
  return "".concat(appConsole(appId), "/counters");
};
exports.atomicCounters = atomicCounters;
var gamification = function gamification() {
  return "".concat(console(), "/gamification");
};
exports.gamification = gamification;
var gamificationApp = function gamificationApp(appId) {
  return "".concat(appConsole(appId), "/gamification");
};
exports.gamificationApp = gamificationApp;
var userActivity = function userActivity(appId) {
  return "".concat(appConsole(appId), "/user-activity");
};
exports.userActivity = userActivity;
var devTeam = function devTeam(appId, devId) {
  return "".concat(appConsole(appId), "/devteam").concat((0, _path.optional)(devId));
};
exports.devTeam = devTeam;
var users = function users(appId) {
  return "".concat(appConsole(appId), "/users");
};
exports.users = users;
var oauth1 = function oauth1(appId) {
  return "".concat(users(appId), "/oauth1");
};
exports.oauth1 = oauth1;
var oauth2 = function oauth2(appId) {
  return "".concat(users(appId), "/oauth2");
};
exports.oauth2 = oauth2;
var oauth0 = function oauth0(appId) {
  return "".concat(appConsole(appId), "/security/auth0");
};
exports.oauth0 = oauth0;
var oauth0Config = function oauth0Config(appId) {
  return "".concat(oauth0(appId), "/config");
};
exports.oauth0Config = oauth0Config;
var oauth0Binding = function oauth0Binding(appId) {
  return "".concat(oauth0(appId), "/scope-to-role");
};
exports.oauth0Binding = oauth0Binding;
var downloadComplianceFile = function downloadComplianceFile(appId, complianceName) {
  return "".concat(security(appId), "/compliances/").concat(complianceName, "/download");
};
exports.downloadComplianceFile = downloadComplianceFile;
var _default = {
  appConsole: appConsole,
  appInfo: appInfo,
  atomicCounters: atomicCounters,
  billing: billing,
  blBasePath: blBasePath,
  blDraft: blDraft,
  blDraftsProjectDownload: blDraftsProjectDownload,
  blHandlersCategory: blHandlersCategory,
  blHandlersChain: blHandlersChain,
  blProd: blProd,
  blServicesClientDownload: blServicesClientDownload,
  blueprints: blueprints,
  cache: cache,
  codelessApiServices: codelessApiServices,
  codelessDeployModel: codelessDeployModel,
  codelessFunctionSource: codelessFunctionSource,
  codelessFunctions: codelessFunctions,
  console: console,
  createDir: createDir,
  data: data,
  dataConfigs: dataConfigs,
  dataCell: dataCell,
  dataRecord: dataRecord,
  dataTable: dataTable,
  dataTableBulkCreate: dataTableBulkCreate,
  dataTableBulkUpsert: dataTableBulkUpsert,
  dataTables: dataTables,
  devTeam: devTeam,
  emailTemplates: emailTemplates,
  fileCopy: fileCopy,
  fileCreate: fileCreate,
  fileDelete: fileDelete,
  fileDownload: fileDownload,
  fileEdit: fileEdit,
  fileExists: fileExists,
  fileMove: fileMove,
  fileRename: fileRename,
  fileUpload: fileUpload,
  fileView: fileView,
  gamification: gamification,
  gamificationApp: gamificationApp,
  directoryView: directoryView,
  geo: geo,
  installEmailTemplate: installEmailTemplate,
  landingPage: landingPage,
  mailSettings: mailSettings,
  marketplace: marketplace,
  messaging: messaging,
  messagingChannel: messagingChannel,
  messagingChannels: messagingChannels,
  messagingPush: messagingPush,
  messagingPushRecipientsCount: messagingPushRecipientsCount,
  messagingPushTemplates: messagingPushTemplates,
  messagingPushTemplate: messagingPushTemplate,
  messagingPushButtonTemplates: messagingPushButtonTemplates,
  messagingPushButtonTemplate: messagingPushButtonTemplate,
  messagingPushChannelTemplates: messagingPushChannelTemplates,
  messagingPushChannelTemplate: messagingPushChannelTemplate,
  mobileSettings: mobileSettings,
  mobileSettingsAndroid: mobileSettingsAndroid,
  security: security,
  securityRoles: securityRoles,
  serverCode: serverCode,
  tableColumns: tableColumns,
  userActivity: userActivity,
  users: users,
  dataViews: dataViews,
  dataHives: dataHives,
  dataToVisualize: dataToVisualize,
  dataConnectors: dataConnectors,
  dataConnectorTemplates: dataConnectorTemplates,
  dataConnector: dataConnector,
  dataConnectorTables: dataConnectorTables,
  dataConnectorTableEntries: dataConnectorTableEntries,
  dataConnectorStoredProcedures: dataConnectorStoredProcedures,
  dataConnectorStoredProcedureExecution: dataConnectorStoredProcedureExecution,
  apiDocsDataTable: apiDocsDataTable,
  apiDocsMessagingChannel: apiDocsMessagingChannel,
  apiDocsFiles: apiDocsFiles,
  apiDocsService: apiDocsService,
  apiDocsGeo: apiDocsGeo,
  downloadComplianceFile: downloadComplianceFile
};
exports["default"] = _default;

/***/ }),

/***/ "./src/user.js":
/*!*********************!*\
  !*** ./src/user.js ***!
  \*********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _cookie = __webpack_require__(/*! ./utils/cookie */ "./src/utils/cookie.js");
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var routes = (0, _routes.prepareRoutes)({
  getMyAccount: '/console/home/myaccount',
  updateMyAccount: '/console/home/myaccount/',
  login: '/console/home/login',
  loginWithTOTP: '/console/home/otp-login',
  cloudLogin: '/console/home/cloud/login',
  cloudLoginWithTOTP: '/console/home/cloud/otp-login',
  logout: '/console/home/logout',
  registerDev: '/console/devreg',
  deleteDev: '/console/developer-suicide',
  twoFA: '/console/developer/login/2fa',
  stripeConnect: '/console/developer/stripe-connect',
  changePassword: '/console/passwordchange',
  restorePassword: '/console/restorepassword',
  resendConfirmEmail: '/console/resend',
  discourseSSO: '/console/discourse/sso',
  socialLogin: '/console/social/oauth/:type/request_url',
  devToAutomationWorkspace: '/console/automation/management/:workspaceId/activatedev',
  stripeConnectionAuth: '/console/community/marketplace/stripe-connect/auth',
  stripeConnectionToken: '/console/community/marketplace/stripe-connect/token',
  devToAppTeam: '/:appId/console/activatedev',
  devPermissions: '/:appId/console/my-permissions'
});

/**
 *
 * @param req
 * @param {Context} context
 */
var _default = function _default(req, context) {
  return {
    /**
     * @param {String=}authKey
     * @return {Promise|*}
     */
    getAccountInfo: function getAccountInfo(authKey) {
      var request = req.get(routes.getMyAccount());
      if (authKey) {
        request.set('auth-key', authKey);
      }
      return request.send().then(function (account) {
        context.setAuthKey(account.authKey);
        return account;
      });
    },
    register: function register(userData) {
      return req.post(routes.registerDev()).send(userData);
    },
    suicide: function suicide() {
      return req["delete"](routes.deleteDev()).send();
    },
    /**
     * @param {String} login
     * @param {String} password
     * @return {Promise.<{name:String, email:String, authKey:String}>}
     */
    login: function login(_login, password) {
      return req.post(routes.login()).unwrapBody(false).send({
        login: _login,
        password: password
      }).then(function (res) {
        if (res.body.otpCreated) {
          return res.body;
        }
        return contextifyWithAuthToken(res, context);
      });
    },
    loginWithTOTP: function loginWithTOTP(authData) {
      return req.post(routes.loginWithTOTP()).unwrapBody(false).send(authData).then(function (res) {
        return contextifyWithAuthToken(res, context);
      });
    },
    /**
     * @param {String} login
     * @param {String} password
     * @return {Promise.<{name:String, email:String, authKey:String}>}
     */
    cloudLogin: function cloudLogin(login, password) {
      return req.post(routes.cloudLogin()).unwrapBody(false).send({
        login: login,
        password: password
      }).then(function (res) {
        if (res.body.otpCreated) {
          return res.body;
        }
        return contextifyWithAuthToken(res, context);
      });
    },
    cloudLoginWithTOTP: function cloudLoginWithTOTP(authData) {
      return req.post(routes.cloudLoginWithTOTP()).unwrapBody(false).send(authData).then(function (res) {
        return contextifyWithAuthToken(res, context);
      });
    },
    loginSocial: function loginSocial(type) {
      return req.get(routes.socialLogin(type));
    },
    logout: function logout() {
      return req["delete"](routes.logout()).then(function () {
        context.setAuthKey(null);
        if ((0, _cookie.cookieEnabled)()) {
          (0, _cookie.deleteCookie)('dev-auth-key');
        }
      });
    },
    restorePassword: function restorePassword(email) {
      return req.post(routes.restorePassword()).type('application/x-www-form-urlencoded; charset=UTF-8').send('email=' + encodeURIComponent(email));
    },
    resendConfirmEmail: function resendConfirmEmail(email) {
      return req.get(routes.resendConfirmEmail()).query({
        email: email
      });
    },
    updateProfile: function updateProfile(profile) {
      return req.put(routes.updateMyAccount(), profile);
    },
    registerAndJoinAppTeam: function registerAndJoinAppTeam(appId, confirmationCode, userData) {
      return req.post(routes.devToAppTeam(appId)).query({
        'confirmation-code': confirmationCode
      }).unwrapBody(false).send(userData).then(function (res) {
        return contextifyWithAuthToken(res, context);
      });
    },
    registerAndJoinWorkspace: function registerAndJoinWorkspace(workspaceId, confirmationCode, userData) {
      return req.automation.post(routes.devToAutomationWorkspace(workspaceId)).query({
        'confirmation-code': confirmationCode
      }).unwrapBody(false).send(userData).then(function (res) {
        return contextifyWithAuthToken(res, context);
      });
    },
    loginToDiscourse: function loginToDiscourse(user, sig, sso) {
      return req.post(routes.discourseSSO(), {
        user: user,
        sig: sig,
        sso: sso
      });
    },
    getPermissions: function getPermissions(appId) {
      return req.get(routes.devPermissions(appId));
    },
    completeStripeConnection: function completeStripeConnection(data) {
      return req.post(routes.stripeConnectionAuth(), data);
    },
    getStripeConnectToken: function getStripeConnectToken() {
      return req.get(routes.stripeConnectionToken());
    },
    getStripeConnectAccountId: function getStripeConnectAccountId() {
      return req.get(routes.stripeConnect());
    },
    setStripeConnectAccountId: function setStripeConnectAccountId(data) {
      return req.put(routes.stripeConnect(), data);
    },
    get2FAState: function get2FAState() {
      return req.get(routes.twoFA());
    },
    update2FAState: function update2FAState(enabled) {
      return req.put(routes.twoFA(), {
        enabled: enabled
      });
    },
    changePassword: function changePassword(id, password) {
      return req.post(routes.changePassword(), {
        id: id,
        password: password
      });
    }
  };
};
exports["default"] = _default;
function contextifyWithAuthToken(res, context) {
  var authKey = (0, _cookie.cookieEnabled)() && (0, _cookie.getCookie)('dev-auth-key') || res.headers['auth-key'];
  context.setAuthKey(authKey);
  return _objectSpread(_objectSpread({}, res.body), {}, {
    authKey: authKey
  });
}

/***/ }),

/***/ "./src/users.js":
/*!**********************!*\
  !*** ./src/users.js ***!
  \**********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = __webpack_require__(/*! ./urls */ "./src/urls.js");
var _default = function _default(req) {
  return {
    getUsersRegs: function getUsersRegs(appId) {
      return req.get("".concat((0, _urls.appConsole)(appId), "/userregistration"));
    },
    updateUsersRegs: function updateUsersRegs(appId, data) {
      return req.put("".concat((0, _urls.appConsole)(appId), "/userregistration"), data);
    },
    getUsersLogin: function getUsersLogin(appId) {
      return req.get("".concat((0, _urls.appConsole)(appId), "/userlogin"));
    },
    logoutAllUsers: function logoutAllUsers(appId) {
      return req.post("".concat((0, _urls.appConsole)(appId), "/userlogin/logout/all"));
    },
    getUserSocialLogin: function getUserSocialLogin(provider) {
      return req.get("/console/social/oauth/".concat(provider, "/request_url"));
    },
    updateUsersLogin: function updateUsersLogin(appId, data) {
      return req.post("".concat((0, _urls.appConsole)(appId), "/userlogin"), data);
    },
    getUsersProps: function getUsersProps(appId) {
      return req.get("".concat((0, _urls.appConsole)(appId), "/userproperties"));
    },
    updateUsersProps: function updateUsersProps(appId, data) {
      return req.put("".concat((0, _urls.appConsole)(appId), "/userproperties/").concat(data.name), data);
    },
    updateSocialParams: function updateSocialParams(appId, param) {
      return req.post("".concat((0, _urls.appConsole)(appId), "/socialparams"), param);
    },
    getOAuth1ProviderTemplates: function getOAuth1ProviderTemplates(appId) {
      return req.get("".concat((0, _urls.users)(appId), "/oauth1-templates"));
    },
    getOAuth2ProviderTemplates: function getOAuth2ProviderTemplates(appId) {
      return req.get("".concat((0, _urls.users)(appId), "/oauth2-templates"));
    },
    getOAuth1Providers: function getOAuth1Providers(appId) {
      return req.get("".concat((0, _urls.oauth1)(appId)));
    },
    getOAuth2Providers: function getOAuth2Providers(appId) {
      return req.get("".concat((0, _urls.oauth2)(appId)));
    },
    getOAuth1Provider: function getOAuth1Provider(appId, providerId) {
      return req.get("".concat((0, _urls.oauth1)(appId), "/").concat(providerId));
    },
    getOAuth2Provider: function getOAuth2Provider(appId, providerId) {
      return req.get("".concat((0, _urls.oauth2)(appId), "/").concat(providerId));
    },
    createOAuth2Provider: function createOAuth2Provider(appId, provider) {
      return req.post("".concat((0, _urls.oauth2)(appId)), provider);
    },
    updateOAuth1Provider: function updateOAuth1Provider(appId, provider) {
      return req.put("".concat((0, _urls.oauth1)(appId), "/").concat(provider.id), provider);
    },
    updateOAuth2Provider: function updateOAuth2Provider(appId, provider) {
      return req.put("".concat((0, _urls.oauth2)(appId), "/").concat(provider.id), provider);
    },
    createOAuth1ProviderFromTemplate: function createOAuth1ProviderFromTemplate(appId, data) {
      return req.post("".concat((0, _urls.oauth1)(appId), "/create-from-template"), data);
    },
    createOAuth2ProviderFromTemplate: function createOAuth2ProviderFromTemplate(appId, data) {
      return req.post("".concat((0, _urls.oauth2)(appId), "/create-from-template"), data);
    },
    removeOAuth1Provider: function removeOAuth1Provider(appId, providerId) {
      return req["delete"]("".concat((0, _urls.oauth1)(appId), "/").concat(providerId));
    },
    removeOAuth2Provider: function removeOAuth2Provider(appId, providerId) {
      return req["delete"]("".concat((0, _urls.oauth2)(appId), "/").concat(providerId));
    },
    getOAuth1CallbackUrls: function getOAuth1CallbackUrls(appId, providerCode) {
      return req.get("".concat((0, _urls.oauth1)(appId), "/").concat(providerCode, "/callback-url"));
    },
    getOAuth2CallbackUrls: function getOAuth2CallbackUrls(appId, providerCode) {
      return req.get("".concat((0, _urls.oauth2)(appId), "/").concat(providerCode, "/callback-url"));
    },
    getAuth0Configuration: function getAuth0Configuration(appId) {
      return req.get("".concat((0, _urls.oauth0Config)(appId)));
    },
    updateAuth0Configuration: function updateAuth0Configuration(appId, config) {
      return req.put("".concat((0, _urls.oauth0Config)(appId)), config);
    },
    createAuth0ScopeBinding: function createAuth0ScopeBinding(appId, binding) {
      return req.post("".concat((0, _urls.oauth0Binding)(appId)), binding);
    },
    updateAuth0ScopeBinding: function updateAuth0ScopeBinding(appId, binding) {
      return req.put("".concat((0, _urls.oauth0Binding)(appId), "/").concat(binding.id), binding);
    },
    getAuth0ScopeBindings: function getAuth0ScopeBindings(appId) {
      return req.get("".concat((0, _urls.oauth0Binding)(appId)));
    },
    deleteAuth0ScopeBinding: function deleteAuth0ScopeBinding(appId, bindingId) {
      return req["delete"]("".concat((0, _urls.oauth0Binding)(appId), "/").concat(bindingId));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/utils/cache-tags.js":
/*!*********************************!*\
  !*** ./src/utils/cache-tags.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.VIEW_GROUP_DATA = exports.VIEW_DATA = exports.TABLE_DATA = exports.TABLE = exports.GEO_POINT = exports.GEO_FENCE = exports.GEO_CATEGORY = exports.FOLDER = exports.CHANNEL_DEVICES = exports.BL_MODELS = exports.BL_CHAIN = void 0;
var GEO_POINT = 'GEO_POINT';
exports.GEO_POINT = GEO_POINT;
var GEO_FENCE = 'GEO_FENCE';
exports.GEO_FENCE = GEO_FENCE;
var TABLE = 'TABLE';
exports.TABLE = TABLE;
var FOLDER = function FOLDER(appId, folder) {
  return compose('FOLDER', appId, folder);
};
exports.FOLDER = FOLDER;
var TABLE_DATA = function TABLE_DATA(table) {
  return compose('TABLE_DATA', table);
};
exports.TABLE_DATA = TABLE_DATA;
var CHANNEL_DEVICES = function CHANNEL_DEVICES(channel) {
  return compose('CHANNEL_DEVICES', channel);
};
exports.CHANNEL_DEVICES = CHANNEL_DEVICES;
var GEO_CATEGORY = function GEO_CATEGORY(appId, category) {
  return composePattern('GEO_CATEGORY', appId, category);
};
exports.GEO_CATEGORY = GEO_CATEGORY;
var BL_MODELS = function BL_MODELS(appId, language) {
  return composePattern('BL_MODELS', appId, language);
};
exports.BL_MODELS = BL_MODELS;
var BL_CHAIN = function BL_CHAIN(appId, eventId, context) {
  return composePattern('BL_CHAIN', appId, eventId, context);
};
exports.BL_CHAIN = BL_CHAIN;
var VIEW_DATA = function VIEW_DATA(viewId) {
  return compose('VIEW_DATA', viewId);
};
exports.VIEW_DATA = VIEW_DATA;
var VIEW_GROUP_DATA = function VIEW_GROUP_DATA(viewId) {
  return compose('VIEW_GROUP_DATA', viewId);
};
exports.VIEW_GROUP_DATA = VIEW_GROUP_DATA;
var compose = function compose() {
  for (var _len = arguments.length, tokens = new Array(_len), _key = 0; _key < _len; _key++) {
    tokens[_key] = arguments[_key];
  }
  return tokens.join('-');
};
var composePattern = function composePattern(prefix, value) {
  return value ? [prefix, value].join('-') : new RegExp(prefix + '.*');
};

/***/ }),

/***/ "./src/utils/cookie.js":
/*!*****************************!*\
  !*** ./src/utils/cookie.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.cookieEnabled = void 0;
exports.deleteCookie = deleteCookie;
exports.getCookie = getCookie;
exports.setCookie = setCookie;
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var cookieEnabled = function cookieEnabled() {
  return typeof window !== 'undefined' && navigator && navigator.cookieEnabled;
};
exports.cookieEnabled = cookieEnabled;
function getCookie(name) {
  var matches = document.cookie.match(new RegExp('(?:^|; )' + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + '=([^;]*)'));
  return matches ? decodeURIComponent(matches[1]) : undefined;
}
function setCookie(name, value) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  options = _objectSpread({
    path: '/'
  }, options);
  if (options.expires instanceof Date) {
    options.expires = options.expires.toUTCString();
  }
  var updatedCookie = encodeURIComponent(name) + '=' + encodeURIComponent(value);
  for (var optionKey in options) {
    updatedCookie += "; ".concat(optionKey);
    var optionValue = options[optionKey];
    if (optionValue !== true) {
      updatedCookie += "=".concat(optionValue);
    }
  }
  document.cookie = updatedCookie;
}
function deleteCookie(name) {
  setCookie(name, '', {
    'max-age': -1
  });
}

/***/ }),

/***/ "./src/utils/path.js":
/*!***************************!*\
  !*** ./src/utils/path.js ***!
  \***************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.optional = exports.encodePath = void 0;
var optional = function optional(path) {
  return path ? '/' + path : '';
};
exports.optional = optional;
var encodePath = function encodePath(path) {
  return path.split('/').map(function (pathPart) {
    return encodeURIComponent(pathPart);
  }).join('/');
};
exports.encodePath = encodePath;

/***/ }),

/***/ "./src/utils/routes.js":
/*!*****************************!*\
  !*** ./src/utils/routes.js ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.prepareRoutes = prepareRoutes;
function prepareRoutes(routes) {
  var result = {};
  Object.keys(routes).forEach(function (key) {
    var tokens = routes[key].split('/');
    result[key] = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      var lastArgIndex = 0;
      var targetTokens = tokens.map(function (pathToken) {
        return pathToken.startsWith(':') ? args[lastArgIndex++] : pathToken;
      });
      var route = targetTokens.join('/');
      if (route.indexOf('/:') >= 0) {
        throw new Error("Invalid path params in route [".concat(key, "], arguments: ").concat(args));
      }
      return route;
    };
  });
  return result;
}

/***/ }),

/***/ "./src/utils/sql-builder.js":
/*!**********************************!*\
  !*** ./src/utils/sql-builder.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var UNITS_CONVERTERS = {
  miles: 'mi',
  yards: 'yd',
  kilometers: 'km',
  meters: 'km'
};
var RADIUS_CONVERTERS = {
  meters: function meters(value) {
    return value / 1000;
  }
};
var SQL = {
  and: function and() {
    for (var _len = arguments.length, tokens = new Array(_len), _key = 0; _key < _len; _key++) {
      tokens[_key] = arguments[_key];
    }
    var result = tokens.reduce(function (memo, token) {
      if (token) {
        memo = memo ? "".concat(memo, " AND (").concat(token, ")") : token;
      }
      return memo;
    }, '');
    return result ? result : undefined;
  },
  "in": function _in(name, items) {
    var tokens = items.map(function (item) {
      return typeof item === 'string' ? "'".concat(item, "'") : item;
    });
    return items.length ? "(".concat(name, " IN (").concat(tokens.join(', '), "))") : undefined;
  },
  distance: function distance(lat, lng, unit, radius) {
    var u = UNITS_CONVERTERS[unit];
    var r = RADIUS_CONVERTERS[unit] ? RADIUS_CONVERTERS[unit](radius) : radius;
    return "distance(".concat(lat, ", ").concat(lng, ", latitude, longitude) < ").concat(u, "(").concat(r, ")");
  }
};
var _default = SQL;
exports["default"] = _default;

/***/ }),

/***/ "./src/utils/table.js":
/*!****************************!*\
  !*** ./src/utils/table.js ***!
  \****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.tableRecordsReq = exports.tableRecordsCountReq = exports.composeRequestParams = exports.buildRecordsSearch = void 0;
exports.wrapQueryColumnName = wrapQueryColumnName;
var _data = __webpack_require__(/*! ../constants/data */ "./src/constants/data.js");
var _sqlBuilder = _interopRequireDefault(__webpack_require__(/*! ./sql-builder */ "./src/utils/sql-builder.js"));
var _cacheTags = __webpack_require__(/*! ./cache-tags */ "./src/utils/cache-tags.js");
/* eslint-disable max-len */

var sqlLike = function sqlLike(part) {
  return "like '%".concat(part, "%'");
};
var DATETIME_PATTERN = /[\w]?/;
var TIME_PATTERN = /^((([01]?[0-9]{1}|[2]{1}[0-3]{1})?)?(:([0-5]?[0-9])?)?(:([0-5]?[0-9])))?[ ]?(G|GM|GMT|GMT\+|GMT\+[0-9]+[ ]?)?$/;
var BOOLEAN_SQL_VALUES = {
  'true': '= true',
  'false': '= false',
  'null': 'IS NULL'
};
var composeRequestParams = function composeRequestParams(table, query) {
  var _query$pageSize = query.pageSize,
    pageSize = _query$pageSize === void 0 ? 15 : _query$pageSize,
    _query$offset = query.offset,
    offset = _query$offset === void 0 ? 0 : _query$offset,
    sqlSearch = query.sqlSearch,
    where = query.where,
    sortField = query.sortField,
    sortDir = query.sortDir,
    filterString = query.filterString;
  var property = query.property,
    groupBy = query.groupBy,
    having = query.having,
    distinct = query.distinct,
    loadRelations = query.loadRelations,
    sortBy = query.sortBy,
    props = query.props;
  var params = {
    pageSize: pageSize,
    offset: offset
  };
  var search = buildRecordsSearch(table, sqlSearch, where, filterString);
  if (search) {
    params.where = search;
  }
  if (sortBy) {
    params.sortBy = sortBy;
  } else if (sortField && sortDir) {
    params.sortBy = "".concat(sortField, " ").concat(sortDir);
  }
  if (property) {
    params.property = property;
  }
  if (props) {
    params.props = props;
  }
  if (groupBy) {
    params.groupBy = groupBy;
  }
  if (having) {
    params.having = having;
  }
  if (distinct) {
    params.distinct = distinct;
  }
  if (loadRelations) {
    params.loadRelations = loadRelations;
  }
  return params;
};
exports.composeRequestParams = composeRequestParams;
var tableRecordsReq = function tableRecordsReq(req, url, table) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var resetCache = arguments.length > 4 ? arguments[4] : undefined;
  var params = composeRequestParams(table, query);
  return req.post(url, params).cacheTags((0, _cacheTags.TABLE_DATA)(table.tableId)).resetCache(resetCache);
};
exports.tableRecordsReq = tableRecordsReq;
var tableRecordsCountReq = function tableRecordsCountReq(req, url, table) {
  var query = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var resetCache = arguments.length > 4 ? arguments[4] : undefined;
  var params = composeRequestParams(table, query);
  return req.post(url, params).cacheTags((0, _cacheTags.TABLE_DATA)(table.tableId)).resetCache(resetCache);
};
exports.tableRecordsCountReq = tableRecordsCountReq;
var buildRecordsSearch = function buildRecordsSearch(table, sql, searchString, filterString) {
  searchString = searchString ? searchString.trim() : '';
  var searchSQL = sql || !searchString ? searchString : searchStringToSQLFormat(table, searchString);
  return _sqlBuilder["default"].and(filterString, searchSQL);
};
exports.buildRecordsSearch = buildRecordsSearch;
var searchStringToSQLFormat = function searchStringToSQLFormat(table, searchValue) {
  var ignoreColumns = table.name === _data.USERS_TABLE ? _data.NON_SEARCHABLE_USERS_COLUMNS : _data.NON_SEARCHABLE_COLUMNS;
  var sqlParts = [];
  table.columns.forEach(function (column) {
    if (!ignoreColumns.includes(column.name)) {
      var sqlFragment = getSQLQueryForColumn(searchValue, column.dataType);
      if (sqlFragment) {
        sqlParts.push("".concat(wrapQueryColumnName(column.name), " ").concat(sqlFragment));
      }
    }
  });
  return sqlParts.join(' or ');
};
var getSQLQueryForColumn = function getSQLQueryForColumn(searchString, columnType) {
  if (_data.PRIMITIVES.includes(columnType)) {
    return sqlLike(searchString);
  }
  if (_data.DataTypes.BOOLEAN === columnType) {
    return BOOLEAN_SQL_VALUES[searchString.toLowerCase()];
  }
  if (_data.DataTypes.DATETIME === columnType) {
    if (TIME_PATTERN.test(searchString)) {
      var timeQuery = searchString.replace(/^(\d{1,2}):(\d{1,2})(:(\d{1,4}))?/, function (match, hh, mm, ssW, ss) {
        var hours = hh.length === 1 ? '0' + hh : hh;
        var minutes = mm.length === 1 ? '0' + mm : mm;
        var seconds = ss && ss.length === 1 ? '0' + ss : ss;

        //with seconds => 14:47:29
        //without seconds => 14:47
        return "".concat(hours, ":").concat(minutes).concat(seconds ? ':' + seconds : '');
      });
      return sqlLike(timeQuery);
    }
    if (DATETIME_PATTERN.test(searchString)) {
      var dateTimeQuery = searchString.replace(/^(\d{1,2})[-\/](\d{1,2})[-\/](\d{1,4})/, function (match, m, d, year) {
        var month = m.length === 1 ? '0' + m : m;
        var day = d.length === 1 ? '0' + d : d;

        //1990-04-28
        return "".concat(year, "-").concat(month, "-").concat(day);
      });
      return sqlLike(dateTimeQuery);
    }
  }
};
function shouldWrap(path) {
  if (path && path.startsWith('`') && path.endsWith('`')) {
    return false;
  }
  if (path.includes('[') && path.includes(']')) {
    return false;
  }
  return true;
}
function wrapQueryColumnName(columnName) {
  return columnName.split('.').map(function (path) {
    return shouldWrap(path) ? "`".concat(path, "`") : path;
  }).join('.');
}

/***/ }),

/***/ "./src/utils/total-rows.js":
/*!*********************************!*\
  !*** ./src/utils/total-rows.js ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/toConsumableArray */ "./node_modules/@babel/runtime/helpers/toConsumableArray.js"));
var _omit2 = _interopRequireDefault(__webpack_require__(/*! lodash/omit */ "./node_modules/lodash/omit.js"));
var NON_COUNTS_PARAMS = ['offset', 'pagesize', 'pageSize', 'sortBy', 'sortDirection'];
var DEFAULT_CACHE_TTL = 30000;
var trimQueryParams = function trimQueryParams(path, paramsToTrim) {
  var pathTokens = path.split('?');
  var url = pathTokens[0];
  var params = pathTokens[1] || '';
  var paramsTokens = params.split('&');
  var filteredParams = paramsToTrim && paramsToTrim.length ? paramsTokens.filter(function (param) {
    return paramsToTrim.indexOf(param.split('=')[0]) === -1;
  }) : [];
  var filteredQuery = filteredParams.join('&');
  return filteredQuery ? "".concat(url, "?").concat(filteredQuery) : url;
};
var getCountPath = function getCountPath(path) {
  path = trimQueryParams(path, NON_COUNTS_PARAMS);
  var pathTokens = path.split('?');
  if (pathTokens[0] && pathTokens[0].endsWith('/')) {
    pathTokens[0] = pathTokens[0].slice(0, -1);
  }
  return "".concat(pathTokens[0], "/count").concat(pathTokens[1] ? '?' + pathTokens[1] : '');
};
var getDataReqURL = function getDataReqURL(dataReq) {
  var url = dataReq.path;
  if (url && url.endsWith('/')) {
    url = url.slice(0, -1);
  }
  return url;
};
var _default = function _default(req) {
  return {
    get: function get(path, cacheTags) {
      return req.get(getCountPath(path)).useCache().cacheTags(cacheTags);
    },
    getFor: function getFor(dataReq) {
      var _req$get$useCache;
      var cacheTTL = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_CACHE_TTL;
      var url = getDataReqURL(dataReq);
      return (_req$get$useCache = req.get(url + '/count').useCache(cacheTTL)).cacheTags.apply(_req$get$useCache, (0, _toConsumableArray2["default"])(dataReq.tags || [])).query((0, _omit2["default"])(dataReq.queryParams, NON_COUNTS_PARAMS));
    },
    getViaPostFor: function getViaPostFor(dataReq) {
      var _req$post$useCache;
      var cacheTTL = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_CACHE_TTL;
      var url = getDataReqURL(dataReq);
      return (_req$post$useCache = req.post(url + '/count', (0, _omit2["default"])(dataReq.body, NON_COUNTS_PARAMS)).useCache(cacheTTL)).cacheTags.apply(_req$post$useCache, (0, _toConsumableArray2["default"])(dataReq.tags || []));
    },
    getWithData: function getWithData(dataReq, cacheTTL) {
      var _this = this;
      return dataReq.then(function (data) {
        return _this.getFor(dataReq, cacheTTL).then(function (totalRows) {
          return {
            data: data,
            totalRows: totalRows
          };
        });
      });
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/utils/views.js":
/*!****************************!*\
  !*** ./src/utils/views.js ***!
  \****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.viewRecordsReq = exports.viewRecordsGroupReq = exports.viewRecordsGroupCountReq = exports.viewRecordsCountReq = void 0;
var _cacheTags = __webpack_require__(/*! ./cache-tags */ "./src/utils/cache-tags.js");
var CommonRequestProperties = ['where', 'distinct', 'props', 'excludeProps', 'property', 'loadRelations', 'sortBy'];
var GroupRequestProperties = [].concat(CommonRequestProperties, ['groupDepth', 'relationsPageSize', 'groupPath', 'groupBy']);
var GroupCountRequestProperties = ['where', 'distinct'];
var assignPropertiesIfDefined = function assignPropertiesIfDefined(target, source, properties) {
  return properties.reduce(function (acc, property) {
    if (source.hasOwnProperty(property) && source[property]) {
      acc[property] = source[property];
      return acc;
    }
    return acc;
  }, target);
};
var viewRecordsReq = function viewRecordsReq(req, url, view, query, resetCache) {
  var _query$pageSize = query.pageSize,
    pageSize = _query$pageSize === void 0 ? 15 : _query$pageSize,
    _query$offset = query.offset,
    offset = _query$offset === void 0 ? 0 : _query$offset;
  var params = {
    offset: offset,
    pageSize: pageSize
  };
  assignPropertiesIfDefined(params, query, CommonRequestProperties);
  return req.post(url, params).cacheTags((0, _cacheTags.VIEW_DATA)(view.viewId)).resetCache(resetCache);
};
exports.viewRecordsReq = viewRecordsReq;
var viewRecordsCountReq = function viewRecordsCountReq(req, url, view, query, resetCache) {
  var _query$pageSize2 = query.pageSize,
    pageSize = _query$pageSize2 === void 0 ? 15 : _query$pageSize2,
    _query$offset2 = query.offset,
    offset = _query$offset2 === void 0 ? 0 : _query$offset2;
  var params = {
    offset: offset,
    pageSize: pageSize
  };
  assignPropertiesIfDefined(params, query, CommonRequestProperties);
  return req.post(url, params).cacheTags((0, _cacheTags.VIEW_DATA)(view.viewId)).resetCache(resetCache);
};
exports.viewRecordsCountReq = viewRecordsCountReq;
var viewRecordsGroupReq = function viewRecordsGroupReq(req, url, viewId, query) {
  var _query$offset3 = query.offset,
    offset = _query$offset3 === void 0 ? 0 : _query$offset3,
    _query$pageSize3 = query.pageSize,
    pageSize = _query$pageSize3 === void 0 ? 15 : _query$pageSize3,
    _query$groupPageSize = query.groupPageSize,
    groupPageSize = _query$groupPageSize === void 0 ? 5 : _query$groupPageSize,
    _query$recordsPageSiz = query.recordsPageSize,
    recordsPageSize = _query$recordsPageSiz === void 0 ? 5 : _query$recordsPageSiz;
  var params = {
    offset: offset,
    pageSize: pageSize,
    groupPageSize: groupPageSize,
    recordsPageSize: recordsPageSize
  };
  assignPropertiesIfDefined(params, query, GroupRequestProperties);
  return req.post(url, params).cacheTags((0, _cacheTags.VIEW_GROUP_DATA)(viewId));
};
exports.viewRecordsGroupReq = viewRecordsGroupReq;
var viewRecordsGroupCountReq = function viewRecordsGroupCountReq(req, url, query) {
  var groupPath = query.groupPath;
  var params = {
    groupPath: groupPath
  };
  assignPropertiesIfDefined(params, query, GroupCountRequestProperties);
  return req.post(url, params);
};
exports.viewRecordsGroupCountReq = viewRecordsGroupCountReq;

/***/ }),

/***/ "./src/visualizations.js":
/*!*******************************!*\
  !*** ./src/visualizations.js ***!
  \*******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _routes = __webpack_require__(/*! ./utils/routes */ "./src/utils/routes.js");
var routes = (0, _routes.prepareRoutes)({
  visualizations: '/:appId/console/visualizations',
  visualization: '/:appId/console/visualizations/:visualizationId',
  visualizationResources: '/:appId/console/visualizations/:visualizationId/resources',
  publishedUIBuilderContainers: '/:appId/console/visualizations/ui-builder/containers/published'
});
var _default = function _default(req) {
  return {
    getVisualizations: function getVisualizations(appId) {
      return req.get(routes.visualizations(appId));
    },
    createVisualization: function createVisualization(appId, visualization) {
      return req.post(routes.visualizations(appId), visualization);
    },
    updateVisualization: function updateVisualization(appId, visualizationId, visualization) {
      return req.put(routes.visualization(appId, visualizationId), visualization);
    },
    deleteVisualizations: function deleteVisualizations(appId, visualizationIds) {
      return req["delete"](routes.visualizations(appId)).query({
        visualizationIds: visualizationIds
      });
    },
    updateVisualizationResources: function updateVisualizationResources(appId, visualizationId) {
      return req.put(routes.visualizationResources(appId, visualizationId));
    },
    loadPublishedUIBuilderContainers: function loadPublishedUIBuilderContainers(appId) {
      return req.get(routes.publishedUIBuilderContainers(appId));
    }
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./src/warning.js":
/*!************************!*\
  !*** ./src/warning.js ***!
  \************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _default = function _default(req) {
  return function (appId) {
    return req.get("".concat(_urls["default"].appConsole(appId), "/warning"));
  };
};
exports["default"] = _default;

/***/ }),

/***/ "./node_modules/backendless-request/es/cache.js":
/*!******************************************************!*\
  !*** ./node_modules/backendless-request/es/cache.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.cache = void 0;
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * @typedef {Object} CacheItem
 * @property {*} value
 * @property {Array.<RegExp|String>} tags
 * @property {Number} ttl
 */

/**
 * @param {*} value
 * @param {Array.<RegExp|String>}tags
 * @param {Number} ttl
 * @returns {CacheItem}
 */
var cacheItem = function cacheItem(value, tags, ttl) {
  return {
    value: value,
    tags: tags,
    ttl: ttl
  };
};
var currentTime = function currentTime() {
  return new Date().getTime();
};

/**
 * Returns true if tag A matches tag B :
 *  - if they are non-strictly equal
 *  - if one of them is Regexp matching the opposite
 *
 * @param {String|RegExp} a
 * @param {String|RegExp} b
 * @returns {Boolean}
 */
var tagsMatches = function tagsMatches(a, b) {
  var result = a == b; // eslint-disable-line

  if (!result && a instanceof RegExp) {
    result = a.test(b);
  }
  if (!result && b instanceof RegExp) {
    result = b.test(a);
  }
  return result;
};

/**
 * Returns true if any of A tags matches any of B tags
 *
 * @param {Array.<String|RegExp>} a
 * @param {Array.<String|RegExp>} b
 * @returns {Boolean}
 */
var tagsContainMatches = function tagsContainMatches(a, b) {
  return !!a.find(function (aTag) {
    return b.find(function (bTag) {
      return tagsMatches(aTag, bTag);
    });
  });
};

/**
 * A Cache with TTL and optional tags for the keys
 * Makes it possible to assign multiple tags for a key and delete keys by tags
 * Optionally it starts flushing timer which cleans all outdated keys
 */
var Cache = /*#__PURE__*/function () {
  /**
   * @param {Number?} flushInterval
   */
  function Cache(flushInterval) {
    _classCallCheck(this, Cache);
    this.setFlushInterval(flushInterval);

    /**
     * @type {Map.<String, CacheItem>}
     */
    this.map = new Map();
  }
  _createClass(Cache, [{
    key: "setFlushInterval",
    value: function setFlushInterval(flushInterval) {
      this.flushInterval = flushInterval;
      if (this.flushTimer) {
        clearInterval(this.flushTimer);
        delete this.flushTimer;
      }
    }

    /**
     * @param {String} key
     * @returns {*}
     */
  }, {
    key: "get",
    value: function get(key) {
      var cacheItem = this.map.get(key);
      if (cacheItem) {
        if (cacheItem.ttl > currentTime()) {
          return cacheItem.value;
        } else {
          this.map["delete"](key);
        }
      }
    }

    /**
     * @param {String} key
     * @param {*} value
     * @param {Array.<RegExp|String>=} tags
     * @param {Number=} ttl
     */
  }, {
    key: "set",
    value: function set(key, value, tags, ttl) {
      this.map.set(key, cacheItem(value, tags, currentTime() + ttl));
      if (this.flushInterval && !this.flushTimer) {
        this.flushTimer = setInterval(this.flush.bind(this), this.flushInterval);
        if (this.flushTimer.unref) {
          this.flushTimer.unref();
        }
      }
    }

    /**
     * @param {String} key
     */
  }, {
    key: "delete",
    value: function _delete(key) {
      this.map["delete"](key);
    }
  }, {
    key: "deleteAll",
    value: function deleteAll() {
      var _iterator = _createForOfIteratorHelper(this.map),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = _slicedToArray(_step.value, 1),
            key = _step$value[0];
          this["delete"](key);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }

    /**
     * @param {Array.<String>} tags
     */
  }, {
    key: "deleteByTags",
    value: function deleteByTags(tags) {
      var _iterator2 = _createForOfIteratorHelper(this.map),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _step2$value = _slicedToArray(_step2.value, 2),
            key = _step2$value[0],
            value = _step2$value[1];
          if (value.tags && tagsContainMatches(tags, value.tags)) {
            this["delete"](key);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }

    /**
     * Deletes all outdated keys
     */
  }, {
    key: "flush",
    value: function flush() {
      var now = currentTime();
      var _iterator3 = _createForOfIteratorHelper(this.map),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _step3$value = _slicedToArray(_step3.value, 2),
            key = _step3$value[0],
            value = _step3$value[1];
          if (value.ttl < now) {
            this["delete"](key);
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    }
  }]);
  return Cache;
}();
var CACHE_FLUSH_INTERVAL = 60000; //60 sec

var cache = exports.cache = new Cache(CACHE_FLUSH_INTERVAL);

/***/ }),

/***/ "./node_modules/backendless-request/es/client-browser.js":
/*!***************************************************************!*\
  !*** ./node_modules/backendless-request/es/client-browser.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.sendXmlHttpRequest = sendXmlHttpRequest;
var _request2 = __webpack_require__(/*! ./request */ "./node_modules/backendless-request/es/request.js");
function sendXmlHttpRequest(path, method, headers, body, encoding, timeout, withCredentials) {
  return new Promise(function sendRequest(resolve, reject) {
    var request = new _request2.Request.XMLHttpRequest();
    request.timeout = timeout;
    if (!encoding) {
      request.responseType = 'arraybuffer';
    }
    request.open(method.toUpperCase(), path, true);
    if (typeof withCredentials === 'boolean') {
      request.withCredentials = withCredentials;
    }
    request.onload = function handleLoadEvent() {
      var headers = parseHeaders(request.getAllResponseHeaders());
      var _request = request,
        status = _request.status,
        statusText = _request.statusText;
      var result = {
        status: status,
        statusText: statusText,
        headers: headers
      };
      if (encoding === 'utf8') {
        result.body = request.response || request.responseText;
      } else if (request.response) {
        result.body = new Uint8Array(request.response);
      }
      resolve(result);
      request = null;
    };
    request.onerror = function handleErrorEvent() {
      reject(new Error('Network Error'));
      request = null;
    };
    request.ontimeout = function handleTimeout() {
      reject(new Error('Connection aborted due to timeout'));
      request = null;
    };
    Object.keys(headers).forEach(function (key) {
      request.setRequestHeader(key, headers[key]);
    });
    request.send(body);
  });
}
function parseHeaders(headersString) {
  var parsed = {};
  if (!headersString) {
    return parsed;
  }
  headersString.split('\n').forEach(function (line) {
    var i = line.indexOf(':');
    var key = line.substr(0, i).trim();
    var val = line.substr(i + 1).trim();
    if (key) {
      parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
    }
  });
  return parsed;
}

/***/ }),

/***/ "./node_modules/backendless-request/es/client-node.js":
/*!************************************************************!*\
  !*** ./node_modules/backendless-request/es/client-node.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.sendNodeAPIRequest = sendNodeAPIRequest;
var _utils = __webpack_require__(/*! ./utils */ "./node_modules/backendless-request/es/utils.js");
function sendNodeAPIRequest(path, method, headers, body, encoding, timeout, withCredentials) {
  return new Promise(function (resolve, reject) {
    var u = (__webpack_require__(/*! url */ "url").parse)(path);
    var form = (0, _utils.isFormData)(body) && body;
    var https = u.protocol === 'https:';
    var options = {
      host: u.hostname,
      port: u.port || (https ? 443 : 80),
      path: (0, _utils.normalizeTrailingSlashInPath)(path, u) + (u.search || ''),
      method: method,
      headers: headers,
      timeout: timeout
    };
    if (typeof withCredentials === 'boolean') {
      options.withCredentials = withCredentials;
    }
    var _send = function _send() {
      var Buffer = (__webpack_require__(/*! buffer */ "buffer").Buffer);
      var httpClient = __webpack_require__(https ? /*! https */ "https" : /*! http */ "http");
      var req = httpClient.request(options, function (res) {
        var strings = [];
        var buffers = [];
        var bufferLength = 0;
        var body = '';
        var status = res.statusCode,
          statusText = res.statusMessage,
          headers = res.headers;
        res.on('data', function (chunk) {
          if (!Buffer.isBuffer(chunk)) {
            strings.push(chunk);
          } else if (chunk.length) {
            bufferLength += chunk.length;
            buffers.push(chunk);
          }
        });
        res.on('end', function () {
          if (bufferLength) {
            body = Buffer.concat(buffers, bufferLength);
            if (encoding != null) {
              body = body.toString(encoding);
            }
          } else if (strings.length) {
            body = strings.join();
          }
          resolve({
            status: status,
            statusText: statusText,
            headers: headers,
            body: body
          });
        });
        res.on('error', reject);
      });
      req.on('error', reject);
      req.on('timeout', function () {
        req.destroy(new Error('Connection aborted due to timeout'));
      });
      if (body) {
        if ((0, _utils.isStream)(body)) {
          body.pipe(req);
          return;
        }
        req.write(body);
      }
      req.end();
    };
    if (form) {
      Object.assign(options.headers, form.getHeaders());
      form.getLength(function (err, length) {
        if (!err && !isNaN(length)) {
          options.headers['content-length'] = length;
        }
        _send();
      });
    } else {
      if (body && !options.headers['content-length']) {
        var Buffer = (__webpack_require__(/*! buffer */ "buffer").Buffer);
        options.headers['content-length'] = Buffer.byteLength(body);
      }
      _send();
    }
  });
}

/***/ }),

/***/ "./node_modules/backendless-request/es/error.js":
/*!******************************************************!*\
  !*** ./node_modules/backendless-request/es/error.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.ResponseError = void 0;
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }
function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct.bind(); } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var ResponseError = exports.ResponseError = /*#__PURE__*/function (_Error) {
  _inherits(ResponseError, _Error);
  var _super = _createSuper(ResponseError);
  function ResponseError(response) {
    var _this;
    _classCallCheck(this, ResponseError);
    _this = _super.call(this);
    var error = parseError(response);
    _this.message = error.message || error;
    _this.code = error.code;
    _this.status = response.status;
    _this.headers = response.headers;
    _this.body = response.body;
    return _this;
  }
  return _createClass(ResponseError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
function parseError(res) {
  if (res.status === 502) {
    return 'No connection with server';
  }
  return res.body || "Status Code ".concat(res.status, " (").concat(res.statusText, ")");
}

/***/ }),

/***/ "./node_modules/backendless-request/es/event-emitter.js":
/*!**************************************************************!*\
  !*** ./node_modules/backendless-request/es/event-emitter.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, exports) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var EventEmitter = exports["default"] = /*#__PURE__*/function () {
  function EventEmitter() {
    _classCallCheck(this, EventEmitter);
    this.events = {};
  }
  _createClass(EventEmitter, [{
    key: "on",
    value: function on(eventName, callback) {
      this.events[eventName] = this.events[eventName] || [];
      this.events[eventName].push(callback);
      return this;
    }
  }, {
    key: "off",
    value: function off(eventName, callback) {
      if (!eventName) {
        this.events = {};
      } else if (this.events[eventName]) {
        if (callback) {
          this.events[eventName] = this.events[eventName].filter(function (c) {
            return c !== callback;
          });
        } else {
          delete this.events[eventName];
        }
      }
      return this;
    }
  }, {
    key: "emit",
    value: function emit(eventName) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      if (this.events[eventName]) {
        this.events[eventName].forEach(function (callback) {
          return callback.apply(void 0, args);
        });
      }
    }
  }]);
  return EventEmitter;
}();

/***/ }),

/***/ "./node_modules/backendless-request/es/index.js":
/*!******************************************************!*\
  !*** ./node_modules/backendless-request/es/index.js ***!
  \******************************************************/
/***/ ((module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;
var _clientNode = __webpack_require__(/*! ./client-node */ "./node_modules/backendless-request/es/client-node.js");
var _clientBrowser = __webpack_require__(/*! ./client-browser */ "./node_modules/backendless-request/es/client-browser.js");
var _request = __webpack_require__(/*! ./request */ "./node_modules/backendless-request/es/request.js");
var _utils = __webpack_require__(/*! ./utils */ "./node_modules/backendless-request/es/utils.js");
Object.defineProperty(_request.Request, 'FormData', {
  get: function get() {
    return (0, _utils.getFormData)();
  },
  set: function set(value) {
    (0, _utils.setFormData)(value);
  }
});
_request.Request.XMLHttpRequest = typeof XMLHttpRequest !== 'undefined' ? XMLHttpRequest : undefined;
_request.Request.send = function (path, method, headers, body, encoding, timeout, withCredentials) {
  var sender = typeof _request.Request.XMLHttpRequest !== 'undefined' ? _clientBrowser.sendXmlHttpRequest : _clientNode.sendNodeAPIRequest;
  return sender(path, method, headers, body, encoding, timeout, withCredentials);
};
_request.Request.verbose = false;
_request.Request.withCredentials = false;
_request.Request.methods = ['get', 'post', 'put', 'patch', 'delete'];
_request.Request.methods.forEach(function (method) {
  _request.Request[method] = function (path, body) {
    return new _request.Request(path, method, body);
  };
});
exports = module.exports = _request.Request;
var _default = exports["default"] = _request.Request;

/***/ }),

/***/ "./node_modules/backendless-request/es/qs.js":
/*!***************************************************!*\
  !*** ./node_modules/backendless-request/es/qs.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.stringify = void 0;
var _utils = __webpack_require__(/*! ./utils */ "./node_modules/backendless-request/es/utils.js");
/**
 * Produces a URL query string from a given obj by iterating through the object's "own properties".
 * @param {Object} obj
 * @returns {string}
 */
var stringify = exports.stringify = function stringify(obj) {
  var tokens = [];
  Object.keys(obj).forEach(function (key) {
    var value = obj[key];
    if (value !== undefined) {
      (0, _utils.castArray)(value).forEach(function (value) {
        tokens.push("".concat(encodeURIComponent(key), "=").concat(encodeURIComponent(value)));
      });
    }
  });
  return tokens.join('&');
};

/***/ }),

/***/ "./node_modules/backendless-request/es/request.js":
/*!********************************************************!*\
  !*** ./node_modules/backendless-request/es/request.js ***!
  \********************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.Request = void 0;
var _cache = __webpack_require__(/*! ./cache */ "./node_modules/backendless-request/es/cache.js");
var _eventEmitter = _interopRequireDefault(__webpack_require__(/*! ./event-emitter */ "./node_modules/backendless-request/es/event-emitter.js"));
var qs = _interopRequireWildcard(__webpack_require__(/*! ./qs */ "./node_modules/backendless-request/es/qs.js"));
var _utils = __webpack_require__(/*! ./utils */ "./node_modules/backendless-request/es/utils.js");
var _error = __webpack_require__(/*! ./error */ "./node_modules/backendless-request/es/error.js");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var CONTENT_TYPE_HEADER = 'Content-Type';
var REQUEST_EVENT = 'request';
var RESPONSE_EVENT = 'response';
var ERROR_EVENT = 'error';
var DONE_EVENT = 'done';
var Request = exports.Request = /*#__PURE__*/function (_EventEmitter) {
  _inherits(Request, _EventEmitter);
  var _super = _createSuper(Request);
  function Request(path, method, body) {
    var _this;
    _classCallCheck(this, Request);
    _this = _super.call(this);
    _this.method = method;
    _this.path = (0, _utils.ensureEncoding)(path);
    _this.body = body;
    _this.tags = undefined;
    _this.unwrap = true;
    _this.cacheTTL = 0;
    _this.headers = {};
    _this.queryParams = {};
    _this.encoding = 'utf8';
    _this.timeout = 0;
    _this.withCredentials = null;
    return _this;
  }

  /**
   * Sets a header
   *
   * @param {String|Object} key or map of headers
   * @param {String} [value]
   * @returns {Request}
   */
  _createClass(Request, [{
    key: "set",
    value: function set(key, value) {
      if ((0, _utils.isObject)(key)) {
        for (var headerName in key) {
          this.set(headerName, key[headerName]);
        }
      } else if (typeof value !== 'undefined') {
        this.headers[key] = value;
      }
      return this;
    }

    /**
     * Which kind of tags this request affects.
     * Used for cache validation.
     * Non GET requests with defined tags, will clean all related to these tags caches
     *
     * @param {Array.<String>} tags
     * @returns {Request}
     */
  }, {
    key: "cacheTags",
    value: function cacheTags() {
      for (var _len = arguments.length, tags = new Array(_len), _key = 0; _key < _len; _key++) {
        tags[_key] = arguments[_key];
      }
      this.tags = tags;
      return this;
    }

    /**
     * @param {Object} queryParams
     * @returns {Request}
     */
  }, {
    key: "query",
    value: function query(queryParams) {
      Object.assign(this.queryParams, queryParams);
      return this;
    }
  }, {
    key: "form",
    value: function form(_form) {
      if (_form) {
        var FormData = Request.FormData;
        if (_form instanceof FormData) {
          this.body = _form;
        } else {
          var formData = new FormData();
          var _loop = function _loop(formKey) {
            if (formKey) {
              (0, _utils.castArray)(_form[formKey]).forEach(function (formValue) {
                if (formValue && formValue.hasOwnProperty('value') && formValue.hasOwnProperty('options')) {
                  formData.append(formKey, formValue.value, formValue.options);
                } else {
                  formData.append(formKey, formValue);
                }
              });
            }
          };
          for (var formKey in _form) {
            _loop(formKey);
          }
          this.body = formData;
        }
      }
      return this;
    }

    /**
     * Should we cache or use cached result
     *
     * @param {Number} ttl Time to live for cached response. 15 seconds by default
     * @returns {Request}
     */
  }, {
    key: "useCache",
    value: function useCache() {
      var ttl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 15000;
      this.cacheTTL = ttl;
      return this;
    }

    /**
     * Reset cache if passed TRUE and tags has been specified before
     *
     * @param {Boolean} reset - flag to reset cache or not
     * @returns {Request}
     */
  }, {
    key: "resetCache",
    value: function resetCache(reset) {
      if (reset && this.tags) {
        _cache.cache.deleteByTags(this.tags);
      }
      return this;
    }

    /**
     * Shortcut for req.set('Content-Type', value)
     *
     * @param {String} contentType
     * @returns {Request}
     */
  }, {
    key: "type",
    value: function type(contentType) {
      this.set(CONTENT_TYPE_HEADER, contentType);
      return this;
    }

    /**
     * Should we unwrap the response and return only body. true by default
     * @param {Boolean} unwrap
     * @returns {Request}
     */
  }, {
    key: "unwrapBody",
    value: function unwrapBody(unwrap) {
      this.unwrap = unwrap;
      return this;
    }

    /**
     * set encoding to response
     * works only for Node js
     *
     * @param {String} encoding
     * @returns {Request}
     */
  }, {
    key: "setEncoding",
    value: function setEncoding(encoding) {
      this.encoding = encoding;
      return this;
    }

    /**
     * set withCredentials option
     *
     * @param {Boolean} value
     * @returns {Request}
     */
  }, {
    key: "setWithCredentials",
    value: function setWithCredentials(value) {
      this.withCredentials = value;
      return this;
    }

    /**
     * A number specifying request timeout in milliseconds.
     * @param {Number} ms
     * @returns {Request}
     */
  }, {
    key: "setTimeout",
    value: function setTimeout(ms) {
      this.timeout = ms;
      return this;
    }

    /**
     * Sends the request
     *
     * @param {Object} body
     * @returns {Promise}
     */
  }, {
    key: "send",
    value: function send(body) {
      var _this2 = this;
      this.emit(REQUEST_EVENT, this);
      var path = this.path;
      var queryString = qs.stringify(this.queryParams);
      if (queryString) {
        path += '?' + queryString;
      }
      if (this.cacheTTL) {
        var cached = _cache.cache.get(path);
        if (cached !== undefined) {
          return Promise.resolve(cached);
        }
      }
      var type = this.headers[CONTENT_TYPE_HEADER];
      if (!type && (0, _utils.isObject)(body) && !(0, _utils.isFormData)(body)) {
        this.type('application/json');
      }
      if (body) {
        var isJSON = this.headers[CONTENT_TYPE_HEADER] === 'application/json';
        body = isJSON && typeof body !== 'string' ? JSON.stringify(body) : body;
      }
      var unwrapBody = function unwrapBody(res) {
        return _this2.unwrap ? res.body : res;
      };

      /**
       * Caches the response if required
       */
      var cacheResponse = function cacheResponse(res) {
        if (_this2.cacheTTL) {
          _cache.cache.set(path, res, _this2.tags, _this2.cacheTTL);
        }
        return res;
      };

      /**
       * Deletes all relevant to req.cacheTags keys from the cache if this request method is not GET
       */
      var flushCache = function flushCache(res) {
        if (_this2.tags && _this2.method !== 'get') {
          _cache.cache.deleteByTags(_this2.tags);
        }
        return res;
      };
      if (Request.verbose) {
        console.log(this.method.toUpperCase(), decodeURIComponent(path), body, this.headers);
      }
      var withCredentials = typeof this.withCredentials === 'boolean' ? this.withCredentials : Request.withCredentials;
      var request = Request.send(path, this.method.toUpperCase(), this.headers, body, this.encoding, this.timeout, withCredentials).then(parseBody).then(checkStatus).then(unwrapBody).then(cacheResponse).then(flushCache);
      request.then(function (result) {
        _this2.emit(RESPONSE_EVENT, result);
        _this2.emit(DONE_EVENT, null, result);
      })["catch"](function (error) {
        _this2.emit(ERROR_EVENT, error);
        _this2.emit(DONE_EVENT, error);
      });
      return request;
    }

    /**
     * If you are too lazy to use method 'send', don't use it and stay cool :)
     *
     * @param {Function} successHandler
     * @param {Function} errorHandler
     * @returns {Promise}
     */
  }, {
    key: "then",
    value: function then(successHandler, errorHandler) {
      this.promise = this.promise || this.send(this.body);
      return this.promise.then(successHandler, errorHandler);
    }

    /**
     * @param {Function} errorHandler
     * @returns {Promise}
     */
  }, {
    key: "catch",
    value: function _catch(errorHandler) {
      this.promise = this.promise || this.send(this.body);
      return this.promise["catch"](errorHandler);
    }
  }]);
  return Request;
}(_eventEmitter["default"]);
function parseBody(res) {
  try {
    return _objectSpread(_objectSpread({}, res), {}, {
      body: JSON.parse(res.body)
    });
  } catch (e) {
    return res;
  }
}

/**
 * Checks if a network request came back fine, and throws an error if not
 *
 * @param  {object} response   A response from a network request
 *
 * @return {object|undefined} Returns either the response, or throws an error
 */
function checkStatus(response) {
  if (response.status >= 200 && response.status < 300) {
    return response;
  }
  throw new _error.ResponseError(response);
}

/***/ }),

/***/ "./node_modules/backendless-request/es/utils.js":
/*!******************************************************!*\
  !*** ./node_modules/backendless-request/es/utils.js ***!
  \******************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.castArray = void 0;
exports.ensureEncoding = ensureEncoding;
exports.getFormData = getFormData;
exports.isStream = exports.isObject = exports.isNodeJS = exports.isFormData = exports.isBrowser = void 0;
exports.normalizeTrailingSlashInPath = normalizeTrailingSlashInPath;
exports.setFormData = setFormData;
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
/**
 * Casts `value` as an array if it's not one.
 * Equivalent to lodash/castArray
 */
var castArray = exports.castArray = function castArray(value) {
  return Array.isArray(value) ? value : [value];
};
var isObject = exports.isObject = function isObject(value) {
  return null != value && _typeof(value) === 'object';
};
var isFormData = exports.isFormData = function isFormData(value) {
  if (!value) {
    return false;
  }
  var FormData = getFormData();
  if (value instanceof FormData) {
    return true;
  }
  return value && value.constructor && value.constructor.toString().trim().indexOf('function FormData') === 0;
};
var isStream = exports.isStream = function isStream(value) {
  var stream = __webpack_require__(/*! stream */ "stream");
  return value instanceof stream.Stream;
};
var isNodeJS = exports.isNodeJS = function isNodeJS() {
  return typeof process !== 'undefined' && process.versions != null && process.versions.node != null;
};
var isBrowser = exports.isBrowser = function isBrowser() {
  return typeof window !== 'undefined' && typeof window.document !== 'undefined';
};
var CustomFormData = null;
function getFormData() {
  if (CustomFormData) {
    return CustomFormData;
  }
  return isNodeJS() || typeof FormData === 'undefined' ? __webpack_require__(/*! form-data */ "form-data") : FormData;
}
function setFormData(value) {
  CustomFormData = value;
}
var SAFE_CHAR_CODES = ['%40', '%3A', '%2F', '%23'];
function safeEscape(str, charCodes) {
  var _char = charCodes[0];
  if (_char) {
    var tokens = str.split(_char).map(function (p) {
      return safeEscape(p, charCodes.slice(1));
    });
    return tokens.join(_char);
  }
  return encodeURI(str);
}
function ensureComponentEncoding(uriComponent) {
  if (uriComponent === decodeURI(uriComponent)) {
    return safeEscape(uriComponent, [].concat(SAFE_CHAR_CODES));
  }
  return uriComponent;
}
function encodePath(path) {
  return path.split('/').map(ensureComponentEncoding).join('/');
}
function ensureEncoding(path) {
  try {
    var url = new URL(path);
    return url.origin + encodePath(normalizeTrailingSlashInPath(path, url)) + url.search;
  } catch (_unused) {
    return encodePath(path);
  }
}
function normalizeTrailingSlashInPath(originPath, _ref) {
  var pathname = _ref.pathname;
  if (originPath.includes('?')) {
    originPath = originPath.split('?')[0];
  }
  var keepTrailingSlash = originPath.endsWith('/');
  return !keepTrailingSlash && pathname.endsWith('/') ? pathname.slice(0, -1) : pathname;
}

/***/ }),

/***/ "./node_modules/backendless-request/lib/qs.js":
/*!****************************************************!*\
  !*** ./node_modules/backendless-request/lib/qs.js ***!
  \****************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.stringify = void 0;
var _utils = __webpack_require__(/*! ./utils */ "./node_modules/backendless-request/lib/utils.js");
/**
 * Produces a URL query string from a given obj by iterating through the object's "own properties".
 * @param {Object} obj
 * @returns {string}
 */
var stringify = exports.stringify = function stringify(obj) {
  var tokens = [];
  Object.keys(obj).forEach(function (key) {
    var value = obj[key];
    if (value !== undefined) {
      (0, _utils.castArray)(value).forEach(function (value) {
        tokens.push("".concat(encodeURIComponent(key), "=").concat(encodeURIComponent(value)));
      });
    }
  });
  return tokens.join('&');
};

/***/ }),

/***/ "./node_modules/backendless-request/lib/utils.js":
/*!*******************************************************!*\
  !*** ./node_modules/backendless-request/lib/utils.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.castArray = void 0;
exports.ensureEncoding = ensureEncoding;
exports.getFormData = getFormData;
exports.isStream = exports.isObject = exports.isNodeJS = exports.isFormData = exports.isBrowser = void 0;
exports.normalizeTrailingSlashInPath = normalizeTrailingSlashInPath;
exports.setFormData = setFormData;
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
/**
 * Casts `value` as an array if it's not one.
 * Equivalent to lodash/castArray
 */
var castArray = exports.castArray = function castArray(value) {
  return Array.isArray(value) ? value : [value];
};
var isObject = exports.isObject = function isObject(value) {
  return null != value && _typeof(value) === 'object';
};
var isFormData = exports.isFormData = function isFormData(value) {
  if (!value) {
    return false;
  }
  var FormData = getFormData();
  if (value instanceof FormData) {
    return true;
  }
  return value && value.constructor && value.constructor.toString().trim().indexOf('function FormData') === 0;
};
var isStream = exports.isStream = function isStream(value) {
  var stream = __webpack_require__(/*! stream */ "stream");
  return value instanceof stream.Stream;
};
var isNodeJS = exports.isNodeJS = function isNodeJS() {
  return typeof process !== 'undefined' && process.versions != null && process.versions.node != null;
};
var isBrowser = exports.isBrowser = function isBrowser() {
  return typeof window !== 'undefined' && typeof window.document !== 'undefined';
};
var CustomFormData = null;
function getFormData() {
  if (CustomFormData) {
    return CustomFormData;
  }
  return isNodeJS() || typeof FormData === 'undefined' ? __webpack_require__(/*! form-data */ "form-data") : FormData;
}
function setFormData(value) {
  CustomFormData = value;
}
var SAFE_CHAR_CODES = ['%40', '%3A', '%2F', '%23'];
function safeEscape(str, charCodes) {
  var _char = charCodes[0];
  if (_char) {
    var tokens = str.split(_char).map(function (p) {
      return safeEscape(p, charCodes.slice(1));
    });
    return tokens.join(_char);
  }
  return encodeURI(str);
}
function ensureComponentEncoding(uriComponent) {
  if (uriComponent === decodeURI(uriComponent)) {
    return safeEscape(uriComponent, [].concat(SAFE_CHAR_CODES));
  }
  return uriComponent;
}
function encodePath(path) {
  return path.split('/').map(ensureComponentEncoding).join('/');
}
function ensureEncoding(path) {
  try {
    var url = new URL(path);
    return url.origin + encodePath(normalizeTrailingSlashInPath(path, url)) + url.search;
  } catch (_unused) {
    return encodePath(path);
  }
}
function normalizeTrailingSlashInPath(originPath, _ref) {
  var pathname = _ref.pathname;
  if (originPath.includes('?')) {
    originPath = originPath.split('?')[0];
  }
  var keepTrailingSlash = originPath.endsWith('/');
  return !keepTrailingSlash && pathname.endsWith('/') ? pathname.slice(0, -1) : pathname;
}

/***/ }),

/***/ "./node_modules/lodash/_DataView.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_DataView.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(/*! ./_getNative */ "./node_modules/lodash/_getNative.js"),
    root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/* Built-in method references that are verified to be native. */
var DataView = getNative(root, 'DataView');

module.exports = DataView;


/***/ }),

/***/ "./node_modules/lodash/_Hash.js":
/*!**************************************!*\
  !*** ./node_modules/lodash/_Hash.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var hashClear = __webpack_require__(/*! ./_hashClear */ "./node_modules/lodash/_hashClear.js"),
    hashDelete = __webpack_require__(/*! ./_hashDelete */ "./node_modules/lodash/_hashDelete.js"),
    hashGet = __webpack_require__(/*! ./_hashGet */ "./node_modules/lodash/_hashGet.js"),
    hashHas = __webpack_require__(/*! ./_hashHas */ "./node_modules/lodash/_hashHas.js"),
    hashSet = __webpack_require__(/*! ./_hashSet */ "./node_modules/lodash/_hashSet.js");

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

module.exports = Hash;


/***/ }),

/***/ "./node_modules/lodash/_ListCache.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_ListCache.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var listCacheClear = __webpack_require__(/*! ./_listCacheClear */ "./node_modules/lodash/_listCacheClear.js"),
    listCacheDelete = __webpack_require__(/*! ./_listCacheDelete */ "./node_modules/lodash/_listCacheDelete.js"),
    listCacheGet = __webpack_require__(/*! ./_listCacheGet */ "./node_modules/lodash/_listCacheGet.js"),
    listCacheHas = __webpack_require__(/*! ./_listCacheHas */ "./node_modules/lodash/_listCacheHas.js"),
    listCacheSet = __webpack_require__(/*! ./_listCacheSet */ "./node_modules/lodash/_listCacheSet.js");

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

module.exports = ListCache;


/***/ }),

/***/ "./node_modules/lodash/_Map.js":
/*!*************************************!*\
  !*** ./node_modules/lodash/_Map.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(/*! ./_getNative */ "./node_modules/lodash/_getNative.js"),
    root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/* Built-in method references that are verified to be native. */
var Map = getNative(root, 'Map');

module.exports = Map;


/***/ }),

/***/ "./node_modules/lodash/_MapCache.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_MapCache.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var mapCacheClear = __webpack_require__(/*! ./_mapCacheClear */ "./node_modules/lodash/_mapCacheClear.js"),
    mapCacheDelete = __webpack_require__(/*! ./_mapCacheDelete */ "./node_modules/lodash/_mapCacheDelete.js"),
    mapCacheGet = __webpack_require__(/*! ./_mapCacheGet */ "./node_modules/lodash/_mapCacheGet.js"),
    mapCacheHas = __webpack_require__(/*! ./_mapCacheHas */ "./node_modules/lodash/_mapCacheHas.js"),
    mapCacheSet = __webpack_require__(/*! ./_mapCacheSet */ "./node_modules/lodash/_mapCacheSet.js");

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

module.exports = MapCache;


/***/ }),

/***/ "./node_modules/lodash/_Promise.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_Promise.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(/*! ./_getNative */ "./node_modules/lodash/_getNative.js"),
    root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/* Built-in method references that are verified to be native. */
var Promise = getNative(root, 'Promise');

module.exports = Promise;


/***/ }),

/***/ "./node_modules/lodash/_Set.js":
/*!*************************************!*\
  !*** ./node_modules/lodash/_Set.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(/*! ./_getNative */ "./node_modules/lodash/_getNative.js"),
    root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/* Built-in method references that are verified to be native. */
var Set = getNative(root, 'Set');

module.exports = Set;


/***/ }),

/***/ "./node_modules/lodash/_SetCache.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_SetCache.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var MapCache = __webpack_require__(/*! ./_MapCache */ "./node_modules/lodash/_MapCache.js"),
    setCacheAdd = __webpack_require__(/*! ./_setCacheAdd */ "./node_modules/lodash/_setCacheAdd.js"),
    setCacheHas = __webpack_require__(/*! ./_setCacheHas */ "./node_modules/lodash/_setCacheHas.js");

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

module.exports = SetCache;


/***/ }),

/***/ "./node_modules/lodash/_Stack.js":
/*!***************************************!*\
  !*** ./node_modules/lodash/_Stack.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var ListCache = __webpack_require__(/*! ./_ListCache */ "./node_modules/lodash/_ListCache.js"),
    stackClear = __webpack_require__(/*! ./_stackClear */ "./node_modules/lodash/_stackClear.js"),
    stackDelete = __webpack_require__(/*! ./_stackDelete */ "./node_modules/lodash/_stackDelete.js"),
    stackGet = __webpack_require__(/*! ./_stackGet */ "./node_modules/lodash/_stackGet.js"),
    stackHas = __webpack_require__(/*! ./_stackHas */ "./node_modules/lodash/_stackHas.js"),
    stackSet = __webpack_require__(/*! ./_stackSet */ "./node_modules/lodash/_stackSet.js");

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

module.exports = Stack;


/***/ }),

/***/ "./node_modules/lodash/_Symbol.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/_Symbol.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/** Built-in value references. */
var Symbol = root.Symbol;

module.exports = Symbol;


/***/ }),

/***/ "./node_modules/lodash/_Uint8Array.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_Uint8Array.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/** Built-in value references. */
var Uint8Array = root.Uint8Array;

module.exports = Uint8Array;


/***/ }),

/***/ "./node_modules/lodash/_WeakMap.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_WeakMap.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(/*! ./_getNative */ "./node_modules/lodash/_getNative.js"),
    root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/* Built-in method references that are verified to be native. */
var WeakMap = getNative(root, 'WeakMap');

module.exports = WeakMap;


/***/ }),

/***/ "./node_modules/lodash/_apply.js":
/*!***************************************!*\
  !*** ./node_modules/lodash/_apply.js ***!
  \***************************************/
/***/ ((module) => {

/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}

module.exports = apply;


/***/ }),

/***/ "./node_modules/lodash/_arrayEach.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_arrayEach.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */
function arrayEach(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}

module.exports = arrayEach;


/***/ }),

/***/ "./node_modules/lodash/_arrayFilter.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_arrayFilter.js ***!
  \*********************************************/
/***/ ((module) => {

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

module.exports = arrayFilter;


/***/ }),

/***/ "./node_modules/lodash/_arrayLikeKeys.js":
/*!***********************************************!*\
  !*** ./node_modules/lodash/_arrayLikeKeys.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseTimes = __webpack_require__(/*! ./_baseTimes */ "./node_modules/lodash/_baseTimes.js"),
    isArguments = __webpack_require__(/*! ./isArguments */ "./node_modules/lodash/isArguments.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isBuffer = __webpack_require__(/*! ./isBuffer */ "./node_modules/lodash/isBuffer.js"),
    isIndex = __webpack_require__(/*! ./_isIndex */ "./node_modules/lodash/_isIndex.js"),
    isTypedArray = __webpack_require__(/*! ./isTypedArray */ "./node_modules/lodash/isTypedArray.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  var isArr = isArray(value),
      isArg = !isArr && isArguments(value),
      isBuff = !isArr && !isArg && isBuffer(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

module.exports = arrayLikeKeys;


/***/ }),

/***/ "./node_modules/lodash/_arrayMap.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_arrayMap.js ***!
  \******************************************/
/***/ ((module) => {

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

module.exports = arrayMap;


/***/ }),

/***/ "./node_modules/lodash/_arrayPush.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_arrayPush.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

module.exports = arrayPush;


/***/ }),

/***/ "./node_modules/lodash/_arraySome.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_arraySome.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

module.exports = arraySome;


/***/ }),

/***/ "./node_modules/lodash/_assignValue.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_assignValue.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseAssignValue = __webpack_require__(/*! ./_baseAssignValue */ "./node_modules/lodash/_baseAssignValue.js"),
    eq = __webpack_require__(/*! ./eq */ "./node_modules/lodash/eq.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue(object, key, value);
  }
}

module.exports = assignValue;


/***/ }),

/***/ "./node_modules/lodash/_assocIndexOf.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_assocIndexOf.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var eq = __webpack_require__(/*! ./eq */ "./node_modules/lodash/eq.js");

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

module.exports = assocIndexOf;


/***/ }),

/***/ "./node_modules/lodash/_baseAssign.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_baseAssign.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var copyObject = __webpack_require__(/*! ./_copyObject */ "./node_modules/lodash/_copyObject.js"),
    keys = __webpack_require__(/*! ./keys */ "./node_modules/lodash/keys.js");

/**
 * The base implementation of `_.assign` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssign(object, source) {
  return object && copyObject(source, keys(source), object);
}

module.exports = baseAssign;


/***/ }),

/***/ "./node_modules/lodash/_baseAssignIn.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_baseAssignIn.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var copyObject = __webpack_require__(/*! ./_copyObject */ "./node_modules/lodash/_copyObject.js"),
    keysIn = __webpack_require__(/*! ./keysIn */ "./node_modules/lodash/keysIn.js");

/**
 * The base implementation of `_.assignIn` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssignIn(object, source) {
  return object && copyObject(source, keysIn(source), object);
}

module.exports = baseAssignIn;


/***/ }),

/***/ "./node_modules/lodash/_baseAssignValue.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_baseAssignValue.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var defineProperty = __webpack_require__(/*! ./_defineProperty */ "./node_modules/lodash/_defineProperty.js");

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function baseAssignValue(object, key, value) {
  if (key == '__proto__' && defineProperty) {
    defineProperty(object, key, {
      'configurable': true,
      'enumerable': true,
      'value': value,
      'writable': true
    });
  } else {
    object[key] = value;
  }
}

module.exports = baseAssignValue;


/***/ }),

/***/ "./node_modules/lodash/_baseClone.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseClone.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Stack = __webpack_require__(/*! ./_Stack */ "./node_modules/lodash/_Stack.js"),
    arrayEach = __webpack_require__(/*! ./_arrayEach */ "./node_modules/lodash/_arrayEach.js"),
    assignValue = __webpack_require__(/*! ./_assignValue */ "./node_modules/lodash/_assignValue.js"),
    baseAssign = __webpack_require__(/*! ./_baseAssign */ "./node_modules/lodash/_baseAssign.js"),
    baseAssignIn = __webpack_require__(/*! ./_baseAssignIn */ "./node_modules/lodash/_baseAssignIn.js"),
    cloneBuffer = __webpack_require__(/*! ./_cloneBuffer */ "./node_modules/lodash/_cloneBuffer.js"),
    copyArray = __webpack_require__(/*! ./_copyArray */ "./node_modules/lodash/_copyArray.js"),
    copySymbols = __webpack_require__(/*! ./_copySymbols */ "./node_modules/lodash/_copySymbols.js"),
    copySymbolsIn = __webpack_require__(/*! ./_copySymbolsIn */ "./node_modules/lodash/_copySymbolsIn.js"),
    getAllKeys = __webpack_require__(/*! ./_getAllKeys */ "./node_modules/lodash/_getAllKeys.js"),
    getAllKeysIn = __webpack_require__(/*! ./_getAllKeysIn */ "./node_modules/lodash/_getAllKeysIn.js"),
    getTag = __webpack_require__(/*! ./_getTag */ "./node_modules/lodash/_getTag.js"),
    initCloneArray = __webpack_require__(/*! ./_initCloneArray */ "./node_modules/lodash/_initCloneArray.js"),
    initCloneByTag = __webpack_require__(/*! ./_initCloneByTag */ "./node_modules/lodash/_initCloneByTag.js"),
    initCloneObject = __webpack_require__(/*! ./_initCloneObject */ "./node_modules/lodash/_initCloneObject.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isBuffer = __webpack_require__(/*! ./isBuffer */ "./node_modules/lodash/isBuffer.js"),
    isMap = __webpack_require__(/*! ./isMap */ "./node_modules/lodash/isMap.js"),
    isObject = __webpack_require__(/*! ./isObject */ "./node_modules/lodash/isObject.js"),
    isSet = __webpack_require__(/*! ./isSet */ "./node_modules/lodash/isSet.js"),
    keys = __webpack_require__(/*! ./keys */ "./node_modules/lodash/keys.js"),
    keysIn = __webpack_require__(/*! ./keysIn */ "./node_modules/lodash/keysIn.js");

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG = 4;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values supported by `_.clone`. */
var cloneableTags = {};
cloneableTags[argsTag] = cloneableTags[arrayTag] =
cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =
cloneableTags[boolTag] = cloneableTags[dateTag] =
cloneableTags[float32Tag] = cloneableTags[float64Tag] =
cloneableTags[int8Tag] = cloneableTags[int16Tag] =
cloneableTags[int32Tag] = cloneableTags[mapTag] =
cloneableTags[numberTag] = cloneableTags[objectTag] =
cloneableTags[regexpTag] = cloneableTags[setTag] =
cloneableTags[stringTag] = cloneableTags[symbolTag] =
cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
cloneableTags[errorTag] = cloneableTags[funcTag] =
cloneableTags[weakMapTag] = false;

/**
 * The base implementation of `_.clone` and `_.cloneDeep` which tracks
 * traversed objects.
 *
 * @private
 * @param {*} value The value to clone.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Deep clone
 *  2 - Flatten inherited properties
 *  4 - Clone symbols
 * @param {Function} [customizer] The function to customize cloning.
 * @param {string} [key] The key of `value`.
 * @param {Object} [object] The parent object of `value`.
 * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
 * @returns {*} Returns the cloned value.
 */
function baseClone(value, bitmask, customizer, key, object, stack) {
  var result,
      isDeep = bitmask & CLONE_DEEP_FLAG,
      isFlat = bitmask & CLONE_FLAT_FLAG,
      isFull = bitmask & CLONE_SYMBOLS_FLAG;

  if (customizer) {
    result = object ? customizer(value, key, object, stack) : customizer(value);
  }
  if (result !== undefined) {
    return result;
  }
  if (!isObject(value)) {
    return value;
  }
  var isArr = isArray(value);
  if (isArr) {
    result = initCloneArray(value);
    if (!isDeep) {
      return copyArray(value, result);
    }
  } else {
    var tag = getTag(value),
        isFunc = tag == funcTag || tag == genTag;

    if (isBuffer(value)) {
      return cloneBuffer(value, isDeep);
    }
    if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
      result = (isFlat || isFunc) ? {} : initCloneObject(value);
      if (!isDeep) {
        return isFlat
          ? copySymbolsIn(value, baseAssignIn(result, value))
          : copySymbols(value, baseAssign(result, value));
      }
    } else {
      if (!cloneableTags[tag]) {
        return object ? value : {};
      }
      result = initCloneByTag(value, tag, isDeep);
    }
  }
  // Check for circular references and return its corresponding clone.
  stack || (stack = new Stack);
  var stacked = stack.get(value);
  if (stacked) {
    return stacked;
  }
  stack.set(value, result);

  if (isSet(value)) {
    value.forEach(function(subValue) {
      result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
    });
  } else if (isMap(value)) {
    value.forEach(function(subValue, key) {
      result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
    });
  }

  var keysFunc = isFull
    ? (isFlat ? getAllKeysIn : getAllKeys)
    : (isFlat ? keysIn : keys);

  var props = isArr ? undefined : keysFunc(value);
  arrayEach(props || value, function(subValue, key) {
    if (props) {
      key = subValue;
      subValue = value[key];
    }
    // Recursively populate clone (susceptible to call stack limits).
    assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
  });
  return result;
}

module.exports = baseClone;


/***/ }),

/***/ "./node_modules/lodash/_baseCreate.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_baseCreate.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__(/*! ./isObject */ "./node_modules/lodash/isObject.js");

/** Built-in value references. */
var objectCreate = Object.create;

/**
 * The base implementation of `_.create` without support for assigning
 * properties to the created object.
 *
 * @private
 * @param {Object} proto The object to inherit from.
 * @returns {Object} Returns the new object.
 */
var baseCreate = (function() {
  function object() {}
  return function(proto) {
    if (!isObject(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object.prototype = proto;
    var result = new object;
    object.prototype = undefined;
    return result;
  };
}());

module.exports = baseCreate;


/***/ }),

/***/ "./node_modules/lodash/_baseEach.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_baseEach.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseForOwn = __webpack_require__(/*! ./_baseForOwn */ "./node_modules/lodash/_baseForOwn.js"),
    createBaseEach = __webpack_require__(/*! ./_createBaseEach */ "./node_modules/lodash/_createBaseEach.js");

/**
 * The base implementation of `_.forEach` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 */
var baseEach = createBaseEach(baseForOwn);

module.exports = baseEach;


/***/ }),

/***/ "./node_modules/lodash/_baseFlatten.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_baseFlatten.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayPush = __webpack_require__(/*! ./_arrayPush */ "./node_modules/lodash/_arrayPush.js"),
    isFlattenable = __webpack_require__(/*! ./_isFlattenable */ "./node_modules/lodash/_isFlattenable.js");

/**
 * The base implementation of `_.flatten` with support for restricting flattening.
 *
 * @private
 * @param {Array} array The array to flatten.
 * @param {number} depth The maximum recursion depth.
 * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
 * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
 * @param {Array} [result=[]] The initial result value.
 * @returns {Array} Returns the new flattened array.
 */
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1,
      length = array.length;

  predicate || (predicate = isFlattenable);
  result || (result = []);

  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        // Recursively flatten arrays (susceptible to call stack limits).
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        arrayPush(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}

module.exports = baseFlatten;


/***/ }),

/***/ "./node_modules/lodash/_baseFor.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_baseFor.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var createBaseFor = __webpack_require__(/*! ./_createBaseFor */ "./node_modules/lodash/_createBaseFor.js");

/**
 * The base implementation of `baseForOwn` which iterates over `object`
 * properties returned by `keysFunc` and invokes `iteratee` for each property.
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @returns {Object} Returns `object`.
 */
var baseFor = createBaseFor();

module.exports = baseFor;


/***/ }),

/***/ "./node_modules/lodash/_baseForOwn.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_baseForOwn.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseFor = __webpack_require__(/*! ./_baseFor */ "./node_modules/lodash/_baseFor.js"),
    keys = __webpack_require__(/*! ./keys */ "./node_modules/lodash/keys.js");

/**
 * The base implementation of `_.forOwn` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Object} Returns `object`.
 */
function baseForOwn(object, iteratee) {
  return object && baseFor(object, iteratee, keys);
}

module.exports = baseForOwn;


/***/ }),

/***/ "./node_modules/lodash/_baseGet.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_baseGet.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var castPath = __webpack_require__(/*! ./_castPath */ "./node_modules/lodash/_castPath.js"),
    toKey = __webpack_require__(/*! ./_toKey */ "./node_modules/lodash/_toKey.js");

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

module.exports = baseGet;


/***/ }),

/***/ "./node_modules/lodash/_baseGetAllKeys.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_baseGetAllKeys.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayPush = __webpack_require__(/*! ./_arrayPush */ "./node_modules/lodash/_arrayPush.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js");

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
}

module.exports = baseGetAllKeys;


/***/ }),

/***/ "./node_modules/lodash/_baseGetTag.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_baseGetTag.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(/*! ./_Symbol */ "./node_modules/lodash/_Symbol.js"),
    getRawTag = __webpack_require__(/*! ./_getRawTag */ "./node_modules/lodash/_getRawTag.js"),
    objectToString = __webpack_require__(/*! ./_objectToString */ "./node_modules/lodash/_objectToString.js");

/** `Object#toString` result references. */
var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

module.exports = baseGetTag;


/***/ }),

/***/ "./node_modules/lodash/_baseHasIn.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseHasIn.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

module.exports = baseHasIn;


/***/ }),

/***/ "./node_modules/lodash/_baseIsArguments.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_baseIsArguments.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(/*! ./_baseGetTag */ "./node_modules/lodash/_baseGetTag.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/** `Object#toString` result references. */
var argsTag = '[object Arguments]';

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments(value) {
  return isObjectLike(value) && baseGetTag(value) == argsTag;
}

module.exports = baseIsArguments;


/***/ }),

/***/ "./node_modules/lodash/_baseIsEqual.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_baseIsEqual.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsEqualDeep = __webpack_require__(/*! ./_baseIsEqualDeep */ "./node_modules/lodash/_baseIsEqualDeep.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

module.exports = baseIsEqual;


/***/ }),

/***/ "./node_modules/lodash/_baseIsEqualDeep.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_baseIsEqualDeep.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Stack = __webpack_require__(/*! ./_Stack */ "./node_modules/lodash/_Stack.js"),
    equalArrays = __webpack_require__(/*! ./_equalArrays */ "./node_modules/lodash/_equalArrays.js"),
    equalByTag = __webpack_require__(/*! ./_equalByTag */ "./node_modules/lodash/_equalByTag.js"),
    equalObjects = __webpack_require__(/*! ./_equalObjects */ "./node_modules/lodash/_equalObjects.js"),
    getTag = __webpack_require__(/*! ./_getTag */ "./node_modules/lodash/_getTag.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isBuffer = __webpack_require__(/*! ./isBuffer */ "./node_modules/lodash/isBuffer.js"),
    isTypedArray = __webpack_require__(/*! ./isTypedArray */ "./node_modules/lodash/isTypedArray.js");

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

module.exports = baseIsEqualDeep;


/***/ }),

/***/ "./node_modules/lodash/_baseIsMap.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseIsMap.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getTag = __webpack_require__(/*! ./_getTag */ "./node_modules/lodash/_getTag.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/** `Object#toString` result references. */
var mapTag = '[object Map]';

/**
 * The base implementation of `_.isMap` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 */
function baseIsMap(value) {
  return isObjectLike(value) && getTag(value) == mapTag;
}

module.exports = baseIsMap;


/***/ }),

/***/ "./node_modules/lodash/_baseIsMatch.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_baseIsMatch.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Stack = __webpack_require__(/*! ./_Stack */ "./node_modules/lodash/_Stack.js"),
    baseIsEqual = __webpack_require__(/*! ./_baseIsEqual */ "./node_modules/lodash/_baseIsEqual.js");

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

module.exports = baseIsMatch;


/***/ }),

/***/ "./node_modules/lodash/_baseIsNative.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_baseIsNative.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isFunction = __webpack_require__(/*! ./isFunction */ "./node_modules/lodash/isFunction.js"),
    isMasked = __webpack_require__(/*! ./_isMasked */ "./node_modules/lodash/_isMasked.js"),
    isObject = __webpack_require__(/*! ./isObject */ "./node_modules/lodash/isObject.js"),
    toSource = __webpack_require__(/*! ./_toSource */ "./node_modules/lodash/_toSource.js");

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

module.exports = baseIsNative;


/***/ }),

/***/ "./node_modules/lodash/_baseIsSet.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseIsSet.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getTag = __webpack_require__(/*! ./_getTag */ "./node_modules/lodash/_getTag.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/** `Object#toString` result references. */
var setTag = '[object Set]';

/**
 * The base implementation of `_.isSet` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 */
function baseIsSet(value) {
  return isObjectLike(value) && getTag(value) == setTag;
}

module.exports = baseIsSet;


/***/ }),

/***/ "./node_modules/lodash/_baseIsTypedArray.js":
/*!**************************************************!*\
  !*** ./node_modules/lodash/_baseIsTypedArray.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(/*! ./_baseGetTag */ "./node_modules/lodash/_baseGetTag.js"),
    isLength = __webpack_require__(/*! ./isLength */ "./node_modules/lodash/isLength.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
typedArrayTags[errorTag] = typedArrayTags[funcTag] =
typedArrayTags[mapTag] = typedArrayTags[numberTag] =
typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
typedArrayTags[setTag] = typedArrayTags[stringTag] =
typedArrayTags[weakMapTag] = false;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
  return isObjectLike(value) &&
    isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}

module.exports = baseIsTypedArray;


/***/ }),

/***/ "./node_modules/lodash/_baseIteratee.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_baseIteratee.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseMatches = __webpack_require__(/*! ./_baseMatches */ "./node_modules/lodash/_baseMatches.js"),
    baseMatchesProperty = __webpack_require__(/*! ./_baseMatchesProperty */ "./node_modules/lodash/_baseMatchesProperty.js"),
    identity = __webpack_require__(/*! ./identity */ "./node_modules/lodash/identity.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    property = __webpack_require__(/*! ./property */ "./node_modules/lodash/property.js");

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity;
  }
  if (typeof value == 'object') {
    return isArray(value)
      ? baseMatchesProperty(value[0], value[1])
      : baseMatches(value);
  }
  return property(value);
}

module.exports = baseIteratee;


/***/ }),

/***/ "./node_modules/lodash/_baseKeys.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_baseKeys.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isPrototype = __webpack_require__(/*! ./_isPrototype */ "./node_modules/lodash/_isPrototype.js"),
    nativeKeys = __webpack_require__(/*! ./_nativeKeys */ "./node_modules/lodash/_nativeKeys.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

module.exports = baseKeys;


/***/ }),

/***/ "./node_modules/lodash/_baseKeysIn.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_baseKeysIn.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__(/*! ./isObject */ "./node_modules/lodash/isObject.js"),
    isPrototype = __webpack_require__(/*! ./_isPrototype */ "./node_modules/lodash/_isPrototype.js"),
    nativeKeysIn = __webpack_require__(/*! ./_nativeKeysIn */ "./node_modules/lodash/_nativeKeysIn.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeysIn(object) {
  if (!isObject(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype(object),
      result = [];

  for (var key in object) {
    if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}

module.exports = baseKeysIn;


/***/ }),

/***/ "./node_modules/lodash/_baseMap.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_baseMap.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseEach = __webpack_require__(/*! ./_baseEach */ "./node_modules/lodash/_baseEach.js"),
    isArrayLike = __webpack_require__(/*! ./isArrayLike */ "./node_modules/lodash/isArrayLike.js");

/**
 * The base implementation of `_.map` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function baseMap(collection, iteratee) {
  var index = -1,
      result = isArrayLike(collection) ? Array(collection.length) : [];

  baseEach(collection, function(value, key, collection) {
    result[++index] = iteratee(value, key, collection);
  });
  return result;
}

module.exports = baseMap;


/***/ }),

/***/ "./node_modules/lodash/_baseMatches.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_baseMatches.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsMatch = __webpack_require__(/*! ./_baseIsMatch */ "./node_modules/lodash/_baseIsMatch.js"),
    getMatchData = __webpack_require__(/*! ./_getMatchData */ "./node_modules/lodash/_getMatchData.js"),
    matchesStrictComparable = __webpack_require__(/*! ./_matchesStrictComparable */ "./node_modules/lodash/_matchesStrictComparable.js");

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}

module.exports = baseMatches;


/***/ }),

/***/ "./node_modules/lodash/_baseMatchesProperty.js":
/*!*****************************************************!*\
  !*** ./node_modules/lodash/_baseMatchesProperty.js ***!
  \*****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsEqual = __webpack_require__(/*! ./_baseIsEqual */ "./node_modules/lodash/_baseIsEqual.js"),
    get = __webpack_require__(/*! ./get */ "./node_modules/lodash/get.js"),
    hasIn = __webpack_require__(/*! ./hasIn */ "./node_modules/lodash/hasIn.js"),
    isKey = __webpack_require__(/*! ./_isKey */ "./node_modules/lodash/_isKey.js"),
    isStrictComparable = __webpack_require__(/*! ./_isStrictComparable */ "./node_modules/lodash/_isStrictComparable.js"),
    matchesStrictComparable = __webpack_require__(/*! ./_matchesStrictComparable */ "./node_modules/lodash/_matchesStrictComparable.js"),
    toKey = __webpack_require__(/*! ./_toKey */ "./node_modules/lodash/_toKey.js");

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn(object, path)
      : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

module.exports = baseMatchesProperty;


/***/ }),

/***/ "./node_modules/lodash/_baseOrderBy.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_baseOrderBy.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayMap = __webpack_require__(/*! ./_arrayMap */ "./node_modules/lodash/_arrayMap.js"),
    baseGet = __webpack_require__(/*! ./_baseGet */ "./node_modules/lodash/_baseGet.js"),
    baseIteratee = __webpack_require__(/*! ./_baseIteratee */ "./node_modules/lodash/_baseIteratee.js"),
    baseMap = __webpack_require__(/*! ./_baseMap */ "./node_modules/lodash/_baseMap.js"),
    baseSortBy = __webpack_require__(/*! ./_baseSortBy */ "./node_modules/lodash/_baseSortBy.js"),
    baseUnary = __webpack_require__(/*! ./_baseUnary */ "./node_modules/lodash/_baseUnary.js"),
    compareMultiple = __webpack_require__(/*! ./_compareMultiple */ "./node_modules/lodash/_compareMultiple.js"),
    identity = __webpack_require__(/*! ./identity */ "./node_modules/lodash/identity.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js");

/**
 * The base implementation of `_.orderBy` without param guards.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.
 * @param {string[]} orders The sort orders of `iteratees`.
 * @returns {Array} Returns the new sorted array.
 */
function baseOrderBy(collection, iteratees, orders) {
  if (iteratees.length) {
    iteratees = arrayMap(iteratees, function(iteratee) {
      if (isArray(iteratee)) {
        return function(value) {
          return baseGet(value, iteratee.length === 1 ? iteratee[0] : iteratee);
        }
      }
      return iteratee;
    });
  } else {
    iteratees = [identity];
  }

  var index = -1;
  iteratees = arrayMap(iteratees, baseUnary(baseIteratee));

  var result = baseMap(collection, function(value, key, collection) {
    var criteria = arrayMap(iteratees, function(iteratee) {
      return iteratee(value);
    });
    return { 'criteria': criteria, 'index': ++index, 'value': value };
  });

  return baseSortBy(result, function(object, other) {
    return compareMultiple(object, other, orders);
  });
}

module.exports = baseOrderBy;


/***/ }),

/***/ "./node_modules/lodash/_baseProperty.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_baseProperty.js ***!
  \**********************************************/
/***/ ((module) => {

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

module.exports = baseProperty;


/***/ }),

/***/ "./node_modules/lodash/_basePropertyDeep.js":
/*!**************************************************!*\
  !*** ./node_modules/lodash/_basePropertyDeep.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGet = __webpack_require__(/*! ./_baseGet */ "./node_modules/lodash/_baseGet.js");

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}

module.exports = basePropertyDeep;


/***/ }),

/***/ "./node_modules/lodash/_baseRest.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_baseRest.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var identity = __webpack_require__(/*! ./identity */ "./node_modules/lodash/identity.js"),
    overRest = __webpack_require__(/*! ./_overRest */ "./node_modules/lodash/_overRest.js"),
    setToString = __webpack_require__(/*! ./_setToString */ "./node_modules/lodash/_setToString.js");

/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest(func, start) {
  return setToString(overRest(func, start, identity), func + '');
}

module.exports = baseRest;


/***/ }),

/***/ "./node_modules/lodash/_baseSetToString.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_baseSetToString.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var constant = __webpack_require__(/*! ./constant */ "./node_modules/lodash/constant.js"),
    defineProperty = __webpack_require__(/*! ./_defineProperty */ "./node_modules/lodash/_defineProperty.js"),
    identity = __webpack_require__(/*! ./identity */ "./node_modules/lodash/identity.js");

/**
 * The base implementation of `setToString` without support for hot loop shorting.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var baseSetToString = !defineProperty ? identity : function(func, string) {
  return defineProperty(func, 'toString', {
    'configurable': true,
    'enumerable': false,
    'value': constant(string),
    'writable': true
  });
};

module.exports = baseSetToString;


/***/ }),

/***/ "./node_modules/lodash/_baseSlice.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseSlice.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * The base implementation of `_.slice` without an iteratee call guard.
 *
 * @private
 * @param {Array} array The array to slice.
 * @param {number} [start=0] The start position.
 * @param {number} [end=array.length] The end position.
 * @returns {Array} Returns the slice of `array`.
 */
function baseSlice(array, start, end) {
  var index = -1,
      length = array.length;

  if (start < 0) {
    start = -start > length ? 0 : (length + start);
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : ((end - start) >>> 0);
  start >>>= 0;

  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}

module.exports = baseSlice;


/***/ }),

/***/ "./node_modules/lodash/_baseSortBy.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_baseSortBy.js ***!
  \********************************************/
/***/ ((module) => {

/**
 * The base implementation of `_.sortBy` which uses `comparer` to define the
 * sort order of `array` and replaces criteria objects with their corresponding
 * values.
 *
 * @private
 * @param {Array} array The array to sort.
 * @param {Function} comparer The function to define sort order.
 * @returns {Array} Returns `array`.
 */
function baseSortBy(array, comparer) {
  var length = array.length;

  array.sort(comparer);
  while (length--) {
    array[length] = array[length].value;
  }
  return array;
}

module.exports = baseSortBy;


/***/ }),

/***/ "./node_modules/lodash/_baseTimes.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseTimes.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

module.exports = baseTimes;


/***/ }),

/***/ "./node_modules/lodash/_baseToString.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_baseToString.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(/*! ./_Symbol */ "./node_modules/lodash/_Symbol.js"),
    arrayMap = __webpack_require__(/*! ./_arrayMap */ "./node_modules/lodash/_arrayMap.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isSymbol = __webpack_require__(/*! ./isSymbol */ "./node_modules/lodash/isSymbol.js");

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isArray(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return arrayMap(value, baseToString) + '';
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = baseToString;


/***/ }),

/***/ "./node_modules/lodash/_baseUnary.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseUnary.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}

module.exports = baseUnary;


/***/ }),

/***/ "./node_modules/lodash/_baseUnset.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_baseUnset.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var castPath = __webpack_require__(/*! ./_castPath */ "./node_modules/lodash/_castPath.js"),
    last = __webpack_require__(/*! ./last */ "./node_modules/lodash/last.js"),
    parent = __webpack_require__(/*! ./_parent */ "./node_modules/lodash/_parent.js"),
    toKey = __webpack_require__(/*! ./_toKey */ "./node_modules/lodash/_toKey.js");

/**
 * The base implementation of `_.unset`.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {Array|string} path The property path to unset.
 * @returns {boolean} Returns `true` if the property is deleted, else `false`.
 */
function baseUnset(object, path) {
  path = castPath(path, object);
  object = parent(object, path);
  return object == null || delete object[toKey(last(path))];
}

module.exports = baseUnset;


/***/ }),

/***/ "./node_modules/lodash/_cacheHas.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_cacheHas.js ***!
  \******************************************/
/***/ ((module) => {

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
  return cache.has(key);
}

module.exports = cacheHas;


/***/ }),

/***/ "./node_modules/lodash/_castFunction.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_castFunction.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var identity = __webpack_require__(/*! ./identity */ "./node_modules/lodash/identity.js");

/**
 * Casts `value` to `identity` if it's not a function.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Function} Returns cast function.
 */
function castFunction(value) {
  return typeof value == 'function' ? value : identity;
}

module.exports = castFunction;


/***/ }),

/***/ "./node_modules/lodash/_castPath.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_castPath.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isKey = __webpack_require__(/*! ./_isKey */ "./node_modules/lodash/_isKey.js"),
    stringToPath = __webpack_require__(/*! ./_stringToPath */ "./node_modules/lodash/_stringToPath.js"),
    toString = __webpack_require__(/*! ./toString */ "./node_modules/lodash/toString.js");

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isArray(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath(toString(value));
}

module.exports = castPath;


/***/ }),

/***/ "./node_modules/lodash/_cloneArrayBuffer.js":
/*!**************************************************!*\
  !*** ./node_modules/lodash/_cloneArrayBuffer.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Uint8Array = __webpack_require__(/*! ./_Uint8Array */ "./node_modules/lodash/_Uint8Array.js");

/**
 * Creates a clone of `arrayBuffer`.
 *
 * @private
 * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
 * @returns {ArrayBuffer} Returns the cloned array buffer.
 */
function cloneArrayBuffer(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array(result).set(new Uint8Array(arrayBuffer));
  return result;
}

module.exports = cloneArrayBuffer;


/***/ }),

/***/ "./node_modules/lodash/_cloneBuffer.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_cloneBuffer.js ***!
  \*********************************************/
/***/ ((module, exports, __webpack_require__) => {

/* module decorator */ module = __webpack_require__.nmd(module);
var root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined,
    allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined;

/**
 * Creates a clone of  `buffer`.
 *
 * @private
 * @param {Buffer} buffer The buffer to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Buffer} Returns the cloned buffer.
 */
function cloneBuffer(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length,
      result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

  buffer.copy(result);
  return result;
}

module.exports = cloneBuffer;


/***/ }),

/***/ "./node_modules/lodash/_cloneDataView.js":
/*!***********************************************!*\
  !*** ./node_modules/lodash/_cloneDataView.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var cloneArrayBuffer = __webpack_require__(/*! ./_cloneArrayBuffer */ "./node_modules/lodash/_cloneArrayBuffer.js");

/**
 * Creates a clone of `dataView`.
 *
 * @private
 * @param {Object} dataView The data view to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned data view.
 */
function cloneDataView(dataView, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
  return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}

module.exports = cloneDataView;


/***/ }),

/***/ "./node_modules/lodash/_cloneRegExp.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_cloneRegExp.js ***!
  \*********************************************/
/***/ ((module) => {

/** Used to match `RegExp` flags from their coerced string values. */
var reFlags = /\w*$/;

/**
 * Creates a clone of `regexp`.
 *
 * @private
 * @param {Object} regexp The regexp to clone.
 * @returns {Object} Returns the cloned regexp.
 */
function cloneRegExp(regexp) {
  var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
  result.lastIndex = regexp.lastIndex;
  return result;
}

module.exports = cloneRegExp;


/***/ }),

/***/ "./node_modules/lodash/_cloneSymbol.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_cloneSymbol.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(/*! ./_Symbol */ "./node_modules/lodash/_Symbol.js");

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * Creates a clone of the `symbol` object.
 *
 * @private
 * @param {Object} symbol The symbol object to clone.
 * @returns {Object} Returns the cloned symbol object.
 */
function cloneSymbol(symbol) {
  return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
}

module.exports = cloneSymbol;


/***/ }),

/***/ "./node_modules/lodash/_cloneTypedArray.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_cloneTypedArray.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var cloneArrayBuffer = __webpack_require__(/*! ./_cloneArrayBuffer */ "./node_modules/lodash/_cloneArrayBuffer.js");

/**
 * Creates a clone of `typedArray`.
 *
 * @private
 * @param {Object} typedArray The typed array to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned typed array.
 */
function cloneTypedArray(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}

module.exports = cloneTypedArray;


/***/ }),

/***/ "./node_modules/lodash/_compareAscending.js":
/*!**************************************************!*\
  !*** ./node_modules/lodash/_compareAscending.js ***!
  \**************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isSymbol = __webpack_require__(/*! ./isSymbol */ "./node_modules/lodash/isSymbol.js");

/**
 * Compares values to sort them in ascending order.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {number} Returns the sort order indicator for `value`.
 */
function compareAscending(value, other) {
  if (value !== other) {
    var valIsDefined = value !== undefined,
        valIsNull = value === null,
        valIsReflexive = value === value,
        valIsSymbol = isSymbol(value);

    var othIsDefined = other !== undefined,
        othIsNull = other === null,
        othIsReflexive = other === other,
        othIsSymbol = isSymbol(other);

    if ((!othIsNull && !othIsSymbol && !valIsSymbol && value > other) ||
        (valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol) ||
        (valIsNull && othIsDefined && othIsReflexive) ||
        (!valIsDefined && othIsReflexive) ||
        !valIsReflexive) {
      return 1;
    }
    if ((!valIsNull && !valIsSymbol && !othIsSymbol && value < other) ||
        (othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol) ||
        (othIsNull && valIsDefined && valIsReflexive) ||
        (!othIsDefined && valIsReflexive) ||
        !othIsReflexive) {
      return -1;
    }
  }
  return 0;
}

module.exports = compareAscending;


/***/ }),

/***/ "./node_modules/lodash/_compareMultiple.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_compareMultiple.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var compareAscending = __webpack_require__(/*! ./_compareAscending */ "./node_modules/lodash/_compareAscending.js");

/**
 * Used by `_.orderBy` to compare multiple properties of a value to another
 * and stable sort them.
 *
 * If `orders` is unspecified, all values are sorted in ascending order. Otherwise,
 * specify an order of "desc" for descending or "asc" for ascending sort order
 * of corresponding values.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {boolean[]|string[]} orders The order to sort by for each property.
 * @returns {number} Returns the sort order indicator for `object`.
 */
function compareMultiple(object, other, orders) {
  var index = -1,
      objCriteria = object.criteria,
      othCriteria = other.criteria,
      length = objCriteria.length,
      ordersLength = orders.length;

  while (++index < length) {
    var result = compareAscending(objCriteria[index], othCriteria[index]);
    if (result) {
      if (index >= ordersLength) {
        return result;
      }
      var order = orders[index];
      return result * (order == 'desc' ? -1 : 1);
    }
  }
  // Fixes an `Array#sort` bug in the JS engine embedded in Adobe applications
  // that causes it, under certain circumstances, to provide the same value for
  // `object` and `other`. See https://github.com/jashkenas/underscore/pull/1247
  // for more details.
  //
  // This also ensures a stable sort in V8 and other engines.
  // See https://bugs.chromium.org/p/v8/issues/detail?id=90 for more details.
  return object.index - other.index;
}

module.exports = compareMultiple;


/***/ }),

/***/ "./node_modules/lodash/_copyArray.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_copyArray.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * Copies the values of `source` to `array`.
 *
 * @private
 * @param {Array} source The array to copy values from.
 * @param {Array} [array=[]] The array to copy values to.
 * @returns {Array} Returns `array`.
 */
function copyArray(source, array) {
  var index = -1,
      length = source.length;

  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}

module.exports = copyArray;


/***/ }),

/***/ "./node_modules/lodash/_copyObject.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_copyObject.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assignValue = __webpack_require__(/*! ./_assignValue */ "./node_modules/lodash/_assignValue.js"),
    baseAssignValue = __webpack_require__(/*! ./_baseAssignValue */ "./node_modules/lodash/_baseAssignValue.js");

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */
function copyObject(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});

  var index = -1,
      length = props.length;

  while (++index < length) {
    var key = props[index];

    var newValue = customizer
      ? customizer(object[key], source[key], key, object, source)
      : undefined;

    if (newValue === undefined) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue(object, key, newValue);
    } else {
      assignValue(object, key, newValue);
    }
  }
  return object;
}

module.exports = copyObject;


/***/ }),

/***/ "./node_modules/lodash/_copySymbols.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_copySymbols.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var copyObject = __webpack_require__(/*! ./_copyObject */ "./node_modules/lodash/_copyObject.js"),
    getSymbols = __webpack_require__(/*! ./_getSymbols */ "./node_modules/lodash/_getSymbols.js");

/**
 * Copies own symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbols(source, object) {
  return copyObject(source, getSymbols(source), object);
}

module.exports = copySymbols;


/***/ }),

/***/ "./node_modules/lodash/_copySymbolsIn.js":
/*!***********************************************!*\
  !*** ./node_modules/lodash/_copySymbolsIn.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var copyObject = __webpack_require__(/*! ./_copyObject */ "./node_modules/lodash/_copyObject.js"),
    getSymbolsIn = __webpack_require__(/*! ./_getSymbolsIn */ "./node_modules/lodash/_getSymbolsIn.js");

/**
 * Copies own and inherited symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbolsIn(source, object) {
  return copyObject(source, getSymbolsIn(source), object);
}

module.exports = copySymbolsIn;


/***/ }),

/***/ "./node_modules/lodash/_coreJsData.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_coreJsData.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js");

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

module.exports = coreJsData;


/***/ }),

/***/ "./node_modules/lodash/_createBaseEach.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_createBaseEach.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isArrayLike = __webpack_require__(/*! ./isArrayLike */ "./node_modules/lodash/isArrayLike.js");

/**
 * Creates a `baseEach` or `baseEachRight` function.
 *
 * @private
 * @param {Function} eachFunc The function to iterate over a collection.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseEach(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length,
        index = fromRight ? length : -1,
        iterable = Object(collection);

    while ((fromRight ? index-- : ++index < length)) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}

module.exports = createBaseEach;


/***/ }),

/***/ "./node_modules/lodash/_createBaseFor.js":
/*!***********************************************!*\
  !*** ./node_modules/lodash/_createBaseFor.js ***!
  \***********************************************/
/***/ ((module) => {

/**
 * Creates a base function for methods like `_.forIn` and `_.forOwn`.
 *
 * @private
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseFor(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;

    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}

module.exports = createBaseFor;


/***/ }),

/***/ "./node_modules/lodash/_customOmitClone.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_customOmitClone.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isPlainObject = __webpack_require__(/*! ./isPlainObject */ "./node_modules/lodash/isPlainObject.js");

/**
 * Used by `_.omit` to customize its `_.cloneDeep` use to only clone plain
 * objects.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {string} key The key of the property to inspect.
 * @returns {*} Returns the uncloned value or `undefined` to defer cloning to `_.cloneDeep`.
 */
function customOmitClone(value) {
  return isPlainObject(value) ? undefined : value;
}

module.exports = customOmitClone;


/***/ }),

/***/ "./node_modules/lodash/_defineProperty.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_defineProperty.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(/*! ./_getNative */ "./node_modules/lodash/_getNative.js");

var defineProperty = (function() {
  try {
    var func = getNative(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

module.exports = defineProperty;


/***/ }),

/***/ "./node_modules/lodash/_equalArrays.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_equalArrays.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var SetCache = __webpack_require__(/*! ./_SetCache */ "./node_modules/lodash/_SetCache.js"),
    arraySome = __webpack_require__(/*! ./_arraySome */ "./node_modules/lodash/_arraySome.js"),
    cacheHas = __webpack_require__(/*! ./_cacheHas */ "./node_modules/lodash/_cacheHas.js");

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Check that cyclic values are equal.
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

module.exports = equalArrays;


/***/ }),

/***/ "./node_modules/lodash/_equalByTag.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_equalByTag.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(/*! ./_Symbol */ "./node_modules/lodash/_Symbol.js"),
    Uint8Array = __webpack_require__(/*! ./_Uint8Array */ "./node_modules/lodash/_Uint8Array.js"),
    eq = __webpack_require__(/*! ./eq */ "./node_modules/lodash/eq.js"),
    equalArrays = __webpack_require__(/*! ./_equalArrays */ "./node_modules/lodash/_equalArrays.js"),
    mapToArray = __webpack_require__(/*! ./_mapToArray */ "./node_modules/lodash/_mapToArray.js"),
    setToArray = __webpack_require__(/*! ./_setToArray */ "./node_modules/lodash/_setToArray.js");

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

module.exports = equalByTag;


/***/ }),

/***/ "./node_modules/lodash/_equalObjects.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_equalObjects.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getAllKeys = __webpack_require__(/*! ./_getAllKeys */ "./node_modules/lodash/_getAllKeys.js");

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
      return false;
    }
  }
  // Check that cyclic values are equal.
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

module.exports = equalObjects;


/***/ }),

/***/ "./node_modules/lodash/_flatRest.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_flatRest.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var flatten = __webpack_require__(/*! ./flatten */ "./node_modules/lodash/flatten.js"),
    overRest = __webpack_require__(/*! ./_overRest */ "./node_modules/lodash/_overRest.js"),
    setToString = __webpack_require__(/*! ./_setToString */ "./node_modules/lodash/_setToString.js");

/**
 * A specialized version of `baseRest` which flattens the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @returns {Function} Returns the new function.
 */
function flatRest(func) {
  return setToString(overRest(func, undefined, flatten), func + '');
}

module.exports = flatRest;


/***/ }),

/***/ "./node_modules/lodash/_freeGlobal.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_freeGlobal.js ***!
  \********************************************/
/***/ ((module) => {

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

module.exports = freeGlobal;


/***/ }),

/***/ "./node_modules/lodash/_getAllKeys.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_getAllKeys.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetAllKeys = __webpack_require__(/*! ./_baseGetAllKeys */ "./node_modules/lodash/_baseGetAllKeys.js"),
    getSymbols = __webpack_require__(/*! ./_getSymbols */ "./node_modules/lodash/_getSymbols.js"),
    keys = __webpack_require__(/*! ./keys */ "./node_modules/lodash/keys.js");

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols);
}

module.exports = getAllKeys;


/***/ }),

/***/ "./node_modules/lodash/_getAllKeysIn.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_getAllKeysIn.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetAllKeys = __webpack_require__(/*! ./_baseGetAllKeys */ "./node_modules/lodash/_baseGetAllKeys.js"),
    getSymbolsIn = __webpack_require__(/*! ./_getSymbolsIn */ "./node_modules/lodash/_getSymbolsIn.js"),
    keysIn = __webpack_require__(/*! ./keysIn */ "./node_modules/lodash/keysIn.js");

/**
 * Creates an array of own and inherited enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeysIn(object) {
  return baseGetAllKeys(object, keysIn, getSymbolsIn);
}

module.exports = getAllKeysIn;


/***/ }),

/***/ "./node_modules/lodash/_getMapData.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_getMapData.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isKeyable = __webpack_require__(/*! ./_isKeyable */ "./node_modules/lodash/_isKeyable.js");

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

module.exports = getMapData;


/***/ }),

/***/ "./node_modules/lodash/_getMatchData.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_getMatchData.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isStrictComparable = __webpack_require__(/*! ./_isStrictComparable */ "./node_modules/lodash/_isStrictComparable.js"),
    keys = __webpack_require__(/*! ./keys */ "./node_modules/lodash/keys.js");

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = keys(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}

module.exports = getMatchData;


/***/ }),

/***/ "./node_modules/lodash/_getNative.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_getNative.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsNative = __webpack_require__(/*! ./_baseIsNative */ "./node_modules/lodash/_baseIsNative.js"),
    getValue = __webpack_require__(/*! ./_getValue */ "./node_modules/lodash/_getValue.js");

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

module.exports = getNative;


/***/ }),

/***/ "./node_modules/lodash/_getPrototype.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_getPrototype.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var overArg = __webpack_require__(/*! ./_overArg */ "./node_modules/lodash/_overArg.js");

/** Built-in value references. */
var getPrototype = overArg(Object.getPrototypeOf, Object);

module.exports = getPrototype;


/***/ }),

/***/ "./node_modules/lodash/_getRawTag.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_getRawTag.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(/*! ./_Symbol */ "./node_modules/lodash/_Symbol.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/** Built-in value references. */
var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag),
      tag = value[symToStringTag];

  try {
    value[symToStringTag] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}

module.exports = getRawTag;


/***/ }),

/***/ "./node_modules/lodash/_getSymbols.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_getSymbols.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayFilter = __webpack_require__(/*! ./_arrayFilter */ "./node_modules/lodash/_arrayFilter.js"),
    stubArray = __webpack_require__(/*! ./stubArray */ "./node_modules/lodash/stubArray.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

module.exports = getSymbols;


/***/ }),

/***/ "./node_modules/lodash/_getSymbolsIn.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_getSymbolsIn.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayPush = __webpack_require__(/*! ./_arrayPush */ "./node_modules/lodash/_arrayPush.js"),
    getPrototype = __webpack_require__(/*! ./_getPrototype */ "./node_modules/lodash/_getPrototype.js"),
    getSymbols = __webpack_require__(/*! ./_getSymbols */ "./node_modules/lodash/_getSymbols.js"),
    stubArray = __webpack_require__(/*! ./stubArray */ "./node_modules/lodash/stubArray.js");

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own and inherited enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush(result, getSymbols(object));
    object = getPrototype(object);
  }
  return result;
};

module.exports = getSymbolsIn;


/***/ }),

/***/ "./node_modules/lodash/_getTag.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/_getTag.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var DataView = __webpack_require__(/*! ./_DataView */ "./node_modules/lodash/_DataView.js"),
    Map = __webpack_require__(/*! ./_Map */ "./node_modules/lodash/_Map.js"),
    Promise = __webpack_require__(/*! ./_Promise */ "./node_modules/lodash/_Promise.js"),
    Set = __webpack_require__(/*! ./_Set */ "./node_modules/lodash/_Set.js"),
    WeakMap = __webpack_require__(/*! ./_WeakMap */ "./node_modules/lodash/_WeakMap.js"),
    baseGetTag = __webpack_require__(/*! ./_baseGetTag */ "./node_modules/lodash/_baseGetTag.js"),
    toSource = __webpack_require__(/*! ./_toSource */ "./node_modules/lodash/_toSource.js");

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    setTag = '[object Set]',
    weakMapTag = '[object WeakMap]';

var dataViewTag = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
    (Map && getTag(new Map) != mapTag) ||
    (Promise && getTag(Promise.resolve()) != promiseTag) ||
    (Set && getTag(new Set) != setTag) ||
    (WeakMap && getTag(new WeakMap) != weakMapTag)) {
  getTag = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

module.exports = getTag;


/***/ }),

/***/ "./node_modules/lodash/_getValue.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_getValue.js ***!
  \******************************************/
/***/ ((module) => {

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

module.exports = getValue;


/***/ }),

/***/ "./node_modules/lodash/_hasPath.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_hasPath.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var castPath = __webpack_require__(/*! ./_castPath */ "./node_modules/lodash/_castPath.js"),
    isArguments = __webpack_require__(/*! ./isArguments */ "./node_modules/lodash/isArguments.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isIndex = __webpack_require__(/*! ./_isIndex */ "./node_modules/lodash/_isIndex.js"),
    isLength = __webpack_require__(/*! ./isLength */ "./node_modules/lodash/isLength.js"),
    toKey = __webpack_require__(/*! ./_toKey */ "./node_modules/lodash/_toKey.js");

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength(length) && isIndex(key, length) &&
    (isArray(object) || isArguments(object));
}

module.exports = hasPath;


/***/ }),

/***/ "./node_modules/lodash/_hashClear.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_hashClear.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(/*! ./_nativeCreate */ "./node_modules/lodash/_nativeCreate.js");

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
  this.size = 0;
}

module.exports = hashClear;


/***/ }),

/***/ "./node_modules/lodash/_hashDelete.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_hashDelete.js ***!
  \********************************************/
/***/ ((module) => {

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = hashDelete;


/***/ }),

/***/ "./node_modules/lodash/_hashGet.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_hashGet.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(/*! ./_nativeCreate */ "./node_modules/lodash/_nativeCreate.js");

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}

module.exports = hashGet;


/***/ }),

/***/ "./node_modules/lodash/_hashHas.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_hashHas.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(/*! ./_nativeCreate */ "./node_modules/lodash/_nativeCreate.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? (data[key] !== undefined) : hasOwnProperty.call(data, key);
}

module.exports = hashHas;


/***/ }),

/***/ "./node_modules/lodash/_hashSet.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_hashSet.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(/*! ./_nativeCreate */ "./node_modules/lodash/_nativeCreate.js");

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}

module.exports = hashSet;


/***/ }),

/***/ "./node_modules/lodash/_initCloneArray.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_initCloneArray.js ***!
  \************************************************/
/***/ ((module) => {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Initializes an array clone.
 *
 * @private
 * @param {Array} array The array to clone.
 * @returns {Array} Returns the initialized clone.
 */
function initCloneArray(array) {
  var length = array.length,
      result = new array.constructor(length);

  // Add properties assigned by `RegExp#exec`.
  if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
    result.index = array.index;
    result.input = array.input;
  }
  return result;
}

module.exports = initCloneArray;


/***/ }),

/***/ "./node_modules/lodash/_initCloneByTag.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_initCloneByTag.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var cloneArrayBuffer = __webpack_require__(/*! ./_cloneArrayBuffer */ "./node_modules/lodash/_cloneArrayBuffer.js"),
    cloneDataView = __webpack_require__(/*! ./_cloneDataView */ "./node_modules/lodash/_cloneDataView.js"),
    cloneRegExp = __webpack_require__(/*! ./_cloneRegExp */ "./node_modules/lodash/_cloneRegExp.js"),
    cloneSymbol = __webpack_require__(/*! ./_cloneSymbol */ "./node_modules/lodash/_cloneSymbol.js"),
    cloneTypedArray = __webpack_require__(/*! ./_cloneTypedArray */ "./node_modules/lodash/_cloneTypedArray.js");

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/**
 * Initializes an object clone based on its `toStringTag`.
 *
 * **Note:** This function only supports cloning values with tags of
 * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
 *
 * @private
 * @param {Object} object The object to clone.
 * @param {string} tag The `toStringTag` of the object to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneByTag(object, tag, isDeep) {
  var Ctor = object.constructor;
  switch (tag) {
    case arrayBufferTag:
      return cloneArrayBuffer(object);

    case boolTag:
    case dateTag:
      return new Ctor(+object);

    case dataViewTag:
      return cloneDataView(object, isDeep);

    case float32Tag: case float64Tag:
    case int8Tag: case int16Tag: case int32Tag:
    case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:
      return cloneTypedArray(object, isDeep);

    case mapTag:
      return new Ctor;

    case numberTag:
    case stringTag:
      return new Ctor(object);

    case regexpTag:
      return cloneRegExp(object);

    case setTag:
      return new Ctor;

    case symbolTag:
      return cloneSymbol(object);
  }
}

module.exports = initCloneByTag;


/***/ }),

/***/ "./node_modules/lodash/_initCloneObject.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_initCloneObject.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseCreate = __webpack_require__(/*! ./_baseCreate */ "./node_modules/lodash/_baseCreate.js"),
    getPrototype = __webpack_require__(/*! ./_getPrototype */ "./node_modules/lodash/_getPrototype.js"),
    isPrototype = __webpack_require__(/*! ./_isPrototype */ "./node_modules/lodash/_isPrototype.js");

/**
 * Initializes an object clone.
 *
 * @private
 * @param {Object} object The object to clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneObject(object) {
  return (typeof object.constructor == 'function' && !isPrototype(object))
    ? baseCreate(getPrototype(object))
    : {};
}

module.exports = initCloneObject;


/***/ }),

/***/ "./node_modules/lodash/_isFlattenable.js":
/*!***********************************************!*\
  !*** ./node_modules/lodash/_isFlattenable.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(/*! ./_Symbol */ "./node_modules/lodash/_Symbol.js"),
    isArguments = __webpack_require__(/*! ./isArguments */ "./node_modules/lodash/isArguments.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js");

/** Built-in value references. */
var spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined;

/**
 * Checks if `value` is a flattenable `arguments` object or array.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
 */
function isFlattenable(value) {
  return isArray(value) || isArguments(value) ||
    !!(spreadableSymbol && value && value[spreadableSymbol]);
}

module.exports = isFlattenable;


/***/ }),

/***/ "./node_modules/lodash/_isIndex.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_isIndex.js ***!
  \*****************************************/
/***/ ((module) => {

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER : length;

  return !!length &&
    (type == 'number' ||
      (type != 'symbol' && reIsUint.test(value))) &&
        (value > -1 && value % 1 == 0 && value < length);
}

module.exports = isIndex;


/***/ }),

/***/ "./node_modules/lodash/_isIterateeCall.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_isIterateeCall.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var eq = __webpack_require__(/*! ./eq */ "./node_modules/lodash/eq.js"),
    isArrayLike = __webpack_require__(/*! ./isArrayLike */ "./node_modules/lodash/isArrayLike.js"),
    isIndex = __webpack_require__(/*! ./_isIndex */ "./node_modules/lodash/_isIndex.js"),
    isObject = __webpack_require__(/*! ./isObject */ "./node_modules/lodash/isObject.js");

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject(object)) {
    return false;
  }
  var type = typeof index;
  if (type == 'number'
        ? (isArrayLike(object) && isIndex(index, object.length))
        : (type == 'string' && index in object)
      ) {
    return eq(object[index], value);
  }
  return false;
}

module.exports = isIterateeCall;


/***/ }),

/***/ "./node_modules/lodash/_isKey.js":
/*!***************************************!*\
  !*** ./node_modules/lodash/_isKey.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isSymbol = __webpack_require__(/*! ./isSymbol */ "./node_modules/lodash/isSymbol.js");

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

module.exports = isKey;


/***/ }),

/***/ "./node_modules/lodash/_isKeyable.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/_isKeyable.js ***!
  \*******************************************/
/***/ ((module) => {

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

module.exports = isKeyable;


/***/ }),

/***/ "./node_modules/lodash/_isMasked.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_isMasked.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var coreJsData = __webpack_require__(/*! ./_coreJsData */ "./node_modules/lodash/_coreJsData.js");

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

module.exports = isMasked;


/***/ }),

/***/ "./node_modules/lodash/_isPrototype.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_isPrototype.js ***!
  \*********************************************/
/***/ ((module) => {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

  return value === proto;
}

module.exports = isPrototype;


/***/ }),

/***/ "./node_modules/lodash/_isStrictComparable.js":
/*!****************************************************!*\
  !*** ./node_modules/lodash/_isStrictComparable.js ***!
  \****************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__(/*! ./isObject */ "./node_modules/lodash/isObject.js");

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isObject(value);
}

module.exports = isStrictComparable;


/***/ }),

/***/ "./node_modules/lodash/_listCacheClear.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_listCacheClear.js ***!
  \************************************************/
/***/ ((module) => {

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}

module.exports = listCacheClear;


/***/ }),

/***/ "./node_modules/lodash/_listCacheDelete.js":
/*!*************************************************!*\
  !*** ./node_modules/lodash/_listCacheDelete.js ***!
  \*************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(/*! ./_assocIndexOf */ "./node_modules/lodash/_assocIndexOf.js");

/** Used for built-in method references. */
var arrayProto = Array.prototype;

/** Built-in value references. */
var splice = arrayProto.splice;

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

module.exports = listCacheDelete;


/***/ }),

/***/ "./node_modules/lodash/_listCacheGet.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_listCacheGet.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(/*! ./_assocIndexOf */ "./node_modules/lodash/_assocIndexOf.js");

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

module.exports = listCacheGet;


/***/ }),

/***/ "./node_modules/lodash/_listCacheHas.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_listCacheHas.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(/*! ./_assocIndexOf */ "./node_modules/lodash/_assocIndexOf.js");

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

module.exports = listCacheHas;


/***/ }),

/***/ "./node_modules/lodash/_listCacheSet.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_listCacheSet.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(/*! ./_assocIndexOf */ "./node_modules/lodash/_assocIndexOf.js");

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

module.exports = listCacheSet;


/***/ }),

/***/ "./node_modules/lodash/_mapCacheClear.js":
/*!***********************************************!*\
  !*** ./node_modules/lodash/_mapCacheClear.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Hash = __webpack_require__(/*! ./_Hash */ "./node_modules/lodash/_Hash.js"),
    ListCache = __webpack_require__(/*! ./_ListCache */ "./node_modules/lodash/_ListCache.js"),
    Map = __webpack_require__(/*! ./_Map */ "./node_modules/lodash/_Map.js");

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map || ListCache),
    'string': new Hash
  };
}

module.exports = mapCacheClear;


/***/ }),

/***/ "./node_modules/lodash/_mapCacheDelete.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_mapCacheDelete.js ***!
  \************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(/*! ./_getMapData */ "./node_modules/lodash/_getMapData.js");

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  var result = getMapData(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = mapCacheDelete;


/***/ }),

/***/ "./node_modules/lodash/_mapCacheGet.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_mapCacheGet.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(/*! ./_getMapData */ "./node_modules/lodash/_getMapData.js");

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

module.exports = mapCacheGet;


/***/ }),

/***/ "./node_modules/lodash/_mapCacheHas.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_mapCacheHas.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(/*! ./_getMapData */ "./node_modules/lodash/_getMapData.js");

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

module.exports = mapCacheHas;


/***/ }),

/***/ "./node_modules/lodash/_mapCacheSet.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_mapCacheSet.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(/*! ./_getMapData */ "./node_modules/lodash/_getMapData.js");

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

module.exports = mapCacheSet;


/***/ }),

/***/ "./node_modules/lodash/_mapToArray.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_mapToArray.js ***!
  \********************************************/
/***/ ((module) => {

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

module.exports = mapToArray;


/***/ }),

/***/ "./node_modules/lodash/_matchesStrictComparable.js":
/*!*********************************************************!*\
  !*** ./node_modules/lodash/_matchesStrictComparable.js ***!
  \*********************************************************/
/***/ ((module) => {

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

module.exports = matchesStrictComparable;


/***/ }),

/***/ "./node_modules/lodash/_memoizeCapped.js":
/*!***********************************************!*\
  !*** ./node_modules/lodash/_memoizeCapped.js ***!
  \***********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var memoize = __webpack_require__(/*! ./memoize */ "./node_modules/lodash/memoize.js");

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

module.exports = memoizeCapped;


/***/ }),

/***/ "./node_modules/lodash/_nativeCreate.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_nativeCreate.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(/*! ./_getNative */ "./node_modules/lodash/_getNative.js");

/* Built-in method references that are verified to be native. */
var nativeCreate = getNative(Object, 'create');

module.exports = nativeCreate;


/***/ }),

/***/ "./node_modules/lodash/_nativeKeys.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_nativeKeys.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var overArg = __webpack_require__(/*! ./_overArg */ "./node_modules/lodash/_overArg.js");

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

module.exports = nativeKeys;


/***/ }),

/***/ "./node_modules/lodash/_nativeKeysIn.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_nativeKeysIn.js ***!
  \**********************************************/
/***/ ((module) => {

/**
 * This function is like
 * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * except that it includes inherited enumerable properties.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function nativeKeysIn(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}

module.exports = nativeKeysIn;


/***/ }),

/***/ "./node_modules/lodash/_nodeUtil.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_nodeUtil.js ***!
  \******************************************/
/***/ ((module, exports, __webpack_require__) => {

/* module decorator */ module = __webpack_require__.nmd(module);
var freeGlobal = __webpack_require__(/*! ./_freeGlobal */ "./node_modules/lodash/_freeGlobal.js");

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Detect free variable `process` from Node.js. */
var freeProcess = moduleExports && freeGlobal.process;

/** Used to access faster Node.js helpers. */
var nodeUtil = (function() {
  try {
    // Use `util.types` for Node.js 10+.
    var types = freeModule && freeModule.require && freeModule.require('util').types;

    if (types) {
      return types;
    }

    // Legacy `process.binding('util')` for Node.js < 10.
    return freeProcess && freeProcess.binding && freeProcess.binding('util');
  } catch (e) {}
}());

module.exports = nodeUtil;


/***/ }),

/***/ "./node_modules/lodash/_objectToString.js":
/*!************************************************!*\
  !*** ./node_modules/lodash/_objectToString.js ***!
  \************************************************/
/***/ ((module) => {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString(value) {
  return nativeObjectToString.call(value);
}

module.exports = objectToString;


/***/ }),

/***/ "./node_modules/lodash/_overArg.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/_overArg.js ***!
  \*****************************************/
/***/ ((module) => {

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

module.exports = overArg;


/***/ }),

/***/ "./node_modules/lodash/_overRest.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_overRest.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var apply = __webpack_require__(/*! ./_apply */ "./node_modules/lodash/_apply.js");

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * A specialized version of `baseRest` which transforms the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @param {Function} transform The rest array transform.
 * @returns {Function} Returns the new function.
 */
function overRest(func, start, transform) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);

    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return apply(func, this, otherArgs);
  };
}

module.exports = overRest;


/***/ }),

/***/ "./node_modules/lodash/_parent.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/_parent.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGet = __webpack_require__(/*! ./_baseGet */ "./node_modules/lodash/_baseGet.js"),
    baseSlice = __webpack_require__(/*! ./_baseSlice */ "./node_modules/lodash/_baseSlice.js");

/**
 * Gets the parent value at `path` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array} path The path to get the parent value of.
 * @returns {*} Returns the parent value.
 */
function parent(object, path) {
  return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));
}

module.exports = parent;


/***/ }),

/***/ "./node_modules/lodash/_root.js":
/*!**************************************!*\
  !*** ./node_modules/lodash/_root.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var freeGlobal = __webpack_require__(/*! ./_freeGlobal */ "./node_modules/lodash/_freeGlobal.js");

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

module.exports = root;


/***/ }),

/***/ "./node_modules/lodash/_setCacheAdd.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_setCacheAdd.js ***!
  \*********************************************/
/***/ ((module) => {

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

module.exports = setCacheAdd;


/***/ }),

/***/ "./node_modules/lodash/_setCacheHas.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_setCacheHas.js ***!
  \*********************************************/
/***/ ((module) => {

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
  return this.__data__.has(value);
}

module.exports = setCacheHas;


/***/ }),

/***/ "./node_modules/lodash/_setToArray.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_setToArray.js ***!
  \********************************************/
/***/ ((module) => {

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

module.exports = setToArray;


/***/ }),

/***/ "./node_modules/lodash/_setToString.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_setToString.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseSetToString = __webpack_require__(/*! ./_baseSetToString */ "./node_modules/lodash/_baseSetToString.js"),
    shortOut = __webpack_require__(/*! ./_shortOut */ "./node_modules/lodash/_shortOut.js");

/**
 * Sets the `toString` method of `func` to return `string`.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var setToString = shortOut(baseSetToString);

module.exports = setToString;


/***/ }),

/***/ "./node_modules/lodash/_shortOut.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_shortOut.js ***!
  \******************************************/
/***/ ((module) => {

/** Used to detect hot functions by number of calls within a span of milliseconds. */
var HOT_COUNT = 800,
    HOT_SPAN = 16;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeNow = Date.now;

/**
 * Creates a function that'll short out and invoke `identity` instead
 * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
 * milliseconds.
 *
 * @private
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new shortable function.
 */
function shortOut(func) {
  var count = 0,
      lastCalled = 0;

  return function() {
    var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);

    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(undefined, arguments);
  };
}

module.exports = shortOut;


/***/ }),

/***/ "./node_modules/lodash/_stackClear.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/_stackClear.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var ListCache = __webpack_require__(/*! ./_ListCache */ "./node_modules/lodash/_ListCache.js");

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear() {
  this.__data__ = new ListCache;
  this.size = 0;
}

module.exports = stackClear;


/***/ }),

/***/ "./node_modules/lodash/_stackDelete.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/_stackDelete.js ***!
  \*********************************************/
/***/ ((module) => {

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

module.exports = stackDelete;


/***/ }),

/***/ "./node_modules/lodash/_stackGet.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_stackGet.js ***!
  \******************************************/
/***/ ((module) => {

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
  return this.__data__.get(key);
}

module.exports = stackGet;


/***/ }),

/***/ "./node_modules/lodash/_stackHas.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_stackHas.js ***!
  \******************************************/
/***/ ((module) => {

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
  return this.__data__.has(key);
}

module.exports = stackHas;


/***/ }),

/***/ "./node_modules/lodash/_stackSet.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_stackSet.js ***!
  \******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var ListCache = __webpack_require__(/*! ./_ListCache */ "./node_modules/lodash/_ListCache.js"),
    Map = __webpack_require__(/*! ./_Map */ "./node_modules/lodash/_Map.js"),
    MapCache = __webpack_require__(/*! ./_MapCache */ "./node_modules/lodash/_MapCache.js");

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

module.exports = stackSet;


/***/ }),

/***/ "./node_modules/lodash/_stringToPath.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/_stringToPath.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var memoizeCapped = __webpack_require__(/*! ./_memoizeCapped */ "./node_modules/lodash/_memoizeCapped.js");

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

module.exports = stringToPath;


/***/ }),

/***/ "./node_modules/lodash/_toKey.js":
/*!***************************************!*\
  !*** ./node_modules/lodash/_toKey.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isSymbol = __webpack_require__(/*! ./isSymbol */ "./node_modules/lodash/isSymbol.js");

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = toKey;


/***/ }),

/***/ "./node_modules/lodash/_toSource.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/_toSource.js ***!
  \******************************************/
/***/ ((module) => {

/** Used for built-in method references. */
var funcProto = Function.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

module.exports = toSource;


/***/ }),

/***/ "./node_modules/lodash/constant.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/constant.js ***!
  \*****************************************/
/***/ ((module) => {

/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
function constant(value) {
  return function() {
    return value;
  };
}

module.exports = constant;


/***/ }),

/***/ "./node_modules/lodash/each.js":
/*!*************************************!*\
  !*** ./node_modules/lodash/each.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! ./forEach */ "./node_modules/lodash/forEach.js");


/***/ }),

/***/ "./node_modules/lodash/eq.js":
/*!***********************************!*\
  !*** ./node_modules/lodash/eq.js ***!
  \***********************************/
/***/ ((module) => {

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

module.exports = eq;


/***/ }),

/***/ "./node_modules/lodash/flatten.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/flatten.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseFlatten = __webpack_require__(/*! ./_baseFlatten */ "./node_modules/lodash/_baseFlatten.js");

/**
 * Flattens `array` a single level deep.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {Array} array The array to flatten.
 * @returns {Array} Returns the new flattened array.
 * @example
 *
 * _.flatten([1, [2, [3, [4]], 5]]);
 * // => [1, 2, [3, [4]], 5]
 */
function flatten(array) {
  var length = array == null ? 0 : array.length;
  return length ? baseFlatten(array, 1) : [];
}

module.exports = flatten;


/***/ }),

/***/ "./node_modules/lodash/forEach.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/forEach.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayEach = __webpack_require__(/*! ./_arrayEach */ "./node_modules/lodash/_arrayEach.js"),
    baseEach = __webpack_require__(/*! ./_baseEach */ "./node_modules/lodash/_baseEach.js"),
    castFunction = __webpack_require__(/*! ./_castFunction */ "./node_modules/lodash/_castFunction.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js");

/**
 * Iterates over elements of `collection` and invokes `iteratee` for each element.
 * The iteratee is invoked with three arguments: (value, index|key, collection).
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * **Note:** As with other "Collections" methods, objects with a "length"
 * property are iterated like arrays. To avoid this behavior use `_.forIn`
 * or `_.forOwn` for object iteration.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @alias each
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 * @see _.forEachRight
 * @example
 *
 * _.forEach([1, 2], function(value) {
 *   console.log(value);
 * });
 * // => Logs `1` then `2`.
 *
 * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
 *   console.log(key);
 * });
 * // => Logs 'a' then 'b' (iteration order is not guaranteed).
 */
function forEach(collection, iteratee) {
  var func = isArray(collection) ? arrayEach : baseEach;
  return func(collection, castFunction(iteratee));
}

module.exports = forEach;


/***/ }),

/***/ "./node_modules/lodash/get.js":
/*!************************************!*\
  !*** ./node_modules/lodash/get.js ***!
  \************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGet = __webpack_require__(/*! ./_baseGet */ "./node_modules/lodash/_baseGet.js");

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

module.exports = get;


/***/ }),

/***/ "./node_modules/lodash/hasIn.js":
/*!**************************************!*\
  !*** ./node_modules/lodash/hasIn.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseHasIn = __webpack_require__(/*! ./_baseHasIn */ "./node_modules/lodash/_baseHasIn.js"),
    hasPath = __webpack_require__(/*! ./_hasPath */ "./node_modules/lodash/_hasPath.js");

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}

module.exports = hasIn;


/***/ }),

/***/ "./node_modules/lodash/identity.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/identity.js ***!
  \*****************************************/
/***/ ((module) => {

/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */
function identity(value) {
  return value;
}

module.exports = identity;


/***/ }),

/***/ "./node_modules/lodash/isArguments.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/isArguments.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsArguments = __webpack_require__(/*! ./_baseIsArguments */ "./node_modules/lodash/_baseIsArguments.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&
    !propertyIsEnumerable.call(value, 'callee');
};

module.exports = isArguments;


/***/ }),

/***/ "./node_modules/lodash/isArray.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/isArray.js ***!
  \****************************************/
/***/ ((module) => {

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

module.exports = isArray;


/***/ }),

/***/ "./node_modules/lodash/isArrayLike.js":
/*!********************************************!*\
  !*** ./node_modules/lodash/isArrayLike.js ***!
  \********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isFunction = __webpack_require__(/*! ./isFunction */ "./node_modules/lodash/isFunction.js"),
    isLength = __webpack_require__(/*! ./isLength */ "./node_modules/lodash/isLength.js");

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

module.exports = isArrayLike;


/***/ }),

/***/ "./node_modules/lodash/isBuffer.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/isBuffer.js ***!
  \*****************************************/
/***/ ((module, exports, __webpack_require__) => {

/* module decorator */ module = __webpack_require__.nmd(module);
var root = __webpack_require__(/*! ./_root */ "./node_modules/lodash/_root.js"),
    stubFalse = __webpack_require__(/*! ./stubFalse */ "./node_modules/lodash/stubFalse.js");

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */
var isBuffer = nativeIsBuffer || stubFalse;

module.exports = isBuffer;


/***/ }),

/***/ "./node_modules/lodash/isEmpty.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/isEmpty.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseKeys = __webpack_require__(/*! ./_baseKeys */ "./node_modules/lodash/_baseKeys.js"),
    getTag = __webpack_require__(/*! ./_getTag */ "./node_modules/lodash/_getTag.js"),
    isArguments = __webpack_require__(/*! ./isArguments */ "./node_modules/lodash/isArguments.js"),
    isArray = __webpack_require__(/*! ./isArray */ "./node_modules/lodash/isArray.js"),
    isArrayLike = __webpack_require__(/*! ./isArrayLike */ "./node_modules/lodash/isArrayLike.js"),
    isBuffer = __webpack_require__(/*! ./isBuffer */ "./node_modules/lodash/isBuffer.js"),
    isPrototype = __webpack_require__(/*! ./_isPrototype */ "./node_modules/lodash/_isPrototype.js"),
    isTypedArray = __webpack_require__(/*! ./isTypedArray */ "./node_modules/lodash/isTypedArray.js");

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    setTag = '[object Set]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if `value` is an empty object, collection, map, or set.
 *
 * Objects are considered empty if they have no own enumerable string keyed
 * properties.
 *
 * Array-like values such as `arguments` objects, arrays, buffers, strings, or
 * jQuery-like collections are considered empty if they have a `length` of `0`.
 * Similarly, maps and sets are considered empty if they have a `size` of `0`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is empty, else `false`.
 * @example
 *
 * _.isEmpty(null);
 * // => true
 *
 * _.isEmpty(true);
 * // => true
 *
 * _.isEmpty(1);
 * // => true
 *
 * _.isEmpty([1, 2, 3]);
 * // => false
 *
 * _.isEmpty({ 'a': 1 });
 * // => false
 */
function isEmpty(value) {
  if (value == null) {
    return true;
  }
  if (isArrayLike(value) &&
      (isArray(value) || typeof value == 'string' || typeof value.splice == 'function' ||
        isBuffer(value) || isTypedArray(value) || isArguments(value))) {
    return !value.length;
  }
  var tag = getTag(value);
  if (tag == mapTag || tag == setTag) {
    return !value.size;
  }
  if (isPrototype(value)) {
    return !baseKeys(value).length;
  }
  for (var key in value) {
    if (hasOwnProperty.call(value, key)) {
      return false;
    }
  }
  return true;
}

module.exports = isEmpty;


/***/ }),

/***/ "./node_modules/lodash/isFunction.js":
/*!*******************************************!*\
  !*** ./node_modules/lodash/isFunction.js ***!
  \*******************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(/*! ./_baseGetTag */ "./node_modules/lodash/_baseGetTag.js"),
    isObject = __webpack_require__(/*! ./isObject */ "./node_modules/lodash/isObject.js");

/** `Object#toString` result references. */
var asyncTag = '[object AsyncFunction]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}

module.exports = isFunction;


/***/ }),

/***/ "./node_modules/lodash/isLength.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/isLength.js ***!
  \*****************************************/
/***/ ((module) => {

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

module.exports = isLength;


/***/ }),

/***/ "./node_modules/lodash/isMap.js":
/*!**************************************!*\
  !*** ./node_modules/lodash/isMap.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsMap = __webpack_require__(/*! ./_baseIsMap */ "./node_modules/lodash/_baseIsMap.js"),
    baseUnary = __webpack_require__(/*! ./_baseUnary */ "./node_modules/lodash/_baseUnary.js"),
    nodeUtil = __webpack_require__(/*! ./_nodeUtil */ "./node_modules/lodash/_nodeUtil.js");

/* Node.js helper references. */
var nodeIsMap = nodeUtil && nodeUtil.isMap;

/**
 * Checks if `value` is classified as a `Map` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 * @example
 *
 * _.isMap(new Map);
 * // => true
 *
 * _.isMap(new WeakMap);
 * // => false
 */
var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;

module.exports = isMap;


/***/ }),

/***/ "./node_modules/lodash/isObject.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/isObject.js ***!
  \*****************************************/
/***/ ((module) => {

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

module.exports = isObject;


/***/ }),

/***/ "./node_modules/lodash/isObjectLike.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/isObjectLike.js ***!
  \*********************************************/
/***/ ((module) => {

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

module.exports = isObjectLike;


/***/ }),

/***/ "./node_modules/lodash/isPlainObject.js":
/*!**********************************************!*\
  !*** ./node_modules/lodash/isPlainObject.js ***!
  \**********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(/*! ./_baseGetTag */ "./node_modules/lodash/_baseGetTag.js"),
    getPrototype = __webpack_require__(/*! ./_getPrototype */ "./node_modules/lodash/_getPrototype.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/** `Object#toString` result references. */
var objectTag = '[object Object]';

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to infer the `Object` constructor. */
var objectCtorString = funcToString.call(Object);

/**
 * Checks if `value` is a plain object, that is, an object created by the
 * `Object` constructor or one with a `[[Prototype]]` of `null`.
 *
 * @static
 * @memberOf _
 * @since 0.8.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * _.isPlainObject(new Foo);
 * // => false
 *
 * _.isPlainObject([1, 2, 3]);
 * // => false
 *
 * _.isPlainObject({ 'x': 0, 'y': 0 });
 * // => true
 *
 * _.isPlainObject(Object.create(null));
 * // => true
 */
function isPlainObject(value) {
  if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
    return false;
  }
  var proto = getPrototype(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
  return typeof Ctor == 'function' && Ctor instanceof Ctor &&
    funcToString.call(Ctor) == objectCtorString;
}

module.exports = isPlainObject;


/***/ }),

/***/ "./node_modules/lodash/isSet.js":
/*!**************************************!*\
  !*** ./node_modules/lodash/isSet.js ***!
  \**************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsSet = __webpack_require__(/*! ./_baseIsSet */ "./node_modules/lodash/_baseIsSet.js"),
    baseUnary = __webpack_require__(/*! ./_baseUnary */ "./node_modules/lodash/_baseUnary.js"),
    nodeUtil = __webpack_require__(/*! ./_nodeUtil */ "./node_modules/lodash/_nodeUtil.js");

/* Node.js helper references. */
var nodeIsSet = nodeUtil && nodeUtil.isSet;

/**
 * Checks if `value` is classified as a `Set` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 * @example
 *
 * _.isSet(new Set);
 * // => true
 *
 * _.isSet(new WeakSet);
 * // => false
 */
var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

module.exports = isSet;


/***/ }),

/***/ "./node_modules/lodash/isSymbol.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/isSymbol.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(/*! ./_baseGetTag */ "./node_modules/lodash/_baseGetTag.js"),
    isObjectLike = __webpack_require__(/*! ./isObjectLike */ "./node_modules/lodash/isObjectLike.js");

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && baseGetTag(value) == symbolTag);
}

module.exports = isSymbol;


/***/ }),

/***/ "./node_modules/lodash/isTypedArray.js":
/*!*********************************************!*\
  !*** ./node_modules/lodash/isTypedArray.js ***!
  \*********************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsTypedArray = __webpack_require__(/*! ./_baseIsTypedArray */ "./node_modules/lodash/_baseIsTypedArray.js"),
    baseUnary = __webpack_require__(/*! ./_baseUnary */ "./node_modules/lodash/_baseUnary.js"),
    nodeUtil = __webpack_require__(/*! ./_nodeUtil */ "./node_modules/lodash/_nodeUtil.js");

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

module.exports = isTypedArray;


/***/ }),

/***/ "./node_modules/lodash/keys.js":
/*!*************************************!*\
  !*** ./node_modules/lodash/keys.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayLikeKeys = __webpack_require__(/*! ./_arrayLikeKeys */ "./node_modules/lodash/_arrayLikeKeys.js"),
    baseKeys = __webpack_require__(/*! ./_baseKeys */ "./node_modules/lodash/_baseKeys.js"),
    isArrayLike = __webpack_require__(/*! ./isArrayLike */ "./node_modules/lodash/isArrayLike.js");

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

module.exports = keys;


/***/ }),

/***/ "./node_modules/lodash/keysIn.js":
/*!***************************************!*\
  !*** ./node_modules/lodash/keysIn.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayLikeKeys = __webpack_require__(/*! ./_arrayLikeKeys */ "./node_modules/lodash/_arrayLikeKeys.js"),
    baseKeysIn = __webpack_require__(/*! ./_baseKeysIn */ "./node_modules/lodash/_baseKeysIn.js"),
    isArrayLike = __webpack_require__(/*! ./isArrayLike */ "./node_modules/lodash/isArrayLike.js");

/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keysIn(new Foo);
 * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
 */
function keysIn(object) {
  return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}

module.exports = keysIn;


/***/ }),

/***/ "./node_modules/lodash/last.js":
/*!*************************************!*\
  !*** ./node_modules/lodash/last.js ***!
  \*************************************/
/***/ ((module) => {

/**
 * Gets the last element of `array`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {Array} array The array to query.
 * @returns {*} Returns the last element of `array`.
 * @example
 *
 * _.last([1, 2, 3]);
 * // => 3
 */
function last(array) {
  var length = array == null ? 0 : array.length;
  return length ? array[length - 1] : undefined;
}

module.exports = last;


/***/ }),

/***/ "./node_modules/lodash/memoize.js":
/*!****************************************!*\
  !*** ./node_modules/lodash/memoize.js ***!
  \****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var MapCache = __webpack_require__(/*! ./_MapCache */ "./node_modules/lodash/_MapCache.js");

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = MapCache;

module.exports = memoize;


/***/ }),

/***/ "./node_modules/lodash/omit.js":
/*!*************************************!*\
  !*** ./node_modules/lodash/omit.js ***!
  \*************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayMap = __webpack_require__(/*! ./_arrayMap */ "./node_modules/lodash/_arrayMap.js"),
    baseClone = __webpack_require__(/*! ./_baseClone */ "./node_modules/lodash/_baseClone.js"),
    baseUnset = __webpack_require__(/*! ./_baseUnset */ "./node_modules/lodash/_baseUnset.js"),
    castPath = __webpack_require__(/*! ./_castPath */ "./node_modules/lodash/_castPath.js"),
    copyObject = __webpack_require__(/*! ./_copyObject */ "./node_modules/lodash/_copyObject.js"),
    customOmitClone = __webpack_require__(/*! ./_customOmitClone */ "./node_modules/lodash/_customOmitClone.js"),
    flatRest = __webpack_require__(/*! ./_flatRest */ "./node_modules/lodash/_flatRest.js"),
    getAllKeysIn = __webpack_require__(/*! ./_getAllKeysIn */ "./node_modules/lodash/_getAllKeysIn.js");

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG = 4;

/**
 * The opposite of `_.pick`; this method creates an object composed of the
 * own and inherited enumerable property paths of `object` that are not omitted.
 *
 * **Note:** This method is considerably slower than `_.pick`.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The source object.
 * @param {...(string|string[])} [paths] The property paths to omit.
 * @returns {Object} Returns the new object.
 * @example
 *
 * var object = { 'a': 1, 'b': '2', 'c': 3 };
 *
 * _.omit(object, ['a', 'c']);
 * // => { 'b': '2' }
 */
var omit = flatRest(function(object, paths) {
  var result = {};
  if (object == null) {
    return result;
  }
  var isDeep = false;
  paths = arrayMap(paths, function(path) {
    path = castPath(path, object);
    isDeep || (isDeep = path.length > 1);
    return path;
  });
  copyObject(object, getAllKeysIn(object), result);
  if (isDeep) {
    result = baseClone(result, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
  }
  var length = paths.length;
  while (length--) {
    baseUnset(result, paths[length]);
  }
  return result;
});

module.exports = omit;


/***/ }),

/***/ "./node_modules/lodash/property.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/property.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseProperty = __webpack_require__(/*! ./_baseProperty */ "./node_modules/lodash/_baseProperty.js"),
    basePropertyDeep = __webpack_require__(/*! ./_basePropertyDeep */ "./node_modules/lodash/_basePropertyDeep.js"),
    isKey = __webpack_require__(/*! ./_isKey */ "./node_modules/lodash/_isKey.js"),
    toKey = __webpack_require__(/*! ./_toKey */ "./node_modules/lodash/_toKey.js");

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}

module.exports = property;


/***/ }),

/***/ "./node_modules/lodash/sortBy.js":
/*!***************************************!*\
  !*** ./node_modules/lodash/sortBy.js ***!
  \***************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseFlatten = __webpack_require__(/*! ./_baseFlatten */ "./node_modules/lodash/_baseFlatten.js"),
    baseOrderBy = __webpack_require__(/*! ./_baseOrderBy */ "./node_modules/lodash/_baseOrderBy.js"),
    baseRest = __webpack_require__(/*! ./_baseRest */ "./node_modules/lodash/_baseRest.js"),
    isIterateeCall = __webpack_require__(/*! ./_isIterateeCall */ "./node_modules/lodash/_isIterateeCall.js");

/**
 * Creates an array of elements, sorted in ascending order by the results of
 * running each element in a collection thru each iteratee. This method
 * performs a stable sort, that is, it preserves the original sort order of
 * equal elements. The iteratees are invoked with one argument: (value).
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {...(Function|Function[])} [iteratees=[_.identity]]
 *  The iteratees to sort by.
 * @returns {Array} Returns the new sorted array.
 * @example
 *
 * var users = [
 *   { 'user': 'fred',   'age': 48 },
 *   { 'user': 'barney', 'age': 36 },
 *   { 'user': 'fred',   'age': 30 },
 *   { 'user': 'barney', 'age': 34 }
 * ];
 *
 * _.sortBy(users, [function(o) { return o.user; }]);
 * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 30]]
 *
 * _.sortBy(users, ['user', 'age']);
 * // => objects for [['barney', 34], ['barney', 36], ['fred', 30], ['fred', 48]]
 */
var sortBy = baseRest(function(collection, iteratees) {
  if (collection == null) {
    return [];
  }
  var length = iteratees.length;
  if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
    iteratees = [];
  } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
    iteratees = [iteratees[0]];
  }
  return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
});

module.exports = sortBy;


/***/ }),

/***/ "./node_modules/lodash/stubArray.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/stubArray.js ***!
  \******************************************/
/***/ ((module) => {

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
  return [];
}

module.exports = stubArray;


/***/ }),

/***/ "./node_modules/lodash/stubFalse.js":
/*!******************************************!*\
  !*** ./node_modules/lodash/stubFalse.js ***!
  \******************************************/
/***/ ((module) => {

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
  return false;
}

module.exports = stubFalse;


/***/ }),

/***/ "./node_modules/lodash/toString.js":
/*!*****************************************!*\
  !*** ./node_modules/lodash/toString.js ***!
  \*****************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseToString = __webpack_require__(/*! ./_baseToString */ "./node_modules/lodash/_baseToString.js");

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

module.exports = toString;


/***/ }),

/***/ "buffer":
/*!*************************!*\
  !*** external "buffer" ***!
  \*************************/
/***/ ((module) => {

"use strict";
module.exports = require("buffer");

/***/ }),

/***/ "http":
/*!***********************!*\
  !*** external "http" ***!
  \***********************/
/***/ ((module) => {

"use strict";
module.exports = require("http");

/***/ }),

/***/ "https":
/*!************************!*\
  !*** external "https" ***!
  \************************/
/***/ ((module) => {

"use strict";
module.exports = require("https");

/***/ }),

/***/ "stream":
/*!*************************!*\
  !*** external "stream" ***!
  \*************************/
/***/ ((module) => {

"use strict";
module.exports = require("stream");

/***/ }),

/***/ "url":
/*!**********************!*\
  !*** external "url" ***!
  \**********************/
/***/ ((module) => {

"use strict";
module.exports = require("url");

/***/ }),

/***/ "form-data":
/*!****************************!*\
  !*** external "form-data" ***!
  \****************************/
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_form_data__;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/arrayLikeToArray.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/arrayLikeToArray.js ***!
  \*****************************************************************/
/***/ ((module) => {

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
module.exports = _arrayLikeToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/arrayWithHoles.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/arrayWithHoles.js ***!
  \***************************************************************/
/***/ ((module) => {

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
module.exports = _arrayWithHoles, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/arrayWithoutHoles.js":
/*!******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/arrayWithoutHoles.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayLikeToArray = __webpack_require__(/*! ./arrayLikeToArray.js */ "./node_modules/@babel/runtime/helpers/arrayLikeToArray.js");
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return arrayLikeToArray(arr);
}
module.exports = _arrayWithoutHoles, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/asyncToGenerator.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/asyncToGenerator.js ***!
  \*****************************************************************/
/***/ ((module) => {

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
module.exports = _asyncToGenerator, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/classCallCheck.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/classCallCheck.js ***!
  \***************************************************************/
/***/ ((module) => {

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
module.exports = _classCallCheck, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/createClass.js":
/*!************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/createClass.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var toPropertyKey = __webpack_require__(/*! ./toPropertyKey.js */ "./node_modules/@babel/runtime/helpers/toPropertyKey.js");
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, toPropertyKey(descriptor.key), descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
module.exports = _createClass, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/defineProperty.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/defineProperty.js ***!
  \***************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var toPropertyKey = __webpack_require__(/*! ./toPropertyKey.js */ "./node_modules/@babel/runtime/helpers/toPropertyKey.js");
function _defineProperty(obj, key, value) {
  key = toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/interopRequireDefault.js ***!
  \**********************************************************************/
/***/ ((module) => {

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}
module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/iterableToArray.js":
/*!****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/iterableToArray.js ***!
  \****************************************************************/
/***/ ((module) => {

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
module.exports = _iterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/iterableToArrayLimit.js":
/*!*********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/iterableToArrayLimit.js ***!
  \*********************************************************************/
/***/ ((module) => {

function _iterableToArrayLimit(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s,
      _e,
      _x,
      _r,
      _arr = [],
      _n = !0,
      _d = !1;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i) return;
        _n = !1;
      } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0);
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return;
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}
module.exports = _iterableToArrayLimit, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/nonIterableRest.js":
/*!****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/nonIterableRest.js ***!
  \****************************************************************/
/***/ ((module) => {

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
module.exports = _nonIterableRest, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/nonIterableSpread.js":
/*!******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/nonIterableSpread.js ***!
  \******************************************************************/
/***/ ((module) => {

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
module.exports = _nonIterableSpread, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/objectWithoutProperties.js":
/*!************************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/objectWithoutProperties.js ***!
  \************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var objectWithoutPropertiesLoose = __webpack_require__(/*! ./objectWithoutPropertiesLoose.js */ "./node_modules/@babel/runtime/helpers/objectWithoutPropertiesLoose.js");
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
module.exports = _objectWithoutProperties, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/objectWithoutPropertiesLoose.js":
/*!*****************************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/objectWithoutPropertiesLoose.js ***!
  \*****************************************************************************/
/***/ ((module) => {

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
module.exports = _objectWithoutPropertiesLoose, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/regeneratorRuntime.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/regeneratorRuntime.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var _typeof = (__webpack_require__(/*! ./typeof.js */ "./node_modules/@babel/runtime/helpers/typeof.js")["default"]);
function _regeneratorRuntime() {
  "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
  module.exports = _regeneratorRuntime = function _regeneratorRuntime() {
    return exports;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    defineProperty = Object.defineProperty || function (obj, key, desc) {
      obj[key] = desc.value;
    },
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function define(obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return defineProperty(generator, "_invoke", {
      value: makeInvokeMethod(innerFn, self, context)
    }), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    defineProperty(this, "_invoke", {
      value: function value(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(innerFn, self, context) {
    var state = "suspendedStart";
    return function (method, arg) {
      if ("executing" === state) throw new Error("Generator is already running");
      if ("completed" === state) {
        if ("throw" === method) throw arg;
        return doneResult();
      }
      for (context.method = method, context.arg = arg;;) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }
        if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
          if ("suspendedStart" === state) throw state = "completed", context.arg;
          context.dispatchException(context.arg);
        } else "return" === context.method && context.abrupt("return", context.arg);
        state = "executing";
        var record = tryCatch(innerFn, self, context);
        if ("normal" === record.type) {
          if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
          return {
            value: record.arg,
            done: context.done
          };
        }
        "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
      }
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var methodName = context.method,
      method = delegate.iterator[methodName];
    if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator["return"] && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), defineProperty(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (val) {
    var object = Object(val),
      keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function reset(skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function stop() {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function dispatchException(exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function abrupt(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function complete(record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function finish(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    "catch": function _catch(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}
module.exports = _regeneratorRuntime, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/slicedToArray.js":
/*!**************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/slicedToArray.js ***!
  \**************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayWithHoles = __webpack_require__(/*! ./arrayWithHoles.js */ "./node_modules/@babel/runtime/helpers/arrayWithHoles.js");
var iterableToArrayLimit = __webpack_require__(/*! ./iterableToArrayLimit.js */ "./node_modules/@babel/runtime/helpers/iterableToArrayLimit.js");
var unsupportedIterableToArray = __webpack_require__(/*! ./unsupportedIterableToArray.js */ "./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js");
var nonIterableRest = __webpack_require__(/*! ./nonIterableRest.js */ "./node_modules/@babel/runtime/helpers/nonIterableRest.js");
function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}
module.exports = _slicedToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/toConsumableArray.js":
/*!******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/toConsumableArray.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayWithoutHoles = __webpack_require__(/*! ./arrayWithoutHoles.js */ "./node_modules/@babel/runtime/helpers/arrayWithoutHoles.js");
var iterableToArray = __webpack_require__(/*! ./iterableToArray.js */ "./node_modules/@babel/runtime/helpers/iterableToArray.js");
var unsupportedIterableToArray = __webpack_require__(/*! ./unsupportedIterableToArray.js */ "./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js");
var nonIterableSpread = __webpack_require__(/*! ./nonIterableSpread.js */ "./node_modules/@babel/runtime/helpers/nonIterableSpread.js");
function _toConsumableArray(arr) {
  return arrayWithoutHoles(arr) || iterableToArray(arr) || unsupportedIterableToArray(arr) || nonIterableSpread();
}
module.exports = _toConsumableArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/toPrimitive.js":
/*!************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/toPrimitive.js ***!
  \************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var _typeof = (__webpack_require__(/*! ./typeof.js */ "./node_modules/@babel/runtime/helpers/typeof.js")["default"]);
function _toPrimitive(input, hint) {
  if (_typeof(input) !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (_typeof(res) !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
module.exports = _toPrimitive, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/toPropertyKey.js":
/*!**************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/toPropertyKey.js ***!
  \**************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var _typeof = (__webpack_require__(/*! ./typeof.js */ "./node_modules/@babel/runtime/helpers/typeof.js")["default"]);
var toPrimitive = __webpack_require__(/*! ./toPrimitive.js */ "./node_modules/@babel/runtime/helpers/toPrimitive.js");
function _toPropertyKey(arg) {
  var key = toPrimitive(arg, "string");
  return _typeof(key) === "symbol" ? key : String(key);
}
module.exports = _toPropertyKey, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/typeof.js":
/*!*******************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/typeof.js ***!
  \*******************************************************/
/***/ ((module) => {

function _typeof(obj) {
  "@babel/helpers - typeof";

  return (module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports), _typeof(obj);
}
module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js":
/*!***************************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js ***!
  \***************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayLikeToArray = __webpack_require__(/*! ./arrayLikeToArray.js */ "./node_modules/@babel/runtime/helpers/arrayLikeToArray.js");
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
}
module.exports = _unsupportedIterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/regenerator/index.js":
/*!**********************************************************!*\
  !*** ./node_modules/@babel/runtime/regenerator/index.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// TODO(Babel 8): Remove this file.

var runtime = __webpack_require__(/*! ../helpers/regeneratorRuntime */ "./node_modules/@babel/runtime/helpers/regeneratorRuntime.js")();
module.exports = runtime;

// Copied from https://github.com/facebook/regenerator/blob/main/packages/runtime/runtime.js#L736=
try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  if (typeof globalThis === "object") {
    globalThis.regeneratorRuntime = runtime;
  } else {
    Function("r", "regeneratorRuntime = r")(runtime);
  }
}


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/node module decorator */
/******/ 	(() => {
/******/ 		__webpack_require__.nmd = (module) => {
/******/ 			module.paths = [];
/******/ 			if (!module.children) module.children = [];
/******/ 			return module;
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
var exports = __webpack_exports__;
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/


var _interopRequireDefault = __webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");
var _typeof = __webpack_require__(/*! @babel/runtime/helpers/typeof */ "./node_modules/@babel/runtime/helpers/typeof.js");
Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.CacheTags = void 0;
Object.defineProperty(exports, "DevPermissions", ({
  enumerable: true,
  get: function get() {
    return _devPermissions.DevPermissions;
  }
}));
Object.defineProperty(exports, "Request", ({
  enumerable: true,
  get: function get() {
    return _backendlessRequest["default"];
  }
}));
exports.createClient = void 0;
Object.defineProperty(exports, "urls", ({
  enumerable: true,
  get: function get() {
    return _urls["default"];
  }
}));
var _defineProperty2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));
var _classCallCheck2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/classCallCheck */ "./node_modules/@babel/runtime/helpers/classCallCheck.js"));
var _createClass2 = _interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/createClass */ "./node_modules/@babel/runtime/helpers/createClass.js"));
var _backendlessRequest = _interopRequireDefault(__webpack_require__(/*! backendless-request */ "./node_modules/backendless-request/es/index.js"));
var CacheTags = _interopRequireWildcard(__webpack_require__(/*! ./utils/cache-tags */ "./src/utils/cache-tags.js"));
exports.CacheTags = CacheTags;
var _urls = _interopRequireDefault(__webpack_require__(/*! ./urls */ "./src/urls.js"));
var _activityManager = _interopRequireDefault(__webpack_require__(/*! ./activity-manager */ "./src/activity-manager.js"));
var _analytics = _interopRequireDefault(__webpack_require__(/*! ./analytics */ "./src/analytics.js"));
var _apiDocs = _interopRequireDefault(__webpack_require__(/*! ./api-docs */ "./src/api-docs.js"));
var _apps = _interopRequireDefault(__webpack_require__(/*! ./apps */ "./src/apps.js"));
var _automation = _interopRequireDefault(__webpack_require__(/*! ./automation */ "./src/automation.js"));
var _billing = __webpack_require__(/*! ./billing */ "./src/billing/index.js");
var _bl = _interopRequireDefault(__webpack_require__(/*! ./bl */ "./src/bl.js"));
var _cloudCode = _interopRequireDefault(__webpack_require__(/*! ./cloud-code */ "./src/cloud-code.js"));
var _blueprints = _interopRequireDefault(__webpack_require__(/*! ./blueprints */ "./src/blueprints.js"));
var _cache = _interopRequireDefault(__webpack_require__(/*! ./cache */ "./src/cache.js"));
var _cacheControl = _interopRequireDefault(__webpack_require__(/*! ./cache-control */ "./src/cache-control.js"));
var _codegen = _interopRequireDefault(__webpack_require__(/*! ./codegen */ "./src/codegen.js"));
var _codeless = _interopRequireDefault(__webpack_require__(/*! ./codeless */ "./src/codeless.js"));
var _counters = _interopRequireDefault(__webpack_require__(/*! ./counters */ "./src/counters.js"));
var _dataConnectors = _interopRequireDefault(__webpack_require__(/*! ./data-connectors */ "./src/data-connectors.js"));
var _dataViews = _interopRequireDefault(__webpack_require__(/*! ./data-views */ "./src/data-views.js"));
var _dataHives = _interopRequireDefault(__webpack_require__(/*! ./data-hives */ "./src/data-hives.js"));
var _dataToVisualize = _interopRequireDefault(__webpack_require__(/*! ./data-to-visualize */ "./src/data-to-visualize.js"));
var _developerProfile = _interopRequireDefault(__webpack_require__(/*! ./developer-profile */ "./src/developer-profile.js"));
var _devTeam = _interopRequireDefault(__webpack_require__(/*! ./dev-team */ "./src/dev-team.js"));
var _email = _interopRequireDefault(__webpack_require__(/*! ./email */ "./src/email.js"));
var _files = _interopRequireDefault(__webpack_require__(/*! ./files */ "./src/files.js"));
var _gamification = _interopRequireDefault(__webpack_require__(/*! ./gamification */ "./src/gamification.js"));
var _geo = _interopRequireDefault(__webpack_require__(/*! ./geo */ "./src/geo.js"));
var _license = _interopRequireDefault(__webpack_require__(/*! ./license */ "./src/license.js"));
var _messaging = _interopRequireDefault(__webpack_require__(/*! ./messaging */ "./src/messaging.js"));
var _navigator = _interopRequireDefault(__webpack_require__(/*! ./navigator */ "./src/navigator.js"));
var _projectTemplate = _interopRequireDefault(__webpack_require__(/*! ./project-template */ "./src/project-template.js"));
var _security = _interopRequireDefault(__webpack_require__(/*! ./security */ "./src/security.js"));
var _devPermissions = _interopRequireWildcard(__webpack_require__(/*! ./dev-permissions */ "./src/dev-permissions.js"));
var _openAi = _interopRequireDefault(__webpack_require__(/*! ./open-ai */ "./src/open-ai.js"));
var _integrations = _interopRequireDefault(__webpack_require__(/*! ./integrations */ "./src/integrations.js"));
var _pdf = _interopRequireDefault(__webpack_require__(/*! ./pdf */ "./src/pdf.js"));
var _settings = _interopRequireDefault(__webpack_require__(/*! ./settings */ "./src/settings.js"));
var _status = _interopRequireDefault(__webpack_require__(/*! ./status */ "./src/status.js"));
var _tables = _interopRequireDefault(__webpack_require__(/*! ./tables */ "./src/tables.js"));
var _transfer = _interopRequireDefault(__webpack_require__(/*! ./transfer */ "./src/transfer.js"));
var _user = _interopRequireDefault(__webpack_require__(/*! ./user */ "./src/user.js"));
var _users = _interopRequireDefault(__webpack_require__(/*! ./users */ "./src/users.js"));
var _warning = _interopRequireDefault(__webpack_require__(/*! ./warning */ "./src/warning.js"));
var _uiBuilder = _interopRequireDefault(__webpack_require__(/*! ./ui-builder */ "./src/ui-builder.js"));
var _chartBuilder = _interopRequireDefault(__webpack_require__(/*! ./chart-builder */ "./src/chart-builder.js"));
var _visualizations = _interopRequireDefault(__webpack_require__(/*! ./visualizations */ "./src/visualizations.js"));
var _consolePreview = _interopRequireDefault(__webpack_require__(/*! ./console-preview */ "./src/console-preview.js"));
var _quickApps = _interopRequireDefault(__webpack_require__(/*! ./quick-apps */ "./src/quick-apps.js"));
var _frExtensions = _interopRequireDefault(__webpack_require__(/*! ./fr-extensions */ "./src/fr-extensions.js"));
var _community = __webpack_require__(/*! ./community */ "./src/community.js");
var _marketplace = __webpack_require__(/*! ./marketplace */ "./src/marketplace.js");
var _referrals = __webpack_require__(/*! ./referrals */ "./src/referrals.js");
var _initialQuestionnaire = __webpack_require__(/*! ./initial-questionnaire */ "./src/initial-questionnaire.js");
var _sqlService = __webpack_require__(/*! ./sql-service */ "./src/sql-service.js");
var _system = __webpack_require__(/*! ./system */ "./src/system.js");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Context = /*#__PURE__*/function () {
  function Context(authKey, options) {
    (0, _classCallCheck2["default"])(this, Context);
    this.options = options;
    this.authKey = authKey;
    this.middleware = options.middleware;
  }
  (0, _createClass2["default"])(Context, [{
    key: "setAuthKey",
    value: function setAuthKey(authKey) {
      this.authKey = authKey;
    }

    /**
     * @param {Request} req
     * @returns {Request}
     */
  }, {
    key: "apply",
    value: function apply(req, middleware) {
      if (this.authKey) {
        req.set('auth-key', this.authKey);
      }
      if (this.middleware) {
        this.middleware(req);
      }
      if (middleware) {
        middleware(req);
      }
      return req;
    }
  }]);
  return Context;
}();
/**
 * @param {Context} context
 * @param {String} serverUrl
 */
var contextifyRequest = function contextifyRequest(context, serverUrl, middleware) {
  var result = {
    context: context
  };
  var addServerUrl = function addServerUrl(path) {
    return serverUrl && !path.startsWith('http') ? serverUrl + path : path;
  };
  _backendlessRequest["default"].methods.forEach(function (method) {
    result[method] = function (path, body) {
      return context.apply(new _backendlessRequest["default"](addServerUrl(path), method, body), middleware);
    };
  });
  return result;
};
var DEFAULT_OPTIONS = {
  billingURL: null,
  billingAuth: null
};
var createClient = function createClient(serverUrl, authKey, options) {
  options = _objectSpread(_objectSpread({}, DEFAULT_OPTIONS), options);
  var context = new Context(authKey, options);
  var request = contextifyRequest(context, serverUrl);
  if (options.billingURL) {
    request.billing = contextifyRequest(context, options.billingURL, function (req) {
      if (options.billingAuth) {
        req.set({
          'Authorization': "Basic ".concat(options.billingAuth)
        });
      }
    });
  } else {
    request.billing = request;
  }
  if (options.communityURL) {
    request.community = contextifyRequest(context, options.communityURL, function (req) {
      req.path = req.path.replace('/console/community', '');
    });
  } else {
    request.community = request;
  }
  if (options.sqlServiceURL) {
    request.sqlService = contextifyRequest(context, options.sqlServiceURL);
  } else {
    request.sqlService = request;
  }
  if (options.automationURL) {
    request.automation = contextifyRequest(context, options.automationURL, function (req) {
      req.path = req.path.replace('/console/automation', '');
    });
  } else {
    request.automation = request;
  }
  if (options.nodeApiURL) {
    request.nodeAPI = contextifyRequest(context, options.nodeApiURL, function (req) {
      req.path = req.path.replace('/api/node-server', '');
    });
  } else {
    request.nodeAPI = request;
  }
  var destroy = function destroy() {
    context.middleware = function (req) {
      req.send = function () {
        return Promise.reject(new Error('Client has been destroyed'));
      };
      return req;
    };
  };
  return request.api = {
    destroy: destroy,
    request: request,
    system: (0, _system.systemAPI)(request),
    activityManager: (0, _activityManager["default"])(request),
    analytics: (0, _analytics["default"])(request),
    apiDocs: (0, _apiDocs["default"])(request),
    apps: (0, _apps["default"])(request),
    automation: (0, _automation["default"])(request),
    billing: (0, _billing.billingAPI)(request),
    bl: (0, _bl["default"])(request),
    cloudCode: (0, _cloudCode["default"])(request),
    blueprints: (0, _blueprints["default"])(request),
    cache: (0, _cache["default"])(request),
    cacheControl: (0, _cacheControl["default"])(request),
    codegen: (0, _codegen["default"])(request),
    codeless: (0, _codeless["default"])(request),
    counters: (0, _counters["default"])(request),
    dataConnectors: (0, _dataConnectors["default"])(request),
    dataViews: (0, _dataViews["default"])(request),
    dataHives: (0, _dataHives["default"])(request),
    dataToVisualize: (0, _dataToVisualize["default"])(request),
    developerProfile: (0, _developerProfile["default"])(request),
    devTeam: (0, _devTeam["default"])(request),
    email: (0, _email["default"])(request),
    files: (0, _files["default"])(request),
    gamification: (0, _gamification["default"])(request),
    geo: (0, _geo["default"])(request),
    license: (0, _license["default"])(request),
    messaging: (0, _messaging["default"])(request),
    navigator: (0, _navigator["default"])(request),
    projectTemplate: (0, _projectTemplate["default"])(request),
    security: (0, _security["default"])(request),
    devPermissions: (0, _devPermissions["default"])(request),
    openAI: (0, _openAi["default"])(request),
    settings: (0, _settings["default"])(request),
    status: (0, _status["default"])(request),
    tables: (0, _tables["default"])(request),
    transfer: (0, _transfer["default"])(request),
    user: (0, _user["default"])(request, context),
    users: (0, _users["default"])(request),
    warning: (0, _warning["default"])(request),
    uiBuilder: (0, _uiBuilder["default"])(request),
    chartBuilder: (0, _chartBuilder["default"])(request),
    community: (0, _community.community)(request),
    sqlService: (0, _sqlService.sqlService)(request),
    marketplace: (0, _marketplace.marketplace)(request),
    referrals: (0, _referrals.referrals)(request),
    visualizations: (0, _visualizations["default"])(request),
    initialQuestionnaire: (0, _initialQuestionnaire.initialQuestionnaire)(request),
    consolePreview: (0, _consolePreview["default"])(request),
    quickApps: (0, _quickApps["default"])(request),
    integrations: (0, _integrations["default"])(request),
    pdf: (0, _pdf["default"])(request),
    frExtensions: (0, _frExtensions["default"])(request)
  };
};
exports.createClient = createClient;
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});